/* THIS FILE IS AUTOGENERATED FROM Cache.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_CacheBinding_h
#define mozilla_dom_CacheBinding_h

#include "js/RootingAPI.h"
#include "jspubtd.h"
#include "mozilla/ErrorResult.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/Request.h"
#include "mozilla/dom/Response.h"

namespace mozilla {
namespace dom {

struct CacheBatchOperationAtoms;
struct CacheQueryOptions;
struct CacheQueryOptionsAtoms;
struct NativePropertyHooks;
class ProtoAndIfaceCache;
class Request;
class Response;

namespace cache {

class Cache;
struct CacheAtoms;

} // namespace cache

} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {

struct CacheQueryOptions : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Optional<nsString> mCacheName;
  MOZ_INIT_OUTSIDE_CTOR bool mIgnoreMethod;
  MOZ_INIT_OUTSIDE_CTOR bool mIgnoreSearch;
  MOZ_INIT_OUTSIDE_CTOR bool mIgnoreVary;

  CacheQueryOptions();

  explicit inline CacheQueryOptions(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline CacheQueryOptions(const CacheQueryOptions& aOther)
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);

  CacheQueryOptions&
  operator=(const CacheQueryOptions& aOther);

private:
  static bool
  InitIds(JSContext* cx, CacheQueryOptionsAtoms* atomsCache);
};

namespace binding_detail {
struct FastCacheQueryOptions : public CacheQueryOptions
{
  inline FastCacheQueryOptions()
    : CacheQueryOptions(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct CacheBatchOperation : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR CacheQueryOptions mOptions;
  MOZ_INIT_OUTSIDE_CTOR Optional<OwningNonNull<mozilla::dom::Request>> mRequest;
  MOZ_INIT_OUTSIDE_CTOR Optional<OwningNonNull<mozilla::dom::Response>> mResponse;
  MOZ_INIT_OUTSIDE_CTOR Optional<nsString> mType;

  CacheBatchOperation();

  explicit inline CacheBatchOperation(const FastDictionaryInitializer& )
    : mOptions(FastDictionaryInitializer())
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline CacheBatchOperation(const CacheBatchOperation& aOther)
    : mOptions(FastDictionaryInitializer())
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceDictionary(JSTracer* trc);

  CacheBatchOperation&
  operator=(const CacheBatchOperation& aOther);

private:
  static bool
  InitIds(JSContext* cx, CacheBatchOperationAtoms* atomsCache);
};

namespace binding_detail {
struct FastCacheBatchOperation : public CacheBatchOperation
{
  inline FastCacheBatchOperation()
    : CacheBatchOperation(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace CacheBinding {

  typedef mozilla::dom::cache::Cache NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  JSObject*
  DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::dom::cache::Cache* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  // We declare this as an array so that retrieving a pointer to this
  // binding's property hooks only requires compile/link-time resolvable
  // address arithmetic.  Declaring it as a pointer instead would require
  // doing a run-time load to fetch a pointer to this binding's property
  // hooks.  And then structures which embedded a pointer to this structure
  // would require a run-time load for proper initialization, which would
  // then induce static constructors.  Lots of static constructors.
  extern const NativePropertyHooks sNativePropertyHooks[];

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  JS::Handle<JSObject*>
  GetProtoObjectHandle(JSContext* aCx);

  JS::Handle<JSObject*>
  GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true);

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace CacheBinding



} // namespace dom
} // namespace mozilla

#endif // mozilla_dom_CacheBinding_h
