/* THIS FILE IS AUTOGENERATED FROM L10nUtils.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_L10nUtilsBinding_h
#define mozilla_dom_L10nUtilsBinding_h

#include "js/RootingAPI.h"
#include "jspubtd.h"
#include "mozilla/ErrorResult.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/CallbackFunction.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/ToJSValue.h"

namespace mozilla {
namespace dom {

struct AttributeNameValue;
struct AttributeNameValueAtoms;
class L10nCallback;
struct L10nElement;
struct L10nElementAtoms;
struct L10nValueAtoms;
struct NativePropertyHooks;
class Promise;
class ProtoAndIfaceCache;

} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {

struct AttributeNameValue : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR nsString mName;
  MOZ_INIT_OUTSIDE_CTOR nsString mValue;

  AttributeNameValue();

  explicit inline AttributeNameValue(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline AttributeNameValue(const AttributeNameValue& aOther)
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);

  AttributeNameValue&
  operator=(const AttributeNameValue& aOther);

private:
  static bool
  InitIds(JSContext* cx, AttributeNameValueAtoms* atomsCache);
};

namespace binding_detail {
struct FastAttributeNameValue : public AttributeNameValue
{
  inline FastAttributeNameValue()
    : AttributeNameValue(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct L10nElement : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR JSObject* mL10nArgs;
  MOZ_INIT_OUTSIDE_CTOR nsString mL10nAttrs;
  MOZ_INIT_OUTSIDE_CTOR nsString mL10nId;
  MOZ_INIT_OUTSIDE_CTOR nsString mLocalName;
  MOZ_INIT_OUTSIDE_CTOR nsString mNamespaceURI;
  MOZ_INIT_OUTSIDE_CTOR nsString mType;

  L10nElement();

  explicit inline L10nElement(const FastDictionaryInitializer& )
    : mL10nArgs(nullptr)
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

private:
  L10nElement(const L10nElement&) = delete;
  L10nElement& operator=(const L10nElement&) = delete;

  static bool
  InitIds(JSContext* cx, L10nElementAtoms* atomsCache);

public:
  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceDictionary(JSTracer* trc);
};

namespace binding_detail {
struct FastL10nElement : public L10nElement
{
  inline FastL10nElement()
    : L10nElement(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct L10nValue : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Nullable<Sequence<AttributeNameValue>> mAttributes;
  MOZ_INIT_OUTSIDE_CTOR nsString mValue;

  L10nValue();

  explicit inline L10nValue(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline L10nValue(const L10nValue& aOther)
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);

  L10nValue&
  operator=(const L10nValue& aOther);

private:
  static bool
  InitIds(JSContext* cx, L10nValueAtoms* atomsCache);
};

namespace binding_detail {
struct FastL10nValue : public L10nValue
{
  inline FastL10nValue()
    : L10nValue(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


class L10nCallback : public CallbackFunction
{
public:
  explicit inline L10nCallback(JSContext* aCx, JS::Handle<JSObject*> aCallback, nsIGlobalObject* aIncumbentGlobal)
    : CallbackFunction(aCx, aCallback, aIncumbentGlobal)
  {
    MOZ_ASSERT(JS::IsCallable(mCallback));
  }

  explicit inline L10nCallback(JS::Handle<JSObject*> aCallback, const FastCallbackConstructor& )
    : CallbackFunction(aCallback, FastCallbackConstructor())
  {
    MOZ_ASSERT(JS::IsCallable(mCallback));
  }

  explicit inline L10nCallback(JS::Handle<JSObject*> aCallback, JS::Handle<JSObject*> aAsyncStack, nsIGlobalObject* aIncumbentGlobal)
    : CallbackFunction(aCallback, aAsyncStack, aIncumbentGlobal)
  {
    MOZ_ASSERT(JS::IsCallable(mCallback));
  }

  explicit inline L10nCallback(CallbackFunction* aOther)
    : CallbackFunction(aOther)
  {
  }

  template <typename T>
  inline already_AddRefed<Promise>
  Call(const T& thisVal, const Sequence<L10nElement>& l10nElements, ErrorResult& aRv, const char* aExecutionReason = nullptr, ExceptionHandling aExceptionHandling = eReportExceptions, JSCompartment* aCompartment = nullptr)
  {
    MOZ_ASSERT(!aRv.Failed(), "Don't pass an already-failed ErrorResult to a callback!");
    if (!aExecutionReason) {
      aExecutionReason = "L10nCallback";
    }
    CallSetup s(this, aRv, aExecutionReason, aExceptionHandling, aCompartment);
    if (!s.GetContext()) {
      MOZ_ASSERT(aRv.Failed());
      return nullptr;
    }
    JS::Rooted<JS::Value> thisValJS(s.GetContext());
    if (!ToJSValue(s.GetContext(), thisVal, &thisValJS)) {
      aRv.Throw(NS_ERROR_FAILURE);
      return nullptr;
    }
    return Call(s.GetContext(), thisValJS, l10nElements, aRv);
  }

  inline already_AddRefed<Promise>
  Call(const Sequence<L10nElement>& l10nElements, ErrorResult& aRv, const char* aExecutionReason = nullptr, ExceptionHandling aExceptionHandling = eReportExceptions, JSCompartment* aCompartment = nullptr)
  {
    MOZ_ASSERT(!aRv.Failed(), "Don't pass an already-failed ErrorResult to a callback!");
    if (!aExecutionReason) {
      aExecutionReason = "L10nCallback";
    }
    CallSetup s(this, aRv, aExecutionReason, aExceptionHandling, aCompartment);
    if (!s.GetContext()) {
      MOZ_ASSERT(aRv.Failed());
      return nullptr;
    }
    return Call(s.GetContext(), JS::UndefinedHandleValue, l10nElements, aRv);
  }

  template <typename T>
  inline already_AddRefed<Promise>
  Call(const T& thisVal, const Sequence<L10nElement>& l10nElements, const char* aExecutionReason = nullptr)
  {
    return Call(thisVal, l10nElements, IgnoreErrors(), aExecutionReason);
  }

  inline already_AddRefed<Promise>
  Call(const Sequence<L10nElement>& l10nElements, const char* aExecutionReason = nullptr)
  {
    return Call(l10nElements, IgnoreErrors(), aExecutionReason, eReportExceptions, nullptr);
  }

  inline bool
  operator==(const L10nCallback& aOther) const
  {
    return CallbackFunction::operator==(aOther);
  }

private:
  already_AddRefed<Promise> Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, const Sequence<L10nElement>& l10nElements, ErrorResult& aRv);
};


namespace binding_detail {
class FastL10nCallback : public L10nCallback
{
public:
  explicit inline FastL10nCallback(JS::Handle<JSObject*> aCallback)
    : L10nCallback(aCallback, FastCallbackConstructor())
  {
  }

  inline void
  Trace(JSTracer* aTracer)
  {
    L10nCallback::Trace(aTracer);
  }

  inline void
  FinishSlowJSInitIfMoreThanOneOwner(JSContext* aCx)
  {
    L10nCallback::FinishSlowJSInitIfMoreThanOneOwner(aCx);
  }
};
} // namespace binding_detail


} // namespace dom
} // namespace mozilla

#endif // mozilla_dom_L10nUtilsBinding_h
