/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED FROM RTCTrackEvent.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_RTCTrackEvent_h
#define mozilla_dom_RTCTrackEvent_h

#include "mozilla/Attributes.h"
#include "mozilla/ErrorResult.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/Event.h"
#include "mozilla/dom/RTCTrackEventBinding.h"

struct JSContext;
namespace mozilla {
namespace dom {

class RTCTrackEvent : public Event
{
public:
  NS_DECL_ISUPPORTS_INHERITED
  NS_DECL_CYCLE_COLLECTION_SCRIPT_HOLDER_CLASS_INHERITED(RTCTrackEvent, Event)
protected:
  virtual ~RTCTrackEvent();
  explicit RTCTrackEvent(mozilla::dom::EventTarget* aOwner);

  RefPtr<RTCRtpReceiver> mReceiver;
  RefPtr<MediaStreamTrack> mTrack;
  nsTArray<RefPtr<DOMMediaStream>> mStreams;
  RefPtr<RTCRtpTransceiver> mTransceiver;

public:
  virtual RTCTrackEvent* AsRTCTrackEvent() override;

  virtual JSObject* WrapObjectInternal(JSContext* aCx, JS::Handle<JSObject*> aGivenProto) override;

  static already_AddRefed<RTCTrackEvent> Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const RTCTrackEventInit& aEventInitDict);

  static already_AddRefed<RTCTrackEvent> Constructor(const GlobalObject& aGlobal, const nsAString& aType, const RTCTrackEventInit& aEventInitDict, ErrorResult& aRv);

  RTCRtpReceiver* Receiver() const;

  MediaStreamTrack* Track() const;

  void GetStreams(nsTArray<RefPtr<DOMMediaStream>>& aRetVal) const;

  RTCRtpTransceiver* Transceiver() const;
};

} // namespace dom
} // namespace mozilla

#endif // mozilla_dom_RTCTrackEvent_h
