/* THIS FILE IS AUTOGENERATED FROM UIEvent.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_UIEventBinding_h
#define mozilla_dom_UIEventBinding_h

#include "EventBinding.h"
#include "UIEventBinding.h"
#include "js/RootingAPI.h"
#include "jspubtd.h"
#include "mozilla/ErrorResult.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "nsGlobalWindow.h"

class nsGlobalWindow;

namespace mozilla {
namespace dom {

struct EventModifierInitAtoms;
struct NativePropertyHooks;
class ProtoAndIfaceCache;
class UIEvent;
struct UIEventAtoms;
struct UIEventInitAtoms;

} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {

struct UIEventInit : public EventInit
{
  MOZ_INIT_OUTSIDE_CTOR int32_t mDetail;
  MOZ_INIT_OUTSIDE_CTOR RefPtr<nsGlobalWindow> mView;

  UIEventInit();

  explicit inline UIEventInit(const FastDictionaryInitializer& )
    : EventInit(FastDictionaryInitializer())
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline UIEventInit(const UIEventInit& aOther)
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceDictionary(JSTracer* trc);

  UIEventInit&
  operator=(const UIEventInit& aOther);

private:
  static bool
  InitIds(JSContext* cx, UIEventInitAtoms* atomsCache);
};

namespace binding_detail {
struct FastUIEventInit : public UIEventInit
{
  inline FastUIEventInit()
    : UIEventInit(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct EventModifierInit : public UIEventInit
{
  MOZ_INIT_OUTSIDE_CTOR bool mAltKey;
  MOZ_INIT_OUTSIDE_CTOR bool mCtrlKey;
  MOZ_INIT_OUTSIDE_CTOR bool mMetaKey;
  MOZ_INIT_OUTSIDE_CTOR bool mModifierAltGraph;
  MOZ_INIT_OUTSIDE_CTOR bool mModifierCapsLock;
  MOZ_INIT_OUTSIDE_CTOR bool mModifierFn;
  MOZ_INIT_OUTSIDE_CTOR bool mModifierFnLock;
  MOZ_INIT_OUTSIDE_CTOR bool mModifierNumLock;
  MOZ_INIT_OUTSIDE_CTOR bool mModifierOS;
  MOZ_INIT_OUTSIDE_CTOR bool mModifierScrollLock;
  MOZ_INIT_OUTSIDE_CTOR bool mModifierSymbol;
  MOZ_INIT_OUTSIDE_CTOR bool mModifierSymbolLock;
  MOZ_INIT_OUTSIDE_CTOR bool mShiftKey;

  EventModifierInit();

  explicit inline EventModifierInit(const FastDictionaryInitializer& )
    : UIEventInit(FastDictionaryInitializer())
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline EventModifierInit(const EventModifierInit& aOther)
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);

  EventModifierInit&
  operator=(const EventModifierInit& aOther);

private:
  static bool
  InitIds(JSContext* cx, EventModifierInitAtoms* atomsCache);
};

namespace binding_detail {
struct FastEventModifierInit : public EventModifierInit
{
  inline FastEventModifierInit()
    : EventModifierInit(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace UIEventBinding {

  typedef mozilla::dom::UIEvent NativeType;

  static const int32_t SCROLL_PAGE_UP = -32768;
  static const int32_t SCROLL_PAGE_DOWN = 32768;
  JSObject*
  DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::dom::UIEvent* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  // We declare this as an array so that retrieving a pointer to this
  // binding's property hooks only requires compile/link-time resolvable
  // address arithmetic.  Declaring it as a pointer instead would require
  // doing a run-time load to fetch a pointer to this binding's property
  // hooks.  And then structures which embedded a pointer to this structure
  // would require a run-time load for proper initialization, which would
  // then induce static constructors.  Lots of static constructors.
  extern const NativePropertyHooks sNativePropertyHooks[];

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  JS::Handle<JSObject*>
  GetProtoObjectHandle(JSContext* aCx);

  JSObject*
  GetProtoObject(JSContext* aCx);

  JS::Handle<JSObject*>
  GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true);

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace UIEventBinding



} // namespace dom
} // namespace mozilla

#endif // mozilla_dom_UIEventBinding_h
