/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsICertBlocklist.idl
 */

#ifndef __gen_nsICertBlocklist_h__
#define __gen_nsICertBlocklist_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIX509Cert; /* forward declaration */

#define NS_CERTBLOCKLIST_CONTRACTID "@mozilla.org/security/certblocklist;1"

/* starting interface:    nsICertBlocklist */
#define NS_ICERTBLOCKLIST_IID_STR "e0654480-f433-11e4-b939-0800200c9a66"

#define NS_ICERTBLOCKLIST_IID \
  {0xe0654480, 0xf433, 0x11e4, \
    { 0xb9, 0x39, 0x08, 0x00, 0x20, 0x0c, 0x9a, 0x66 }}

class NS_NO_VTABLE nsICertBlocklist : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ICERTBLOCKLIST_IID)

  /* [must_use] void revokeCertByIssuerAndSerial (in ACString issuer, in ACString serialNumber); */
  MOZ_MUST_USE NS_IMETHOD RevokeCertByIssuerAndSerial(const nsACString & issuer, const nsACString & serialNumber) = 0;

  /* [must_use] void revokeCertBySubjectAndPubKey (in ACString subject, in ACString pubKeyHash); */
  MOZ_MUST_USE NS_IMETHOD RevokeCertBySubjectAndPubKey(const nsACString & subject, const nsACString & pubKeyHash) = 0;

  /* [must_use] void saveEntries (); */
  MOZ_MUST_USE NS_IMETHOD SaveEntries(void) = 0;

  /* [must_use] boolean isCertRevoked ([array, size_is (issuer_length), const] in octet issuer, in unsigned long issuer_length, [array, size_is (serial_length), const] in octet serial, in unsigned long serial_length, [array, size_is (subject_length), const] in octet subject, in unsigned long subject_length, [array, size_is (pubkey_length), const] in octet pubkey, in unsigned long pubkey_length); */
  MOZ_MUST_USE NS_IMETHOD IsCertRevoked(const uint8_t *issuer, uint32_t issuer_length, const uint8_t *serial, uint32_t serial_length, const uint8_t *subject, uint32_t subject_length, const uint8_t *pubkey, uint32_t pubkey_length, bool *_retval) = 0;

  /* [must_use] boolean isBlocklistFresh (); */
  MOZ_MUST_USE NS_IMETHOD IsBlocklistFresh(bool *_retval) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsICertBlocklist, NS_ICERTBLOCKLIST_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSICERTBLOCKLIST \
  MOZ_MUST_USE NS_IMETHOD RevokeCertByIssuerAndSerial(const nsACString & issuer, const nsACString & serialNumber) override; \
  MOZ_MUST_USE NS_IMETHOD RevokeCertBySubjectAndPubKey(const nsACString & subject, const nsACString & pubKeyHash) override; \
  MOZ_MUST_USE NS_IMETHOD SaveEntries(void) override; \
  MOZ_MUST_USE NS_IMETHOD IsCertRevoked(const uint8_t *issuer, uint32_t issuer_length, const uint8_t *serial, uint32_t serial_length, const uint8_t *subject, uint32_t subject_length, const uint8_t *pubkey, uint32_t pubkey_length, bool *_retval) override; \
  MOZ_MUST_USE NS_IMETHOD IsBlocklistFresh(bool *_retval) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSICERTBLOCKLIST \
  MOZ_MUST_USE nsresult RevokeCertByIssuerAndSerial(const nsACString & issuer, const nsACString & serialNumber); \
  MOZ_MUST_USE nsresult RevokeCertBySubjectAndPubKey(const nsACString & subject, const nsACString & pubKeyHash); \
  MOZ_MUST_USE nsresult SaveEntries(void); \
  MOZ_MUST_USE nsresult IsCertRevoked(const uint8_t *issuer, uint32_t issuer_length, const uint8_t *serial, uint32_t serial_length, const uint8_t *subject, uint32_t subject_length, const uint8_t *pubkey, uint32_t pubkey_length, bool *_retval); \
  MOZ_MUST_USE nsresult IsBlocklistFresh(bool *_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSICERTBLOCKLIST(_to) \
  MOZ_MUST_USE NS_IMETHOD RevokeCertByIssuerAndSerial(const nsACString & issuer, const nsACString & serialNumber) override { return _to RevokeCertByIssuerAndSerial(issuer, serialNumber); } \
  MOZ_MUST_USE NS_IMETHOD RevokeCertBySubjectAndPubKey(const nsACString & subject, const nsACString & pubKeyHash) override { return _to RevokeCertBySubjectAndPubKey(subject, pubKeyHash); } \
  MOZ_MUST_USE NS_IMETHOD SaveEntries(void) override { return _to SaveEntries(); } \
  MOZ_MUST_USE NS_IMETHOD IsCertRevoked(const uint8_t *issuer, uint32_t issuer_length, const uint8_t *serial, uint32_t serial_length, const uint8_t *subject, uint32_t subject_length, const uint8_t *pubkey, uint32_t pubkey_length, bool *_retval) override { return _to IsCertRevoked(issuer, issuer_length, serial, serial_length, subject, subject_length, pubkey, pubkey_length, _retval); } \
  MOZ_MUST_USE NS_IMETHOD IsBlocklistFresh(bool *_retval) override { return _to IsBlocklistFresh(_retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSICERTBLOCKLIST(_to) \
  MOZ_MUST_USE NS_IMETHOD RevokeCertByIssuerAndSerial(const nsACString & issuer, const nsACString & serialNumber) override { return !_to ? NS_ERROR_NULL_POINTER : _to->RevokeCertByIssuerAndSerial(issuer, serialNumber); } \
  MOZ_MUST_USE NS_IMETHOD RevokeCertBySubjectAndPubKey(const nsACString & subject, const nsACString & pubKeyHash) override { return !_to ? NS_ERROR_NULL_POINTER : _to->RevokeCertBySubjectAndPubKey(subject, pubKeyHash); } \
  MOZ_MUST_USE NS_IMETHOD SaveEntries(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SaveEntries(); } \
  MOZ_MUST_USE NS_IMETHOD IsCertRevoked(const uint8_t *issuer, uint32_t issuer_length, const uint8_t *serial, uint32_t serial_length, const uint8_t *subject, uint32_t subject_length, const uint8_t *pubkey, uint32_t pubkey_length, bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->IsCertRevoked(issuer, issuer_length, serial, serial_length, subject, subject_length, pubkey, pubkey_length, _retval); } \
  MOZ_MUST_USE NS_IMETHOD IsBlocklistFresh(bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->IsBlocklistFresh(_retval); } 


#endif /* __gen_nsICertBlocklist_h__ */
