/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsIDragService.idl
 */

#ifndef __gen_nsIDragService_h__
#define __gen_nsIDragService_h__


#ifndef __gen_nsIArray_h__
#include "nsIArray.h"
#endif

#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIDragSession_h__
#include "nsIDragSession.h"
#endif

#ifndef __gen_nsIScriptableRegion_h__
#include "nsIScriptableRegion.h"
#endif

#ifndef __gen_nsIContentPolicyBase_h__
#include "nsIContentPolicyBase.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIDOMNode; /* forward declaration */

class nsIDOMDragEvent; /* forward declaration */

class nsIDOMDataTransfer; /* forward declaration */

class nsISelection; /* forward declaration */

#include "mozilla/EventForwards.h"
namespace mozilla {
namespace dom {
class ContentParent;
} // namespace dom
} // namespace mozilla

/* starting interface:    nsIDragService */
#define NS_IDRAGSERVICE_IID_STR "ebd6b3a2-af16-43af-a698-3091a087dd62"

#define NS_IDRAGSERVICE_IID \
  {0xebd6b3a2, 0xaf16, 0x43af, \
    { 0xa6, 0x98, 0x30, 0x91, 0xa0, 0x87, 0xdd, 0x62 }}

class NS_NO_VTABLE nsIDragService : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IDRAGSERVICE_IID)

  enum {
    DRAGDROP_ACTION_NONE = 0,
    DRAGDROP_ACTION_COPY = 1,
    DRAGDROP_ACTION_MOVE = 2,
    DRAGDROP_ACTION_LINK = 4,
    DRAGDROP_ACTION_UNINITIALIZED = 64
  };

  /* void invokeDragSession (in nsIDOMNode aDOMNode, in nsIArray aTransferables, in nsIScriptableRegion aRegion, in unsigned long aActionType, [optional] in nsContentPolicyType aContentPolicyType); */
  NS_IMETHOD InvokeDragSession(nsIDOMNode *aDOMNode, nsIArray *aTransferables, nsIScriptableRegion *aRegion, uint32_t aActionType, nsContentPolicyType aContentPolicyType) = 0;

  /* void invokeDragSessionWithImage (in nsIDOMNode aDOMNode, in nsIArray aTransferableArray, in nsIScriptableRegion aRegion, in unsigned long aActionType, in nsIDOMNode aImage, in long aImageX, in long aImageY, in nsIDOMDragEvent aDragEvent, in nsIDOMDataTransfer aDataTransfer); */
  NS_IMETHOD InvokeDragSessionWithImage(nsIDOMNode *aDOMNode, nsIArray *aTransferableArray, nsIScriptableRegion *aRegion, uint32_t aActionType, nsIDOMNode *aImage, int32_t aImageX, int32_t aImageY, nsIDOMDragEvent *aDragEvent, nsIDOMDataTransfer *aDataTransfer) = 0;

  /* void invokeDragSessionWithSelection (in nsISelection aSelection, in nsIArray aTransferableArray, in unsigned long aActionType, in nsIDOMDragEvent aDragEvent, in nsIDOMDataTransfer aDataTransfer); */
  NS_IMETHOD InvokeDragSessionWithSelection(nsISelection *aSelection, nsIArray *aTransferableArray, uint32_t aActionType, nsIDOMDragEvent *aDragEvent, nsIDOMDataTransfer *aDataTransfer) = 0;

  /* nsIDragSession getCurrentSession (); */
  NS_IMETHOD GetCurrentSession(nsIDragSession * *_retval) = 0;

  /* void startDragSession (); */
  NS_IMETHOD StartDragSession(void) = 0;

  /* void endDragSession (in boolean aDoneDrag, [optional] in unsigned long aKeyModifiers); */
  NS_IMETHOD EndDragSession(bool aDoneDrag, uint32_t aKeyModifiers) = 0;

  /* [noscript] void fireDragEventAtSource (in EventMessage aEventMessage, in unsigned long aKeyModifiers); */
  NS_IMETHOD FireDragEventAtSource(mozilla::EventMessage aEventMessage, uint32_t aKeyModifiers) = 0;

  /* void suppress (); */
  NS_IMETHOD Suppress(void) = 0;

  /* void unsuppress (); */
  NS_IMETHOD Unsuppress(void) = 0;

  /* [noscript] void dragMoved (in long aX, in long aY); */
  NS_IMETHOD DragMoved(int32_t aX, int32_t aY) = 0;

  /* [nostdcall,notxpcom] boolean maybeAddChildProcess (in ContentParentPtr aChild); */
  virtual bool MaybeAddChildProcess(mozilla::dom::ContentParent *aChild) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIDragService, NS_IDRAGSERVICE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIDRAGSERVICE \
  NS_IMETHOD InvokeDragSession(nsIDOMNode *aDOMNode, nsIArray *aTransferables, nsIScriptableRegion *aRegion, uint32_t aActionType, nsContentPolicyType aContentPolicyType) override; \
  NS_IMETHOD InvokeDragSessionWithImage(nsIDOMNode *aDOMNode, nsIArray *aTransferableArray, nsIScriptableRegion *aRegion, uint32_t aActionType, nsIDOMNode *aImage, int32_t aImageX, int32_t aImageY, nsIDOMDragEvent *aDragEvent, nsIDOMDataTransfer *aDataTransfer) override; \
  NS_IMETHOD InvokeDragSessionWithSelection(nsISelection *aSelection, nsIArray *aTransferableArray, uint32_t aActionType, nsIDOMDragEvent *aDragEvent, nsIDOMDataTransfer *aDataTransfer) override; \
  NS_IMETHOD GetCurrentSession(nsIDragSession * *_retval) override; \
  NS_IMETHOD StartDragSession(void) override; \
  NS_IMETHOD EndDragSession(bool aDoneDrag, uint32_t aKeyModifiers) override; \
  NS_IMETHOD FireDragEventAtSource(mozilla::EventMessage aEventMessage, uint32_t aKeyModifiers) override; \
  NS_IMETHOD Suppress(void) override; \
  NS_IMETHOD Unsuppress(void) override; \
  NS_IMETHOD DragMoved(int32_t aX, int32_t aY) override; \
  virtual bool MaybeAddChildProcess(mozilla::dom::ContentParent *aChild) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIDRAGSERVICE \
  nsresult InvokeDragSession(nsIDOMNode *aDOMNode, nsIArray *aTransferables, nsIScriptableRegion *aRegion, uint32_t aActionType, nsContentPolicyType aContentPolicyType); \
  nsresult InvokeDragSessionWithImage(nsIDOMNode *aDOMNode, nsIArray *aTransferableArray, nsIScriptableRegion *aRegion, uint32_t aActionType, nsIDOMNode *aImage, int32_t aImageX, int32_t aImageY, nsIDOMDragEvent *aDragEvent, nsIDOMDataTransfer *aDataTransfer); \
  nsresult InvokeDragSessionWithSelection(nsISelection *aSelection, nsIArray *aTransferableArray, uint32_t aActionType, nsIDOMDragEvent *aDragEvent, nsIDOMDataTransfer *aDataTransfer); \
  nsresult GetCurrentSession(nsIDragSession * *_retval); \
  nsresult StartDragSession(void); \
  nsresult EndDragSession(bool aDoneDrag, uint32_t aKeyModifiers); \
  nsresult FireDragEventAtSource(mozilla::EventMessage aEventMessage, uint32_t aKeyModifiers); \
  nsresult Suppress(void); \
  nsresult Unsuppress(void); \
  nsresult DragMoved(int32_t aX, int32_t aY); \
  bool MaybeAddChildProcess(mozilla::dom::ContentParent *aChild); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIDRAGSERVICE(_to) \
  NS_IMETHOD InvokeDragSession(nsIDOMNode *aDOMNode, nsIArray *aTransferables, nsIScriptableRegion *aRegion, uint32_t aActionType, nsContentPolicyType aContentPolicyType) override { return _to InvokeDragSession(aDOMNode, aTransferables, aRegion, aActionType, aContentPolicyType); } \
  NS_IMETHOD InvokeDragSessionWithImage(nsIDOMNode *aDOMNode, nsIArray *aTransferableArray, nsIScriptableRegion *aRegion, uint32_t aActionType, nsIDOMNode *aImage, int32_t aImageX, int32_t aImageY, nsIDOMDragEvent *aDragEvent, nsIDOMDataTransfer *aDataTransfer) override { return _to InvokeDragSessionWithImage(aDOMNode, aTransferableArray, aRegion, aActionType, aImage, aImageX, aImageY, aDragEvent, aDataTransfer); } \
  NS_IMETHOD InvokeDragSessionWithSelection(nsISelection *aSelection, nsIArray *aTransferableArray, uint32_t aActionType, nsIDOMDragEvent *aDragEvent, nsIDOMDataTransfer *aDataTransfer) override { return _to InvokeDragSessionWithSelection(aSelection, aTransferableArray, aActionType, aDragEvent, aDataTransfer); } \
  NS_IMETHOD GetCurrentSession(nsIDragSession * *_retval) override { return _to GetCurrentSession(_retval); } \
  NS_IMETHOD StartDragSession(void) override { return _to StartDragSession(); } \
  NS_IMETHOD EndDragSession(bool aDoneDrag, uint32_t aKeyModifiers) override { return _to EndDragSession(aDoneDrag, aKeyModifiers); } \
  NS_IMETHOD FireDragEventAtSource(mozilla::EventMessage aEventMessage, uint32_t aKeyModifiers) override { return _to FireDragEventAtSource(aEventMessage, aKeyModifiers); } \
  NS_IMETHOD Suppress(void) override { return _to Suppress(); } \
  NS_IMETHOD Unsuppress(void) override { return _to Unsuppress(); } \
  NS_IMETHOD DragMoved(int32_t aX, int32_t aY) override { return _to DragMoved(aX, aY); } \
  virtual bool MaybeAddChildProcess(mozilla::dom::ContentParent *aChild) override { return _to MaybeAddChildProcess(aChild); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIDRAGSERVICE(_to) \
  NS_IMETHOD InvokeDragSession(nsIDOMNode *aDOMNode, nsIArray *aTransferables, nsIScriptableRegion *aRegion, uint32_t aActionType, nsContentPolicyType aContentPolicyType) override { return !_to ? NS_ERROR_NULL_POINTER : _to->InvokeDragSession(aDOMNode, aTransferables, aRegion, aActionType, aContentPolicyType); } \
  NS_IMETHOD InvokeDragSessionWithImage(nsIDOMNode *aDOMNode, nsIArray *aTransferableArray, nsIScriptableRegion *aRegion, uint32_t aActionType, nsIDOMNode *aImage, int32_t aImageX, int32_t aImageY, nsIDOMDragEvent *aDragEvent, nsIDOMDataTransfer *aDataTransfer) override { return !_to ? NS_ERROR_NULL_POINTER : _to->InvokeDragSessionWithImage(aDOMNode, aTransferableArray, aRegion, aActionType, aImage, aImageX, aImageY, aDragEvent, aDataTransfer); } \
  NS_IMETHOD InvokeDragSessionWithSelection(nsISelection *aSelection, nsIArray *aTransferableArray, uint32_t aActionType, nsIDOMDragEvent *aDragEvent, nsIDOMDataTransfer *aDataTransfer) override { return !_to ? NS_ERROR_NULL_POINTER : _to->InvokeDragSessionWithSelection(aSelection, aTransferableArray, aActionType, aDragEvent, aDataTransfer); } \
  NS_IMETHOD GetCurrentSession(nsIDragSession * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCurrentSession(_retval); } \
  NS_IMETHOD StartDragSession(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->StartDragSession(); } \
  NS_IMETHOD EndDragSession(bool aDoneDrag, uint32_t aKeyModifiers) override { return !_to ? NS_ERROR_NULL_POINTER : _to->EndDragSession(aDoneDrag, aKeyModifiers); } \
  NS_IMETHOD FireDragEventAtSource(mozilla::EventMessage aEventMessage, uint32_t aKeyModifiers) override { return !_to ? NS_ERROR_NULL_POINTER : _to->FireDragEventAtSource(aEventMessage, aKeyModifiers); } \
  NS_IMETHOD Suppress(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Suppress(); } \
  NS_IMETHOD Unsuppress(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Unsuppress(); } \
  NS_IMETHOD DragMoved(int32_t aX, int32_t aY) override { return !_to ? NS_ERROR_NULL_POINTER : _to->DragMoved(aX, aY); } \
  virtual bool MaybeAddChildProcess(mozilla::dom::ContentParent *aChild) override; 



#endif /* __gen_nsIDragService_h__ */
