/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsIFrameLoader.idl
 */

#ifndef __gen_nsIFrameLoader_h__
#define __gen_nsIFrameLoader_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#include "js/Value.h"

#include "mozilla/Assertions.h"
#include "mozilla/DebugOnly.h"

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsFrameLoader; /* forward declaration */

class nsIDocShell; /* forward declaration */

class nsIURI; /* forward declaration */

class nsIFrame; /* forward declaration */

class nsSubDocumentFrame; /* forward declaration */

class nsIMessageSender; /* forward declaration */

class nsIVariant; /* forward declaration */

class nsIDOMElement; /* forward declaration */

class nsITabParent; /* forward declaration */

class nsILoadContext; /* forward declaration */

class nsIPrintSettings; /* forward declaration */

class nsIWebProgressListener; /* forward declaration */


/* starting interface:    nsIFrameLoader */
#define NS_IFRAMELOADER_IID_STR "1645af04-1bc7-4363-8f2c-eb9679220ab1"

#define NS_IFRAMELOADER_IID \
  {0x1645af04, 0x1bc7, 0x4363, \
    { 0x8f, 0x2c, 0xeb, 0x96, 0x79, 0x22, 0x0a, 0xb1 }}

class NS_NO_VTABLE nsIFrameLoader : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IFRAMELOADER_IID)

  /* readonly attribute nsIDocShell docShell; */
  NS_IMETHOD GetDocShell(nsIDocShell * *aDocShell) = 0;

  /* readonly attribute nsITabParent tabParent; */
  NS_IMETHOD GetTabParent(nsITabParent * *aTabParent) = 0;

  /* readonly attribute nsILoadContext loadContext; */
  NS_IMETHOD GetLoadContext(nsILoadContext * *aLoadContext) = 0;

  /* void loadFrame (); */
  NS_IMETHOD LoadFrame(void) = 0;

  /* void loadURI (in nsIURI aURI); */
  NS_IMETHOD LoadURI(nsIURI *aURI) = 0;

  /* [implicit_jscontext] void addProcessChangeBlockingPromise (in jsval aPromise); */
  NS_IMETHOD AddProcessChangeBlockingPromise(JS::HandleValue aPromise, JSContext* cx) = 0;

  /* void destroy (); */
  NS_IMETHOD Destroy(void) = 0;

  /* readonly attribute boolean depthTooGreat; */
  NS_IMETHOD GetDepthTooGreat(bool *aDepthTooGreat) = 0;

  /* [noscript] void updatePositionAndSize (in nsSubDocumentFrame aIFrame); */
  NS_IMETHOD UpdatePositionAndSize(nsSubDocumentFrame *aIFrame) = 0;

  /* void activateRemoteFrame (); */
  NS_IMETHOD ActivateRemoteFrame(void) = 0;

  /* void deactivateRemoteFrame (); */
  NS_IMETHOD DeactivateRemoteFrame(void) = 0;

  /* void sendCrossProcessMouseEvent (in AString aType, in float aX, in float aY, in long aButton, in long aClickCount, in long aModifiers, [optional] in boolean aIgnoreRootScrollFrame); */
  NS_IMETHOD SendCrossProcessMouseEvent(const nsAString & aType, float aX, float aY, int32_t aButton, int32_t aClickCount, int32_t aModifiers, bool aIgnoreRootScrollFrame) = 0;

  /* void activateFrameEvent (in AString aType, in boolean capture); */
  NS_IMETHOD ActivateFrameEvent(const nsAString & aType, bool capture) = 0;

  /* readonly attribute nsIMessageSender messageManager; */
  NS_IMETHOD GetMessageManager(nsIMessageSender * *aMessageManager) = 0;

  /* void sendCrossProcessKeyEvent (in AString aType, in long aKeyCode, in long aCharCode, in long aModifiers, [optional] in boolean aPreventDefault); */
  NS_IMETHOD SendCrossProcessKeyEvent(const nsAString & aType, int32_t aKeyCode, int32_t aCharCode, int32_t aModifiers, bool aPreventDefault) = 0;

  /* void requestNotifyAfterRemotePaint (); */
  NS_IMETHOD RequestNotifyAfterRemotePaint(void) = 0;

  /* void requestFrameLoaderClose (); */
  NS_IMETHOD RequestFrameLoaderClose(void) = 0;

  /* void print (in unsigned long long aOuterWindowID, in nsIPrintSettings aPrintSettings, in nsIWebProgressListener aProgressListener); */
  NS_IMETHOD Print(uint64_t aOuterWindowID, nsIPrintSettings *aPrintSettings, nsIWebProgressListener *aProgressListener) = 0;

  enum {
    EVENT_MODE_NORMAL_DISPATCH = 0U,
    EVENT_MODE_DONT_FORWARD_TO_CHILD = 1U
  };

  /* attribute unsigned long eventMode; */
  NS_IMETHOD GetEventMode(uint32_t *aEventMode) = 0;
  NS_IMETHOD SetEventMode(uint32_t aEventMode) = 0;

  /* attribute boolean clipSubdocument; */
  NS_IMETHOD GetClipSubdocument(bool *aClipSubdocument) = 0;
  NS_IMETHOD SetClipSubdocument(bool aClipSubdocument) = 0;

  /* attribute boolean clampScrollPosition; */
  NS_IMETHOD GetClampScrollPosition(bool *aClampScrollPosition) = 0;
  NS_IMETHOD SetClampScrollPosition(bool aClampScrollPosition) = 0;

  /* readonly attribute nsIDOMElement ownerElement; */
  NS_IMETHOD GetOwnerElement(nsIDOMElement * *aOwnerElement) = 0;

  /* readonly attribute unsigned long long childID; */
  NS_IMETHOD GetChildID(uint64_t *aChildID) = 0;

  /* readonly attribute boolean ownerIsMozBrowserFrame; */
  NS_IMETHOD GetOwnerIsMozBrowserFrame(bool *aOwnerIsMozBrowserFrame) = 0;

  /* readonly attribute unsigned long lazyWidth; */
  NS_IMETHOD GetLazyWidth(uint32_t *aLazyWidth) = 0;

  /* readonly attribute unsigned long lazyHeight; */
  NS_IMETHOD GetLazyHeight(uint32_t *aLazyHeight) = 0;

  /* [infallible] readonly attribute boolean isDead; */
  NS_IMETHOD GetIsDead(bool *aIsDead) = 0;
  inline bool GetIsDead()
  {
    bool result;
    mozilla::DebugOnly<nsresult> rv = GetIsDead(&result);
    MOZ_ASSERT(NS_SUCCEEDED(rv));
    return result;
  }

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIFrameLoader, NS_IFRAMELOADER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIFRAMELOADER \
  NS_IMETHOD GetDocShell(nsIDocShell * *aDocShell) override; \
  NS_IMETHOD GetTabParent(nsITabParent * *aTabParent) override; \
  NS_IMETHOD GetLoadContext(nsILoadContext * *aLoadContext) override; \
  NS_IMETHOD LoadFrame(void) override; \
  NS_IMETHOD LoadURI(nsIURI *aURI) override; \
  NS_IMETHOD AddProcessChangeBlockingPromise(JS::HandleValue aPromise, JSContext* cx) override; \
  NS_IMETHOD Destroy(void) override; \
  NS_IMETHOD GetDepthTooGreat(bool *aDepthTooGreat) override; \
  NS_IMETHOD UpdatePositionAndSize(nsSubDocumentFrame *aIFrame) override; \
  NS_IMETHOD ActivateRemoteFrame(void) override; \
  NS_IMETHOD DeactivateRemoteFrame(void) override; \
  NS_IMETHOD SendCrossProcessMouseEvent(const nsAString & aType, float aX, float aY, int32_t aButton, int32_t aClickCount, int32_t aModifiers, bool aIgnoreRootScrollFrame) override; \
  NS_IMETHOD ActivateFrameEvent(const nsAString & aType, bool capture) override; \
  NS_IMETHOD GetMessageManager(nsIMessageSender * *aMessageManager) override; \
  NS_IMETHOD SendCrossProcessKeyEvent(const nsAString & aType, int32_t aKeyCode, int32_t aCharCode, int32_t aModifiers, bool aPreventDefault) override; \
  NS_IMETHOD RequestNotifyAfterRemotePaint(void) override; \
  NS_IMETHOD RequestFrameLoaderClose(void) override; \
  NS_IMETHOD Print(uint64_t aOuterWindowID, nsIPrintSettings *aPrintSettings, nsIWebProgressListener *aProgressListener) override; \
  NS_IMETHOD GetEventMode(uint32_t *aEventMode) override; \
  NS_IMETHOD SetEventMode(uint32_t aEventMode) override; \
  NS_IMETHOD GetClipSubdocument(bool *aClipSubdocument) override; \
  NS_IMETHOD SetClipSubdocument(bool aClipSubdocument) override; \
  NS_IMETHOD GetClampScrollPosition(bool *aClampScrollPosition) override; \
  NS_IMETHOD SetClampScrollPosition(bool aClampScrollPosition) override; \
  NS_IMETHOD GetOwnerElement(nsIDOMElement * *aOwnerElement) override; \
  NS_IMETHOD GetChildID(uint64_t *aChildID) override; \
  NS_IMETHOD GetOwnerIsMozBrowserFrame(bool *aOwnerIsMozBrowserFrame) override; \
  NS_IMETHOD GetLazyWidth(uint32_t *aLazyWidth) override; \
  NS_IMETHOD GetLazyHeight(uint32_t *aLazyHeight) override; \
  using nsIFrameLoader::GetIsDead; \
  NS_IMETHOD GetIsDead(bool *aIsDead) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIFRAMELOADER \
  nsresult GetDocShell(nsIDocShell * *aDocShell); \
  nsresult GetTabParent(nsITabParent * *aTabParent); \
  nsresult GetLoadContext(nsILoadContext * *aLoadContext); \
  nsresult LoadFrame(void); \
  nsresult LoadURI(nsIURI *aURI); \
  nsresult AddProcessChangeBlockingPromise(JS::HandleValue aPromise, JSContext* cx); \
  nsresult Destroy(void); \
  nsresult GetDepthTooGreat(bool *aDepthTooGreat); \
  nsresult UpdatePositionAndSize(nsSubDocumentFrame *aIFrame); \
  nsresult ActivateRemoteFrame(void); \
  nsresult DeactivateRemoteFrame(void); \
  nsresult SendCrossProcessMouseEvent(const nsAString & aType, float aX, float aY, int32_t aButton, int32_t aClickCount, int32_t aModifiers, bool aIgnoreRootScrollFrame); \
  nsresult ActivateFrameEvent(const nsAString & aType, bool capture); \
  nsresult GetMessageManager(nsIMessageSender * *aMessageManager); \
  nsresult SendCrossProcessKeyEvent(const nsAString & aType, int32_t aKeyCode, int32_t aCharCode, int32_t aModifiers, bool aPreventDefault); \
  nsresult RequestNotifyAfterRemotePaint(void); \
  nsresult RequestFrameLoaderClose(void); \
  nsresult Print(uint64_t aOuterWindowID, nsIPrintSettings *aPrintSettings, nsIWebProgressListener *aProgressListener); \
  nsresult GetEventMode(uint32_t *aEventMode); \
  nsresult SetEventMode(uint32_t aEventMode); \
  nsresult GetClipSubdocument(bool *aClipSubdocument); \
  nsresult SetClipSubdocument(bool aClipSubdocument); \
  nsresult GetClampScrollPosition(bool *aClampScrollPosition); \
  nsresult SetClampScrollPosition(bool aClampScrollPosition); \
  nsresult GetOwnerElement(nsIDOMElement * *aOwnerElement); \
  nsresult GetChildID(uint64_t *aChildID); \
  nsresult GetOwnerIsMozBrowserFrame(bool *aOwnerIsMozBrowserFrame); \
  nsresult GetLazyWidth(uint32_t *aLazyWidth); \
  nsresult GetLazyHeight(uint32_t *aLazyHeight); \
  using nsIFrameLoader::GetIsDead; \
  nsresult GetIsDead(bool *aIsDead); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIFRAMELOADER(_to) \
  NS_IMETHOD GetDocShell(nsIDocShell * *aDocShell) override { return _to GetDocShell(aDocShell); } \
  NS_IMETHOD GetTabParent(nsITabParent * *aTabParent) override { return _to GetTabParent(aTabParent); } \
  NS_IMETHOD GetLoadContext(nsILoadContext * *aLoadContext) override { return _to GetLoadContext(aLoadContext); } \
  NS_IMETHOD LoadFrame(void) override { return _to LoadFrame(); } \
  NS_IMETHOD LoadURI(nsIURI *aURI) override { return _to LoadURI(aURI); } \
  NS_IMETHOD AddProcessChangeBlockingPromise(JS::HandleValue aPromise, JSContext* cx) override { return _to AddProcessChangeBlockingPromise(aPromise, cx); } \
  NS_IMETHOD Destroy(void) override { return _to Destroy(); } \
  NS_IMETHOD GetDepthTooGreat(bool *aDepthTooGreat) override { return _to GetDepthTooGreat(aDepthTooGreat); } \
  NS_IMETHOD UpdatePositionAndSize(nsSubDocumentFrame *aIFrame) override { return _to UpdatePositionAndSize(aIFrame); } \
  NS_IMETHOD ActivateRemoteFrame(void) override { return _to ActivateRemoteFrame(); } \
  NS_IMETHOD DeactivateRemoteFrame(void) override { return _to DeactivateRemoteFrame(); } \
  NS_IMETHOD SendCrossProcessMouseEvent(const nsAString & aType, float aX, float aY, int32_t aButton, int32_t aClickCount, int32_t aModifiers, bool aIgnoreRootScrollFrame) override { return _to SendCrossProcessMouseEvent(aType, aX, aY, aButton, aClickCount, aModifiers, aIgnoreRootScrollFrame); } \
  NS_IMETHOD ActivateFrameEvent(const nsAString & aType, bool capture) override { return _to ActivateFrameEvent(aType, capture); } \
  NS_IMETHOD GetMessageManager(nsIMessageSender * *aMessageManager) override { return _to GetMessageManager(aMessageManager); } \
  NS_IMETHOD SendCrossProcessKeyEvent(const nsAString & aType, int32_t aKeyCode, int32_t aCharCode, int32_t aModifiers, bool aPreventDefault) override { return _to SendCrossProcessKeyEvent(aType, aKeyCode, aCharCode, aModifiers, aPreventDefault); } \
  NS_IMETHOD RequestNotifyAfterRemotePaint(void) override { return _to RequestNotifyAfterRemotePaint(); } \
  NS_IMETHOD RequestFrameLoaderClose(void) override { return _to RequestFrameLoaderClose(); } \
  NS_IMETHOD Print(uint64_t aOuterWindowID, nsIPrintSettings *aPrintSettings, nsIWebProgressListener *aProgressListener) override { return _to Print(aOuterWindowID, aPrintSettings, aProgressListener); } \
  NS_IMETHOD GetEventMode(uint32_t *aEventMode) override { return _to GetEventMode(aEventMode); } \
  NS_IMETHOD SetEventMode(uint32_t aEventMode) override { return _to SetEventMode(aEventMode); } \
  NS_IMETHOD GetClipSubdocument(bool *aClipSubdocument) override { return _to GetClipSubdocument(aClipSubdocument); } \
  NS_IMETHOD SetClipSubdocument(bool aClipSubdocument) override { return _to SetClipSubdocument(aClipSubdocument); } \
  NS_IMETHOD GetClampScrollPosition(bool *aClampScrollPosition) override { return _to GetClampScrollPosition(aClampScrollPosition); } \
  NS_IMETHOD SetClampScrollPosition(bool aClampScrollPosition) override { return _to SetClampScrollPosition(aClampScrollPosition); } \
  NS_IMETHOD GetOwnerElement(nsIDOMElement * *aOwnerElement) override { return _to GetOwnerElement(aOwnerElement); } \
  NS_IMETHOD GetChildID(uint64_t *aChildID) override { return _to GetChildID(aChildID); } \
  NS_IMETHOD GetOwnerIsMozBrowserFrame(bool *aOwnerIsMozBrowserFrame) override { return _to GetOwnerIsMozBrowserFrame(aOwnerIsMozBrowserFrame); } \
  NS_IMETHOD GetLazyWidth(uint32_t *aLazyWidth) override { return _to GetLazyWidth(aLazyWidth); } \
  NS_IMETHOD GetLazyHeight(uint32_t *aLazyHeight) override { return _to GetLazyHeight(aLazyHeight); } \
  using nsIFrameLoader::GetIsDead; \
  NS_IMETHOD GetIsDead(bool *aIsDead) override { return _to GetIsDead(aIsDead); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIFRAMELOADER(_to) \
  NS_IMETHOD GetDocShell(nsIDocShell * *aDocShell) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDocShell(aDocShell); } \
  NS_IMETHOD GetTabParent(nsITabParent * *aTabParent) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTabParent(aTabParent); } \
  NS_IMETHOD GetLoadContext(nsILoadContext * *aLoadContext) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLoadContext(aLoadContext); } \
  NS_IMETHOD LoadFrame(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->LoadFrame(); } \
  NS_IMETHOD LoadURI(nsIURI *aURI) override { return !_to ? NS_ERROR_NULL_POINTER : _to->LoadURI(aURI); } \
  NS_IMETHOD AddProcessChangeBlockingPromise(JS::HandleValue aPromise, JSContext* cx) override { return !_to ? NS_ERROR_NULL_POINTER : _to->AddProcessChangeBlockingPromise(aPromise, cx); } \
  NS_IMETHOD Destroy(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Destroy(); } \
  NS_IMETHOD GetDepthTooGreat(bool *aDepthTooGreat) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDepthTooGreat(aDepthTooGreat); } \
  NS_IMETHOD UpdatePositionAndSize(nsSubDocumentFrame *aIFrame) override { return !_to ? NS_ERROR_NULL_POINTER : _to->UpdatePositionAndSize(aIFrame); } \
  NS_IMETHOD ActivateRemoteFrame(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ActivateRemoteFrame(); } \
  NS_IMETHOD DeactivateRemoteFrame(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->DeactivateRemoteFrame(); } \
  NS_IMETHOD SendCrossProcessMouseEvent(const nsAString & aType, float aX, float aY, int32_t aButton, int32_t aClickCount, int32_t aModifiers, bool aIgnoreRootScrollFrame) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SendCrossProcessMouseEvent(aType, aX, aY, aButton, aClickCount, aModifiers, aIgnoreRootScrollFrame); } \
  NS_IMETHOD ActivateFrameEvent(const nsAString & aType, bool capture) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ActivateFrameEvent(aType, capture); } \
  NS_IMETHOD GetMessageManager(nsIMessageSender * *aMessageManager) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetMessageManager(aMessageManager); } \
  NS_IMETHOD SendCrossProcessKeyEvent(const nsAString & aType, int32_t aKeyCode, int32_t aCharCode, int32_t aModifiers, bool aPreventDefault) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SendCrossProcessKeyEvent(aType, aKeyCode, aCharCode, aModifiers, aPreventDefault); } \
  NS_IMETHOD RequestNotifyAfterRemotePaint(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->RequestNotifyAfterRemotePaint(); } \
  NS_IMETHOD RequestFrameLoaderClose(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->RequestFrameLoaderClose(); } \
  NS_IMETHOD Print(uint64_t aOuterWindowID, nsIPrintSettings *aPrintSettings, nsIWebProgressListener *aProgressListener) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Print(aOuterWindowID, aPrintSettings, aProgressListener); } \
  NS_IMETHOD GetEventMode(uint32_t *aEventMode) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetEventMode(aEventMode); } \
  NS_IMETHOD SetEventMode(uint32_t aEventMode) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetEventMode(aEventMode); } \
  NS_IMETHOD GetClipSubdocument(bool *aClipSubdocument) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetClipSubdocument(aClipSubdocument); } \
  NS_IMETHOD SetClipSubdocument(bool aClipSubdocument) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetClipSubdocument(aClipSubdocument); } \
  NS_IMETHOD GetClampScrollPosition(bool *aClampScrollPosition) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetClampScrollPosition(aClampScrollPosition); } \
  NS_IMETHOD SetClampScrollPosition(bool aClampScrollPosition) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetClampScrollPosition(aClampScrollPosition); } \
  NS_IMETHOD GetOwnerElement(nsIDOMElement * *aOwnerElement) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOwnerElement(aOwnerElement); } \
  NS_IMETHOD GetChildID(uint64_t *aChildID) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetChildID(aChildID); } \
  NS_IMETHOD GetOwnerIsMozBrowserFrame(bool *aOwnerIsMozBrowserFrame) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOwnerIsMozBrowserFrame(aOwnerIsMozBrowserFrame); } \
  NS_IMETHOD GetLazyWidth(uint32_t *aLazyWidth) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLazyWidth(aLazyWidth); } \
  NS_IMETHOD GetLazyHeight(uint32_t *aLazyHeight) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLazyHeight(aLazyHeight); } \
  NS_IMETHOD GetIsDead(bool *aIsDead) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsDead(aIsDead); } 

class nsFrameLoader;

/* starting interface:    nsIFrameLoaderOwner */
#define NS_IFRAMELOADEROWNER_IID_STR "adc1b3ba-8deb-4943-8045-e6de0044f2ce"

#define NS_IFRAMELOADEROWNER_IID \
  {0xadc1b3ba, 0x8deb, 0x4943, \
    { 0x80, 0x45, 0xe6, 0xde, 0x00, 0x44, 0xf2, 0xce }}

class NS_NO_VTABLE nsIFrameLoaderOwner : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IFRAMELOADEROWNER_IID)

  /* [binaryname(FrameLoaderXPCOM)] readonly attribute nsIFrameLoader frameLoader; */
  NS_IMETHOD GetFrameLoaderXPCOM(nsIFrameLoader * *aFrameLoader) = 0;

  /* [noscript,notxpcom] alreadyAddRefed_nsFrameLoader GetFrameLoader (); */
  NS_IMETHOD_(already_AddRefed<nsFrameLoader>) GetFrameLoader(void) = 0;

  /* [noscript,notxpcom] void internalSetFrameLoader (in nsIFrameLoader aNewFrameLoader); */
  NS_IMETHOD_(void) InternalSetFrameLoader(nsIFrameLoader *aNewFrameLoader) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIFrameLoaderOwner, NS_IFRAMELOADEROWNER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIFRAMELOADEROWNER \
  NS_IMETHOD GetFrameLoaderXPCOM(nsIFrameLoader * *aFrameLoader) override; \
  NS_IMETHOD_(already_AddRefed<nsFrameLoader>) GetFrameLoader(void) override; \
  NS_IMETHOD_(void) InternalSetFrameLoader(nsIFrameLoader *aNewFrameLoader) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIFRAMELOADEROWNER \
  nsresult GetFrameLoaderXPCOM(nsIFrameLoader * *aFrameLoader); \
  nsresult_(already_AddRefed<nsFrameLoader>) GetFrameLoader(void); \
  nsresult_(void) InternalSetFrameLoader(nsIFrameLoader *aNewFrameLoader); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIFRAMELOADEROWNER(_to) \
  NS_IMETHOD GetFrameLoaderXPCOM(nsIFrameLoader * *aFrameLoader) override { return _to GetFrameLoaderXPCOM(aFrameLoader); } \
  NS_IMETHOD_(already_AddRefed<nsFrameLoader>) GetFrameLoader(void) override { return _to GetFrameLoader(); } \
  NS_IMETHOD_(void) InternalSetFrameLoader(nsIFrameLoader *aNewFrameLoader) override { return _to InternalSetFrameLoader(aNewFrameLoader); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIFRAMELOADEROWNER(_to) \
  NS_IMETHOD GetFrameLoaderXPCOM(nsIFrameLoader * *aFrameLoader) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFrameLoaderXPCOM(aFrameLoader); } \
  NS_IMETHOD_(already_AddRefed<nsFrameLoader>) GetFrameLoader(void) override; \
  NS_IMETHOD_(void) InternalSetFrameLoader(nsIFrameLoader *aNewFrameLoader) override; 


#endif /* __gen_nsIFrameLoader_h__ */
