/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsIProfiler.idl
 */

#ifndef __gen_nsIProfiler_h__
#define __gen_nsIProfiler_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#include "js/Value.h"

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
#include "nsTArrayForwardDeclare.h"
#include "nsStringFwd.h"

/* starting interface:    nsIProfilerStartParams */
#define NS_IPROFILERSTARTPARAMS_IID_STR "0a175ba7-8fcf-4ce9-9c4b-ccc6272f4425"

#define NS_IPROFILERSTARTPARAMS_IID \
  {0x0a175ba7, 0x8fcf, 0x4ce9, \
    { 0x9c, 0x4b, 0xcc, 0xc6, 0x27, 0x2f, 0x44, 0x25 }}

class NS_NO_VTABLE nsIProfilerStartParams : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IPROFILERSTARTPARAMS_IID)

  /* readonly attribute uint32_t entries; */
  NS_IMETHOD GetEntries(uint32_t *aEntries) = 0;

  /* readonly attribute double interval; */
  NS_IMETHOD GetInterval(double *aInterval) = 0;

  /* readonly attribute uint32_t features; */
  NS_IMETHOD GetFeatures(uint32_t *aFeatures) = 0;

  /* [noscript,nostdcall,notxpcom] StringArrayRef getFilters (); */
  virtual const nsTArray<nsCString> & GetFilters(void) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIProfilerStartParams, NS_IPROFILERSTARTPARAMS_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPROFILERSTARTPARAMS \
  NS_IMETHOD GetEntries(uint32_t *aEntries) override; \
  NS_IMETHOD GetInterval(double *aInterval) override; \
  NS_IMETHOD GetFeatures(uint32_t *aFeatures) override; \
  virtual const nsTArray<nsCString> & GetFilters(void) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIPROFILERSTARTPARAMS \
  nsresult GetEntries(uint32_t *aEntries); \
  nsresult GetInterval(double *aInterval); \
  nsresult GetFeatures(uint32_t *aFeatures); \
  const nsTArray<nsCString> & GetFilters(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPROFILERSTARTPARAMS(_to) \
  NS_IMETHOD GetEntries(uint32_t *aEntries) override { return _to GetEntries(aEntries); } \
  NS_IMETHOD GetInterval(double *aInterval) override { return _to GetInterval(aInterval); } \
  NS_IMETHOD GetFeatures(uint32_t *aFeatures) override { return _to GetFeatures(aFeatures); } \
  virtual const nsTArray<nsCString> & GetFilters(void) override { return _to GetFilters(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPROFILERSTARTPARAMS(_to) \
  NS_IMETHOD GetEntries(uint32_t *aEntries) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetEntries(aEntries); } \
  NS_IMETHOD GetInterval(double *aInterval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetInterval(aInterval); } \
  NS_IMETHOD GetFeatures(uint32_t *aFeatures) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFeatures(aFeatures); } \
  virtual const nsTArray<nsCString> & GetFilters(void) override; 


/* starting interface:    nsIProfiler */
#define NS_IPROFILER_IID_STR "ead3f75c-0e0e-4fbb-901c-1e5392ef5b2a"

#define NS_IPROFILER_IID \
  {0xead3f75c, 0x0e0e, 0x4fbb, \
    { 0x90, 0x1c, 0x1e, 0x53, 0x92, 0xef, 0x5b, 0x2a }}

class NS_NO_VTABLE nsIProfiler : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IPROFILER_IID)

  /* boolean CanProfile (); */
  NS_IMETHOD CanProfile(bool *_retval) = 0;

  /* void StartProfiler (in uint32_t aEntries, in double aInterval, [array, size_is (aFeatureCount)] in string aFeatures, in uint32_t aFeatureCount, [array, size_is (aFilterCount), optional] in string aFilters, [optional] in uint32_t aFilterCount); */
  NS_IMETHOD StartProfiler(uint32_t aEntries, double aInterval, const char * *aFeatures, uint32_t aFeatureCount, const char * *aFilters, uint32_t aFilterCount) = 0;

  /* void StopProfiler (); */
  NS_IMETHOD StopProfiler(void) = 0;

  /* boolean IsPaused (); */
  NS_IMETHOD IsPaused(bool *_retval) = 0;

  /* void PauseSampling (); */
  NS_IMETHOD PauseSampling(void) = 0;

  /* void ResumeSampling (); */
  NS_IMETHOD ResumeSampling(void) = 0;

  /* void AddMarker (in string aMarker); */
  NS_IMETHOD AddMarker(const char * aMarker) = 0;

  /* string GetProfile ([optional] in double aSinceTime); */
  NS_IMETHOD GetProfile(double aSinceTime, char * *_retval) = 0;

  /* [implicit_jscontext] jsval getProfileData ([optional] in double aSinceTime); */
  NS_IMETHOD GetProfileData(double aSinceTime, JSContext* cx, JS::MutableHandleValue _retval) = 0;

  /* [implicit_jscontext] nsISupports getProfileDataAsync ([optional] in double aSinceTime); */
  NS_IMETHOD GetProfileDataAsync(double aSinceTime, JSContext* cx, nsISupports * *_retval) = 0;

  /* [implicit_jscontext] nsISupports getProfileDataAsArrayBuffer ([optional] in double aSinceTime); */
  NS_IMETHOD GetProfileDataAsArrayBuffer(double aSinceTime, JSContext* cx, nsISupports * *_retval) = 0;

  /* [implicit_jscontext] nsISupports dumpProfileToFileAsync (in ACString aFilename, [optional] in double aSinceTime); */
  NS_IMETHOD DumpProfileToFileAsync(const nsACString & aFilename, double aSinceTime, JSContext* cx, nsISupports * *_retval) = 0;

  /* boolean IsActive (); */
  NS_IMETHOD IsActive(bool *_retval) = 0;

  /* void GetFeatures (out uint32_t aCount, [array, size_is (aCount), retval] out string aFeatures); */
  NS_IMETHOD GetFeatures(uint32_t *aCount, char * **aFeatures) = 0;

  /* void GetAllFeatures (out uint32_t aCount, [array, size_is (aCount), retval] out string aFeatures); */
  NS_IMETHOD GetAllFeatures(uint32_t *aCount, char * **aFeatures) = 0;

  /* [noscript] readonly attribute nsIProfilerStartParams startParams; */
  NS_IMETHOD GetStartParams(nsIProfilerStartParams * *aStartParams) = 0;

  /* void GetBufferInfo (out uint32_t aCurrentPosition, out uint32_t aTotalSize, out uint32_t aGeneration); */
  NS_IMETHOD GetBufferInfo(uint32_t *aCurrentPosition, uint32_t *aTotalSize, uint32_t *aGeneration) = 0;

  /* double getElapsedTime (); */
  NS_IMETHOD GetElapsedTime(double *_retval) = 0;

  /* [implicit_jscontext] readonly attribute jsval sharedLibraries; */
  NS_IMETHOD GetSharedLibraries(JSContext* cx, JS::MutableHandleValue aSharedLibraries) = 0;

  /* void dumpProfileToFile (in string aFilename); */
  NS_IMETHOD DumpProfileToFile(const char * aFilename) = 0;

  /* [noscript,nostdcall,notxpcom] void receiveShutdownProfile (in nsCString aProfile); */
  virtual void ReceiveShutdownProfile(const nsCString & aProfile) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIProfiler, NS_IPROFILER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPROFILER \
  NS_IMETHOD CanProfile(bool *_retval) override; \
  NS_IMETHOD StartProfiler(uint32_t aEntries, double aInterval, const char * *aFeatures, uint32_t aFeatureCount, const char * *aFilters, uint32_t aFilterCount) override; \
  NS_IMETHOD StopProfiler(void) override; \
  NS_IMETHOD IsPaused(bool *_retval) override; \
  NS_IMETHOD PauseSampling(void) override; \
  NS_IMETHOD ResumeSampling(void) override; \
  NS_IMETHOD AddMarker(const char * aMarker) override; \
  NS_IMETHOD GetProfile(double aSinceTime, char * *_retval) override; \
  NS_IMETHOD GetProfileData(double aSinceTime, JSContext* cx, JS::MutableHandleValue _retval) override; \
  NS_IMETHOD GetProfileDataAsync(double aSinceTime, JSContext* cx, nsISupports * *_retval) override; \
  NS_IMETHOD GetProfileDataAsArrayBuffer(double aSinceTime, JSContext* cx, nsISupports * *_retval) override; \
  NS_IMETHOD DumpProfileToFileAsync(const nsACString & aFilename, double aSinceTime, JSContext* cx, nsISupports * *_retval) override; \
  NS_IMETHOD IsActive(bool *_retval) override; \
  NS_IMETHOD GetFeatures(uint32_t *aCount, char * **aFeatures) override; \
  NS_IMETHOD GetAllFeatures(uint32_t *aCount, char * **aFeatures) override; \
  NS_IMETHOD GetStartParams(nsIProfilerStartParams * *aStartParams) override; \
  NS_IMETHOD GetBufferInfo(uint32_t *aCurrentPosition, uint32_t *aTotalSize, uint32_t *aGeneration) override; \
  NS_IMETHOD GetElapsedTime(double *_retval) override; \
  NS_IMETHOD GetSharedLibraries(JSContext* cx, JS::MutableHandleValue aSharedLibraries) override; \
  NS_IMETHOD DumpProfileToFile(const char * aFilename) override; \
  virtual void ReceiveShutdownProfile(const nsCString & aProfile) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIPROFILER \
  nsresult CanProfile(bool *_retval); \
  nsresult StartProfiler(uint32_t aEntries, double aInterval, const char * *aFeatures, uint32_t aFeatureCount, const char * *aFilters, uint32_t aFilterCount); \
  nsresult StopProfiler(void); \
  nsresult IsPaused(bool *_retval); \
  nsresult PauseSampling(void); \
  nsresult ResumeSampling(void); \
  nsresult AddMarker(const char * aMarker); \
  nsresult GetProfile(double aSinceTime, char * *_retval); \
  nsresult GetProfileData(double aSinceTime, JSContext* cx, JS::MutableHandleValue _retval); \
  nsresult GetProfileDataAsync(double aSinceTime, JSContext* cx, nsISupports * *_retval); \
  nsresult GetProfileDataAsArrayBuffer(double aSinceTime, JSContext* cx, nsISupports * *_retval); \
  nsresult DumpProfileToFileAsync(const nsACString & aFilename, double aSinceTime, JSContext* cx, nsISupports * *_retval); \
  nsresult IsActive(bool *_retval); \
  nsresult GetFeatures(uint32_t *aCount, char * **aFeatures); \
  nsresult GetAllFeatures(uint32_t *aCount, char * **aFeatures); \
  nsresult GetStartParams(nsIProfilerStartParams * *aStartParams); \
  nsresult GetBufferInfo(uint32_t *aCurrentPosition, uint32_t *aTotalSize, uint32_t *aGeneration); \
  nsresult GetElapsedTime(double *_retval); \
  nsresult GetSharedLibraries(JSContext* cx, JS::MutableHandleValue aSharedLibraries); \
  nsresult DumpProfileToFile(const char * aFilename); \
  void ReceiveShutdownProfile(const nsCString & aProfile); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPROFILER(_to) \
  NS_IMETHOD CanProfile(bool *_retval) override { return _to CanProfile(_retval); } \
  NS_IMETHOD StartProfiler(uint32_t aEntries, double aInterval, const char * *aFeatures, uint32_t aFeatureCount, const char * *aFilters, uint32_t aFilterCount) override { return _to StartProfiler(aEntries, aInterval, aFeatures, aFeatureCount, aFilters, aFilterCount); } \
  NS_IMETHOD StopProfiler(void) override { return _to StopProfiler(); } \
  NS_IMETHOD IsPaused(bool *_retval) override { return _to IsPaused(_retval); } \
  NS_IMETHOD PauseSampling(void) override { return _to PauseSampling(); } \
  NS_IMETHOD ResumeSampling(void) override { return _to ResumeSampling(); } \
  NS_IMETHOD AddMarker(const char * aMarker) override { return _to AddMarker(aMarker); } \
  NS_IMETHOD GetProfile(double aSinceTime, char * *_retval) override { return _to GetProfile(aSinceTime, _retval); } \
  NS_IMETHOD GetProfileData(double aSinceTime, JSContext* cx, JS::MutableHandleValue _retval) override { return _to GetProfileData(aSinceTime, cx, _retval); } \
  NS_IMETHOD GetProfileDataAsync(double aSinceTime, JSContext* cx, nsISupports * *_retval) override { return _to GetProfileDataAsync(aSinceTime, cx, _retval); } \
  NS_IMETHOD GetProfileDataAsArrayBuffer(double aSinceTime, JSContext* cx, nsISupports * *_retval) override { return _to GetProfileDataAsArrayBuffer(aSinceTime, cx, _retval); } \
  NS_IMETHOD DumpProfileToFileAsync(const nsACString & aFilename, double aSinceTime, JSContext* cx, nsISupports * *_retval) override { return _to DumpProfileToFileAsync(aFilename, aSinceTime, cx, _retval); } \
  NS_IMETHOD IsActive(bool *_retval) override { return _to IsActive(_retval); } \
  NS_IMETHOD GetFeatures(uint32_t *aCount, char * **aFeatures) override { return _to GetFeatures(aCount, aFeatures); } \
  NS_IMETHOD GetAllFeatures(uint32_t *aCount, char * **aFeatures) override { return _to GetAllFeatures(aCount, aFeatures); } \
  NS_IMETHOD GetStartParams(nsIProfilerStartParams * *aStartParams) override { return _to GetStartParams(aStartParams); } \
  NS_IMETHOD GetBufferInfo(uint32_t *aCurrentPosition, uint32_t *aTotalSize, uint32_t *aGeneration) override { return _to GetBufferInfo(aCurrentPosition, aTotalSize, aGeneration); } \
  NS_IMETHOD GetElapsedTime(double *_retval) override { return _to GetElapsedTime(_retval); } \
  NS_IMETHOD GetSharedLibraries(JSContext* cx, JS::MutableHandleValue aSharedLibraries) override { return _to GetSharedLibraries(cx, aSharedLibraries); } \
  NS_IMETHOD DumpProfileToFile(const char * aFilename) override { return _to DumpProfileToFile(aFilename); } \
  virtual void ReceiveShutdownProfile(const nsCString & aProfile) override { return _to ReceiveShutdownProfile(aProfile); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPROFILER(_to) \
  NS_IMETHOD CanProfile(bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->CanProfile(_retval); } \
  NS_IMETHOD StartProfiler(uint32_t aEntries, double aInterval, const char * *aFeatures, uint32_t aFeatureCount, const char * *aFilters, uint32_t aFilterCount) override { return !_to ? NS_ERROR_NULL_POINTER : _to->StartProfiler(aEntries, aInterval, aFeatures, aFeatureCount, aFilters, aFilterCount); } \
  NS_IMETHOD StopProfiler(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->StopProfiler(); } \
  NS_IMETHOD IsPaused(bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->IsPaused(_retval); } \
  NS_IMETHOD PauseSampling(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->PauseSampling(); } \
  NS_IMETHOD ResumeSampling(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ResumeSampling(); } \
  NS_IMETHOD AddMarker(const char * aMarker) override { return !_to ? NS_ERROR_NULL_POINTER : _to->AddMarker(aMarker); } \
  NS_IMETHOD GetProfile(double aSinceTime, char * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetProfile(aSinceTime, _retval); } \
  NS_IMETHOD GetProfileData(double aSinceTime, JSContext* cx, JS::MutableHandleValue _retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetProfileData(aSinceTime, cx, _retval); } \
  NS_IMETHOD GetProfileDataAsync(double aSinceTime, JSContext* cx, nsISupports * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetProfileDataAsync(aSinceTime, cx, _retval); } \
  NS_IMETHOD GetProfileDataAsArrayBuffer(double aSinceTime, JSContext* cx, nsISupports * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetProfileDataAsArrayBuffer(aSinceTime, cx, _retval); } \
  NS_IMETHOD DumpProfileToFileAsync(const nsACString & aFilename, double aSinceTime, JSContext* cx, nsISupports * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->DumpProfileToFileAsync(aFilename, aSinceTime, cx, _retval); } \
  NS_IMETHOD IsActive(bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->IsActive(_retval); } \
  NS_IMETHOD GetFeatures(uint32_t *aCount, char * **aFeatures) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFeatures(aCount, aFeatures); } \
  NS_IMETHOD GetAllFeatures(uint32_t *aCount, char * **aFeatures) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAllFeatures(aCount, aFeatures); } \
  NS_IMETHOD GetStartParams(nsIProfilerStartParams * *aStartParams) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStartParams(aStartParams); } \
  NS_IMETHOD GetBufferInfo(uint32_t *aCurrentPosition, uint32_t *aTotalSize, uint32_t *aGeneration) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBufferInfo(aCurrentPosition, aTotalSize, aGeneration); } \
  NS_IMETHOD GetElapsedTime(double *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetElapsedTime(_retval); } \
  NS_IMETHOD GetSharedLibraries(JSContext* cx, JS::MutableHandleValue aSharedLibraries) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSharedLibraries(cx, aSharedLibraries); } \
  NS_IMETHOD DumpProfileToFile(const char * aFilename) override { return !_to ? NS_ERROR_NULL_POINTER : _to->DumpProfileToFile(aFilename); } \
  virtual void ReceiveShutdownProfile(const nsCString & aProfile) override; 


#endif /* __gen_nsIProfiler_h__ */
