/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsISSLStatus.idl
 */

#ifndef __gen_nsISSLStatus_h__
#define __gen_nsISSLStatus_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIX509Cert; /* forward declaration */

class nsIX509CertList; /* forward declaration */


/* starting interface:    nsISSLStatus */
#define NS_ISSLSTATUS_IID_STR "fa9ba95b-ca3b-498a-b889-7c79cf28fee8"

#define NS_ISSLSTATUS_IID \
  {0xfa9ba95b, 0xca3b, 0x498a, \
    { 0xb8, 0x89, 0x7c, 0x79, 0xcf, 0x28, 0xfe, 0xe8 }}

class NS_NO_VTABLE nsISSLStatus : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ISSLSTATUS_IID)

  /* readonly attribute nsIX509Cert serverCert; */
  NS_IMETHOD GetServerCert(nsIX509Cert * *aServerCert) = 0;

  /* readonly attribute nsIX509CertList failedCertChain; */
  NS_IMETHOD GetFailedCertChain(nsIX509CertList * *aFailedCertChain) = 0;

  /* readonly attribute nsIX509CertList succeededCertChain; */
  NS_IMETHOD GetSucceededCertChain(nsIX509CertList * *aSucceededCertChain) = 0;

  /* [must_use] readonly attribute ACString cipherName; */
  MOZ_MUST_USE NS_IMETHOD GetCipherName(nsACString & aCipherName) = 0;

  /* [must_use] readonly attribute unsigned long keyLength; */
  MOZ_MUST_USE NS_IMETHOD GetKeyLength(uint32_t *aKeyLength) = 0;

  /* [must_use] readonly attribute unsigned long secretKeyLength; */
  MOZ_MUST_USE NS_IMETHOD GetSecretKeyLength(uint32_t *aSecretKeyLength) = 0;

  /* [must_use] readonly attribute ACString keaGroupName; */
  MOZ_MUST_USE NS_IMETHOD GetKeaGroupName(nsACString & aKeaGroupName) = 0;

  /* [must_use] readonly attribute ACString signatureSchemeName; */
  MOZ_MUST_USE NS_IMETHOD GetSignatureSchemeName(nsACString & aSignatureSchemeName) = 0;

  enum {
    SSL_VERSION_3 = 0,
    TLS_VERSION_1 = 1,
    TLS_VERSION_1_1 = 2,
    TLS_VERSION_1_2 = 3,
    TLS_VERSION_1_3 = 4
  };

  /* [must_use] readonly attribute unsigned short protocolVersion; */
  MOZ_MUST_USE NS_IMETHOD GetProtocolVersion(uint16_t *aProtocolVersion) = 0;

  enum {
    CERTIFICATE_TRANSPARENCY_NOT_APPLICABLE = 0,
    CERTIFICATE_TRANSPARENCY_POLICY_COMPLIANT = 5,
    CERTIFICATE_TRANSPARENCY_POLICY_NOT_ENOUGH_SCTS = 6,
    CERTIFICATE_TRANSPARENCY_POLICY_NOT_DIVERSE_SCTS = 7
  };

  /* [must_use] readonly attribute unsigned short certificateTransparencyStatus; */
  MOZ_MUST_USE NS_IMETHOD GetCertificateTransparencyStatus(uint16_t *aCertificateTransparencyStatus) = 0;

  /* [must_use] readonly attribute boolean isDomainMismatch; */
  MOZ_MUST_USE NS_IMETHOD GetIsDomainMismatch(bool *aIsDomainMismatch) = 0;

  /* [must_use] readonly attribute boolean isNotValidAtThisTime; */
  MOZ_MUST_USE NS_IMETHOD GetIsNotValidAtThisTime(bool *aIsNotValidAtThisTime) = 0;

  /* [must_use] readonly attribute boolean isUntrusted; */
  MOZ_MUST_USE NS_IMETHOD GetIsUntrusted(bool *aIsUntrusted) = 0;

  /* [must_use] readonly attribute boolean isExtendedValidation; */
  MOZ_MUST_USE NS_IMETHOD GetIsExtendedValidation(bool *aIsExtendedValidation) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsISSLStatus, NS_ISSLSTATUS_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISSLSTATUS \
  NS_IMETHOD GetServerCert(nsIX509Cert * *aServerCert) override; \
  NS_IMETHOD GetFailedCertChain(nsIX509CertList * *aFailedCertChain) override; \
  NS_IMETHOD GetSucceededCertChain(nsIX509CertList * *aSucceededCertChain) override; \
  MOZ_MUST_USE NS_IMETHOD GetCipherName(nsACString & aCipherName) override; \
  MOZ_MUST_USE NS_IMETHOD GetKeyLength(uint32_t *aKeyLength) override; \
  MOZ_MUST_USE NS_IMETHOD GetSecretKeyLength(uint32_t *aSecretKeyLength) override; \
  MOZ_MUST_USE NS_IMETHOD GetKeaGroupName(nsACString & aKeaGroupName) override; \
  MOZ_MUST_USE NS_IMETHOD GetSignatureSchemeName(nsACString & aSignatureSchemeName) override; \
  MOZ_MUST_USE NS_IMETHOD GetProtocolVersion(uint16_t *aProtocolVersion) override; \
  MOZ_MUST_USE NS_IMETHOD GetCertificateTransparencyStatus(uint16_t *aCertificateTransparencyStatus) override; \
  MOZ_MUST_USE NS_IMETHOD GetIsDomainMismatch(bool *aIsDomainMismatch) override; \
  MOZ_MUST_USE NS_IMETHOD GetIsNotValidAtThisTime(bool *aIsNotValidAtThisTime) override; \
  MOZ_MUST_USE NS_IMETHOD GetIsUntrusted(bool *aIsUntrusted) override; \
  MOZ_MUST_USE NS_IMETHOD GetIsExtendedValidation(bool *aIsExtendedValidation) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSISSLSTATUS \
  nsresult GetServerCert(nsIX509Cert * *aServerCert); \
  nsresult GetFailedCertChain(nsIX509CertList * *aFailedCertChain); \
  nsresult GetSucceededCertChain(nsIX509CertList * *aSucceededCertChain); \
  MOZ_MUST_USE nsresult GetCipherName(nsACString & aCipherName); \
  MOZ_MUST_USE nsresult GetKeyLength(uint32_t *aKeyLength); \
  MOZ_MUST_USE nsresult GetSecretKeyLength(uint32_t *aSecretKeyLength); \
  MOZ_MUST_USE nsresult GetKeaGroupName(nsACString & aKeaGroupName); \
  MOZ_MUST_USE nsresult GetSignatureSchemeName(nsACString & aSignatureSchemeName); \
  MOZ_MUST_USE nsresult GetProtocolVersion(uint16_t *aProtocolVersion); \
  MOZ_MUST_USE nsresult GetCertificateTransparencyStatus(uint16_t *aCertificateTransparencyStatus); \
  MOZ_MUST_USE nsresult GetIsDomainMismatch(bool *aIsDomainMismatch); \
  MOZ_MUST_USE nsresult GetIsNotValidAtThisTime(bool *aIsNotValidAtThisTime); \
  MOZ_MUST_USE nsresult GetIsUntrusted(bool *aIsUntrusted); \
  MOZ_MUST_USE nsresult GetIsExtendedValidation(bool *aIsExtendedValidation); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISSLSTATUS(_to) \
  NS_IMETHOD GetServerCert(nsIX509Cert * *aServerCert) override { return _to GetServerCert(aServerCert); } \
  NS_IMETHOD GetFailedCertChain(nsIX509CertList * *aFailedCertChain) override { return _to GetFailedCertChain(aFailedCertChain); } \
  NS_IMETHOD GetSucceededCertChain(nsIX509CertList * *aSucceededCertChain) override { return _to GetSucceededCertChain(aSucceededCertChain); } \
  MOZ_MUST_USE NS_IMETHOD GetCipherName(nsACString & aCipherName) override { return _to GetCipherName(aCipherName); } \
  MOZ_MUST_USE NS_IMETHOD GetKeyLength(uint32_t *aKeyLength) override { return _to GetKeyLength(aKeyLength); } \
  MOZ_MUST_USE NS_IMETHOD GetSecretKeyLength(uint32_t *aSecretKeyLength) override { return _to GetSecretKeyLength(aSecretKeyLength); } \
  MOZ_MUST_USE NS_IMETHOD GetKeaGroupName(nsACString & aKeaGroupName) override { return _to GetKeaGroupName(aKeaGroupName); } \
  MOZ_MUST_USE NS_IMETHOD GetSignatureSchemeName(nsACString & aSignatureSchemeName) override { return _to GetSignatureSchemeName(aSignatureSchemeName); } \
  MOZ_MUST_USE NS_IMETHOD GetProtocolVersion(uint16_t *aProtocolVersion) override { return _to GetProtocolVersion(aProtocolVersion); } \
  MOZ_MUST_USE NS_IMETHOD GetCertificateTransparencyStatus(uint16_t *aCertificateTransparencyStatus) override { return _to GetCertificateTransparencyStatus(aCertificateTransparencyStatus); } \
  MOZ_MUST_USE NS_IMETHOD GetIsDomainMismatch(bool *aIsDomainMismatch) override { return _to GetIsDomainMismatch(aIsDomainMismatch); } \
  MOZ_MUST_USE NS_IMETHOD GetIsNotValidAtThisTime(bool *aIsNotValidAtThisTime) override { return _to GetIsNotValidAtThisTime(aIsNotValidAtThisTime); } \
  MOZ_MUST_USE NS_IMETHOD GetIsUntrusted(bool *aIsUntrusted) override { return _to GetIsUntrusted(aIsUntrusted); } \
  MOZ_MUST_USE NS_IMETHOD GetIsExtendedValidation(bool *aIsExtendedValidation) override { return _to GetIsExtendedValidation(aIsExtendedValidation); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSISSLSTATUS(_to) \
  NS_IMETHOD GetServerCert(nsIX509Cert * *aServerCert) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetServerCert(aServerCert); } \
  NS_IMETHOD GetFailedCertChain(nsIX509CertList * *aFailedCertChain) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFailedCertChain(aFailedCertChain); } \
  NS_IMETHOD GetSucceededCertChain(nsIX509CertList * *aSucceededCertChain) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSucceededCertChain(aSucceededCertChain); } \
  MOZ_MUST_USE NS_IMETHOD GetCipherName(nsACString & aCipherName) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCipherName(aCipherName); } \
  MOZ_MUST_USE NS_IMETHOD GetKeyLength(uint32_t *aKeyLength) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetKeyLength(aKeyLength); } \
  MOZ_MUST_USE NS_IMETHOD GetSecretKeyLength(uint32_t *aSecretKeyLength) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSecretKeyLength(aSecretKeyLength); } \
  MOZ_MUST_USE NS_IMETHOD GetKeaGroupName(nsACString & aKeaGroupName) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetKeaGroupName(aKeaGroupName); } \
  MOZ_MUST_USE NS_IMETHOD GetSignatureSchemeName(nsACString & aSignatureSchemeName) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSignatureSchemeName(aSignatureSchemeName); } \
  MOZ_MUST_USE NS_IMETHOD GetProtocolVersion(uint16_t *aProtocolVersion) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetProtocolVersion(aProtocolVersion); } \
  MOZ_MUST_USE NS_IMETHOD GetCertificateTransparencyStatus(uint16_t *aCertificateTransparencyStatus) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCertificateTransparencyStatus(aCertificateTransparencyStatus); } \
  MOZ_MUST_USE NS_IMETHOD GetIsDomainMismatch(bool *aIsDomainMismatch) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsDomainMismatch(aIsDomainMismatch); } \
  MOZ_MUST_USE NS_IMETHOD GetIsNotValidAtThisTime(bool *aIsNotValidAtThisTime) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsNotValidAtThisTime(aIsNotValidAtThisTime); } \
  MOZ_MUST_USE NS_IMETHOD GetIsUntrusted(bool *aIsUntrusted) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsUntrusted(aIsUntrusted); } \
  MOZ_MUST_USE NS_IMETHOD GetIsExtendedValidation(bool *aIsExtendedValidation) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsExtendedValidation(aIsExtendedValidation); } 


#endif /* __gen_nsISSLStatus_h__ */
