/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsISelection.idl
 */

#ifndef __gen_nsISelection_h__
#define __gen_nsISelection_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIDOMNode; /* forward declaration */

class nsIDOMRange; /* forward declaration */

class nsINode; /* forward declaration */

namespace mozilla {
namespace dom {
class Selection;
} // namespace dom
} // namespace mozilla

/* starting interface:    nsISelection */
#define NS_ISELECTION_IID_STR "e0a4d4b3-f34e-44bd-b1f2-4e3bde9b6915"

#define NS_ISELECTION_IID \
  {0xe0a4d4b3, 0xf34e, 0x44bd, \
    { 0xb1, 0xf2, 0x4e, 0x3b, 0xde, 0x9b, 0x69, 0x15 }}

class nsISelection : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ISELECTION_IID)

  /* readonly attribute nsIDOMNode anchorNode; */
  NS_IMETHOD GetAnchorNode(nsIDOMNode * *aAnchorNode) = 0;

  /* readonly attribute long anchorOffset; */
  NS_IMETHOD GetAnchorOffset(int32_t *aAnchorOffset) = 0;

  /* readonly attribute nsIDOMNode focusNode; */
  NS_IMETHOD GetFocusNode(nsIDOMNode * *aFocusNode) = 0;

  /* readonly attribute long focusOffset; */
  NS_IMETHOD GetFocusOffset(int32_t *aFocusOffset) = 0;

  /* readonly attribute boolean isCollapsed; */
  NS_IMETHOD GetIsCollapsed(bool *aIsCollapsed) = 0;

  /* [noscript,nostdcall,notxpcom] boolean collapsed (); */
  virtual bool Collapsed(void) = 0;

  /* readonly attribute long rangeCount; */
  NS_IMETHOD GetRangeCount(int32_t *aRangeCount) = 0;

  /* nsIDOMRange getRangeAt (in long index); */
  NS_IMETHOD GetRangeAt(int32_t index, nsIDOMRange * *_retval) = 0;

  /* void collapse (in nsIDOMNode parentNode, in long offset); */
  NS_IMETHOD Collapse(nsIDOMNode *parentNode, int32_t offset) = 0;

  /* [noscript] void collapseNative (in nsINode parentNode, in long offset); */
  NS_IMETHOD CollapseNative(nsINode *parentNode, int32_t offset) = 0;

  /* void extend (in nsIDOMNode parentNode, in long offset); */
  NS_IMETHOD Extend(nsIDOMNode *parentNode, int32_t offset) = 0;

  /* [noscript] void extendNative (in nsINode parentNode, in long offset); */
  NS_IMETHOD ExtendNative(nsINode *parentNode, int32_t offset) = 0;

  /* void collapseToStart (); */
  NS_IMETHOD CollapseToStart(void) = 0;

  /* void collapseToEnd (); */
  NS_IMETHOD CollapseToEnd(void) = 0;

  /* boolean containsNode (in nsIDOMNode node, in boolean partlyContained); */
  NS_IMETHOD ContainsNode(nsIDOMNode *node, bool partlyContained, bool *_retval) = 0;

  /* void selectAllChildren (in nsIDOMNode parentNode); */
  NS_IMETHOD SelectAllChildren(nsIDOMNode *parentNode) = 0;

  /* void addRange (in nsIDOMRange range); */
  NS_IMETHOD AddRange(nsIDOMRange *range) = 0;

  /* void removeRange (in nsIDOMRange range); */
  NS_IMETHOD RemoveRange(nsIDOMRange *range) = 0;

  /* void removeAllRanges (); */
  NS_IMETHOD RemoveAllRanges(void) = 0;

  /* void deleteFromDocument (); */
  NS_IMETHOD DeleteFromDocument(void) = 0;

  /* DOMString toString (); */
  NS_IMETHOD ToString(nsAString & _retval) = 0;

  /* void modify (in DOMString alter, in DOMString direction, in DOMString granularity); */
  NS_IMETHOD Modify(const nsAString & alter, const nsAString & direction, const nsAString & granularity) = 0;

     /**
     * AsSelection() returns a pointer to Selection class.
     *
     * In order to avoid circular dependency issues, this method is defined
     * in mozilla/dom/Selection.h.  Consumers need to #include that header.
     */
    inline mozilla::dom::Selection* AsSelection();
};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsISelection, NS_ISELECTION_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISELECTION \
  NS_IMETHOD GetAnchorNode(nsIDOMNode * *aAnchorNode) override; \
  NS_IMETHOD GetAnchorOffset(int32_t *aAnchorOffset) override; \
  NS_IMETHOD GetFocusNode(nsIDOMNode * *aFocusNode) override; \
  NS_IMETHOD GetFocusOffset(int32_t *aFocusOffset) override; \
  NS_IMETHOD GetIsCollapsed(bool *aIsCollapsed) override; \
  virtual bool Collapsed(void) override; \
  NS_IMETHOD GetRangeCount(int32_t *aRangeCount) override; \
  NS_IMETHOD GetRangeAt(int32_t index, nsIDOMRange * *_retval) override; \
  NS_IMETHOD Collapse(nsIDOMNode *parentNode, int32_t offset) override; \
  NS_IMETHOD CollapseNative(nsINode *parentNode, int32_t offset) override; \
  NS_IMETHOD Extend(nsIDOMNode *parentNode, int32_t offset) override; \
  NS_IMETHOD ExtendNative(nsINode *parentNode, int32_t offset) override; \
  NS_IMETHOD CollapseToStart(void) override; \
  NS_IMETHOD CollapseToEnd(void) override; \
  NS_IMETHOD ContainsNode(nsIDOMNode *node, bool partlyContained, bool *_retval) override; \
  NS_IMETHOD SelectAllChildren(nsIDOMNode *parentNode) override; \
  NS_IMETHOD AddRange(nsIDOMRange *range) override; \
  NS_IMETHOD RemoveRange(nsIDOMRange *range) override; \
  NS_IMETHOD RemoveAllRanges(void) override; \
  NS_IMETHOD DeleteFromDocument(void) override; \
  NS_IMETHOD ToString(nsAString & _retval) override; \
  NS_IMETHOD Modify(const nsAString & alter, const nsAString & direction, const nsAString & granularity) override; \

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSISELECTION \
  nsresult GetAnchorNode(nsIDOMNode * *aAnchorNode); \
  nsresult GetAnchorOffset(int32_t *aAnchorOffset); \
  nsresult GetFocusNode(nsIDOMNode * *aFocusNode); \
  nsresult GetFocusOffset(int32_t *aFocusOffset); \
  nsresult GetIsCollapsed(bool *aIsCollapsed); \
  bool Collapsed(void); \
  nsresult GetRangeCount(int32_t *aRangeCount); \
  nsresult GetRangeAt(int32_t index, nsIDOMRange * *_retval); \
  nsresult Collapse(nsIDOMNode *parentNode, int32_t offset); \
  nsresult CollapseNative(nsINode *parentNode, int32_t offset); \
  nsresult Extend(nsIDOMNode *parentNode, int32_t offset); \
  nsresult ExtendNative(nsINode *parentNode, int32_t offset); \
  nsresult CollapseToStart(void); \
  nsresult CollapseToEnd(void); \
  nsresult ContainsNode(nsIDOMNode *node, bool partlyContained, bool *_retval); \
  nsresult SelectAllChildren(nsIDOMNode *parentNode); \
  nsresult AddRange(nsIDOMRange *range); \
  nsresult RemoveRange(nsIDOMRange *range); \
  nsresult RemoveAllRanges(void); \
  nsresult DeleteFromDocument(void); \
  nsresult ToString(nsAString & _retval); \
  nsresult Modify(const nsAString & alter, const nsAString & direction, const nsAString & granularity); \

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISELECTION(_to) \
  NS_IMETHOD GetAnchorNode(nsIDOMNode * *aAnchorNode) override { return _to GetAnchorNode(aAnchorNode); } \
  NS_IMETHOD GetAnchorOffset(int32_t *aAnchorOffset) override { return _to GetAnchorOffset(aAnchorOffset); } \
  NS_IMETHOD GetFocusNode(nsIDOMNode * *aFocusNode) override { return _to GetFocusNode(aFocusNode); } \
  NS_IMETHOD GetFocusOffset(int32_t *aFocusOffset) override { return _to GetFocusOffset(aFocusOffset); } \
  NS_IMETHOD GetIsCollapsed(bool *aIsCollapsed) override { return _to GetIsCollapsed(aIsCollapsed); } \
  virtual bool Collapsed(void) override { return _to Collapsed(); } \
  NS_IMETHOD GetRangeCount(int32_t *aRangeCount) override { return _to GetRangeCount(aRangeCount); } \
  NS_IMETHOD GetRangeAt(int32_t index, nsIDOMRange * *_retval) override { return _to GetRangeAt(index, _retval); } \
  NS_IMETHOD Collapse(nsIDOMNode *parentNode, int32_t offset) override { return _to Collapse(parentNode, offset); } \
  NS_IMETHOD CollapseNative(nsINode *parentNode, int32_t offset) override { return _to CollapseNative(parentNode, offset); } \
  NS_IMETHOD Extend(nsIDOMNode *parentNode, int32_t offset) override { return _to Extend(parentNode, offset); } \
  NS_IMETHOD ExtendNative(nsINode *parentNode, int32_t offset) override { return _to ExtendNative(parentNode, offset); } \
  NS_IMETHOD CollapseToStart(void) override { return _to CollapseToStart(); } \
  NS_IMETHOD CollapseToEnd(void) override { return _to CollapseToEnd(); } \
  NS_IMETHOD ContainsNode(nsIDOMNode *node, bool partlyContained, bool *_retval) override { return _to ContainsNode(node, partlyContained, _retval); } \
  NS_IMETHOD SelectAllChildren(nsIDOMNode *parentNode) override { return _to SelectAllChildren(parentNode); } \
  NS_IMETHOD AddRange(nsIDOMRange *range) override { return _to AddRange(range); } \
  NS_IMETHOD RemoveRange(nsIDOMRange *range) override { return _to RemoveRange(range); } \
  NS_IMETHOD RemoveAllRanges(void) override { return _to RemoveAllRanges(); } \
  NS_IMETHOD DeleteFromDocument(void) override { return _to DeleteFromDocument(); } \
  NS_IMETHOD ToString(nsAString & _retval) override { return _to ToString(_retval); } \
  NS_IMETHOD Modify(const nsAString & alter, const nsAString & direction, const nsAString & granularity) override { return _to Modify(alter, direction, granularity); } \

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSISELECTION(_to) \
  NS_IMETHOD GetAnchorNode(nsIDOMNode * *aAnchorNode) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAnchorNode(aAnchorNode); } \
  NS_IMETHOD GetAnchorOffset(int32_t *aAnchorOffset) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAnchorOffset(aAnchorOffset); } \
  NS_IMETHOD GetFocusNode(nsIDOMNode * *aFocusNode) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFocusNode(aFocusNode); } \
  NS_IMETHOD GetFocusOffset(int32_t *aFocusOffset) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFocusOffset(aFocusOffset); } \
  NS_IMETHOD GetIsCollapsed(bool *aIsCollapsed) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsCollapsed(aIsCollapsed); } \
  virtual bool Collapsed(void) override; \
  NS_IMETHOD GetRangeCount(int32_t *aRangeCount) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRangeCount(aRangeCount); } \
  NS_IMETHOD GetRangeAt(int32_t index, nsIDOMRange * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRangeAt(index, _retval); } \
  NS_IMETHOD Collapse(nsIDOMNode *parentNode, int32_t offset) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Collapse(parentNode, offset); } \
  NS_IMETHOD CollapseNative(nsINode *parentNode, int32_t offset) override { return !_to ? NS_ERROR_NULL_POINTER : _to->CollapseNative(parentNode, offset); } \
  NS_IMETHOD Extend(nsIDOMNode *parentNode, int32_t offset) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Extend(parentNode, offset); } \
  NS_IMETHOD ExtendNative(nsINode *parentNode, int32_t offset) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ExtendNative(parentNode, offset); } \
  NS_IMETHOD CollapseToStart(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->CollapseToStart(); } \
  NS_IMETHOD CollapseToEnd(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->CollapseToEnd(); } \
  NS_IMETHOD ContainsNode(nsIDOMNode *node, bool partlyContained, bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ContainsNode(node, partlyContained, _retval); } \
  NS_IMETHOD SelectAllChildren(nsIDOMNode *parentNode) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SelectAllChildren(parentNode); } \
  NS_IMETHOD AddRange(nsIDOMRange *range) override { return !_to ? NS_ERROR_NULL_POINTER : _to->AddRange(range); } \
  NS_IMETHOD RemoveRange(nsIDOMRange *range) override { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveRange(range); } \
  NS_IMETHOD RemoveAllRanges(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveAllRanges(); } \
  NS_IMETHOD DeleteFromDocument(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->DeleteFromDocument(); } \
  NS_IMETHOD ToString(nsAString & _retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ToString(_retval); } \
  NS_IMETHOD Modify(const nsAString & alter, const nsAString & direction, const nsAString & granularity) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Modify(alter, direction, granularity); } \


#endif /* __gen_nsISelection_h__ */
