/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsITransferable.idl
 */

#ifndef __gen_nsITransferable_h__
#define __gen_nsITransferable_h__


#ifndef __gen_nsIArray_h__
#include "nsIArray.h"
#endif

#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIFormatConverter_h__
#include "nsIFormatConverter.h"
#endif

#ifndef __gen_nsIContentPolicyBase_h__
#include "nsIContentPolicyBase.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIPrincipal; /* forward declaration */


// these probably shouldn't live here, but in some central repository shared
// by the entire app.
#define kTextMime                   "text/plain"
#define kRTFMime                    "text/rtf"
#define kUnicodeMime                "text/unicode"
#define kMozTextInternal          "text/x-moz-text-internal"  // text data which isn't suppoed to be parsed by other apps.
#define kHTMLMime                   "text/html"
#define kAOLMailMime                "AOLMAIL"
#define kPNGImageMime               "image/png"
#define kJPEGImageMime              "image/jpeg"
#define kJPGImageMime               "image/jpg"
#define kGIFImageMime               "image/gif"
#define kFileMime                   "application/x-moz-file"
#define kURLMime                    "text/x-moz-url"        // data contains url\ntitle
#define kURLDataMime                "text/x-moz-url-data"   // data contains url only
#define kURLDescriptionMime         "text/x-moz-url-desc"   // data contains description
#define kURLPrivateMime             "text/x-moz-url-priv"   // same as kURLDataMime but for private uses
#define kNativeImageMime            "application/x-moz-nativeimage"
#define kNativeHTMLMime             "application/x-moz-nativehtml"
// These are used to indicate the context for a fragment of HTML source, such
// that some parent structure and style can be preserved. kHTMLContext
// contains the serialized ancestor elements, whereas kHTMLInfo are numbers
// identifying where in the context the fragment was from.
#define kHTMLContext   "text/_moz_htmlcontext"
#define kHTMLInfo      "text/_moz_htmlinfo"
// the source URL for a file promise
#define kFilePromiseURLMime         "application/x-moz-file-promise-url"
// the destination filename for a file promise
#define kFilePromiseDestFilename    "application/x-moz-file-promise-dest-filename"
// a dataless flavor used to interact with the OS during file drags
#define kFilePromiseMime            "application/x-moz-file-promise"
// a synthetic flavor, put into the transferable once we know the destination directory of a file drag
#define kFilePromiseDirectoryMime   "application/x-moz-file-promise-dir"
#define kCustomTypesMime "application/x-moz-custom-clipdata"
class nsITransferable; /* forward declaration */

class nsILoadContext; /* forward declaration */


/* starting interface:    nsIFlavorDataProvider */
#define NS_IFLAVORDATAPROVIDER_IID_STR "7e225e5f-711c-11d7-9fae-000393636592"

#define NS_IFLAVORDATAPROVIDER_IID \
  {0x7e225e5f, 0x711c, 0x11d7, \
    { 0x9f, 0xae, 0x00, 0x03, 0x93, 0x63, 0x65, 0x92 }}

class NS_NO_VTABLE nsIFlavorDataProvider : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IFLAVORDATAPROVIDER_IID)

  /* void getFlavorData (in nsITransferable aTransferable, in string aFlavor, out nsISupports aData, out unsigned long aDataLen); */
  NS_IMETHOD GetFlavorData(nsITransferable *aTransferable, const char * aFlavor, nsISupports * *aData, uint32_t *aDataLen) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIFlavorDataProvider, NS_IFLAVORDATAPROVIDER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIFLAVORDATAPROVIDER \
  NS_IMETHOD GetFlavorData(nsITransferable *aTransferable, const char * aFlavor, nsISupports * *aData, uint32_t *aDataLen) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIFLAVORDATAPROVIDER \
  nsresult GetFlavorData(nsITransferable *aTransferable, const char * aFlavor, nsISupports * *aData, uint32_t *aDataLen); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIFLAVORDATAPROVIDER(_to) \
  NS_IMETHOD GetFlavorData(nsITransferable *aTransferable, const char * aFlavor, nsISupports * *aData, uint32_t *aDataLen) override { return _to GetFlavorData(aTransferable, aFlavor, aData, aDataLen); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIFLAVORDATAPROVIDER(_to) \
  NS_IMETHOD GetFlavorData(nsITransferable *aTransferable, const char * aFlavor, nsISupports * *aData, uint32_t *aDataLen) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFlavorData(aTransferable, aFlavor, aData, aDataLen); } 


/* starting interface:    nsITransferable */
#define NS_ITRANSFERABLE_IID_STR "97e0c418-1c1e-4106-bad1-9fcb11dff2fe"

#define NS_ITRANSFERABLE_IID \
  {0x97e0c418, 0x1c1e, 0x4106, \
    { 0xba, 0xd1, 0x9f, 0xcb, 0x11, 0xdf, 0xf2, 0xfe }}

class NS_NO_VTABLE nsITransferable : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ITRANSFERABLE_IID)

  enum {
    kFlavorHasDataProvider = 0
  };

  /* void init (in nsILoadContext aContext); */
  NS_IMETHOD Init(nsILoadContext *aContext) = 0;

  /* nsIArray flavorsTransferableCanExport (); */
  NS_IMETHOD FlavorsTransferableCanExport(nsIArray * *_retval) = 0;

  /* void getTransferData (in string aFlavor, out nsISupports aData, out unsigned long aDataLen); */
  NS_IMETHOD GetTransferData(const char * aFlavor, nsISupports * *aData, uint32_t *aDataLen) = 0;

  /* void getAnyTransferData (out ACString aFlavor, out nsISupports aData, out unsigned long aDataLen); */
  NS_IMETHOD GetAnyTransferData(nsACString & aFlavor, nsISupports * *aData, uint32_t *aDataLen) = 0;

  /* boolean isLargeDataSet (); */
  NS_IMETHOD IsLargeDataSet(bool *_retval) = 0;

  /* nsIArray flavorsTransferableCanImport (); */
  NS_IMETHOD FlavorsTransferableCanImport(nsIArray * *_retval) = 0;

  /* void setTransferData (in string aFlavor, in nsISupports aData, in unsigned long aDataLen); */
  NS_IMETHOD SetTransferData(const char * aFlavor, nsISupports *aData, uint32_t aDataLen) = 0;

  /* void addDataFlavor (in string aDataFlavor); */
  NS_IMETHOD AddDataFlavor(const char * aDataFlavor) = 0;

  /* void removeDataFlavor (in string aDataFlavor); */
  NS_IMETHOD RemoveDataFlavor(const char * aDataFlavor) = 0;

  /* attribute nsIFormatConverter converter; */
  NS_IMETHOD GetConverter(nsIFormatConverter * *aConverter) = 0;
  NS_IMETHOD SetConverter(nsIFormatConverter *aConverter) = 0;

  /* [noscript] attribute boolean isPrivateData; */
  NS_IMETHOD GetIsPrivateData(bool *aIsPrivateData) = 0;
  NS_IMETHOD SetIsPrivateData(bool aIsPrivateData) = 0;

  /* [noscript] attribute nsIPrincipal requestingPrincipal; */
  NS_IMETHOD GetRequestingPrincipal(nsIPrincipal * *aRequestingPrincipal) = 0;
  NS_IMETHOD SetRequestingPrincipal(nsIPrincipal *aRequestingPrincipal) = 0;

  /* [noscript] attribute nsContentPolicyType contentPolicyType; */
  NS_IMETHOD GetContentPolicyType(nsContentPolicyType *aContentPolicyType) = 0;
  NS_IMETHOD SetContentPolicyType(nsContentPolicyType aContentPolicyType) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsITransferable, NS_ITRANSFERABLE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSITRANSFERABLE \
  NS_IMETHOD Init(nsILoadContext *aContext) override; \
  NS_IMETHOD FlavorsTransferableCanExport(nsIArray * *_retval) override; \
  NS_IMETHOD GetTransferData(const char * aFlavor, nsISupports * *aData, uint32_t *aDataLen) override; \
  NS_IMETHOD GetAnyTransferData(nsACString & aFlavor, nsISupports * *aData, uint32_t *aDataLen) override; \
  NS_IMETHOD IsLargeDataSet(bool *_retval) override; \
  NS_IMETHOD FlavorsTransferableCanImport(nsIArray * *_retval) override; \
  NS_IMETHOD SetTransferData(const char * aFlavor, nsISupports *aData, uint32_t aDataLen) override; \
  NS_IMETHOD AddDataFlavor(const char * aDataFlavor) override; \
  NS_IMETHOD RemoveDataFlavor(const char * aDataFlavor) override; \
  NS_IMETHOD GetConverter(nsIFormatConverter * *aConverter) override; \
  NS_IMETHOD SetConverter(nsIFormatConverter *aConverter) override; \
  NS_IMETHOD GetIsPrivateData(bool *aIsPrivateData) override; \
  NS_IMETHOD SetIsPrivateData(bool aIsPrivateData) override; \
  NS_IMETHOD GetRequestingPrincipal(nsIPrincipal * *aRequestingPrincipal) override; \
  NS_IMETHOD SetRequestingPrincipal(nsIPrincipal *aRequestingPrincipal) override; \
  NS_IMETHOD GetContentPolicyType(nsContentPolicyType *aContentPolicyType) override; \
  NS_IMETHOD SetContentPolicyType(nsContentPolicyType aContentPolicyType) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSITRANSFERABLE \
  nsresult Init(nsILoadContext *aContext); \
  nsresult FlavorsTransferableCanExport(nsIArray * *_retval); \
  nsresult GetTransferData(const char * aFlavor, nsISupports * *aData, uint32_t *aDataLen); \
  nsresult GetAnyTransferData(nsACString & aFlavor, nsISupports * *aData, uint32_t *aDataLen); \
  nsresult IsLargeDataSet(bool *_retval); \
  nsresult FlavorsTransferableCanImport(nsIArray * *_retval); \
  nsresult SetTransferData(const char * aFlavor, nsISupports *aData, uint32_t aDataLen); \
  nsresult AddDataFlavor(const char * aDataFlavor); \
  nsresult RemoveDataFlavor(const char * aDataFlavor); \
  nsresult GetConverter(nsIFormatConverter * *aConverter); \
  nsresult SetConverter(nsIFormatConverter *aConverter); \
  nsresult GetIsPrivateData(bool *aIsPrivateData); \
  nsresult SetIsPrivateData(bool aIsPrivateData); \
  nsresult GetRequestingPrincipal(nsIPrincipal * *aRequestingPrincipal); \
  nsresult SetRequestingPrincipal(nsIPrincipal *aRequestingPrincipal); \
  nsresult GetContentPolicyType(nsContentPolicyType *aContentPolicyType); \
  nsresult SetContentPolicyType(nsContentPolicyType aContentPolicyType); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSITRANSFERABLE(_to) \
  NS_IMETHOD Init(nsILoadContext *aContext) override { return _to Init(aContext); } \
  NS_IMETHOD FlavorsTransferableCanExport(nsIArray * *_retval) override { return _to FlavorsTransferableCanExport(_retval); } \
  NS_IMETHOD GetTransferData(const char * aFlavor, nsISupports * *aData, uint32_t *aDataLen) override { return _to GetTransferData(aFlavor, aData, aDataLen); } \
  NS_IMETHOD GetAnyTransferData(nsACString & aFlavor, nsISupports * *aData, uint32_t *aDataLen) override { return _to GetAnyTransferData(aFlavor, aData, aDataLen); } \
  NS_IMETHOD IsLargeDataSet(bool *_retval) override { return _to IsLargeDataSet(_retval); } \
  NS_IMETHOD FlavorsTransferableCanImport(nsIArray * *_retval) override { return _to FlavorsTransferableCanImport(_retval); } \
  NS_IMETHOD SetTransferData(const char * aFlavor, nsISupports *aData, uint32_t aDataLen) override { return _to SetTransferData(aFlavor, aData, aDataLen); } \
  NS_IMETHOD AddDataFlavor(const char * aDataFlavor) override { return _to AddDataFlavor(aDataFlavor); } \
  NS_IMETHOD RemoveDataFlavor(const char * aDataFlavor) override { return _to RemoveDataFlavor(aDataFlavor); } \
  NS_IMETHOD GetConverter(nsIFormatConverter * *aConverter) override { return _to GetConverter(aConverter); } \
  NS_IMETHOD SetConverter(nsIFormatConverter *aConverter) override { return _to SetConverter(aConverter); } \
  NS_IMETHOD GetIsPrivateData(bool *aIsPrivateData) override { return _to GetIsPrivateData(aIsPrivateData); } \
  NS_IMETHOD SetIsPrivateData(bool aIsPrivateData) override { return _to SetIsPrivateData(aIsPrivateData); } \
  NS_IMETHOD GetRequestingPrincipal(nsIPrincipal * *aRequestingPrincipal) override { return _to GetRequestingPrincipal(aRequestingPrincipal); } \
  NS_IMETHOD SetRequestingPrincipal(nsIPrincipal *aRequestingPrincipal) override { return _to SetRequestingPrincipal(aRequestingPrincipal); } \
  NS_IMETHOD GetContentPolicyType(nsContentPolicyType *aContentPolicyType) override { return _to GetContentPolicyType(aContentPolicyType); } \
  NS_IMETHOD SetContentPolicyType(nsContentPolicyType aContentPolicyType) override { return _to SetContentPolicyType(aContentPolicyType); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSITRANSFERABLE(_to) \
  NS_IMETHOD Init(nsILoadContext *aContext) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Init(aContext); } \
  NS_IMETHOD FlavorsTransferableCanExport(nsIArray * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->FlavorsTransferableCanExport(_retval); } \
  NS_IMETHOD GetTransferData(const char * aFlavor, nsISupports * *aData, uint32_t *aDataLen) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTransferData(aFlavor, aData, aDataLen); } \
  NS_IMETHOD GetAnyTransferData(nsACString & aFlavor, nsISupports * *aData, uint32_t *aDataLen) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAnyTransferData(aFlavor, aData, aDataLen); } \
  NS_IMETHOD IsLargeDataSet(bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->IsLargeDataSet(_retval); } \
  NS_IMETHOD FlavorsTransferableCanImport(nsIArray * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->FlavorsTransferableCanImport(_retval); } \
  NS_IMETHOD SetTransferData(const char * aFlavor, nsISupports *aData, uint32_t aDataLen) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetTransferData(aFlavor, aData, aDataLen); } \
  NS_IMETHOD AddDataFlavor(const char * aDataFlavor) override { return !_to ? NS_ERROR_NULL_POINTER : _to->AddDataFlavor(aDataFlavor); } \
  NS_IMETHOD RemoveDataFlavor(const char * aDataFlavor) override { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveDataFlavor(aDataFlavor); } \
  NS_IMETHOD GetConverter(nsIFormatConverter * *aConverter) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetConverter(aConverter); } \
  NS_IMETHOD SetConverter(nsIFormatConverter *aConverter) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetConverter(aConverter); } \
  NS_IMETHOD GetIsPrivateData(bool *aIsPrivateData) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsPrivateData(aIsPrivateData); } \
  NS_IMETHOD SetIsPrivateData(bool aIsPrivateData) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetIsPrivateData(aIsPrivateData); } \
  NS_IMETHOD GetRequestingPrincipal(nsIPrincipal * *aRequestingPrincipal) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRequestingPrincipal(aRequestingPrincipal); } \
  NS_IMETHOD SetRequestingPrincipal(nsIPrincipal *aRequestingPrincipal) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetRequestingPrincipal(aRequestingPrincipal); } \
  NS_IMETHOD GetContentPolicyType(nsContentPolicyType *aContentPolicyType) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetContentPolicyType(aContentPolicyType); } \
  NS_IMETHOD SetContentPolicyType(nsContentPolicyType aContentPolicyType) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetContentPolicyType(aContentPolicyType); } 


#endif /* __gen_nsITransferable_h__ */
