/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsIWebSocketChannel.idl
 */

#ifndef __gen_nsIWebSocketChannel_h__
#define __gen_nsIWebSocketChannel_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIURI; /* forward declaration */

class nsIInterfaceRequestor; /* forward declaration */

class nsILoadGroup; /* forward declaration */

class nsIWebSocketListener; /* forward declaration */

class nsIInputStream; /* forward declaration */

class nsILoadInfo; /* forward declaration */

class nsIDOMNode; /* forward declaration */

class nsIPrincipal; /* forward declaration */

class nsITransportProvider; /* forward declaration */


/* starting interface:    nsIWebSocketChannel */
#define NS_IWEBSOCKETCHANNEL_IID_STR "ce71d028-322a-4105-a947-a894689b52bf"

#define NS_IWEBSOCKETCHANNEL_IID \
  {0xce71d028, 0x322a, 0x4105, \
    { 0xa9, 0x47, 0xa8, 0x94, 0x68, 0x9b, 0x52, 0xbf }}

class nsIWebSocketChannel : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IWEBSOCKETCHANNEL_IID)

  /* [must_use] readonly attribute nsIURI originalURI; */
  MOZ_MUST_USE NS_IMETHOD GetOriginalURI(nsIURI * *aOriginalURI) = 0;

  /* [must_use] readonly attribute nsIURI URI; */
  MOZ_MUST_USE NS_IMETHOD GetURI(nsIURI * *aURI) = 0;

  /* [must_use] attribute nsIInterfaceRequestor notificationCallbacks; */
  MOZ_MUST_USE NS_IMETHOD GetNotificationCallbacks(nsIInterfaceRequestor * *aNotificationCallbacks) = 0;
  MOZ_MUST_USE NS_IMETHOD SetNotificationCallbacks(nsIInterfaceRequestor *aNotificationCallbacks) = 0;

  /* [must_use] readonly attribute nsISupports securityInfo; */
  MOZ_MUST_USE NS_IMETHOD GetSecurityInfo(nsISupports * *aSecurityInfo) = 0;

  /* [must_use] attribute nsILoadGroup loadGroup; */
  MOZ_MUST_USE NS_IMETHOD GetLoadGroup(nsILoadGroup * *aLoadGroup) = 0;
  MOZ_MUST_USE NS_IMETHOD SetLoadGroup(nsILoadGroup *aLoadGroup) = 0;

  /* [must_use] attribute nsILoadInfo loadInfo; */
  MOZ_MUST_USE NS_IMETHOD GetLoadInfo(nsILoadInfo * *aLoadInfo) = 0;
  MOZ_MUST_USE NS_IMETHOD SetLoadInfo(nsILoadInfo *aLoadInfo) = 0;

  /* [must_use] attribute ACString protocol; */
  MOZ_MUST_USE NS_IMETHOD GetProtocol(nsACString & aProtocol) = 0;
  MOZ_MUST_USE NS_IMETHOD SetProtocol(const nsACString & aProtocol) = 0;

  /* [must_use] readonly attribute ACString extensions; */
  MOZ_MUST_USE NS_IMETHOD GetExtensions(nsACString & aExtensions) = 0;

  /* [must_use] void initLoadInfo (in nsIDOMNode aLoadingNode, in nsIPrincipal aLoadingPrincipal, in nsIPrincipal aTriggeringPrincipal, in unsigned long aSecurityFlags, in unsigned long aContentPolicyType); */
  MOZ_MUST_USE NS_IMETHOD InitLoadInfo(nsIDOMNode *aLoadingNode, nsIPrincipal *aLoadingPrincipal, nsIPrincipal *aTriggeringPrincipal, uint32_t aSecurityFlags, uint32_t aContentPolicyType) = 0;

  /* [must_use] void asyncOpen (in nsIURI aURI, in ACString aOrigin, in unsigned long long aInnerWindowID, in nsIWebSocketListener aListener, in nsISupports aContext); */
  MOZ_MUST_USE NS_IMETHOD AsyncOpen(nsIURI *aURI, const nsACString & aOrigin, uint64_t aInnerWindowID, nsIWebSocketListener *aListener, nsISupports *aContext) = 0;

  /* [must_use] void close (in unsigned short aCode, in AUTF8String aReason); */
  MOZ_MUST_USE NS_IMETHOD Close(uint16_t aCode, const nsACString & aReason) = 0;

  enum {
    CLOSE_NORMAL = 1000U,
    CLOSE_GOING_AWAY = 1001U,
    CLOSE_PROTOCOL_ERROR = 1002U,
    CLOSE_UNSUPPORTED_DATATYPE = 1003U,
    CLOSE_NO_STATUS = 1005U,
    CLOSE_ABNORMAL = 1006U,
    CLOSE_INVALID_PAYLOAD = 1007U,
    CLOSE_POLICY_VIOLATION = 1008U,
    CLOSE_TOO_LARGE = 1009U,
    CLOSE_EXTENSION_MISSING = 1010U,
    CLOSE_INTERNAL_ERROR = 1011U,
    CLOSE_TLS_FAILED = 1015U
  };

  /* [must_use] void sendMsg (in AUTF8String aMsg); */
  MOZ_MUST_USE NS_IMETHOD SendMsg(const nsACString & aMsg) = 0;

  /* [must_use] void sendBinaryMsg (in ACString aMsg); */
  MOZ_MUST_USE NS_IMETHOD SendBinaryMsg(const nsACString & aMsg) = 0;

  /* [must_use] void sendBinaryStream (in nsIInputStream aStream, in unsigned long length); */
  MOZ_MUST_USE NS_IMETHOD SendBinaryStream(nsIInputStream *aStream, uint32_t length) = 0;

  /* [must_use] attribute unsigned long pingInterval; */
  MOZ_MUST_USE NS_IMETHOD GetPingInterval(uint32_t *aPingInterval) = 0;
  MOZ_MUST_USE NS_IMETHOD SetPingInterval(uint32_t aPingInterval) = 0;

  /* [must_use] attribute unsigned long pingTimeout; */
  MOZ_MUST_USE NS_IMETHOD GetPingTimeout(uint32_t *aPingTimeout) = 0;
  MOZ_MUST_USE NS_IMETHOD SetPingTimeout(uint32_t aPingTimeout) = 0;

  /* [must_use] attribute unsigned long serial; */
  MOZ_MUST_USE NS_IMETHOD GetSerial(uint32_t *aSerial) = 0;
  MOZ_MUST_USE NS_IMETHOD SetSerial(uint32_t aSerial) = 0;

  /* [must_use] void setServerParameters (in nsITransportProvider aProvider, in ACString aNegotiatedExtensions); */
  MOZ_MUST_USE NS_IMETHOD SetServerParameters(nsITransportProvider *aProvider, const nsACString & aNegotiatedExtensions) = 0;

     inline uint32_t Serial()
    {
      uint32_t serial;
      nsresult rv = GetSerial(&serial);
      if (NS_WARN_IF(NS_FAILED(rv))) {
        return 0;
      }
      return serial;
    }
};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIWebSocketChannel, NS_IWEBSOCKETCHANNEL_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIWEBSOCKETCHANNEL \
  MOZ_MUST_USE NS_IMETHOD GetOriginalURI(nsIURI * *aOriginalURI) override; \
  MOZ_MUST_USE NS_IMETHOD GetURI(nsIURI * *aURI) override; \
  MOZ_MUST_USE NS_IMETHOD GetNotificationCallbacks(nsIInterfaceRequestor * *aNotificationCallbacks) override; \
  MOZ_MUST_USE NS_IMETHOD SetNotificationCallbacks(nsIInterfaceRequestor *aNotificationCallbacks) override; \
  MOZ_MUST_USE NS_IMETHOD GetSecurityInfo(nsISupports * *aSecurityInfo) override; \
  MOZ_MUST_USE NS_IMETHOD GetLoadGroup(nsILoadGroup * *aLoadGroup) override; \
  MOZ_MUST_USE NS_IMETHOD SetLoadGroup(nsILoadGroup *aLoadGroup) override; \
  MOZ_MUST_USE NS_IMETHOD GetLoadInfo(nsILoadInfo * *aLoadInfo) override; \
  MOZ_MUST_USE NS_IMETHOD SetLoadInfo(nsILoadInfo *aLoadInfo) override; \
  MOZ_MUST_USE NS_IMETHOD GetProtocol(nsACString & aProtocol) override; \
  MOZ_MUST_USE NS_IMETHOD SetProtocol(const nsACString & aProtocol) override; \
  MOZ_MUST_USE NS_IMETHOD GetExtensions(nsACString & aExtensions) override; \
  MOZ_MUST_USE NS_IMETHOD InitLoadInfo(nsIDOMNode *aLoadingNode, nsIPrincipal *aLoadingPrincipal, nsIPrincipal *aTriggeringPrincipal, uint32_t aSecurityFlags, uint32_t aContentPolicyType) override; \
  MOZ_MUST_USE NS_IMETHOD AsyncOpen(nsIURI *aURI, const nsACString & aOrigin, uint64_t aInnerWindowID, nsIWebSocketListener *aListener, nsISupports *aContext) override; \
  MOZ_MUST_USE NS_IMETHOD Close(uint16_t aCode, const nsACString & aReason) override; \
  MOZ_MUST_USE NS_IMETHOD SendMsg(const nsACString & aMsg) override; \
  MOZ_MUST_USE NS_IMETHOD SendBinaryMsg(const nsACString & aMsg) override; \
  MOZ_MUST_USE NS_IMETHOD SendBinaryStream(nsIInputStream *aStream, uint32_t length) override; \
  MOZ_MUST_USE NS_IMETHOD GetPingInterval(uint32_t *aPingInterval) override; \
  MOZ_MUST_USE NS_IMETHOD SetPingInterval(uint32_t aPingInterval) override; \
  MOZ_MUST_USE NS_IMETHOD GetPingTimeout(uint32_t *aPingTimeout) override; \
  MOZ_MUST_USE NS_IMETHOD SetPingTimeout(uint32_t aPingTimeout) override; \
  MOZ_MUST_USE NS_IMETHOD GetSerial(uint32_t *aSerial) override; \
  MOZ_MUST_USE NS_IMETHOD SetSerial(uint32_t aSerial) override; \
  MOZ_MUST_USE NS_IMETHOD SetServerParameters(nsITransportProvider *aProvider, const nsACString & aNegotiatedExtensions) override; \

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIWEBSOCKETCHANNEL \
  MOZ_MUST_USE nsresult GetOriginalURI(nsIURI * *aOriginalURI); \
  MOZ_MUST_USE nsresult GetURI(nsIURI * *aURI); \
  MOZ_MUST_USE nsresult GetNotificationCallbacks(nsIInterfaceRequestor * *aNotificationCallbacks); \
  MOZ_MUST_USE nsresult SetNotificationCallbacks(nsIInterfaceRequestor *aNotificationCallbacks); \
  MOZ_MUST_USE nsresult GetSecurityInfo(nsISupports * *aSecurityInfo); \
  MOZ_MUST_USE nsresult GetLoadGroup(nsILoadGroup * *aLoadGroup); \
  MOZ_MUST_USE nsresult SetLoadGroup(nsILoadGroup *aLoadGroup); \
  MOZ_MUST_USE nsresult GetLoadInfo(nsILoadInfo * *aLoadInfo); \
  MOZ_MUST_USE nsresult SetLoadInfo(nsILoadInfo *aLoadInfo); \
  MOZ_MUST_USE nsresult GetProtocol(nsACString & aProtocol); \
  MOZ_MUST_USE nsresult SetProtocol(const nsACString & aProtocol); \
  MOZ_MUST_USE nsresult GetExtensions(nsACString & aExtensions); \
  MOZ_MUST_USE nsresult InitLoadInfo(nsIDOMNode *aLoadingNode, nsIPrincipal *aLoadingPrincipal, nsIPrincipal *aTriggeringPrincipal, uint32_t aSecurityFlags, uint32_t aContentPolicyType); \
  MOZ_MUST_USE nsresult AsyncOpen(nsIURI *aURI, const nsACString & aOrigin, uint64_t aInnerWindowID, nsIWebSocketListener *aListener, nsISupports *aContext); \
  MOZ_MUST_USE nsresult Close(uint16_t aCode, const nsACString & aReason); \
  MOZ_MUST_USE nsresult SendMsg(const nsACString & aMsg); \
  MOZ_MUST_USE nsresult SendBinaryMsg(const nsACString & aMsg); \
  MOZ_MUST_USE nsresult SendBinaryStream(nsIInputStream *aStream, uint32_t length); \
  MOZ_MUST_USE nsresult GetPingInterval(uint32_t *aPingInterval); \
  MOZ_MUST_USE nsresult SetPingInterval(uint32_t aPingInterval); \
  MOZ_MUST_USE nsresult GetPingTimeout(uint32_t *aPingTimeout); \
  MOZ_MUST_USE nsresult SetPingTimeout(uint32_t aPingTimeout); \
  MOZ_MUST_USE nsresult GetSerial(uint32_t *aSerial); \
  MOZ_MUST_USE nsresult SetSerial(uint32_t aSerial); \
  MOZ_MUST_USE nsresult SetServerParameters(nsITransportProvider *aProvider, const nsACString & aNegotiatedExtensions); \

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIWEBSOCKETCHANNEL(_to) \
  MOZ_MUST_USE NS_IMETHOD GetOriginalURI(nsIURI * *aOriginalURI) override { return _to GetOriginalURI(aOriginalURI); } \
  MOZ_MUST_USE NS_IMETHOD GetURI(nsIURI * *aURI) override { return _to GetURI(aURI); } \
  MOZ_MUST_USE NS_IMETHOD GetNotificationCallbacks(nsIInterfaceRequestor * *aNotificationCallbacks) override { return _to GetNotificationCallbacks(aNotificationCallbacks); } \
  MOZ_MUST_USE NS_IMETHOD SetNotificationCallbacks(nsIInterfaceRequestor *aNotificationCallbacks) override { return _to SetNotificationCallbacks(aNotificationCallbacks); } \
  MOZ_MUST_USE NS_IMETHOD GetSecurityInfo(nsISupports * *aSecurityInfo) override { return _to GetSecurityInfo(aSecurityInfo); } \
  MOZ_MUST_USE NS_IMETHOD GetLoadGroup(nsILoadGroup * *aLoadGroup) override { return _to GetLoadGroup(aLoadGroup); } \
  MOZ_MUST_USE NS_IMETHOD SetLoadGroup(nsILoadGroup *aLoadGroup) override { return _to SetLoadGroup(aLoadGroup); } \
  MOZ_MUST_USE NS_IMETHOD GetLoadInfo(nsILoadInfo * *aLoadInfo) override { return _to GetLoadInfo(aLoadInfo); } \
  MOZ_MUST_USE NS_IMETHOD SetLoadInfo(nsILoadInfo *aLoadInfo) override { return _to SetLoadInfo(aLoadInfo); } \
  MOZ_MUST_USE NS_IMETHOD GetProtocol(nsACString & aProtocol) override { return _to GetProtocol(aProtocol); } \
  MOZ_MUST_USE NS_IMETHOD SetProtocol(const nsACString & aProtocol) override { return _to SetProtocol(aProtocol); } \
  MOZ_MUST_USE NS_IMETHOD GetExtensions(nsACString & aExtensions) override { return _to GetExtensions(aExtensions); } \
  MOZ_MUST_USE NS_IMETHOD InitLoadInfo(nsIDOMNode *aLoadingNode, nsIPrincipal *aLoadingPrincipal, nsIPrincipal *aTriggeringPrincipal, uint32_t aSecurityFlags, uint32_t aContentPolicyType) override { return _to InitLoadInfo(aLoadingNode, aLoadingPrincipal, aTriggeringPrincipal, aSecurityFlags, aContentPolicyType); } \
  MOZ_MUST_USE NS_IMETHOD AsyncOpen(nsIURI *aURI, const nsACString & aOrigin, uint64_t aInnerWindowID, nsIWebSocketListener *aListener, nsISupports *aContext) override { return _to AsyncOpen(aURI, aOrigin, aInnerWindowID, aListener, aContext); } \
  MOZ_MUST_USE NS_IMETHOD Close(uint16_t aCode, const nsACString & aReason) override { return _to Close(aCode, aReason); } \
  MOZ_MUST_USE NS_IMETHOD SendMsg(const nsACString & aMsg) override { return _to SendMsg(aMsg); } \
  MOZ_MUST_USE NS_IMETHOD SendBinaryMsg(const nsACString & aMsg) override { return _to SendBinaryMsg(aMsg); } \
  MOZ_MUST_USE NS_IMETHOD SendBinaryStream(nsIInputStream *aStream, uint32_t length) override { return _to SendBinaryStream(aStream, length); } \
  MOZ_MUST_USE NS_IMETHOD GetPingInterval(uint32_t *aPingInterval) override { return _to GetPingInterval(aPingInterval); } \
  MOZ_MUST_USE NS_IMETHOD SetPingInterval(uint32_t aPingInterval) override { return _to SetPingInterval(aPingInterval); } \
  MOZ_MUST_USE NS_IMETHOD GetPingTimeout(uint32_t *aPingTimeout) override { return _to GetPingTimeout(aPingTimeout); } \
  MOZ_MUST_USE NS_IMETHOD SetPingTimeout(uint32_t aPingTimeout) override { return _to SetPingTimeout(aPingTimeout); } \
  MOZ_MUST_USE NS_IMETHOD GetSerial(uint32_t *aSerial) override { return _to GetSerial(aSerial); } \
  MOZ_MUST_USE NS_IMETHOD SetSerial(uint32_t aSerial) override { return _to SetSerial(aSerial); } \
  MOZ_MUST_USE NS_IMETHOD SetServerParameters(nsITransportProvider *aProvider, const nsACString & aNegotiatedExtensions) override { return _to SetServerParameters(aProvider, aNegotiatedExtensions); } \

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIWEBSOCKETCHANNEL(_to) \
  MOZ_MUST_USE NS_IMETHOD GetOriginalURI(nsIURI * *aOriginalURI) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOriginalURI(aOriginalURI); } \
  MOZ_MUST_USE NS_IMETHOD GetURI(nsIURI * *aURI) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetURI(aURI); } \
  MOZ_MUST_USE NS_IMETHOD GetNotificationCallbacks(nsIInterfaceRequestor * *aNotificationCallbacks) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetNotificationCallbacks(aNotificationCallbacks); } \
  MOZ_MUST_USE NS_IMETHOD SetNotificationCallbacks(nsIInterfaceRequestor *aNotificationCallbacks) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetNotificationCallbacks(aNotificationCallbacks); } \
  MOZ_MUST_USE NS_IMETHOD GetSecurityInfo(nsISupports * *aSecurityInfo) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSecurityInfo(aSecurityInfo); } \
  MOZ_MUST_USE NS_IMETHOD GetLoadGroup(nsILoadGroup * *aLoadGroup) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLoadGroup(aLoadGroup); } \
  MOZ_MUST_USE NS_IMETHOD SetLoadGroup(nsILoadGroup *aLoadGroup) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetLoadGroup(aLoadGroup); } \
  MOZ_MUST_USE NS_IMETHOD GetLoadInfo(nsILoadInfo * *aLoadInfo) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLoadInfo(aLoadInfo); } \
  MOZ_MUST_USE NS_IMETHOD SetLoadInfo(nsILoadInfo *aLoadInfo) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetLoadInfo(aLoadInfo); } \
  MOZ_MUST_USE NS_IMETHOD GetProtocol(nsACString & aProtocol) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetProtocol(aProtocol); } \
  MOZ_MUST_USE NS_IMETHOD SetProtocol(const nsACString & aProtocol) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetProtocol(aProtocol); } \
  MOZ_MUST_USE NS_IMETHOD GetExtensions(nsACString & aExtensions) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetExtensions(aExtensions); } \
  MOZ_MUST_USE NS_IMETHOD InitLoadInfo(nsIDOMNode *aLoadingNode, nsIPrincipal *aLoadingPrincipal, nsIPrincipal *aTriggeringPrincipal, uint32_t aSecurityFlags, uint32_t aContentPolicyType) override { return !_to ? NS_ERROR_NULL_POINTER : _to->InitLoadInfo(aLoadingNode, aLoadingPrincipal, aTriggeringPrincipal, aSecurityFlags, aContentPolicyType); } \
  MOZ_MUST_USE NS_IMETHOD AsyncOpen(nsIURI *aURI, const nsACString & aOrigin, uint64_t aInnerWindowID, nsIWebSocketListener *aListener, nsISupports *aContext) override { return !_to ? NS_ERROR_NULL_POINTER : _to->AsyncOpen(aURI, aOrigin, aInnerWindowID, aListener, aContext); } \
  MOZ_MUST_USE NS_IMETHOD Close(uint16_t aCode, const nsACString & aReason) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Close(aCode, aReason); } \
  MOZ_MUST_USE NS_IMETHOD SendMsg(const nsACString & aMsg) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SendMsg(aMsg); } \
  MOZ_MUST_USE NS_IMETHOD SendBinaryMsg(const nsACString & aMsg) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SendBinaryMsg(aMsg); } \
  MOZ_MUST_USE NS_IMETHOD SendBinaryStream(nsIInputStream *aStream, uint32_t length) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SendBinaryStream(aStream, length); } \
  MOZ_MUST_USE NS_IMETHOD GetPingInterval(uint32_t *aPingInterval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPingInterval(aPingInterval); } \
  MOZ_MUST_USE NS_IMETHOD SetPingInterval(uint32_t aPingInterval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetPingInterval(aPingInterval); } \
  MOZ_MUST_USE NS_IMETHOD GetPingTimeout(uint32_t *aPingTimeout) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPingTimeout(aPingTimeout); } \
  MOZ_MUST_USE NS_IMETHOD SetPingTimeout(uint32_t aPingTimeout) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetPingTimeout(aPingTimeout); } \
  MOZ_MUST_USE NS_IMETHOD GetSerial(uint32_t *aSerial) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSerial(aSerial); } \
  MOZ_MUST_USE NS_IMETHOD SetSerial(uint32_t aSerial) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetSerial(aSerial); } \
  MOZ_MUST_USE NS_IMETHOD SetServerParameters(nsITransportProvider *aProvider, const nsACString & aNegotiatedExtensions) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetServerParameters(aProvider, aNegotiatedExtensions); } \


#endif /* __gen_nsIWebSocketChannel_h__ */
