/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED FROM PageTransitionEvent.webidl BY Codegen.py - DO NOT EDIT */

#include "EventBinding.h"
#include "PageTransitionEvent.h"
#include "PageTransitionEventBinding.h"
#include "js/GCAPI.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PageTransitionEvent.h"
#include "mozilla/dom/PrimitiveConversions.h"

namespace mozilla {
namespace dom {


NS_IMPL_CYCLE_COLLECTION_CLASS(PageTransitionEvent)

NS_IMPL_ADDREF_INHERITED(PageTransitionEvent, Event)
NS_IMPL_RELEASE_INHERITED(PageTransitionEvent, Event)

NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(PageTransitionEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END

NS_IMPL_CYCLE_COLLECTION_TRACE_BEGIN_INHERITED(PageTransitionEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRACE_END

NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN_INHERITED(PageTransitionEvent, Event)
NS_IMPL_CYCLE_COLLECTION_UNLINK_END

NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION(PageTransitionEvent)
NS_INTERFACE_MAP_END_INHERITING(Event)

PageTransitionEvent::PageTransitionEvent(mozilla::dom::EventTarget* aOwner)
  : Event(aOwner, nullptr, nullptr)
{
}

PageTransitionEvent::~PageTransitionEvent()
{
}

PageTransitionEvent*
PageTransitionEvent::AsPageTransitionEvent()
{
  return this;
}

JSObject*
PageTransitionEvent::WrapObjectInternal(JSContext* aCx, JS::Handle<JSObject*> aGivenProto)
{
  return PageTransitionEventBinding::Wrap(aCx, this, aGivenProto);
}

already_AddRefed<PageTransitionEvent>
PageTransitionEvent::Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const PageTransitionEventInit& aEventInitDict)
{
  RefPtr<PageTransitionEvent> e = new PageTransitionEvent(aOwner);
  bool trusted = e->Init(aOwner);
  e->InitEvent(aType, aEventInitDict.mBubbles, aEventInitDict.mCancelable);
  e->mPersisted = aEventInitDict.mPersisted;
  e->mInFrameSwap = aEventInitDict.mInFrameSwap;
  e->SetTrusted(trusted);
  e->SetComposed(aEventInitDict.mComposed);
  return e.forget();
}

already_AddRefed<PageTransitionEvent>
PageTransitionEvent::Constructor(const GlobalObject& aGlobal, const nsAString& aType, const PageTransitionEventInit& aEventInitDict, ErrorResult& aRv)
{
  nsCOMPtr<mozilla::dom::EventTarget> owner = do_QueryInterface(aGlobal.GetAsSupports());
  return Constructor(owner, aType, aEventInitDict);
}

bool
PageTransitionEvent::Persisted() const
{
  return mPersisted;
}

bool
PageTransitionEvent::InFrameSwap() const
{
  return mInFrameSwap;
}


} // namespace dom
} // namespace mozilla
