/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED FROM StyleRuleChangeEvent.webidl BY Codegen.py - DO NOT EDIT */

#include "EventBinding.h"
#include "StyleRuleChangeEvent.h"
#include "StyleRuleChangeEventBinding.h"
#include "js/GCAPI.h"
#include "mozilla/StyleSheet.h"
#include "mozilla/css/Rule.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/StyleRuleChangeEvent.h"

namespace mozilla {
namespace dom {


NS_IMPL_CYCLE_COLLECTION_CLASS(StyleRuleChangeEvent)

NS_IMPL_ADDREF_INHERITED(StyleRuleChangeEvent, Event)
NS_IMPL_RELEASE_INHERITED(StyleRuleChangeEvent, Event)

NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(StyleRuleChangeEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE(mStylesheet)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE(mRule)
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END

NS_IMPL_CYCLE_COLLECTION_TRACE_BEGIN_INHERITED(StyleRuleChangeEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRACE_END

NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN_INHERITED(StyleRuleChangeEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_UNLINK(mStylesheet)
  NS_IMPL_CYCLE_COLLECTION_UNLINK(mRule)
NS_IMPL_CYCLE_COLLECTION_UNLINK_END

NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION(StyleRuleChangeEvent)
NS_INTERFACE_MAP_END_INHERITING(Event)

StyleRuleChangeEvent::StyleRuleChangeEvent(mozilla::dom::EventTarget* aOwner)
  : Event(aOwner, nullptr, nullptr)
{
}

StyleRuleChangeEvent::~StyleRuleChangeEvent()
{
}

StyleRuleChangeEvent*
StyleRuleChangeEvent::AsStyleRuleChangeEvent()
{
  return this;
}

JSObject*
StyleRuleChangeEvent::WrapObjectInternal(JSContext* aCx, JS::Handle<JSObject*> aGivenProto)
{
  return StyleRuleChangeEventBinding::Wrap(aCx, this, aGivenProto);
}

already_AddRefed<StyleRuleChangeEvent>
StyleRuleChangeEvent::Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const StyleRuleChangeEventInit& aEventInitDict)
{
  RefPtr<StyleRuleChangeEvent> e = new StyleRuleChangeEvent(aOwner);
  bool trusted = e->Init(aOwner);
  e->InitEvent(aType, aEventInitDict.mBubbles, aEventInitDict.mCancelable);
  e->mStylesheet = aEventInitDict.mStylesheet;
  e->mRule = aEventInitDict.mRule;
  e->SetTrusted(trusted);
  e->SetComposed(aEventInitDict.mComposed);
  return e.forget();
}

already_AddRefed<StyleRuleChangeEvent>
StyleRuleChangeEvent::Constructor(const GlobalObject& aGlobal, const nsAString& aType, const StyleRuleChangeEventInit& aEventInitDict, ErrorResult& aRv)
{
  nsCOMPtr<mozilla::dom::EventTarget> owner = do_QueryInterface(aGlobal.GetAsSupports());
  return Constructor(owner, aType, aEventInitDict);
}

StyleSheet*
StyleRuleChangeEvent::GetStylesheet() const
{
  return mStylesheet;
}

css::Rule*
StyleRuleChangeEvent::GetRule() const
{
  return mRule;
}


} // namespace dom
} // namespace mozilla
