/* THIS FILE IS AUTOGENERATED FROM WebComponents.webidl BY Codegen.py - DO NOT EDIT */

#include "AtomList.h"
#include "WebComponentsBinding.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/ScriptSettings.h"
#include "nsIDocument.h"

namespace mozilla {
namespace dom {


LifecycleCallbacks::LifecycleCallbacks()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}


bool
LifecycleCallbacks::InitIds(JSContext* cx, LifecycleCallbacksAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->disconnectedCallback_id.init(cx, "disconnectedCallback") ||
      !atomsCache->connectedCallback_id.init(cx, "connectedCallback") ||
      !atomsCache->attributeChangedCallback_id.init(cx, "attributeChangedCallback") ||
      !atomsCache->adoptedCallback_id.init(cx, "adoptedCallback")) {
    return false;
  }
  return true;
}

bool
LifecycleCallbacks::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  // Also evaluate isNullOrUndefined in order to avoid false-positive
  // checkers by static analysis tools
  MOZ_ASSERT_IF(!cx, val.isNull() && val.isNullOrUndefined());
  LifecycleCallbacksAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<LifecycleCallbacksAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    MOZ_ASSERT(cx);
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->adoptedCallback_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mAdoptedCallback.Construct();
    if (temp.ref().isObject()) {
      if (JS::IsCallable(&temp.ref().toObject())) {
      { // scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &temp.ref().toObject());
        (mAdoptedCallback.Value()) = new LifecycleAdoptedCallback(cx, tempRoot, GetIncumbentGlobal());
      }
      } else {
        ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "'adoptedCallback' member of LifecycleCallbacks");
        return false;
      }
    } else if (temp.ref().isNullOrUndefined()) {
      (mAdoptedCallback.Value()) = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'adoptedCallback' member of LifecycleCallbacks");
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->attributeChangedCallback_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mAttributeChangedCallback.Construct();
    if (temp.ref().isObject()) {
      if (JS::IsCallable(&temp.ref().toObject())) {
      { // scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &temp.ref().toObject());
        (mAttributeChangedCallback.Value()) = new LifecycleAttributeChangedCallback(cx, tempRoot, GetIncumbentGlobal());
      }
      } else {
        ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "'attributeChangedCallback' member of LifecycleCallbacks");
        return false;
      }
    } else if (temp.ref().isNullOrUndefined()) {
      (mAttributeChangedCallback.Value()) = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'attributeChangedCallback' member of LifecycleCallbacks");
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->connectedCallback_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mConnectedCallback.Construct();
    if (temp.ref().isObject()) {
      if (JS::IsCallable(&temp.ref().toObject())) {
      { // scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &temp.ref().toObject());
        (mConnectedCallback.Value()) = new LifecycleConnectedCallback(cx, tempRoot, GetIncumbentGlobal());
      }
      } else {
        ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "'connectedCallback' member of LifecycleCallbacks");
        return false;
      }
    } else if (temp.ref().isNullOrUndefined()) {
      (mConnectedCallback.Value()) = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'connectedCallback' member of LifecycleCallbacks");
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->disconnectedCallback_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mDisconnectedCallback.Construct();
    if (temp.ref().isObject()) {
      if (JS::IsCallable(&temp.ref().toObject())) {
      { // scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &temp.ref().toObject());
        (mDisconnectedCallback.Value()) = new LifecycleDisconnectedCallback(cx, tempRoot, GetIncumbentGlobal());
      }
      } else {
        ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "'disconnectedCallback' member of LifecycleCallbacks");
        return false;
      }
    } else if (temp.ref().isNullOrUndefined()) {
      (mDisconnectedCallback.Value()) = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'disconnectedCallback' member of LifecycleCallbacks");
      return false;
    }
    mIsAnyMemberPresent = true;
  }
  return true;
}

bool
LifecycleCallbacks::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  LifecycleCallbacksAtoms* atomsCache = GetAtomCache<LifecycleCallbacksAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mAdoptedCallback.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      RefPtr<LifecycleAdoptedCallback> const & currentValue = mAdoptedCallback.InternalValue();
      if (currentValue) {
        temp.setObjectOrNull(GetCallbackFromCallbackObject(cx, currentValue));
        if (!MaybeWrapObjectOrNullValue(cx, &temp)) {
          return false;
        }
        if (!JS_DefinePropertyById(cx, obj, atomsCache->adoptedCallback_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      } else {
        temp.setNull();
        if (!JS_DefinePropertyById(cx, obj, atomsCache->adoptedCallback_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      }
    } while(false);
  }

  if (mAttributeChangedCallback.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      RefPtr<LifecycleAttributeChangedCallback> const & currentValue = mAttributeChangedCallback.InternalValue();
      if (currentValue) {
        temp.setObjectOrNull(GetCallbackFromCallbackObject(cx, currentValue));
        if (!MaybeWrapObjectOrNullValue(cx, &temp)) {
          return false;
        }
        if (!JS_DefinePropertyById(cx, obj, atomsCache->attributeChangedCallback_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      } else {
        temp.setNull();
        if (!JS_DefinePropertyById(cx, obj, atomsCache->attributeChangedCallback_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      }
    } while(false);
  }

  if (mConnectedCallback.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      RefPtr<LifecycleConnectedCallback> const & currentValue = mConnectedCallback.InternalValue();
      if (currentValue) {
        temp.setObjectOrNull(GetCallbackFromCallbackObject(cx, currentValue));
        if (!MaybeWrapObjectOrNullValue(cx, &temp)) {
          return false;
        }
        if (!JS_DefinePropertyById(cx, obj, atomsCache->connectedCallback_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      } else {
        temp.setNull();
        if (!JS_DefinePropertyById(cx, obj, atomsCache->connectedCallback_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      }
    } while(false);
  }

  if (mDisconnectedCallback.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      RefPtr<LifecycleDisconnectedCallback> const & currentValue = mDisconnectedCallback.InternalValue();
      if (currentValue) {
        temp.setObjectOrNull(GetCallbackFromCallbackObject(cx, currentValue));
        if (!MaybeWrapObjectOrNullValue(cx, &temp)) {
          return false;
        }
        if (!JS_DefinePropertyById(cx, obj, atomsCache->disconnectedCallback_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      } else {
        temp.setNull();
        if (!JS_DefinePropertyById(cx, obj, atomsCache->disconnectedCallback_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      }
    } while(false);
  }

  return true;
}

void
LifecycleCallbacks::TraceDictionary(JSTracer* trc)
{
}

namespace binding_detail {
} // namespace binding_detail


void
LifecycleConnectedCallback::Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, ErrorResult& aRv)
{
  JS::Rooted<JS::Value> rval(cx);

  JS::Rooted<JS::Value> callable(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, aThisVal, callable,
                JS::HandleValueArray::empty(), &rval)) {
    aRv.NoteJSContextException(cx);
    return;
  }
}



void
LifecycleDisconnectedCallback::Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, ErrorResult& aRv)
{
  JS::Rooted<JS::Value> rval(cx);

  JS::Rooted<JS::Value> callable(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, aThisVal, callable,
                JS::HandleValueArray::empty(), &rval)) {
    aRv.NoteJSContextException(cx);
    return;
  }
}



void
LifecycleAdoptedCallback::Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, nsIDocument* oldDocument, nsIDocument* newDocment, ErrorResult& aRv)
{
  JS::Rooted<JS::Value> rval(cx);
  JS::AutoValueVector argv(cx);
  if (!argv.resize(2)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return;
  }
  unsigned argc = 2;

  do {
    if (!newDocment) {
      argv[1].setNull();
      break;
    }
    if (!GetOrCreateDOMReflector(cx, newDocment, argv[1])) {
      MOZ_ASSERT(JS_IsExceptionPending(cx));
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (false);

  do {
    if (!oldDocument) {
      argv[0].setNull();
      break;
    }
    if (!GetOrCreateDOMReflector(cx, oldDocument, argv[0])) {
      MOZ_ASSERT(JS_IsExceptionPending(cx));
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (false);

  JS::Rooted<JS::Value> callable(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, aThisVal, callable,
                JS::HandleValueArray::subarray(argv, 0, argc), &rval)) {
    aRv.NoteJSContextException(cx);
    return;
  }
}



void
LifecycleAttributeChangedCallback::Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, const nsAString& attrName, const nsAString& oldValue, const nsAString& newValue, const nsAString& namespaceURI, ErrorResult& aRv)
{
  JS::Rooted<JS::Value> rval(cx);
  JS::AutoValueVector argv(cx);
  if (!argv.resize(4)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return;
  }
  unsigned argc = 4;

  do {
    nsString mutableStr(namespaceURI);
    if (!xpc::StringToJsval(cx, mutableStr, argv[3])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (false);

  do {
    nsString mutableStr(newValue);
    if (!xpc::StringToJsval(cx, mutableStr, argv[2])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (false);

  do {
    nsString mutableStr(oldValue);
    if (!xpc::StringToJsval(cx, mutableStr, argv[1])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (false);

  do {
    nsString mutableStr(attrName);
    if (!xpc::NonVoidStringToJsval(cx, mutableStr, argv[0])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (false);

  JS::Rooted<JS::Value> callable(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, aThisVal, callable,
                JS::HandleValueArray::subarray(argv, 0, argc), &rval)) {
    aRv.NoteJSContextException(cx);
    return;
  }
}



namespace binding_detail {
} // namespace binding_detail


namespace binding_detail {
} // namespace binding_detail


namespace binding_detail {
} // namespace binding_detail


namespace binding_detail {
} // namespace binding_detail


} // namespace dom
} // namespace mozilla
