//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PProfilerParent_h
#define PProfilerParent_h

#include "mozilla/PProfiler.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

#include "mozilla/WeakPtr.h"
class nsIFile;

namespace mozilla {


class PProfilerParent :
    public mozilla::ipc::IToplevelProtocol,
    public SupportsWeakPtr<PProfilerParent>
{
public:
    MOZ_DECLARE_WEAKREFERENCE_TYPENAME(PProfilerParent)
private:
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ProfilerInitParams ProfilerInitParams;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PProfiler::State State;

public:
    typedef MozPromise<nsCString, ResponseRejectReason, false> GatherProfilePromise;

protected:

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

    void
    ProcessingError(
            Result aCode,
            const char* aReason) override;
    bool
    ShouldContinueFromReplyTimeout() override;
    void
    EnteredCxxStack() override;
    void
    ExitedCxxStack() override;
    void
    EnteredCall() override;
    void
    ExitedCall() override;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PProfilerParent();

    virtual ~PProfilerParent();

    MOZ_MUST_USE bool
    SendStart(const ProfilerInitParams& params);

    MOZ_MUST_USE bool
    SendEnsureStarted(const ProfilerInitParams& params);

    MOZ_MUST_USE bool
    SendStop();

    MOZ_MUST_USE bool
    SendPause();

    MOZ_MUST_USE bool
    SendResume();

    void
    SendGatherProfile(
            mozilla::ipc::ResolveCallback<nsCString>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    MOZ_MUST_USE RefPtr<GatherProfilePromise>
    SendGatherProfile();

    MessageChannel*
    GetIPCChannel() override;
    const MessageChannel*
    GetIPCChannel() const override;
    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

    void
    OnChannelClose() override;

    void
    OnChannelError() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    virtual void
    DeallocPProfilerParent();

    MessageChannel mChannel;
    State mState;
};


} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::PProfilerParent*>
{
    typedef mozilla::PProfilerParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
class ProfilerParent :
    public PProfilerParent
{
    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT ProfilerParent();
    virtual ~ProfilerParent();
};
} // namespace mozilla


// C++ file contents
namespace mozilla {
void
ProfilerParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT ProfilerParent::ProfilerParent()
{
    MOZ_COUNT_CTOR(ProfilerParent);
}

MOZ_IMPLICIT ProfilerParent::~ProfilerParent()
{
    MOZ_COUNT_DTOR(ProfilerParent);
}

} // namespace mozilla
#endif // if 0

#endif // ifndef PProfilerParent_h
