//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef DOMTypes_h
#define DOMTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "Units.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/dom/ScreenOrientation.h"
#include "mozilla/layers/CompositorOptions.h"
#include "mozilla/layers/CompositorTypes.h"
#include "mozilla/layers/LayersTypes.h"
#include "mozilla/dom/IPCBlob.h"
#include "mozilla/ipc/IPCStream.h"
#include "mozilla/ipc/ProtocolTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MessagePortIdentifier|
//
namespace mozilla {
namespace dom {
class MessagePortIdentifier final
{
private:

public:
    MOZ_IMPLICIT MessagePortIdentifier() :
        uuid_(),
        destinationUuid_(),
        sequenceId_(),
        neutered_()
    {
    }

    MOZ_IMPLICIT MessagePortIdentifier(
            const nsID& _uuid,
            const nsID& _destinationUuid,
            const uint32_t& _sequenceId,
            const bool& _neutered) :
        uuid_(_uuid),
        destinationUuid_(_destinationUuid),
        sequenceId_(_sequenceId),
        neutered_(_neutered)
    {
    }

    bool
    operator==(const MessagePortIdentifier& _o) const;

    bool
    operator!=(const MessagePortIdentifier& _o) const;

    nsID&
    uuid()
    {
        return uuid_;
    }
    const nsID&
    uuid() const
    {
        return uuid_;
    }

    nsID&
    destinationUuid()
    {
        return destinationUuid_;
    }
    const nsID&
    destinationUuid() const
    {
        return destinationUuid_;
    }

    uint32_t&
    sequenceId()
    {
        return sequenceId_;
    }
    const uint32_t&
    sequenceId() const
    {
        return sequenceId_;
    }

    bool&
    neutered()
    {
        return neutered_;
    }
    const bool&
    neutered() const
    {
        return neutered_;
    }

private:
    nsID uuid_;
    nsID destinationUuid_;
    uint32_t sequenceId_;
    bool neutered_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::MessagePortIdentifier>
{
    typedef mozilla::dom::MessagePortIdentifier paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClonedMessageData|
//
namespace mozilla {
namespace dom {
class ClonedMessageData final
{
private:
    typedef mozilla::SerializedStructuredCloneBuffer SerializedStructuredCloneBuffer;
    typedef mozilla::dom::IPCBlob IPCBlob;
    typedef mozilla::ipc::IPCStream IPCStream;
    typedef mozilla::dom::MessagePortIdentifier MessagePortIdentifier;

public:
    MOZ_IMPLICIT ClonedMessageData() :
        data_(),
        blobs_(),
        inputStreams_(),
        identfiers_()
    {
    }

    MOZ_IMPLICIT ClonedMessageData(
            const SerializedStructuredCloneBuffer& _data,
            const nsTArray<IPCBlob>& _blobs,
            const nsTArray<IPCStream>& _inputStreams,
            const nsTArray<MessagePortIdentifier>& _identfiers) :
        data_(_data),
        blobs_(_blobs),
        inputStreams_(_inputStreams),
        identfiers_(_identfiers)
    {
    }

    bool
    operator==(const ClonedMessageData& _o) const;

    bool
    operator!=(const ClonedMessageData& _o) const;

    SerializedStructuredCloneBuffer&
    data()
    {
        return data_;
    }
    const SerializedStructuredCloneBuffer&
    data() const
    {
        return data_;
    }

    nsTArray<IPCBlob>&
    blobs()
    {
        return blobs_;
    }
    const nsTArray<IPCBlob>&
    blobs() const
    {
        return blobs_;
    }

    nsTArray<IPCStream>&
    inputStreams()
    {
        return inputStreams_;
    }
    const nsTArray<IPCStream>&
    inputStreams() const
    {
        return inputStreams_;
    }

    nsTArray<MessagePortIdentifier>&
    identfiers()
    {
        return identfiers_;
    }
    const nsTArray<MessagePortIdentifier>&
    identfiers() const
    {
        return identfiers_;
    }

private:
    SerializedStructuredCloneBuffer data_;
    nsTArray<IPCBlob> blobs_;
    nsTArray<IPCStream> inputStreams_;
    nsTArray<MessagePortIdentifier> identfiers_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::ClonedMessageData>
{
    typedef mozilla::dom::ClonedMessageData paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCDataTransferData|
//
namespace mozilla {
namespace dom {
class IPCDataTransferData final
{
public:
    enum Type {
        T__None,
        TnsString = 1,
        TShmem,
        TIPCBlob,
        T__Last = TIPCBlob
    };

private:
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::dom::IPCBlob IPCBlob;
    typedef nsString nsString__tdef;
    typedef Shmem Shmem__tdef;
    typedef IPCBlob IPCBlob__tdef;

    union Value {
        mozilla::AlignedStorage2<nsString> VnsString;
        mozilla::AlignedStorage2<Shmem> VShmem;
        mozilla::AlignedStorage2<IPCBlob> VIPCBlob;
    };

    nsString*
    ptr_nsString()
    {
        return ((mValue).VnsString).addr();
    }
    const nsString*
    constptr_nsString() const
    {
        return ((mValue).VnsString).addr();
    }
    Shmem*
    ptr_Shmem()
    {
        return ((mValue).VShmem).addr();
    }
    const Shmem*
    constptr_Shmem() const
    {
        return ((mValue).VShmem).addr();
    }
    IPCBlob*
    ptr_IPCBlob()
    {
        return ((mValue).VIPCBlob).addr();
    }
    const IPCBlob*
    constptr_IPCBlob() const
    {
        return ((mValue).VIPCBlob).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCDataTransferData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCDataTransferData(const nsString& aOther);

    MOZ_IMPLICIT IPCDataTransferData(nsString&& aOther);

    MOZ_IMPLICIT IPCDataTransferData(Shmem& aOther);

    MOZ_IMPLICIT IPCDataTransferData(Shmem&& aOther);

    MOZ_IMPLICIT IPCDataTransferData(const IPCBlob& aOther);

    MOZ_IMPLICIT IPCDataTransferData(IPCBlob&& aOther);

    MOZ_IMPLICIT IPCDataTransferData(const IPCDataTransferData& aOther);

    MOZ_IMPLICIT IPCDataTransferData(IPCDataTransferData&& aOther);

    ~IPCDataTransferData();

    Type
    type() const
    {
        return mType;
    }

    IPCDataTransferData&
    operator=(const nsString& aRhs);

    IPCDataTransferData&
    operator=(nsString&& aRhs);

    IPCDataTransferData&
    operator=(Shmem& aRhs);

    IPCDataTransferData&
    operator=(Shmem&& aRhs);

    IPCDataTransferData&
    operator=(const IPCBlob& aRhs);

    IPCDataTransferData&
    operator=(IPCBlob&& aRhs);

    IPCDataTransferData&
    operator=(const IPCDataTransferData& aRhs);

    IPCDataTransferData&
    operator=(IPCDataTransferData&& aRhs);

    bool
    operator==(const nsString& aRhs) const;

    bool
    operator==(Shmem& aRhs) const;

    bool
    operator==(const IPCBlob& aRhs) const;

    bool
    operator==(const IPCDataTransferData& aRhs) const;

    nsString&
    get_nsString()
    {
        AssertSanity(TnsString);
        return (*(ptr_nsString()));
    }
    const nsString&
    get_nsString() const
    {
        AssertSanity(TnsString);
        return (*(constptr_nsString()));
    }
    void
    get(nsString* aOutValue) const;
    operator nsString&()
    {
        return get_nsString();
    }
    operator const nsString&() const
    {
        return get_nsString();
    }

    Shmem&
    get_Shmem()
    {
        AssertSanity(TShmem);
        return (*(ptr_Shmem()));
    }
    Shmem&
    get_Shmem() const
    {
        AssertSanity(TShmem);
        return const_cast<Shmem&>((*(constptr_Shmem())));
    }
    void
    get(Shmem* aOutValue) const;
    operator Shmem&()
    {
        return get_Shmem();
    }
    operator Shmem&() const
    {
        return get_Shmem();
    }

    IPCBlob&
    get_IPCBlob()
    {
        AssertSanity(TIPCBlob);
        return (*(ptr_IPCBlob()));
    }
    const IPCBlob&
    get_IPCBlob() const
    {
        AssertSanity(TIPCBlob);
        return (*(constptr_IPCBlob()));
    }
    void
    get(IPCBlob* aOutValue) const;
    operator IPCBlob&()
    {
        return get_IPCBlob();
    }
    operator const IPCBlob&() const
    {
        return get_IPCBlob();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCDataTransferData>
{
    typedef mozilla::dom::IPCDataTransferData paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCDataTransferImage|
//
namespace mozilla {
namespace dom {
class IPCDataTransferImage final
{
private:

public:
    MOZ_IMPLICIT IPCDataTransferImage() :
        width_(),
        height_(),
        stride_(),
        format_()
    {
    }

    MOZ_IMPLICIT IPCDataTransferImage(
            const uint32_t& _width,
            const uint32_t& _height,
            const uint32_t& _stride,
            const uint8_t& _format) :
        width_(_width),
        height_(_height),
        stride_(_stride),
        format_(_format)
    {
    }

    bool
    operator==(const IPCDataTransferImage& _o) const;

    bool
    operator!=(const IPCDataTransferImage& _o) const;

    uint32_t&
    width()
    {
        return width_;
    }
    const uint32_t&
    width() const
    {
        return width_;
    }

    uint32_t&
    height()
    {
        return height_;
    }
    const uint32_t&
    height() const
    {
        return height_;
    }

    uint32_t&
    stride()
    {
        return stride_;
    }
    const uint32_t&
    stride() const
    {
        return stride_;
    }

    uint8_t&
    format()
    {
        return format_;
    }
    const uint8_t&
    format() const
    {
        return format_;
    }

private:
    uint32_t width_;
    uint32_t height_;
    uint32_t stride_;
    uint8_t format_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCDataTransferImage>
{
    typedef mozilla::dom::IPCDataTransferImage paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCDataTransferItem|
//
namespace mozilla {
namespace dom {
class IPCDataTransferItem final
{
private:
    typedef mozilla::dom::IPCDataTransferImage IPCDataTransferImage;
    typedef mozilla::dom::IPCDataTransferData IPCDataTransferData;

public:
    MOZ_IMPLICIT IPCDataTransferItem() :
        flavor_(),
        imageDetails_(),
        data_()
    {
    }

    MOZ_IMPLICIT IPCDataTransferItem(
            const nsCString& _flavor,
            const IPCDataTransferImage& _imageDetails,
            const IPCDataTransferData& _data) :
        flavor_(_flavor),
        imageDetails_(_imageDetails),
        data_(_data)
    {
    }

    bool
    operator==(const IPCDataTransferItem& _o) const;

    bool
    operator!=(const IPCDataTransferItem& _o) const;

    nsCString&
    flavor()
    {
        return flavor_;
    }
    const nsCString&
    flavor() const
    {
        return flavor_;
    }

    IPCDataTransferImage&
    imageDetails()
    {
        return imageDetails_;
    }
    const IPCDataTransferImage&
    imageDetails() const
    {
        return imageDetails_;
    }

    IPCDataTransferData&
    data()
    {
        return data_;
    }
    const IPCDataTransferData&
    data() const
    {
        return data_;
    }

private:
    nsCString flavor_;
    IPCDataTransferImage imageDetails_;
    IPCDataTransferData data_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCDataTransferItem>
{
    typedef mozilla::dom::IPCDataTransferItem paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCDataTransfer|
//
namespace mozilla {
namespace dom {
class IPCDataTransfer final
{
private:
    typedef mozilla::dom::IPCDataTransferItem IPCDataTransferItem;

public:
    MOZ_IMPLICIT IPCDataTransfer() :
        items_()
    {
    }

    MOZ_IMPLICIT IPCDataTransfer(const nsTArray<IPCDataTransferItem>& _items) :
        items_(_items)
    {
    }

    bool
    operator==(const IPCDataTransfer& _o) const;

    bool
    operator!=(const IPCDataTransfer& _o) const;

    nsTArray<IPCDataTransferItem>&
    items()
    {
        return items_;
    }
    const nsTArray<IPCDataTransferItem>&
    items() const
    {
        return items_;
    }

private:
    nsTArray<IPCDataTransferItem> items_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCDataTransfer>
{
    typedef mozilla::dom::IPCDataTransfer paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ScreenDetails|
//
namespace mozilla {
namespace dom {
class ScreenDetails final
{
private:

public:
    MOZ_IMPLICIT ScreenDetails() :
        rect_(),
        rectDisplayPix_(),
        availRect_(),
        availRectDisplayPix_(),
        pixelDepth_(),
        colorDepth_(),
        contentsScaleFactor_(),
        defaultCSSScaleFactor_(),
        dpi_()
    {
    }

    MOZ_IMPLICIT ScreenDetails(
            const LayoutDeviceIntRect& _rect,
            const DesktopIntRect& _rectDisplayPix,
            const LayoutDeviceIntRect& _availRect,
            const DesktopIntRect& _availRectDisplayPix,
            const int32_t& _pixelDepth,
            const int32_t& _colorDepth,
            const DesktopToLayoutDeviceScale& _contentsScaleFactor,
            const CSSToLayoutDeviceScale& _defaultCSSScaleFactor,
            const float& _dpi) :
        rect_(_rect),
        rectDisplayPix_(_rectDisplayPix),
        availRect_(_availRect),
        availRectDisplayPix_(_availRectDisplayPix),
        pixelDepth_(_pixelDepth),
        colorDepth_(_colorDepth),
        contentsScaleFactor_(_contentsScaleFactor),
        defaultCSSScaleFactor_(_defaultCSSScaleFactor),
        dpi_(_dpi)
    {
    }

    bool
    operator==(const ScreenDetails& _o) const;

    bool
    operator!=(const ScreenDetails& _o) const;

    LayoutDeviceIntRect&
    rect()
    {
        return rect_;
    }
    const LayoutDeviceIntRect&
    rect() const
    {
        return rect_;
    }

    DesktopIntRect&
    rectDisplayPix()
    {
        return rectDisplayPix_;
    }
    const DesktopIntRect&
    rectDisplayPix() const
    {
        return rectDisplayPix_;
    }

    LayoutDeviceIntRect&
    availRect()
    {
        return availRect_;
    }
    const LayoutDeviceIntRect&
    availRect() const
    {
        return availRect_;
    }

    DesktopIntRect&
    availRectDisplayPix()
    {
        return availRectDisplayPix_;
    }
    const DesktopIntRect&
    availRectDisplayPix() const
    {
        return availRectDisplayPix_;
    }

    int32_t&
    pixelDepth()
    {
        return pixelDepth_;
    }
    const int32_t&
    pixelDepth() const
    {
        return pixelDepth_;
    }

    int32_t&
    colorDepth()
    {
        return colorDepth_;
    }
    const int32_t&
    colorDepth() const
    {
        return colorDepth_;
    }

    DesktopToLayoutDeviceScale&
    contentsScaleFactor()
    {
        return contentsScaleFactor_;
    }
    const DesktopToLayoutDeviceScale&
    contentsScaleFactor() const
    {
        return contentsScaleFactor_;
    }

    CSSToLayoutDeviceScale&
    defaultCSSScaleFactor()
    {
        return defaultCSSScaleFactor_;
    }
    const CSSToLayoutDeviceScale&
    defaultCSSScaleFactor() const
    {
        return defaultCSSScaleFactor_;
    }

    float&
    dpi()
    {
        return dpi_;
    }
    const float&
    dpi() const
    {
        return dpi_;
    }

private:
    LayoutDeviceIntRect rect_;
    DesktopIntRect rectDisplayPix_;
    LayoutDeviceIntRect availRect_;
    DesktopIntRect availRectDisplayPix_;
    int32_t pixelDepth_;
    int32_t colorDepth_;
    DesktopToLayoutDeviceScale contentsScaleFactor_;
    CSSToLayoutDeviceScale defaultCSSScaleFactor_;
    float dpi_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::ScreenDetails>
{
    typedef mozilla::dom::ScreenDetails paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DimensionInfo|
//
namespace mozilla {
namespace dom {
class DimensionInfo final
{
private:
    typedef mozilla::dom::ScreenOrientationInternal ScreenOrientationInternal;
    typedef mozilla::LayoutDeviceIntPoint LayoutDeviceIntPoint;

public:
    MOZ_IMPLICIT DimensionInfo() :
        rect_(),
        size_(),
        orientation_(),
        clientOffset_(),
        chromeOffset_()
    {
    }

    MOZ_IMPLICIT DimensionInfo(
            const CSSRect& _rect,
            const CSSSize& _size,
            const ScreenOrientationInternal& _orientation,
            const LayoutDeviceIntPoint& _clientOffset,
            const LayoutDeviceIntPoint& _chromeOffset) :
        rect_(_rect),
        size_(_size),
        orientation_(_orientation),
        clientOffset_(_clientOffset),
        chromeOffset_(_chromeOffset)
    {
    }

    bool
    operator==(const DimensionInfo& _o) const;

    bool
    operator!=(const DimensionInfo& _o) const;

    CSSRect&
    rect()
    {
        return rect_;
    }
    const CSSRect&
    rect() const
    {
        return rect_;
    }

    CSSSize&
    size()
    {
        return size_;
    }
    const CSSSize&
    size() const
    {
        return size_;
    }

    ScreenOrientationInternal&
    orientation()
    {
        return orientation_;
    }
    const ScreenOrientationInternal&
    orientation() const
    {
        return orientation_;
    }

    LayoutDeviceIntPoint&
    clientOffset()
    {
        return clientOffset_;
    }
    const LayoutDeviceIntPoint&
    clientOffset() const
    {
        return clientOffset_;
    }

    LayoutDeviceIntPoint&
    chromeOffset()
    {
        return chromeOffset_;
    }
    const LayoutDeviceIntPoint&
    chromeOffset() const
    {
        return chromeOffset_;
    }

private:
    CSSRect rect_;
    CSSSize size_;
    ScreenOrientationInternal orientation_;
    LayoutDeviceIntPoint clientOffset_;
    LayoutDeviceIntPoint chromeOffset_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::DimensionInfo>
{
    typedef mozilla::dom::DimensionInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FrameScriptInfo|
//
namespace mozilla {
namespace dom {
class FrameScriptInfo final
{
private:

public:
    MOZ_IMPLICIT FrameScriptInfo() :
        url_(),
        runInGlobalScope_()
    {
    }

    MOZ_IMPLICIT FrameScriptInfo(
            const nsString& _url,
            const bool& _runInGlobalScope) :
        url_(_url),
        runInGlobalScope_(_runInGlobalScope)
    {
    }

    bool
    operator==(const FrameScriptInfo& _o) const;

    bool
    operator!=(const FrameScriptInfo& _o) const;

    nsString&
    url()
    {
        return url_;
    }
    const nsString&
    url() const
    {
        return url_;
    }

    bool&
    runInGlobalScope()
    {
        return runInGlobalScope_;
    }
    const bool&
    runInGlobalScope() const
    {
        return runInGlobalScope_;
    }

private:
    nsString url_;
    bool runInGlobalScope_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::FrameScriptInfo>
{
    typedef mozilla::dom::FrameScriptInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CreatedWindowInfo|
//
namespace mozilla {
namespace dom {
class CreatedWindowInfo final
{
private:
    typedef mozilla::dom::FrameScriptInfo FrameScriptInfo;
    typedef mozilla::layers::TextureFactoryIdentifier TextureFactoryIdentifier;
    typedef mozilla::layers::LayersId LayersId;
    typedef mozilla::layers::CompositorOptions CompositorOptions;
    typedef mozilla::dom::DimensionInfo DimensionInfo;

public:
    MOZ_IMPLICIT CreatedWindowInfo() :
        rv_(),
        windowOpened_(),
        frameScripts_(),
        urlToLoad_(),
        textureFactoryIdentifier_(),
        layersId_(),
        compositorOptions_(),
        maxTouchPoints_(),
        dimensions_()
    {
    }

    MOZ_IMPLICIT CreatedWindowInfo(
            const nsresult& _rv,
            const bool& _windowOpened,
            const nsTArray<FrameScriptInfo>& _frameScripts,
            const nsCString& _urlToLoad,
            const TextureFactoryIdentifier& _textureFactoryIdentifier,
            const LayersId& _layersId,
            const CompositorOptions& _compositorOptions,
            const uint32_t& _maxTouchPoints,
            const DimensionInfo& _dimensions) :
        rv_(_rv),
        windowOpened_(_windowOpened),
        frameScripts_(_frameScripts),
        urlToLoad_(_urlToLoad),
        textureFactoryIdentifier_(_textureFactoryIdentifier),
        layersId_(_layersId),
        compositorOptions_(_compositorOptions),
        maxTouchPoints_(_maxTouchPoints),
        dimensions_(_dimensions)
    {
    }

    bool
    operator==(const CreatedWindowInfo& _o) const;

    bool
    operator!=(const CreatedWindowInfo& _o) const;

    nsresult&
    rv()
    {
        return rv_;
    }
    const nsresult&
    rv() const
    {
        return rv_;
    }

    bool&
    windowOpened()
    {
        return windowOpened_;
    }
    const bool&
    windowOpened() const
    {
        return windowOpened_;
    }

    nsTArray<FrameScriptInfo>&
    frameScripts()
    {
        return frameScripts_;
    }
    const nsTArray<FrameScriptInfo>&
    frameScripts() const
    {
        return frameScripts_;
    }

    nsCString&
    urlToLoad()
    {
        return urlToLoad_;
    }
    const nsCString&
    urlToLoad() const
    {
        return urlToLoad_;
    }

    TextureFactoryIdentifier&
    textureFactoryIdentifier()
    {
        return textureFactoryIdentifier_;
    }
    const TextureFactoryIdentifier&
    textureFactoryIdentifier() const
    {
        return textureFactoryIdentifier_;
    }

    LayersId&
    layersId()
    {
        return layersId_;
    }
    const LayersId&
    layersId() const
    {
        return layersId_;
    }

    CompositorOptions&
    compositorOptions()
    {
        return compositorOptions_;
    }
    const CompositorOptions&
    compositorOptions() const
    {
        return compositorOptions_;
    }

    uint32_t&
    maxTouchPoints()
    {
        return maxTouchPoints_;
    }
    const uint32_t&
    maxTouchPoints() const
    {
        return maxTouchPoints_;
    }

    DimensionInfo&
    dimensions()
    {
        return dimensions_;
    }
    const DimensionInfo&
    dimensions() const
    {
        return dimensions_;
    }

private:
    nsresult rv_;
    bool windowOpened_;
    nsTArray<FrameScriptInfo> frameScripts_;
    nsCString urlToLoad_;
    TextureFactoryIdentifier textureFactoryIdentifier_;
    LayersId layersId_;
    CompositorOptions compositorOptions_;
    uint32_t maxTouchPoints_;
    DimensionInfo dimensions_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::CreatedWindowInfo>
{
    typedef mozilla::dom::CreatedWindowInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef DOMTypes_h
