//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef FetchTypes_h
#define FetchTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "mozilla/dom/FetchIPCTypes.h"
#include "mozilla/ipc/IPCStream.h"
#include "mozilla/ipc/ChannelInfo.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HeadersEntry|
//
namespace mozilla {
namespace dom {
class HeadersEntry final
{
private:

public:
    MOZ_IMPLICIT HeadersEntry() :
        name_(),
        value_()
    {
    }

    MOZ_IMPLICIT HeadersEntry(
            const nsCString& _name,
            const nsCString& _value) :
        name_(_name),
        value_(_value)
    {
    }

    bool
    operator==(const HeadersEntry& _o) const;

    bool
    operator!=(const HeadersEntry& _o) const;

    nsCString&
    name()
    {
        return name_;
    }
    const nsCString&
    name() const
    {
        return name_;
    }

    nsCString&
    value()
    {
        return value_;
    }
    const nsCString&
    value() const
    {
        return value_;
    }

private:
    nsCString name_;
    nsCString value_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::HeadersEntry>
{
    typedef mozilla::dom::HeadersEntry paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCInternalRequest|
//
namespace mozilla {
namespace dom {
class IPCInternalRequest final
{
private:
    typedef mozilla::dom::HeadersEntry HeadersEntry;

public:
    MOZ_IMPLICIT IPCInternalRequest() :
        urls_(),
        method_(),
        headers_(),
        headersGuard_(),
        referrer_(),
        referrerPolicy_(),
        mode_(),
        credentials_(),
        contentPolicyType_(),
        requestCache_(),
        requestRedirect_()
    {
    }

    MOZ_IMPLICIT IPCInternalRequest(
            const nsTArray<nsCString>& _urls,
            const nsCString& _method,
            const nsTArray<HeadersEntry>& _headers,
            const HeadersGuardEnum& _headersGuard,
            const nsString& _referrer,
            const ReferrerPolicy& _referrerPolicy,
            const RequestMode& _mode,
            const RequestCredentials& _credentials,
            const uint32_t& _contentPolicyType,
            const RequestCache& _requestCache,
            const RequestRedirect& _requestRedirect) :
        urls_(_urls),
        method_(_method),
        headers_(_headers),
        headersGuard_(_headersGuard),
        referrer_(_referrer),
        referrerPolicy_(_referrerPolicy),
        mode_(_mode),
        credentials_(_credentials),
        contentPolicyType_(_contentPolicyType),
        requestCache_(_requestCache),
        requestRedirect_(_requestRedirect)
    {
    }

    bool
    operator==(const IPCInternalRequest& _o) const;

    bool
    operator!=(const IPCInternalRequest& _o) const;

    nsTArray<nsCString>&
    urls()
    {
        return urls_;
    }
    const nsTArray<nsCString>&
    urls() const
    {
        return urls_;
    }

    nsCString&
    method()
    {
        return method_;
    }
    const nsCString&
    method() const
    {
        return method_;
    }

    nsTArray<HeadersEntry>&
    headers()
    {
        return headers_;
    }
    const nsTArray<HeadersEntry>&
    headers() const
    {
        return headers_;
    }

    HeadersGuardEnum&
    headersGuard()
    {
        return headersGuard_;
    }
    const HeadersGuardEnum&
    headersGuard() const
    {
        return headersGuard_;
    }

    nsString&
    referrer()
    {
        return referrer_;
    }
    const nsString&
    referrer() const
    {
        return referrer_;
    }

    ReferrerPolicy&
    referrerPolicy()
    {
        return referrerPolicy_;
    }
    const ReferrerPolicy&
    referrerPolicy() const
    {
        return referrerPolicy_;
    }

    RequestMode&
    mode()
    {
        return mode_;
    }
    const RequestMode&
    mode() const
    {
        return mode_;
    }

    RequestCredentials&
    credentials()
    {
        return credentials_;
    }
    const RequestCredentials&
    credentials() const
    {
        return credentials_;
    }

    uint32_t&
    contentPolicyType()
    {
        return contentPolicyType_;
    }
    const uint32_t&
    contentPolicyType() const
    {
        return contentPolicyType_;
    }

    RequestCache&
    requestCache()
    {
        return requestCache_;
    }
    const RequestCache&
    requestCache() const
    {
        return requestCache_;
    }

    RequestRedirect&
    requestRedirect()
    {
        return requestRedirect_;
    }
    const RequestRedirect&
    requestRedirect() const
    {
        return requestRedirect_;
    }

private:
    nsTArray<nsCString> urls_;
    nsCString method_;
    nsTArray<HeadersEntry> headers_;
    HeadersGuardEnum headersGuard_;
    nsString referrer_;
    ReferrerPolicy referrerPolicy_;
    RequestMode mode_;
    RequestCredentials credentials_;
    uint32_t contentPolicyType_;
    RequestCache requestCache_;
    RequestRedirect requestRedirect_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCInternalRequest>
{
    typedef mozilla::dom::IPCInternalRequest paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCInternalResponse|
//
namespace mozilla {
namespace dom {
class IPCInternalResponse final
{
private:
    typedef mozilla::dom::HeadersEntry HeadersEntry;
    typedef mozilla::ipc::IPCChannelInfo IPCChannelInfo;
    typedef mozilla::ipc::OptionalPrincipalInfo OptionalPrincipalInfo;
    typedef mozilla::ipc::OptionalIPCStream OptionalIPCStream;

public:
    MOZ_IMPLICIT IPCInternalResponse() :
        type_(),
        urlList_(),
        status_(),
        statusText_(),
        headers_(),
        headersGuard_(),
        channelInfo_(),
        principalInfo_(),
        body_(),
        bodySize_(),
        errorCode_()
    {
    }

    MOZ_IMPLICIT IPCInternalResponse(
            const ResponseType& _type,
            const nsTArray<nsCString>& _urlList,
            const uint32_t& _status,
            const nsCString& _statusText,
            const nsTArray<HeadersEntry>& _headers,
            const HeadersGuardEnum& _headersGuard,
            const IPCChannelInfo& _channelInfo,
            const OptionalPrincipalInfo& _principalInfo,
            const OptionalIPCStream& _body,
            const int64_t& _bodySize,
            const nsresult& _errorCode) :
        type_(_type),
        urlList_(_urlList),
        status_(_status),
        statusText_(_statusText),
        headers_(_headers),
        headersGuard_(_headersGuard),
        channelInfo_(_channelInfo),
        principalInfo_(_principalInfo),
        body_(_body),
        bodySize_(_bodySize),
        errorCode_(_errorCode)
    {
    }

    bool
    operator==(const IPCInternalResponse& _o) const;

    bool
    operator!=(const IPCInternalResponse& _o) const;

    ResponseType&
    type()
    {
        return type_;
    }
    const ResponseType&
    type() const
    {
        return type_;
    }

    nsTArray<nsCString>&
    urlList()
    {
        return urlList_;
    }
    const nsTArray<nsCString>&
    urlList() const
    {
        return urlList_;
    }

    uint32_t&
    status()
    {
        return status_;
    }
    const uint32_t&
    status() const
    {
        return status_;
    }

    nsCString&
    statusText()
    {
        return statusText_;
    }
    const nsCString&
    statusText() const
    {
        return statusText_;
    }

    nsTArray<HeadersEntry>&
    headers()
    {
        return headers_;
    }
    const nsTArray<HeadersEntry>&
    headers() const
    {
        return headers_;
    }

    HeadersGuardEnum&
    headersGuard()
    {
        return headersGuard_;
    }
    const HeadersGuardEnum&
    headersGuard() const
    {
        return headersGuard_;
    }

    IPCChannelInfo&
    channelInfo()
    {
        return channelInfo_;
    }
    const IPCChannelInfo&
    channelInfo() const
    {
        return channelInfo_;
    }

    OptionalPrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const OptionalPrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    OptionalIPCStream&
    body()
    {
        return body_;
    }
    const OptionalIPCStream&
    body() const
    {
        return body_;
    }

    int64_t&
    bodySize()
    {
        return bodySize_;
    }
    const int64_t&
    bodySize() const
    {
        return bodySize_;
    }

    nsresult&
    errorCode()
    {
        return errorCode_;
    }
    const nsresult&
    errorCode() const
    {
        return errorCode_;
    }

private:
    ResponseType type_;
    nsTArray<nsCString> urlList_;
    uint32_t status_;
    nsCString statusText_;
    nsTArray<HeadersEntry> headers_;
    HeadersGuardEnum headersGuard_;
    IPCChannelInfo channelInfo_;
    OptionalPrincipalInfo principalInfo_;
    OptionalIPCStream body_;
    int64_t bodySize_;
    nsresult errorCode_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCInternalResponse>
{
    typedef mozilla::dom::IPCInternalResponse paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef FetchTypes_h
