//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef IPCServiceWorkerDescriptor_h
#define IPCServiceWorkerDescriptor_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "mozilla/dom/ServiceWorkerIPCUtils.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCServiceWorkerDescriptor|
//
namespace mozilla {
namespace dom {
class IPCServiceWorkerDescriptor final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;

public:
    MOZ_IMPLICIT IPCServiceWorkerDescriptor() :
        id_(),
        principalInfo_(),
        scope_(),
        scriptURL_(),
        state_()
    {
    }

    MOZ_IMPLICIT IPCServiceWorkerDescriptor(
            const uint64_t& _id,
            const PrincipalInfo& _principalInfo,
            const nsCString& _scope,
            const nsCString& _scriptURL,
            const ServiceWorkerState& _state) :
        id_(_id),
        principalInfo_(_principalInfo),
        scope_(_scope),
        scriptURL_(_scriptURL),
        state_(_state)
    {
    }

    bool
    operator==(const IPCServiceWorkerDescriptor& _o) const;

    bool
    operator!=(const IPCServiceWorkerDescriptor& _o) const;

    uint64_t&
    id()
    {
        return id_;
    }
    const uint64_t&
    id() const
    {
        return id_;
    }

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    nsCString&
    scope()
    {
        return scope_;
    }
    const nsCString&
    scope() const
    {
        return scope_;
    }

    nsCString&
    scriptURL()
    {
        return scriptURL_;
    }
    const nsCString&
    scriptURL() const
    {
        return scriptURL_;
    }

    ServiceWorkerState&
    state()
    {
        return state_;
    }
    const ServiceWorkerState&
    state() const
    {
        return state_;
    }

private:
    uint64_t id_;
    PrincipalInfo principalInfo_;
    nsCString scope_;
    nsCString scriptURL_;
    ServiceWorkerState state_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCServiceWorkerDescriptor>
{
    typedef mozilla::dom::IPCServiceWorkerDescriptor paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalIPCServiceWorkerDescriptor|
//
namespace mozilla {
namespace dom {
class OptionalIPCServiceWorkerDescriptor final
{
public:
    enum Type {
        T__None,
        TIPCServiceWorkerDescriptor = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::dom::IPCServiceWorkerDescriptor IPCServiceWorkerDescriptor;
    typedef mozilla::void_t void_t;
    typedef IPCServiceWorkerDescriptor IPCServiceWorkerDescriptor__tdef;
    typedef void_t void_t__tdef;

    union Value {
        mozilla::AlignedStorage2<IPCServiceWorkerDescriptor> VIPCServiceWorkerDescriptor;
        mozilla::AlignedStorage2<void_t> Vvoid_t;
    };

    IPCServiceWorkerDescriptor*
    ptr_IPCServiceWorkerDescriptor()
    {
        return ((mValue).VIPCServiceWorkerDescriptor).addr();
    }
    const IPCServiceWorkerDescriptor*
    constptr_IPCServiceWorkerDescriptor() const
    {
        return ((mValue).VIPCServiceWorkerDescriptor).addr();
    }
    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalIPCServiceWorkerDescriptor() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalIPCServiceWorkerDescriptor(const IPCServiceWorkerDescriptor& aOther);

    MOZ_IMPLICIT OptionalIPCServiceWorkerDescriptor(IPCServiceWorkerDescriptor&& aOther);

    MOZ_IMPLICIT OptionalIPCServiceWorkerDescriptor(const void_t& aOther);

    MOZ_IMPLICIT OptionalIPCServiceWorkerDescriptor(void_t&& aOther);

    MOZ_IMPLICIT OptionalIPCServiceWorkerDescriptor(const OptionalIPCServiceWorkerDescriptor& aOther);

    MOZ_IMPLICIT OptionalIPCServiceWorkerDescriptor(OptionalIPCServiceWorkerDescriptor&& aOther);

    ~OptionalIPCServiceWorkerDescriptor();

    Type
    type() const
    {
        return mType;
    }

    OptionalIPCServiceWorkerDescriptor&
    operator=(const IPCServiceWorkerDescriptor& aRhs);

    OptionalIPCServiceWorkerDescriptor&
    operator=(IPCServiceWorkerDescriptor&& aRhs);

    OptionalIPCServiceWorkerDescriptor&
    operator=(const void_t& aRhs);

    OptionalIPCServiceWorkerDescriptor&
    operator=(void_t&& aRhs);

    OptionalIPCServiceWorkerDescriptor&
    operator=(const OptionalIPCServiceWorkerDescriptor& aRhs);

    OptionalIPCServiceWorkerDescriptor&
    operator=(OptionalIPCServiceWorkerDescriptor&& aRhs);

    bool
    operator==(const IPCServiceWorkerDescriptor& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const OptionalIPCServiceWorkerDescriptor& aRhs) const;

    IPCServiceWorkerDescriptor&
    get_IPCServiceWorkerDescriptor()
    {
        AssertSanity(TIPCServiceWorkerDescriptor);
        return (*(ptr_IPCServiceWorkerDescriptor()));
    }
    const IPCServiceWorkerDescriptor&
    get_IPCServiceWorkerDescriptor() const
    {
        AssertSanity(TIPCServiceWorkerDescriptor);
        return (*(constptr_IPCServiceWorkerDescriptor()));
    }
    void
    get(IPCServiceWorkerDescriptor* aOutValue) const;
    operator IPCServiceWorkerDescriptor&()
    {
        return get_IPCServiceWorkerDescriptor();
    }
    operator const IPCServiceWorkerDescriptor&() const
    {
        return get_IPCServiceWorkerDescriptor();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::OptionalIPCServiceWorkerDescriptor>
{
    typedef mozilla::dom::OptionalIPCServiceWorkerDescriptor paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef IPCServiceWorkerDescriptor_h
