//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef MemoryReportTypes_h
#define MemoryReportTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MemoryReport|
//
namespace mozilla {
namespace dom {
class MemoryReport final
{
private:

public:
    MOZ_IMPLICIT MemoryReport() :
        process_(),
        path_(),
        kind_(),
        units_(),
        amount_(),
        generation_(),
        desc_()
    {
    }

    MOZ_IMPLICIT MemoryReport(
            const nsCString& _process,
            const nsCString& _path,
            const int32_t& _kind,
            const int32_t& _units,
            const int64_t& _amount,
            const uint32_t& _generation,
            const nsCString& _desc) :
        process_(_process),
        path_(_path),
        kind_(_kind),
        units_(_units),
        amount_(_amount),
        generation_(_generation),
        desc_(_desc)
    {
    }

    bool
    operator==(const MemoryReport& _o) const;

    bool
    operator!=(const MemoryReport& _o) const;

    nsCString&
    process()
    {
        return process_;
    }
    const nsCString&
    process() const
    {
        return process_;
    }

    nsCString&
    path()
    {
        return path_;
    }
    const nsCString&
    path() const
    {
        return path_;
    }

    int32_t&
    kind()
    {
        return kind_;
    }
    const int32_t&
    kind() const
    {
        return kind_;
    }

    int32_t&
    units()
    {
        return units_;
    }
    const int32_t&
    units() const
    {
        return units_;
    }

    int64_t&
    amount()
    {
        return amount_;
    }
    const int64_t&
    amount() const
    {
        return amount_;
    }

    uint32_t&
    generation()
    {
        return generation_;
    }
    const uint32_t&
    generation() const
    {
        return generation_;
    }

    nsCString&
    desc()
    {
        return desc_;
    }
    const nsCString&
    desc() const
    {
        return desc_;
    }

private:
    nsCString process_;
    nsCString path_;
    int32_t kind_;
    int32_t units_;
    int64_t amount_;
    uint32_t generation_;
    nsCString desc_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::MemoryReport>
{
    typedef mozilla::dom::MemoryReport paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union MaybeFileDesc|
//
namespace mozilla {
namespace dom {
class MaybeFileDesc final
{
public:
    enum Type {
        T__None,
        TFileDescriptor = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::void_t void_t;
    typedef FileDescriptor FileDescriptor__tdef;
    typedef void_t void_t__tdef;

    union Value {
        mozilla::AlignedStorage2<FileDescriptor> VFileDescriptor;
        mozilla::AlignedStorage2<void_t> Vvoid_t;
    };

    FileDescriptor*
    ptr_FileDescriptor()
    {
        return ((mValue).VFileDescriptor).addr();
    }
    const FileDescriptor*
    constptr_FileDescriptor() const
    {
        return ((mValue).VFileDescriptor).addr();
    }
    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT MaybeFileDesc() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT MaybeFileDesc(const FileDescriptor& aOther);

    MOZ_IMPLICIT MaybeFileDesc(FileDescriptor&& aOther);

    MOZ_IMPLICIT MaybeFileDesc(const void_t& aOther);

    MOZ_IMPLICIT MaybeFileDesc(void_t&& aOther);

    MOZ_IMPLICIT MaybeFileDesc(const MaybeFileDesc& aOther);

    MOZ_IMPLICIT MaybeFileDesc(MaybeFileDesc&& aOther);

    ~MaybeFileDesc();

    Type
    type() const
    {
        return mType;
    }

    MaybeFileDesc&
    operator=(const FileDescriptor& aRhs);

    MaybeFileDesc&
    operator=(FileDescriptor&& aRhs);

    MaybeFileDesc&
    operator=(const void_t& aRhs);

    MaybeFileDesc&
    operator=(void_t&& aRhs);

    MaybeFileDesc&
    operator=(const MaybeFileDesc& aRhs);

    MaybeFileDesc&
    operator=(MaybeFileDesc&& aRhs);

    bool
    operator==(const FileDescriptor& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const MaybeFileDesc& aRhs) const;

    FileDescriptor&
    get_FileDescriptor()
    {
        AssertSanity(TFileDescriptor);
        return (*(ptr_FileDescriptor()));
    }
    const FileDescriptor&
    get_FileDescriptor() const
    {
        AssertSanity(TFileDescriptor);
        return const_cast<FileDescriptor&>((*(constptr_FileDescriptor())));
    }
    void
    get(FileDescriptor* aOutValue) const;
    operator FileDescriptor&()
    {
        return get_FileDescriptor();
    }
    operator const FileDescriptor&() const
    {
        return get_FileDescriptor();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::MaybeFileDesc>
{
    typedef mozilla::dom::MaybeFileDesc paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef MemoryReportTypes_h
