//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBackgroundStorageParent_h
#define PBackgroundStorageParent_h

#include "mozilla/dom/PBackgroundStorage.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/OriginAttributes.h"
#include "mozilla/dom/quota/SerializationHelpers.h"

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {


class PBackgroundStorageParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::ipc::PBackgroundParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::OriginAttributesPattern OriginAttributesPattern;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;

    typedef PBackgroundStorage::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvDeleteMe() = 0;
    virtual mozilla::ipc::IPCResult
    RecvPreload(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const uint32_t& alreadyLoadedCount,
            nsTArray<nsString>* keys,
            nsTArray<nsString>* values,
            nsresult* rv) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncPreload(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const bool& priority) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncGetUsage(const nsCString& scope) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncAddItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncUpdateItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncRemoveItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncClear(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncFlush() = 0;
    virtual mozilla::ipc::IPCResult
    RecvStartup() = 0;
    virtual mozilla::ipc::IPCResult
    RecvClearAll() = 0;
    virtual mozilla::ipc::IPCResult
    RecvClearMatchingOrigin(const nsCString& originNoSuffix) = 0;
    virtual mozilla::ipc::IPCResult
    RecvClearMatchingOriginAttributes(const OriginAttributesPattern& pattern) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PBackgroundStorageParent();

    virtual ~PBackgroundStorageParent();

    PBackgroundParent*
    Manager() const;

    MOZ_MUST_USE static bool
    Send__delete__(PBackgroundStorageParent* actor);

    MOZ_MUST_USE bool
    SendObserve(
            const nsCString& topic,
            const nsString& originAttributesPattern,
            const nsCString& originScope);

    MOZ_MUST_USE bool
    SendOriginsHavingData(const nsTArray<nsCString>& origins);

    MOZ_MUST_USE bool
    SendLoadItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value);

    MOZ_MUST_USE bool
    SendLoadDone(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsresult& rv);

    MOZ_MUST_USE bool
    SendLoadUsage(
            const nsCString& scope,
            const int64_t& usage);

    MOZ_MUST_USE bool
    SendError(const nsresult& rv);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::PBackgroundStorageParent*>
{
    typedef mozilla::dom::PBackgroundStorageParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class BackgroundStorageParent :
    public PBackgroundStorageParent
{
    mozilla::ipc::IPCResult
    RecvDeleteMe() override;

    mozilla::ipc::IPCResult
    RecvPreload(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const uint32_t& alreadyLoadedCount,
            nsTArray<nsString>* keys,
            nsTArray<nsString>* values,
            nsresult* rv) override;

    mozilla::ipc::IPCResult
    RecvAsyncPreload(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const bool& priority) override;

    mozilla::ipc::IPCResult
    RecvAsyncGetUsage(const nsCString& scope) override;

    mozilla::ipc::IPCResult
    RecvAsyncAddItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value) override;

    mozilla::ipc::IPCResult
    RecvAsyncUpdateItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value) override;

    mozilla::ipc::IPCResult
    RecvAsyncRemoveItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key) override;

    mozilla::ipc::IPCResult
    RecvAsyncClear(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix) override;

    mozilla::ipc::IPCResult
    RecvAsyncFlush() override;

    mozilla::ipc::IPCResult
    RecvStartup() override;

    mozilla::ipc::IPCResult
    RecvClearAll() override;

    mozilla::ipc::IPCResult
    RecvClearMatchingOrigin(const nsCString& originNoSuffix) override;

    mozilla::ipc::IPCResult
    RecvClearMatchingOriginAttributes(const OriginAttributesPattern& pattern) override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT BackgroundStorageParent();
    virtual ~BackgroundStorageParent();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
mozilla::ipc::IPCResult
BackgroundStorageParent::RecvDeleteMe()
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvPreload(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const uint32_t& alreadyLoadedCount,
        nsTArray<nsString>* keys,
        nsTArray<nsString>* values,
        nsresult* rv)
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvAsyncPreload(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const bool& priority)
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvAsyncGetUsage(const nsCString& scope)
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvAsyncAddItem(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const nsString& key,
        const nsString& value)
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvAsyncUpdateItem(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const nsString& key,
        const nsString& value)
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvAsyncRemoveItem(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const nsString& key)
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvAsyncClear(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix)
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvAsyncFlush()
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvStartup()
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvClearAll()
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvClearMatchingOrigin(const nsCString& originNoSuffix)
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvClearMatchingOriginAttributes(const OriginAttributesPattern& pattern)
{
}

void
BackgroundStorageParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT BackgroundStorageParent::BackgroundStorageParent()
{
    MOZ_COUNT_CTOR(BackgroundStorageParent);
}

MOZ_IMPLICIT BackgroundStorageParent::~BackgroundStorageParent()
{
    MOZ_COUNT_DTOR(BackgroundStorageParent);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PBackgroundStorageParent_h
