//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBrowser_h
#define PBrowser_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/dom/DOMTypes.h"
#include "mozilla/dom/IPCBlob.h"
#include "mozilla/ipc/IPCStream.h"
#include "mozilla/jsipc/JavaScriptTypes.h"
#include "mozilla/ipc/URIParams.h"
#include "mozilla/embedding/PPrintingTypes.h"
#include "mozilla/dom/PTabContext.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ShowInfo|
//
namespace mozilla {
namespace dom {
class ShowInfo final
{
private:

public:
    MOZ_IMPLICIT ShowInfo() :
        name_(),
        fullscreenAllowed_(),
        isPrivate_(),
        fakeShowInfo_(),
        isTransparent_(),
        dpi_(),
        widgetRounding_(),
        defaultScale_()
    {
    }

    MOZ_IMPLICIT ShowInfo(
            const nsString& _name,
            const bool& _fullscreenAllowed,
            const bool& _isPrivate,
            const bool& _fakeShowInfo,
            const bool& _isTransparent,
            const float& _dpi,
            const int32_t& _widgetRounding,
            const double& _defaultScale) :
        name_(_name),
        fullscreenAllowed_(_fullscreenAllowed),
        isPrivate_(_isPrivate),
        fakeShowInfo_(_fakeShowInfo),
        isTransparent_(_isTransparent),
        dpi_(_dpi),
        widgetRounding_(_widgetRounding),
        defaultScale_(_defaultScale)
    {
    }

    bool
    operator==(const ShowInfo& _o) const;

    bool
    operator!=(const ShowInfo& _o) const;

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

    bool&
    fullscreenAllowed()
    {
        return fullscreenAllowed_;
    }
    const bool&
    fullscreenAllowed() const
    {
        return fullscreenAllowed_;
    }

    bool&
    isPrivate()
    {
        return isPrivate_;
    }
    const bool&
    isPrivate() const
    {
        return isPrivate_;
    }

    bool&
    fakeShowInfo()
    {
        return fakeShowInfo_;
    }
    const bool&
    fakeShowInfo() const
    {
        return fakeShowInfo_;
    }

    bool&
    isTransparent()
    {
        return isTransparent_;
    }
    const bool&
    isTransparent() const
    {
        return isTransparent_;
    }

    float&
    dpi()
    {
        return dpi_;
    }
    const float&
    dpi() const
    {
        return dpi_;
    }

    int32_t&
    widgetRounding()
    {
        return widgetRounding_;
    }
    const int32_t&
    widgetRounding() const
    {
        return widgetRounding_;
    }

    double&
    defaultScale()
    {
        return defaultScale_;
    }
    const double&
    defaultScale() const
    {
        return defaultScale_;
    }

private:
    nsString name_;
    bool fullscreenAllowed_;
    bool isPrivate_;
    bool fakeShowInfo_;
    bool isTransparent_;
    float dpi_;
    int32_t widgetRounding_;
    double defaultScale_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::ShowInfo>
{
    typedef mozilla::dom::ShowInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalShmem|
//
namespace mozilla {
namespace dom {
class OptionalShmem final
{
public:
    enum Type {
        T__None,
        Tvoid_t = 1,
        TShmem,
        T__Last = TShmem
    };

private:
    typedef mozilla::void_t void_t;
    typedef mozilla::ipc::Shmem Shmem;
    typedef void_t void_t__tdef;
    typedef Shmem Shmem__tdef;

    union Value {
        mozilla::AlignedStorage2<void_t> Vvoid_t;
        mozilla::AlignedStorage2<Shmem> VShmem;
    };

    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }
    Shmem*
    ptr_Shmem()
    {
        return ((mValue).VShmem).addr();
    }
    const Shmem*
    constptr_Shmem() const
    {
        return ((mValue).VShmem).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalShmem() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalShmem(const void_t& aOther);

    MOZ_IMPLICIT OptionalShmem(void_t&& aOther);

    MOZ_IMPLICIT OptionalShmem(Shmem& aOther);

    MOZ_IMPLICIT OptionalShmem(Shmem&& aOther);

    MOZ_IMPLICIT OptionalShmem(const OptionalShmem& aOther);

    MOZ_IMPLICIT OptionalShmem(OptionalShmem&& aOther);

    ~OptionalShmem();

    Type
    type() const
    {
        return mType;
    }

    OptionalShmem&
    operator=(const void_t& aRhs);

    OptionalShmem&
    operator=(void_t&& aRhs);

    OptionalShmem&
    operator=(Shmem& aRhs);

    OptionalShmem&
    operator=(Shmem&& aRhs);

    OptionalShmem&
    operator=(const OptionalShmem& aRhs);

    OptionalShmem&
    operator=(OptionalShmem&& aRhs);

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(Shmem& aRhs) const;

    bool
    operator==(const OptionalShmem& aRhs) const;

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

    Shmem&
    get_Shmem()
    {
        AssertSanity(TShmem);
        return (*(ptr_Shmem()));
    }
    Shmem&
    get_Shmem() const
    {
        AssertSanity(TShmem);
        return const_cast<Shmem&>((*(constptr_Shmem())));
    }
    void
    get(Shmem* aOutValue) const;
    operator Shmem&()
    {
        return get_Shmem();
    }
    operator Shmem&() const
    {
        return get_Shmem();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::OptionalShmem>
{
    typedef mozilla::dom::OptionalShmem paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PBrowserChild and PBrowserParent
//
namespace mozilla {
namespace dom {
namespace PBrowser {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PBrowserParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PBrowserChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Start = __Null
};

enum MessageType {
    PBrowserStart = PBrowserMsgStart << 16,
    Msg_AsyncMessage__ID,
    Msg_PRenderFrameConstructor__ID,
    Reply_PRenderFrameConstructor__ID,
    Msg_PDocAccessibleConstructor__ID,
    Reply_PDocAccessibleConstructor__ID,
    Msg_PPaymentRequestConstructor__ID,
    Reply_PPaymentRequestConstructor__ID,
    Msg_SetNativeChildOfShareableWindow__ID,
    Msg_DispatchFocusToTopLevelWindow__ID,
    Reply_DispatchFocusToTopLevelWindow__ID,
    Msg_MoveFocus__ID,
    Msg_SizeShellTo__ID,
    Msg_DropLinks__ID,
    Msg_Event__ID,
    Msg_SyncMessage__ID,
    Reply_SyncMessage__ID,
    Msg_RpcMessage__ID,
    Reply_RpcMessage__ID,
    Msg_NotifyIMEFocus__ID,
    Reply_NotifyIMEFocus__ID,
    Msg_NotifyIMETextChange__ID,
    Msg_NotifyIMECompositionUpdate__ID,
    Msg_NotifyIMESelection__ID,
    Msg_UpdateContentCache__ID,
    Msg_NotifyIMEMouseButtonEvent__ID,
    Reply_NotifyIMEMouseButtonEvent__ID,
    Msg_NotifyIMEPositionChange__ID,
    Msg_RequestIMEToCommitComposition__ID,
    Reply_RequestIMEToCommitComposition__ID,
    Msg_OnEventNeedingAckHandled__ID,
    Msg_RequestFocus__ID,
    Msg_EnableDisableCommands__ID,
    Msg_GetInputContext__ID,
    Reply_GetInputContext__ID,
    Msg_SetInputContext__ID,
    Msg_SetCursor__ID,
    Msg_SetCustomCursor__ID,
    Msg_SetStatus__ID,
    Msg_ShowTooltip__ID,
    Msg_HideTooltip__ID,
    Msg_PColorPickerConstructor__ID,
    Reply_PColorPickerConstructor__ID,
    Msg_PFilePickerConstructor__ID,
    Reply_PFilePickerConstructor__ID,
    Msg_PIndexedDBPermissionRequestConstructor__ID,
    Reply_PIndexedDBPermissionRequestConstructor__ID,
    Msg_BrowserFrameOpenWindow__ID,
    Reply_BrowserFrameOpenWindow__ID,
    Msg_RespondStartSwipeEvent__ID,
    Msg_AsyncAuthPrompt__ID,
    Msg_LookUpDictionary__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_ReplyKeyEvent__ID,
    Msg_RequestNativeKeyBindings__ID,
    Reply_RequestNativeKeyBindings__ID,
    Msg_SynthesizeNativeKeyEvent__ID,
    Msg_SynthesizeNativeMouseEvent__ID,
    Msg_SynthesizeNativeMouseMove__ID,
    Msg_SynthesizeNativeMouseScrollEvent__ID,
    Msg_SynthesizeNativeTouchPoint__ID,
    Msg_SynthesizeNativeTouchTap__ID,
    Msg_ClearNativeTouchSequence__ID,
    Msg_GetTabCount__ID,
    Reply_GetTabCount__ID,
    Msg_AccessKeyNotHandled__ID,
    Msg_SetHasBeforeUnload__ID,
    Msg_NativeSynthesisResponse__ID,
    Msg_RemotePaintIsReady__ID,
    Msg_RemoteIsReadyToHandleInputEvents__ID,
    Msg_ForcePaintNoOp__ID,
    Msg_SetDimensions__ID,
    Msg_DispatchWheelEvent__ID,
    Reply_DispatchWheelEvent__ID,
    Msg_DispatchMouseEvent__ID,
    Reply_DispatchMouseEvent__ID,
    Msg_DispatchKeyboardEvent__ID,
    Reply_DispatchKeyboardEvent__ID,
    Msg_InvokeDragSession__ID,
    Msg_EnsureLayersConnected__ID,
    Reply_EnsureLayersConnected__ID,
    Msg_Show__ID,
    Msg_InitRendering__ID,
    Msg_LoadURL__ID,
    Msg_UpdateDimensions__ID,
    Msg_SizeModeChanged__ID,
    Msg_ParentActivated__ID,
    Msg_SetKeyboardIndicators__ID,
    Msg_StopIMEStateManagement__ID,
    Msg_MouseEvent__ID,
    Msg_RealMouseMoveEvent__ID,
    Msg_NormalPriorityRealMouseMoveEvent__ID,
    Msg_SynthMouseMoveEvent__ID,
    Msg_NormalPrioritySynthMouseMoveEvent__ID,
    Msg_RealMouseButtonEvent__ID,
    Msg_NormalPriorityRealMouseButtonEvent__ID,
    Msg_RealKeyEvent__ID,
    Msg_NormalPriorityRealKeyEvent__ID,
    Msg_MouseWheelEvent__ID,
    Msg_NormalPriorityMouseWheelEvent__ID,
    Msg_RealTouchEvent__ID,
    Msg_NormalPriorityRealTouchEvent__ID,
    Msg_HandleTap__ID,
    Msg_NormalPriorityHandleTap__ID,
    Msg_RealTouchMoveEvent__ID,
    Msg_NormalPriorityRealTouchMoveEvent__ID,
    Msg_RealDragEvent__ID,
    Msg_KeyEvent__ID,
    Msg_CompositionEvent__ID,
    Msg_NormalPriorityCompositionEvent__ID,
    Msg_SelectionEvent__ID,
    Msg_NormalPrioritySelectionEvent__ID,
    Msg_PasteTransferable__ID,
    Msg_ActivateFrameEvent__ID,
    Msg_LoadRemoteScript__ID,
    Msg_Destroy__ID,
    Msg_SetDocShellIsActive__ID,
    Msg_RenderLayers__ID,
    Msg_SuppressDisplayport__ID,
    Msg_NavigateByKey__ID,
    Msg_RequestNotifyAfterRemotePaint__ID,
    Msg_UIResolutionChanged__ID,
    Msg_ThemeChanged__ID,
    Msg_SwappedWithOtherRemoteLoader__ID,
    Msg_HandleAccessKey__ID,
    Msg_SetUseGlobalHistory__ID,
    Msg_Print__ID,
    Msg_UpdateNativeWindowHandle__ID,
    Msg_AwaitLargeAlloc__ID,
    Msg_SetWindowName__ID,
    Msg_SetOriginAttributes__ID,
    Msg_SetWidgetNativeData__ID,
    PBrowserEnd
};

void
Transition(
        MessageType msg,
        State* next);

IPC::Message*
Msg_AsyncMessage(int32_t routingId);

IPC::Message*
Msg_PRenderFrameConstructor(int32_t routingId);
IPC::Message*
Reply_PRenderFrameConstructor(int32_t routingId);

IPC::Message*
Msg_PDocAccessibleConstructor(int32_t routingId);
IPC::Message*
Reply_PDocAccessibleConstructor(int32_t routingId);

IPC::Message*
Msg_PPaymentRequestConstructor(int32_t routingId);
IPC::Message*
Reply_PPaymentRequestConstructor(int32_t routingId);

IPC::Message*
Msg_SetNativeChildOfShareableWindow(int32_t routingId);

IPC::Message*
Msg_DispatchFocusToTopLevelWindow(int32_t routingId);
IPC::Message*
Reply_DispatchFocusToTopLevelWindow(int32_t routingId);

IPC::Message*
Msg_MoveFocus(int32_t routingId);

IPC::Message*
Msg_SizeShellTo(int32_t routingId);

IPC::Message*
Msg_DropLinks(int32_t routingId);

IPC::Message*
Msg_Event(int32_t routingId);

IPC::Message*
Msg_SyncMessage(int32_t routingId);
IPC::Message*
Reply_SyncMessage(int32_t routingId);

IPC::Message*
Msg_RpcMessage(int32_t routingId);
IPC::Message*
Reply_RpcMessage(int32_t routingId);

IPC::Message*
Msg_NotifyIMEFocus(int32_t routingId);
IPC::Message*
Reply_NotifyIMEFocus(int32_t routingId);

IPC::Message*
Msg_NotifyIMETextChange(int32_t routingId);

IPC::Message*
Msg_NotifyIMECompositionUpdate(int32_t routingId);

IPC::Message*
Msg_NotifyIMESelection(int32_t routingId);

IPC::Message*
Msg_UpdateContentCache(int32_t routingId);

IPC::Message*
Msg_NotifyIMEMouseButtonEvent(int32_t routingId);
IPC::Message*
Reply_NotifyIMEMouseButtonEvent(int32_t routingId);

IPC::Message*
Msg_NotifyIMEPositionChange(int32_t routingId);

IPC::Message*
Msg_RequestIMEToCommitComposition(int32_t routingId);
IPC::Message*
Reply_RequestIMEToCommitComposition(int32_t routingId);

IPC::Message*
Msg_OnEventNeedingAckHandled(int32_t routingId);

IPC::Message*
Msg_RequestFocus(int32_t routingId);

IPC::Message*
Msg_EnableDisableCommands(int32_t routingId);

IPC::Message*
Msg_GetInputContext(int32_t routingId);
IPC::Message*
Reply_GetInputContext(int32_t routingId);

IPC::Message*
Msg_SetInputContext(int32_t routingId);

IPC::Message*
Msg_SetCursor(int32_t routingId);

IPC::Message*
Msg_SetCustomCursor(int32_t routingId);

IPC::Message*
Msg_SetStatus(int32_t routingId);

IPC::Message*
Msg_ShowTooltip(int32_t routingId);

IPC::Message*
Msg_HideTooltip(int32_t routingId);

IPC::Message*
Msg_PColorPickerConstructor(int32_t routingId);
IPC::Message*
Reply_PColorPickerConstructor(int32_t routingId);

IPC::Message*
Msg_PFilePickerConstructor(int32_t routingId);
IPC::Message*
Reply_PFilePickerConstructor(int32_t routingId);

IPC::Message*
Msg_PIndexedDBPermissionRequestConstructor(int32_t routingId);
IPC::Message*
Reply_PIndexedDBPermissionRequestConstructor(int32_t routingId);

IPC::Message*
Msg_BrowserFrameOpenWindow(int32_t routingId);
IPC::Message*
Reply_BrowserFrameOpenWindow(int32_t routingId);

IPC::Message*
Msg_RespondStartSwipeEvent(int32_t routingId);

IPC::Message*
Msg_AsyncAuthPrompt(int32_t routingId);

IPC::Message*
Msg_LookUpDictionary(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_ReplyKeyEvent(int32_t routingId);

IPC::Message*
Msg_RequestNativeKeyBindings(int32_t routingId);
IPC::Message*
Reply_RequestNativeKeyBindings(int32_t routingId);

IPC::Message*
Msg_SynthesizeNativeKeyEvent(int32_t routingId);

IPC::Message*
Msg_SynthesizeNativeMouseEvent(int32_t routingId);

IPC::Message*
Msg_SynthesizeNativeMouseMove(int32_t routingId);

IPC::Message*
Msg_SynthesizeNativeMouseScrollEvent(int32_t routingId);

IPC::Message*
Msg_SynthesizeNativeTouchPoint(int32_t routingId);

IPC::Message*
Msg_SynthesizeNativeTouchTap(int32_t routingId);

IPC::Message*
Msg_ClearNativeTouchSequence(int32_t routingId);

IPC::Message*
Msg_GetTabCount(int32_t routingId);
IPC::Message*
Reply_GetTabCount(int32_t routingId);

IPC::Message*
Msg_AccessKeyNotHandled(int32_t routingId);

IPC::Message*
Msg_SetHasBeforeUnload(int32_t routingId);

IPC::Message*
Msg_NativeSynthesisResponse(int32_t routingId);

IPC::Message*
Msg_RemotePaintIsReady(int32_t routingId);

IPC::Message*
Msg_RemoteIsReadyToHandleInputEvents(int32_t routingId);

IPC::Message*
Msg_ForcePaintNoOp(int32_t routingId);

IPC::Message*
Msg_SetDimensions(int32_t routingId);

IPC::Message*
Msg_DispatchWheelEvent(int32_t routingId);
IPC::Message*
Reply_DispatchWheelEvent(int32_t routingId);

IPC::Message*
Msg_DispatchMouseEvent(int32_t routingId);
IPC::Message*
Reply_DispatchMouseEvent(int32_t routingId);

IPC::Message*
Msg_DispatchKeyboardEvent(int32_t routingId);
IPC::Message*
Reply_DispatchKeyboardEvent(int32_t routingId);

IPC::Message*
Msg_InvokeDragSession(int32_t routingId);

IPC::Message*
Msg_EnsureLayersConnected(int32_t routingId);
IPC::Message*
Reply_EnsureLayersConnected(int32_t routingId);

IPC::Message*
Msg_Show(int32_t routingId);

IPC::Message*
Msg_InitRendering(int32_t routingId);

IPC::Message*
Msg_LoadURL(int32_t routingId);

IPC::Message*
Msg_UpdateDimensions(int32_t routingId);

IPC::Message*
Msg_SizeModeChanged(int32_t routingId);

IPC::Message*
Msg_ParentActivated(int32_t routingId);

IPC::Message*
Msg_SetKeyboardIndicators(int32_t routingId);

IPC::Message*
Msg_StopIMEStateManagement(int32_t routingId);

IPC::Message*
Msg_MouseEvent(int32_t routingId);

IPC::Message*
Msg_RealMouseMoveEvent(int32_t routingId);

IPC::Message*
Msg_NormalPriorityRealMouseMoveEvent(int32_t routingId);

IPC::Message*
Msg_SynthMouseMoveEvent(int32_t routingId);

IPC::Message*
Msg_NormalPrioritySynthMouseMoveEvent(int32_t routingId);

IPC::Message*
Msg_RealMouseButtonEvent(int32_t routingId);

IPC::Message*
Msg_NormalPriorityRealMouseButtonEvent(int32_t routingId);

IPC::Message*
Msg_RealKeyEvent(int32_t routingId);

IPC::Message*
Msg_NormalPriorityRealKeyEvent(int32_t routingId);

IPC::Message*
Msg_MouseWheelEvent(int32_t routingId);

IPC::Message*
Msg_NormalPriorityMouseWheelEvent(int32_t routingId);

IPC::Message*
Msg_RealTouchEvent(int32_t routingId);

IPC::Message*
Msg_NormalPriorityRealTouchEvent(int32_t routingId);

IPC::Message*
Msg_HandleTap(int32_t routingId);

IPC::Message*
Msg_NormalPriorityHandleTap(int32_t routingId);

IPC::Message*
Msg_RealTouchMoveEvent(int32_t routingId);

IPC::Message*
Msg_NormalPriorityRealTouchMoveEvent(int32_t routingId);

IPC::Message*
Msg_RealDragEvent(int32_t routingId);

IPC::Message*
Msg_KeyEvent(int32_t routingId);

IPC::Message*
Msg_CompositionEvent(int32_t routingId);

IPC::Message*
Msg_NormalPriorityCompositionEvent(int32_t routingId);

IPC::Message*
Msg_SelectionEvent(int32_t routingId);

IPC::Message*
Msg_NormalPrioritySelectionEvent(int32_t routingId);

IPC::Message*
Msg_PasteTransferable(int32_t routingId);

IPC::Message*
Msg_ActivateFrameEvent(int32_t routingId);

IPC::Message*
Msg_LoadRemoteScript(int32_t routingId);

IPC::Message*
Msg_Destroy(int32_t routingId);

IPC::Message*
Msg_SetDocShellIsActive(int32_t routingId);

IPC::Message*
Msg_RenderLayers(int32_t routingId);

IPC::Message*
Msg_SuppressDisplayport(int32_t routingId);

IPC::Message*
Msg_NavigateByKey(int32_t routingId);

IPC::Message*
Msg_RequestNotifyAfterRemotePaint(int32_t routingId);

IPC::Message*
Msg_UIResolutionChanged(int32_t routingId);

IPC::Message*
Msg_ThemeChanged(int32_t routingId);

IPC::Message*
Msg_SwappedWithOtherRemoteLoader(int32_t routingId);

IPC::Message*
Msg_HandleAccessKey(int32_t routingId);

IPC::Message*
Msg_SetUseGlobalHistory(int32_t routingId);

IPC::Message*
Msg_Print(int32_t routingId);

IPC::Message*
Msg_UpdateNativeWindowHandle(int32_t routingId);

IPC::Message*
Msg_AwaitLargeAlloc(int32_t routingId);

IPC::Message*
Msg_SetWindowName(int32_t routingId);

IPC::Message*
Msg_SetOriginAttributes(int32_t routingId);

IPC::Message*
Msg_SetWidgetNativeData(int32_t routingId);



} // namespace PBrowser
} // namespace dom
} // namespace mozilla

#endif // ifndef PBrowser_h
