//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGamepadEventChannelParent_h
#define PGamepadEventChannelParent_h

#include "mozilla/dom/PGamepadEventChannel.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {


class PGamepadEventChannelParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::ipc::PBackgroundParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::dom::GamepadAdded GamepadAdded;
    typedef mozilla::dom::GamepadAxisInformation GamepadAxisInformation;
    typedef mozilla::dom::GamepadButtonInformation GamepadButtonInformation;
    typedef mozilla::dom::GamepadChangeEvent GamepadChangeEvent;
    typedef mozilla::dom::GamepadChangeEventBody GamepadChangeEventBody;
    typedef mozilla::dom::GamepadHand GamepadHand;
    typedef mozilla::dom::GamepadHandInformation GamepadHandInformation;
    typedef mozilla::dom::GamepadMappingType GamepadMappingType;
    typedef mozilla::dom::GamepadPoseInformation GamepadPoseInformation;
    typedef mozilla::dom::GamepadPoseState GamepadPoseState;
    typedef mozilla::dom::GamepadRemoved GamepadRemoved;
    typedef mozilla::dom::GamepadServiceType GamepadServiceType;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;

    typedef PGamepadEventChannel::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvGamepadListenerAdded() = 0;
    virtual mozilla::ipc::IPCResult
    RecvGamepadListenerRemoved() = 0;
    virtual mozilla::ipc::IPCResult
    RecvVibrateHaptic(
            const uint32_t& aControllerIdx,
            const uint32_t& aHapticIndex,
            const double& aIntensity,
            const double& aDuration,
            const uint32_t& aPromiseID) = 0;
    virtual mozilla::ipc::IPCResult
    RecvStopVibrateHaptic(const uint32_t& aGamepadIndex) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PGamepadEventChannelParent();

    virtual ~PGamepadEventChannelParent();

    PBackgroundParent*
    Manager() const;

    MOZ_MUST_USE static bool
    Send__delete__(PGamepadEventChannelParent* actor);

    MOZ_MUST_USE bool
    SendGamepadUpdate(const GamepadChangeEvent& aGamepadEvent);

    MOZ_MUST_USE bool
    SendReplyGamepadVibrateHaptic(const uint32_t& aPromiseID);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::PGamepadEventChannelParent*>
{
    typedef mozilla::dom::PGamepadEventChannelParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class GamepadEventChannelParent :
    public PGamepadEventChannelParent
{
    mozilla::ipc::IPCResult
    RecvGamepadListenerAdded() override;

    mozilla::ipc::IPCResult
    RecvGamepadListenerRemoved() override;

    mozilla::ipc::IPCResult
    RecvVibrateHaptic(
            const uint32_t& aControllerIdx,
            const uint32_t& aHapticIndex,
            const double& aIntensity,
            const double& aDuration,
            const uint32_t& aPromiseID) override;

    mozilla::ipc::IPCResult
    RecvStopVibrateHaptic(const uint32_t& aGamepadIndex) override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT GamepadEventChannelParent();
    virtual ~GamepadEventChannelParent();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
mozilla::ipc::IPCResult
GamepadEventChannelParent::RecvGamepadListenerAdded()
{
}

mozilla::ipc::IPCResult
GamepadEventChannelParent::RecvGamepadListenerRemoved()
{
}

mozilla::ipc::IPCResult
GamepadEventChannelParent::RecvVibrateHaptic(
        const uint32_t& aControllerIdx,
        const uint32_t& aHapticIndex,
        const double& aIntensity,
        const double& aDuration,
        const uint32_t& aPromiseID)
{
}

mozilla::ipc::IPCResult
GamepadEventChannelParent::RecvStopVibrateHaptic(const uint32_t& aGamepadIndex)
{
}

void
GamepadEventChannelParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT GamepadEventChannelParent::GamepadEventChannelParent()
{
    MOZ_COUNT_CTOR(GamepadEventChannelParent);
}

MOZ_IMPLICIT GamepadEventChannelParent::~GamepadEventChannelParent()
{
    MOZ_COUNT_DTOR(GamepadEventChannelParent);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PGamepadEventChannelParent_h
