//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PPaymentRequestChild_h
#define PPaymentRequestChild_h

#include "mozilla/dom/PPaymentRequest.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla

namespace IPC {
class Principal;
} // namespace IPC

namespace mozilla {
namespace dom {


class PPaymentRequestChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::dom::PBrowserChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::dom::IPCPaymentAbortActionRequest IPCPaymentAbortActionRequest;
    typedef mozilla::dom::IPCPaymentAbortActionResponse IPCPaymentAbortActionResponse;
    typedef mozilla::dom::IPCPaymentActionRequest IPCPaymentActionRequest;
    typedef mozilla::dom::IPCPaymentActionResponse IPCPaymentActionResponse;
    typedef mozilla::dom::IPCPaymentAddress IPCPaymentAddress;
    typedef mozilla::dom::IPCPaymentCanMakeActionRequest IPCPaymentCanMakeActionRequest;
    typedef mozilla::dom::IPCPaymentCanMakeActionResponse IPCPaymentCanMakeActionResponse;
    typedef mozilla::dom::IPCPaymentCompleteActionRequest IPCPaymentCompleteActionRequest;
    typedef mozilla::dom::IPCPaymentCompleteActionResponse IPCPaymentCompleteActionResponse;
    typedef mozilla::dom::IPCPaymentCreateActionRequest IPCPaymentCreateActionRequest;
    typedef mozilla::dom::IPCPaymentCurrencyAmount IPCPaymentCurrencyAmount;
    typedef mozilla::dom::IPCPaymentDetails IPCPaymentDetails;
    typedef mozilla::dom::IPCPaymentDetailsModifier IPCPaymentDetailsModifier;
    typedef mozilla::dom::IPCPaymentItem IPCPaymentItem;
    typedef mozilla::dom::IPCPaymentMethodData IPCPaymentMethodData;
    typedef mozilla::dom::IPCPaymentOptions IPCPaymentOptions;
    typedef mozilla::dom::IPCPaymentShippingOption IPCPaymentShippingOption;
    typedef mozilla::dom::IPCPaymentShowActionRequest IPCPaymentShowActionRequest;
    typedef mozilla::dom::IPCPaymentShowActionResponse IPCPaymentShowActionResponse;
    typedef mozilla::dom::IPCPaymentUpdateActionRequest IPCPaymentUpdateActionRequest;
    typedef IPC::Principal Principal;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PBrowserChild PBrowserChild;
    typedef mozilla::dom::PBrowserParent PBrowserParent;

    typedef PPaymentRequest::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvRespondPayment(const IPCPaymentActionResponse& aResponse) = 0;
    virtual mozilla::ipc::IPCResult
    RecvChangeShippingAddress(
            const nsString& aRequestId,
            const IPCPaymentAddress& aAddress) = 0;
    virtual mozilla::ipc::IPCResult
    RecvChangeShippingOption(
            const nsString& aRequestId,
            const nsString& aOption) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PPaymentRequestChild();

    virtual ~PPaymentRequestChild();

    PBrowserChild*
    Manager() const;

    static bool
    Send__delete__(PPaymentRequestChild* actor);

    bool
    SendRequestPayment(const IPCPaymentActionRequest& aAction);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::PPaymentRequestChild*>
{
    typedef mozilla::dom::PPaymentRequestChild* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class PaymentRequestChild :
    public PPaymentRequestChild
{
    mozilla::ipc::IPCResult
    RecvRespondPayment(const IPCPaymentActionResponse& aResponse) override;

    mozilla::ipc::IPCResult
    RecvChangeShippingAddress(
            const nsString& aRequestId,
            const IPCPaymentAddress& aAddress) override;

    mozilla::ipc::IPCResult
    RecvChangeShippingOption(
            const nsString& aRequestId,
            const nsString& aOption) override;

    MOZ_IMPLICIT PaymentRequestChild();
    virtual ~PaymentRequestChild();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
mozilla::ipc::IPCResult
PaymentRequestChild::RecvRespondPayment(const IPCPaymentActionResponse& aResponse)
{
}

mozilla::ipc::IPCResult
PaymentRequestChild::RecvChangeShippingAddress(
        const nsString& aRequestId,
        const IPCPaymentAddress& aAddress)
{
}

mozilla::ipc::IPCResult
PaymentRequestChild::RecvChangeShippingOption(
        const nsString& aRequestId,
        const nsString& aOption)
{
}

MOZ_IMPLICIT PaymentRequestChild::PaymentRequestChild()
{
    MOZ_COUNT_CTOR(PaymentRequestChild);
}

MOZ_IMPLICIT PaymentRequestChild::~PaymentRequestChild()
{
    MOZ_COUNT_DTOR(PaymentRequestChild);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PPaymentRequestChild_h
