//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PSpeechSynthesisParent_h
#define PSpeechSynthesisParent_h

#include "mozilla/dom/PSpeechSynthesis.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PSpeechSynthesisRequestParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PSpeechSynthesisRequestChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PSpeechSynthesisRequestParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {


class PSpeechSynthesisParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::dom::PSpeechSynthesisRequestParent;
    friend class mozilla::dom::PContentParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::dom::RemoteVoice RemoteVoice;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PSpeechSynthesisRequestParent PSpeechSynthesisRequestParent;
    typedef mozilla::dom::PSpeechSynthesisRequestChild PSpeechSynthesisRequestChild;

    typedef PSpeechSynthesis::State State;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
    virtual mozilla::ipc::IPCResult
    RecvPSpeechSynthesisRequestConstructor(
            PSpeechSynthesisRequestParent* actor,
            const nsString& aText,
            const nsString& aUri,
            const nsString& aLang,
            const float& aVolume,
            const float& aRate,
            const float& aPitch,
            const bool& aIsChrome);
    virtual PSpeechSynthesisRequestParent*
    AllocPSpeechSynthesisRequestParent(
            const nsString& aText,
            const nsString& aUri,
            const nsString& aLang,
            const float& aVolume,
            const float& aRate,
            const float& aPitch,
            const bool& aIsChrome) = 0;
    virtual bool
    DeallocPSpeechSynthesisRequestParent(PSpeechSynthesisRequestParent* aActor) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PSpeechSynthesisParent();

    virtual ~PSpeechSynthesisParent();

    PContentParent*
    Manager() const;

    void
    ManagedPSpeechSynthesisRequestParent(nsTArray<PSpeechSynthesisRequestParent*>& aArr) const;
    const ManagedContainer<PSpeechSynthesisRequestParent>&
    ManagedPSpeechSynthesisRequestParent() const;

    MOZ_MUST_USE bool
    SendVoiceAdded(const RemoteVoice& aVoice);

    MOZ_MUST_USE bool
    SendVoiceRemoved(const nsString& aUri);

    MOZ_MUST_USE bool
    SendSetDefaultVoice(
            const nsString& aUri,
            const bool& aIsDefault);

    MOZ_MUST_USE bool
    SendIsSpeakingChanged(const bool& aIsSpeaking);

    MOZ_MUST_USE bool
    SendNotifyVoicesChanged();

    MOZ_MUST_USE bool
    SendInitialVoicesAndState(
            const nsTArray<RemoteVoice>& aVoices,
            const nsTArray<nsString>& aDefaults,
            const bool& aIsSpeaking);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
    ManagedContainer<PSpeechSynthesisRequestParent> mManagedPSpeechSynthesisRequestParent;
};


} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::PSpeechSynthesisParent*>
{
    typedef mozilla::dom::PSpeechSynthesisParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class SpeechSynthesisParent :
    public PSpeechSynthesisParent
{
    PSpeechSynthesisRequestParent*
    AllocPSpeechSynthesisRequestParent(
            const nsString& aText,
            const nsString& aUri,
            const nsString& aLang,
            const float& aVolume,
            const float& aRate,
            const float& aPitch,
            const bool& aIsChrome) override;

    bool
    DeallocPSpeechSynthesisRequestParent(PSpeechSynthesisRequestParent* aActor) override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT SpeechSynthesisParent();
    virtual ~SpeechSynthesisParent();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
PSpeechSynthesisRequestParent*
SpeechSynthesisParent::AllocPSpeechSynthesisRequestParent(
        const nsString& aText,
        const nsString& aUri,
        const nsString& aLang,
        const float& aVolume,
        const float& aRate,
        const float& aPitch,
        const bool& aIsChrome)
{
    return 0;
}

bool
SpeechSynthesisParent::DeallocPSpeechSynthesisRequestParent(PSpeechSynthesisRequestParent* aActor)
{
    return false;
}

void
SpeechSynthesisParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT SpeechSynthesisParent::SpeechSynthesisParent()
{
    MOZ_COUNT_CTOR(SpeechSynthesisParent);
}

MOZ_IMPLICIT SpeechSynthesisParent::~SpeechSynthesisParent()
{
    MOZ_COUNT_DTOR(SpeechSynthesisParent);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PSpeechSynthesisParent_h
