//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PVideoDecoder_h
#define PVideoDecoder_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/layers/LayersSurfaces.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MediaDataIPDL|
//
namespace mozilla {
namespace dom {
class MediaDataIPDL final
{
private:

public:
    MOZ_IMPLICIT MediaDataIPDL() :
        offset_(),
        time_(),
        timecode_(),
        duration_(),
        frames_(),
        keyframe_()
    {
    }

    MOZ_IMPLICIT MediaDataIPDL(
            const int64_t& _offset,
            const int64_t& _time,
            const int64_t& _timecode,
            const int64_t& _duration,
            const uint32_t& _frames,
            const bool& _keyframe) :
        offset_(_offset),
        time_(_time),
        timecode_(_timecode),
        duration_(_duration),
        frames_(_frames),
        keyframe_(_keyframe)
    {
    }

    bool
    operator==(const MediaDataIPDL& _o) const;

    bool
    operator!=(const MediaDataIPDL& _o) const;

    int64_t&
    offset()
    {
        return offset_;
    }
    const int64_t&
    offset() const
    {
        return offset_;
    }

    int64_t&
    time()
    {
        return time_;
    }
    const int64_t&
    time() const
    {
        return time_;
    }

    int64_t&
    timecode()
    {
        return timecode_;
    }
    const int64_t&
    timecode() const
    {
        return timecode_;
    }

    int64_t&
    duration()
    {
        return duration_;
    }
    const int64_t&
    duration() const
    {
        return duration_;
    }

    uint32_t&
    frames()
    {
        return frames_;
    }
    const uint32_t&
    frames() const
    {
        return frames_;
    }

    bool&
    keyframe()
    {
        return keyframe_;
    }
    const bool&
    keyframe() const
    {
        return keyframe_;
    }

private:
    int64_t offset_;
    int64_t time_;
    int64_t timecode_;
    int64_t duration_;
    uint32_t frames_;
    bool keyframe_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::MediaDataIPDL>
{
    typedef mozilla::dom::MediaDataIPDL paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct VideoDataIPDL|
//
namespace mozilla {
namespace dom {
class VideoDataIPDL final
{
private:
    typedef mozilla::dom::MediaDataIPDL MediaDataIPDL;
    typedef mozilla::gfx::IntSize IntSize;
    typedef mozilla::layers::SurfaceDescriptorGPUVideo SurfaceDescriptorGPUVideo;

public:
    MOZ_IMPLICIT VideoDataIPDL() :
        base_(),
        display_(),
        frameSize_(),
        sd_(),
        frameID_()
    {
    }

    MOZ_IMPLICIT VideoDataIPDL(
            const MediaDataIPDL& _base,
            const IntSize& _display,
            const IntSize& _frameSize,
            const SurfaceDescriptorGPUVideo& _sd,
            const int32_t& _frameID) :
        base_(_base),
        display_(_display),
        frameSize_(_frameSize),
        sd_(_sd),
        frameID_(_frameID)
    {
    }

    bool
    operator==(const VideoDataIPDL& _o) const;

    bool
    operator!=(const VideoDataIPDL& _o) const;

    MediaDataIPDL&
    base()
    {
        return base_;
    }
    const MediaDataIPDL&
    base() const
    {
        return base_;
    }

    IntSize&
    display()
    {
        return display_;
    }
    const IntSize&
    display() const
    {
        return display_;
    }

    IntSize&
    frameSize()
    {
        return frameSize_;
    }
    const IntSize&
    frameSize() const
    {
        return frameSize_;
    }

    SurfaceDescriptorGPUVideo&
    sd()
    {
        return sd_;
    }
    const SurfaceDescriptorGPUVideo&
    sd() const
    {
        return sd_;
    }

    int32_t&
    frameID()
    {
        return frameID_;
    }
    const int32_t&
    frameID() const
    {
        return frameID_;
    }

private:
    MediaDataIPDL base_;
    IntSize display_;
    IntSize frameSize_;
    SurfaceDescriptorGPUVideo sd_;
    int32_t frameID_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::VideoDataIPDL>
{
    typedef mozilla::dom::VideoDataIPDL paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MediaRawDataIPDL|
//
namespace mozilla {
namespace dom {
class MediaRawDataIPDL final
{
private:
    typedef mozilla::dom::MediaDataIPDL MediaDataIPDL;
    typedef mozilla::ipc::Shmem Shmem;

public:
    MOZ_IMPLICIT MediaRawDataIPDL() :
        base_(),
        buffer_()
    {
    }

    MOZ_IMPLICIT MediaRawDataIPDL(
            const MediaDataIPDL& _base,
            Shmem& _buffer) :
        base_(_base),
        buffer_(_buffer)
    {
    }

    bool
    operator==(const MediaRawDataIPDL& _o) const;

    bool
    operator!=(const MediaRawDataIPDL& _o) const;

    MediaDataIPDL&
    base()
    {
        return base_;
    }
    const MediaDataIPDL&
    base() const
    {
        return base_;
    }

    Shmem&
    buffer()
    {
        return buffer_;
    }
    Shmem&
    buffer() const
    {
        return const_cast<Shmem&>(buffer_);
    }

private:
    MediaDataIPDL base_;
    Shmem buffer_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::MediaRawDataIPDL>
{
    typedef mozilla::dom::MediaRawDataIPDL paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {
class PVideoDecoderParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PVideoDecoderChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PVideoDecoderChild and PVideoDecoderParent
//
namespace mozilla {
namespace dom {
namespace PVideoDecoder {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PVideoDecoderParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PVideoDecoderChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Start = __Null
};

enum MessageType {
    PVideoDecoderStart = PVideoDecoderMsgStart << 16,
    Msg_Init__ID,
    Msg_Input__ID,
    Msg_Flush__ID,
    Msg_Drain__ID,
    Msg_Shutdown__ID,
    Msg_SetSeekThreshold__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_InitComplete__ID,
    Msg_InitFailed__ID,
    Msg_FlushComplete__ID,
    Msg_Output__ID,
    Msg_InputExhausted__ID,
    Msg_DrainComplete__ID,
    Msg_Error__ID,
    PVideoDecoderEnd
};

void
Transition(
        MessageType msg,
        State* next);

IPC::Message*
Msg_Init(int32_t routingId);

IPC::Message*
Msg_Input(int32_t routingId);

IPC::Message*
Msg_Flush(int32_t routingId);

IPC::Message*
Msg_Drain(int32_t routingId);

IPC::Message*
Msg_Shutdown(int32_t routingId);

IPC::Message*
Msg_SetSeekThreshold(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_InitComplete(int32_t routingId);

IPC::Message*
Msg_InitFailed(int32_t routingId);

IPC::Message*
Msg_FlushComplete(int32_t routingId);

IPC::Message*
Msg_Output(int32_t routingId);

IPC::Message*
Msg_InputExhausted(int32_t routingId);

IPC::Message*
Msg_DrainComplete(int32_t routingId);

IPC::Message*
Msg_Error(int32_t routingId);



} // namespace PVideoDecoder
} // namespace dom
} // namespace mozilla

#endif // ifndef PVideoDecoder_h
