//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebAuthnTransactionChild_h
#define PWebAuthnTransactionChild_h

#include "mozilla/dom/PWebAuthnTransaction.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {


class PWebAuthnTransactionChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::ipc::PBackgroundChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::WebAuthnAuthenticatorSelection WebAuthnAuthenticatorSelection;
    typedef mozilla::dom::WebAuthnExtension WebAuthnExtension;
    typedef mozilla::dom::WebAuthnExtensionAppId WebAuthnExtensionAppId;
    typedef mozilla::dom::WebAuthnExtensionResult WebAuthnExtensionResult;
    typedef mozilla::dom::WebAuthnExtensionResultAppId WebAuthnExtensionResultAppId;
    typedef mozilla::dom::WebAuthnGetAssertionInfo WebAuthnGetAssertionInfo;
    typedef mozilla::dom::WebAuthnGetAssertionResult WebAuthnGetAssertionResult;
    typedef mozilla::dom::WebAuthnMakeCredentialInfo WebAuthnMakeCredentialInfo;
    typedef mozilla::dom::WebAuthnMakeCredentialResult WebAuthnMakeCredentialResult;
    typedef mozilla::dom::WebAuthnScopedCredential WebAuthnScopedCredential;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;

    typedef PWebAuthnTransaction::State State;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
    virtual mozilla::ipc::IPCResult
    RecvConfirmRegister(
            const uint64_t& aTransactionId,
            const WebAuthnMakeCredentialResult& aResult) = 0;
    virtual mozilla::ipc::IPCResult
    RecvConfirmSign(
            const uint64_t& aTransactionId,
            const WebAuthnGetAssertionResult& aResult) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAbort(
            const uint64_t& aTransactionId,
            const nsresult& Error) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PWebAuthnTransactionChild();

    virtual ~PWebAuthnTransactionChild();

    PBackgroundChild*
    Manager() const;

    bool
    SendRequestRegister(
            const uint64_t& aTransactionId,
            const WebAuthnMakeCredentialInfo& aTransactionInfo);

    bool
    SendRequestSign(
            const uint64_t& aTransactionId,
            const WebAuthnGetAssertionInfo& aTransactionInfo);

    bool
    SendRequestCancel(const uint64_t& aTransactionId);

    bool
    SendDestroyMe();

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::PWebAuthnTransactionChild*>
{
    typedef mozilla::dom::PWebAuthnTransactionChild* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class WebAuthnTransactionChild :
    public PWebAuthnTransactionChild
{
    mozilla::ipc::IPCResult
    RecvConfirmRegister(
            const uint64_t& aTransactionId,
            const WebAuthnMakeCredentialResult& aResult) override;

    mozilla::ipc::IPCResult
    RecvConfirmSign(
            const uint64_t& aTransactionId,
            const WebAuthnGetAssertionResult& aResult) override;

    mozilla::ipc::IPCResult
    RecvAbort(
            const uint64_t& aTransactionId,
            const nsresult& Error) override;

    MOZ_IMPLICIT WebAuthnTransactionChild();
    virtual ~WebAuthnTransactionChild();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
mozilla::ipc::IPCResult
WebAuthnTransactionChild::RecvConfirmRegister(
        const uint64_t& aTransactionId,
        const WebAuthnMakeCredentialResult& aResult)
{
}

mozilla::ipc::IPCResult
WebAuthnTransactionChild::RecvConfirmSign(
        const uint64_t& aTransactionId,
        const WebAuthnGetAssertionResult& aResult)
{
}

mozilla::ipc::IPCResult
WebAuthnTransactionChild::RecvAbort(
        const uint64_t& aTransactionId,
        const nsresult& Error)
{
}

MOZ_IMPLICIT WebAuthnTransactionChild::WebAuthnTransactionChild()
{
    MOZ_COUNT_CTOR(WebAuthnTransactionChild);
}

MOZ_IMPLICIT WebAuthnTransactionChild::~WebAuthnTransactionChild()
{
    MOZ_COUNT_DTOR(WebAuthnTransactionChild);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PWebAuthnTransactionChild_h
