//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PCacheStreamControlChild_h
#define PCacheStreamControlChild_h

#include "mozilla/dom/cache/PCacheStreamControl.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

#include "mozilla/WeakPtr.h"
// Headers for things that cannot be forward declared
#include "mozilla/ipc/IPCStreamUtils.h"

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PFileDescriptorSetChild;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PFileDescriptorSetParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PChildToParentStreamChild;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PChildToParentStreamParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PParentToChildStreamChild;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PParentToChildStreamParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace cache {
class PCacheChild;
} // namespace cache
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace cache {
class PCacheStorageChild;
} // namespace cache
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace cache {
class PCacheOpChild;
} // namespace cache
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

struct nsID;

namespace mozilla {
namespace dom {
namespace cache {


class PCacheStreamControlChild :
    public mozilla::ipc::IProtocol,
    public SupportsWeakPtr<PCacheStreamControlChild>
{
public:
    MOZ_DECLARE_WEAKREFERENCE_TYPENAME(PCacheStreamControlChild)
private:
    friend class mozilla::dom::cache::PCacheChild;
    friend class mozilla::dom::cache::PCacheStorageChild;
    friend class mozilla::dom::cache::PCacheOpChild;
    friend class mozilla::ipc::PBackgroundChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef mozilla::ipc::PFileDescriptorSetChild PFileDescriptorSetChild;
    typedef mozilla::ipc::PFileDescriptorSetParent PFileDescriptorSetParent;
    typedef mozilla::ipc::PChildToParentStreamChild PChildToParentStreamChild;
    typedef mozilla::ipc::PChildToParentStreamParent PChildToParentStreamParent;
    typedef mozilla::ipc::PParentToChildStreamChild PParentToChildStreamChild;
    typedef mozilla::ipc::PParentToChildStreamParent PParentToChildStreamParent;

    typedef PCacheStreamControl::State State;

public:
    typedef MozPromise<nsCOMPtr<nsIInputStream>, ResponseRejectReason, false> OpenStreamPromise;

protected:
    virtual mozilla::ipc::IPCResult
    RecvClose(const nsID& aStreamId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvCloseAll() = 0;
    virtual mozilla::ipc::IPCResult
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PCacheStreamControlChild();

    virtual ~PCacheStreamControlChild();

    PBackgroundChild*
    Manager() const;

    void
    SendOpenStream(
            const nsID& aStreamId,
            mozilla::ipc::ResolveCallback<nsCOMPtr<nsIInputStream>>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<OpenStreamPromise>
    SendOpenStream(const nsID& aStreamId);

    bool
    SendNoteClosed(const nsID& aStreamId);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace cache
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::cache::PCacheStreamControlChild*>
{
    typedef mozilla::dom::cache::PCacheStreamControlChild* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
namespace cache {
class CacheStreamControlChild :
    public PCacheStreamControlChild
{
    mozilla::ipc::IPCResult
    RecvClose(const nsID& aStreamId) override;

    mozilla::ipc::IPCResult
    RecvCloseAll() override;

    MOZ_IMPLICIT CacheStreamControlChild();
    virtual ~CacheStreamControlChild();
};
} // namespace cache
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
namespace cache {
mozilla::ipc::IPCResult
CacheStreamControlChild::RecvClose(const nsID& aStreamId)
{
}

mozilla::ipc::IPCResult
CacheStreamControlChild::RecvCloseAll()
{
}

MOZ_IMPLICIT CacheStreamControlChild::CacheStreamControlChild()
{
    MOZ_COUNT_CTOR(CacheStreamControlChild);
}

MOZ_IMPLICIT CacheStreamControlChild::~CacheStreamControlChild()
{
    MOZ_COUNT_DTOR(CacheStreamControlChild);
}

} // namespace cache
} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PCacheStreamControlChild_h
