//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PCacheStreamControlParent_h
#define PCacheStreamControlParent_h

#include "mozilla/dom/cache/PCacheStreamControl.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

#include "mozilla/WeakPtr.h"
// Headers for things that cannot be forward declared
#include "mozilla/ipc/IPCStreamUtils.h"

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PFileDescriptorSetParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PFileDescriptorSetChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PChildToParentStreamParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PChildToParentStreamChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PParentToChildStreamParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PParentToChildStreamChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace cache {
class PCacheParent;
} // namespace cache
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace cache {
class PCacheStorageParent;
} // namespace cache
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace cache {
class PCacheOpParent;
} // namespace cache
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

struct nsID;

namespace mozilla {
namespace dom {
namespace cache {


class PCacheStreamControlParent :
    public mozilla::ipc::IProtocol,
    public SupportsWeakPtr<PCacheStreamControlParent>
{
public:
    MOZ_DECLARE_WEAKREFERENCE_TYPENAME(PCacheStreamControlParent)
private:
    friend class mozilla::dom::cache::PCacheParent;
    friend class mozilla::dom::cache::PCacheStorageParent;
    friend class mozilla::dom::cache::PCacheOpParent;
    friend class mozilla::ipc::PBackgroundParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;
    typedef mozilla::ipc::PFileDescriptorSetParent PFileDescriptorSetParent;
    typedef mozilla::ipc::PFileDescriptorSetChild PFileDescriptorSetChild;
    typedef mozilla::ipc::PChildToParentStreamParent PChildToParentStreamParent;
    typedef mozilla::ipc::PChildToParentStreamChild PChildToParentStreamChild;
    typedef mozilla::ipc::PParentToChildStreamParent PParentToChildStreamParent;
    typedef mozilla::ipc::PParentToChildStreamChild PParentToChildStreamChild;

    typedef PCacheStreamControl::State State;

public:
    typedef std::function<void(const nsCOMPtr<nsIInputStream>&)> OpenStreamResolver;

protected:
    virtual mozilla::ipc::IPCResult
    RecvOpenStream(
            const nsID& aStreamId,
            OpenStreamResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNoteClosed(const nsID& aStreamId) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PCacheStreamControlParent();

    virtual ~PCacheStreamControlParent();

    PBackgroundParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendClose(const nsID& aStreamId);

    MOZ_MUST_USE bool
    SendCloseAll();

    MOZ_MUST_USE static bool
    Send__delete__(PCacheStreamControlParent* actor);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace cache
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::cache::PCacheStreamControlParent*>
{
    typedef mozilla::dom::cache::PCacheStreamControlParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
namespace cache {
class CacheStreamControlParent :
    public PCacheStreamControlParent
{
    mozilla::ipc::IPCResult
    RecvOpenStream(
            const nsID& aStreamId,
            OpenStreamResolver&& aResolve) override;

    mozilla::ipc::IPCResult
    RecvNoteClosed(const nsID& aStreamId) override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT CacheStreamControlParent();
    virtual ~CacheStreamControlParent();
};
} // namespace cache
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
namespace cache {
mozilla::ipc::IPCResult
CacheStreamControlParent::RecvOpenStream(
        const nsID& aStreamId,
        OpenStreamResolver&& aResolve)
{
}

mozilla::ipc::IPCResult
CacheStreamControlParent::RecvNoteClosed(const nsID& aStreamId)
{
}

void
CacheStreamControlParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT CacheStreamControlParent::CacheStreamControlParent()
{
    MOZ_COUNT_CTOR(CacheStreamControlParent);
}

MOZ_IMPLICIT CacheStreamControlParent::~CacheStreamControlParent()
{
    MOZ_COUNT_DTOR(CacheStreamControlParent);
}

} // namespace cache
} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PCacheStreamControlParent_h
