//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PPrintingTypes_h
#define PPrintingTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CStringKeyValue|
//
namespace mozilla {
namespace embedding {
class CStringKeyValue final
{
private:

public:
    MOZ_IMPLICIT CStringKeyValue() :
        key_(),
        value_()
    {
    }

    MOZ_IMPLICIT CStringKeyValue(
            const nsCString& _key,
            const nsCString& _value) :
        key_(_key),
        value_(_value)
    {
    }

    bool
    operator==(const CStringKeyValue& _o) const;

    bool
    operator!=(const CStringKeyValue& _o) const;

    nsCString&
    key()
    {
        return key_;
    }
    const nsCString&
    key() const
    {
        return key_;
    }

    nsCString&
    value()
    {
        return value_;
    }
    const nsCString&
    value() const
    {
        return value_;
    }

private:
    nsCString key_;
    nsCString value_;
};
} // namespace embedding
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::embedding::CStringKeyValue>
{
    typedef mozilla::embedding::CStringKeyValue paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace layout {
class PRemotePrintJobParent;
} // namespace layout
} // namespace mozilla

namespace mozilla {
namespace layout {
class PRemotePrintJobChild;
} // namespace layout
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PrintData|
//
namespace mozilla {
namespace embedding {
class PrintData final
{
private:
    typedef mozilla::layout::PRemotePrintJobParent PRemotePrintJobParent;
    typedef mozilla::layout::PRemotePrintJobChild PRemotePrintJobChild;
    typedef mozilla::embedding::CStringKeyValue CStringKeyValue;

public:
    MOZ_IMPLICIT PrintData() :
        remotePrintJobParent_(),
        remotePrintJobChild_(),
        startPageRange_(),
        endPageRange_(),
        edgeTop_(),
        edgeLeft_(),
        edgeBottom_(),
        edgeRight_(),
        marginTop_(),
        marginLeft_(),
        marginBottom_(),
        marginRight_(),
        unwriteableMarginTop_(),
        unwriteableMarginLeft_(),
        unwriteableMarginBottom_(),
        unwriteableMarginRight_(),
        scaling_(),
        printBGColors_(),
        printBGImages_(),
        printRange_(),
        title_(),
        docURL_(),
        headerStrLeft_(),
        headerStrCenter_(),
        headerStrRight_(),
        footerStrLeft_(),
        footerStrCenter_(),
        footerStrRight_(),
        howToEnableFrameUI_(),
        isCancelled_(),
        printFrameTypeUsage_(),
        printFrameType_(),
        printSilent_(),
        shrinkToFit_(),
        showPrintProgress_(),
        paperName_(),
        paperData_(),
        paperWidth_(),
        paperHeight_(),
        paperSizeUnit_(),
        printReversed_(),
        printInColor_(),
        orientation_(),
        numCopies_(),
        printerName_(),
        printToFile_(),
        toFileName_(),
        outputFormat_(),
        printPageDelay_(),
        resolution_(),
        duplex_(),
        isInitializedFromPrinter_(),
        isInitializedFromPrefs_(),
        optionFlags_(),
        driverName_(),
        deviceName_(),
        printableWidthInInches_(),
        printableHeightInInches_(),
        isFramesetDocument_(),
        isFramesetFrameSelected_(),
        isIFrameSelected_(),
        isRangeSelection_(),
        devModeData_(),
        GTKPrintSettings_(),
        printJobName_(),
        printAllPages_(),
        mustCollate_(),
        disposition_(),
        pagesAcross_(),
        pagesDown_(),
        printTime_(),
        detailedErrorReporting_(),
        faxNumber_(),
        addHeaderAndFooter_(),
        fileNameExtensionHidden_(),
        scalingFactor_(),
        widthScale_(),
        heightScale_(),
        adjustedPaperWidth_(),
        adjustedPaperHeight_()
    {
    }

    MOZ_IMPLICIT PrintData(
            PRemotePrintJobParent* _remotePrintJobParent,
            PRemotePrintJobChild* _remotePrintJobChild,
            const int32_t& _startPageRange,
            const int32_t& _endPageRange,
            const double& _edgeTop,
            const double& _edgeLeft,
            const double& _edgeBottom,
            const double& _edgeRight,
            const double& _marginTop,
            const double& _marginLeft,
            const double& _marginBottom,
            const double& _marginRight,
            const double& _unwriteableMarginTop,
            const double& _unwriteableMarginLeft,
            const double& _unwriteableMarginBottom,
            const double& _unwriteableMarginRight,
            const double& _scaling,
            const bool& _printBGColors,
            const bool& _printBGImages,
            const short& _printRange,
            const nsString& _title,
            const nsString& _docURL,
            const nsString& _headerStrLeft,
            const nsString& _headerStrCenter,
            const nsString& _headerStrRight,
            const nsString& _footerStrLeft,
            const nsString& _footerStrCenter,
            const nsString& _footerStrRight,
            const short& _howToEnableFrameUI,
            const bool& _isCancelled,
            const short& _printFrameTypeUsage,
            const short& _printFrameType,
            const bool& _printSilent,
            const bool& _shrinkToFit,
            const bool& _showPrintProgress,
            const nsString& _paperName,
            const short& _paperData,
            const double& _paperWidth,
            const double& _paperHeight,
            const short& _paperSizeUnit,
            const bool& _printReversed,
            const bool& _printInColor,
            const int32_t& _orientation,
            const int32_t& _numCopies,
            const nsString& _printerName,
            const bool& _printToFile,
            const nsString& _toFileName,
            const short& _outputFormat,
            const int32_t& _printPageDelay,
            const int32_t& _resolution,
            const int32_t& _duplex,
            const bool& _isInitializedFromPrinter,
            const bool& _isInitializedFromPrefs,
            const int32_t& _optionFlags,
            const nsString& _driverName,
            const nsString& _deviceName,
            const double& _printableWidthInInches,
            const double& _printableHeightInInches,
            const bool& _isFramesetDocument,
            const bool& _isFramesetFrameSelected,
            const bool& _isIFrameSelected,
            const bool& _isRangeSelection,
            const nsTArray<uint8_t>& _devModeData,
            const nsTArray<CStringKeyValue>& _GTKPrintSettings,
            const nsString& _printJobName,
            const bool& _printAllPages,
            const bool& _mustCollate,
            const nsString& _disposition,
            const short& _pagesAcross,
            const short& _pagesDown,
            const double& _printTime,
            const bool& _detailedErrorReporting,
            const nsString& _faxNumber,
            const bool& _addHeaderAndFooter,
            const bool& _fileNameExtensionHidden,
            const float& _scalingFactor,
            const float& _widthScale,
            const float& _heightScale,
            const double& _adjustedPaperWidth,
            const double& _adjustedPaperHeight) :
        remotePrintJobParent_(_remotePrintJobParent),
        remotePrintJobChild_(_remotePrintJobChild),
        startPageRange_(_startPageRange),
        endPageRange_(_endPageRange),
        edgeTop_(_edgeTop),
        edgeLeft_(_edgeLeft),
        edgeBottom_(_edgeBottom),
        edgeRight_(_edgeRight),
        marginTop_(_marginTop),
        marginLeft_(_marginLeft),
        marginBottom_(_marginBottom),
        marginRight_(_marginRight),
        unwriteableMarginTop_(_unwriteableMarginTop),
        unwriteableMarginLeft_(_unwriteableMarginLeft),
        unwriteableMarginBottom_(_unwriteableMarginBottom),
        unwriteableMarginRight_(_unwriteableMarginRight),
        scaling_(_scaling),
        printBGColors_(_printBGColors),
        printBGImages_(_printBGImages),
        printRange_(_printRange),
        title_(_title),
        docURL_(_docURL),
        headerStrLeft_(_headerStrLeft),
        headerStrCenter_(_headerStrCenter),
        headerStrRight_(_headerStrRight),
        footerStrLeft_(_footerStrLeft),
        footerStrCenter_(_footerStrCenter),
        footerStrRight_(_footerStrRight),
        howToEnableFrameUI_(_howToEnableFrameUI),
        isCancelled_(_isCancelled),
        printFrameTypeUsage_(_printFrameTypeUsage),
        printFrameType_(_printFrameType),
        printSilent_(_printSilent),
        shrinkToFit_(_shrinkToFit),
        showPrintProgress_(_showPrintProgress),
        paperName_(_paperName),
        paperData_(_paperData),
        paperWidth_(_paperWidth),
        paperHeight_(_paperHeight),
        paperSizeUnit_(_paperSizeUnit),
        printReversed_(_printReversed),
        printInColor_(_printInColor),
        orientation_(_orientation),
        numCopies_(_numCopies),
        printerName_(_printerName),
        printToFile_(_printToFile),
        toFileName_(_toFileName),
        outputFormat_(_outputFormat),
        printPageDelay_(_printPageDelay),
        resolution_(_resolution),
        duplex_(_duplex),
        isInitializedFromPrinter_(_isInitializedFromPrinter),
        isInitializedFromPrefs_(_isInitializedFromPrefs),
        optionFlags_(_optionFlags),
        driverName_(_driverName),
        deviceName_(_deviceName),
        printableWidthInInches_(_printableWidthInInches),
        printableHeightInInches_(_printableHeightInInches),
        isFramesetDocument_(_isFramesetDocument),
        isFramesetFrameSelected_(_isFramesetFrameSelected),
        isIFrameSelected_(_isIFrameSelected),
        isRangeSelection_(_isRangeSelection),
        devModeData_(_devModeData),
        GTKPrintSettings_(_GTKPrintSettings),
        printJobName_(_printJobName),
        printAllPages_(_printAllPages),
        mustCollate_(_mustCollate),
        disposition_(_disposition),
        pagesAcross_(_pagesAcross),
        pagesDown_(_pagesDown),
        printTime_(_printTime),
        detailedErrorReporting_(_detailedErrorReporting),
        faxNumber_(_faxNumber),
        addHeaderAndFooter_(_addHeaderAndFooter),
        fileNameExtensionHidden_(_fileNameExtensionHidden),
        scalingFactor_(_scalingFactor),
        widthScale_(_widthScale),
        heightScale_(_heightScale),
        adjustedPaperWidth_(_adjustedPaperWidth),
        adjustedPaperHeight_(_adjustedPaperHeight)
    {
    }

    bool
    operator==(const PrintData& _o) const;

    bool
    operator!=(const PrintData& _o) const;

    PRemotePrintJobParent*&
    remotePrintJobParent()
    {
        return remotePrintJobParent_;
    }
    PRemotePrintJobParent*
    remotePrintJobParent() const
    {
        return remotePrintJobParent_;
    }

    PRemotePrintJobChild*&
    remotePrintJobChild()
    {
        return remotePrintJobChild_;
    }
    PRemotePrintJobChild*
    remotePrintJobChild() const
    {
        return remotePrintJobChild_;
    }

    int32_t&
    startPageRange()
    {
        return startPageRange_;
    }
    const int32_t&
    startPageRange() const
    {
        return startPageRange_;
    }

    int32_t&
    endPageRange()
    {
        return endPageRange_;
    }
    const int32_t&
    endPageRange() const
    {
        return endPageRange_;
    }

    double&
    edgeTop()
    {
        return edgeTop_;
    }
    const double&
    edgeTop() const
    {
        return edgeTop_;
    }

    double&
    edgeLeft()
    {
        return edgeLeft_;
    }
    const double&
    edgeLeft() const
    {
        return edgeLeft_;
    }

    double&
    edgeBottom()
    {
        return edgeBottom_;
    }
    const double&
    edgeBottom() const
    {
        return edgeBottom_;
    }

    double&
    edgeRight()
    {
        return edgeRight_;
    }
    const double&
    edgeRight() const
    {
        return edgeRight_;
    }

    double&
    marginTop()
    {
        return marginTop_;
    }
    const double&
    marginTop() const
    {
        return marginTop_;
    }

    double&
    marginLeft()
    {
        return marginLeft_;
    }
    const double&
    marginLeft() const
    {
        return marginLeft_;
    }

    double&
    marginBottom()
    {
        return marginBottom_;
    }
    const double&
    marginBottom() const
    {
        return marginBottom_;
    }

    double&
    marginRight()
    {
        return marginRight_;
    }
    const double&
    marginRight() const
    {
        return marginRight_;
    }

    double&
    unwriteableMarginTop()
    {
        return unwriteableMarginTop_;
    }
    const double&
    unwriteableMarginTop() const
    {
        return unwriteableMarginTop_;
    }

    double&
    unwriteableMarginLeft()
    {
        return unwriteableMarginLeft_;
    }
    const double&
    unwriteableMarginLeft() const
    {
        return unwriteableMarginLeft_;
    }

    double&
    unwriteableMarginBottom()
    {
        return unwriteableMarginBottom_;
    }
    const double&
    unwriteableMarginBottom() const
    {
        return unwriteableMarginBottom_;
    }

    double&
    unwriteableMarginRight()
    {
        return unwriteableMarginRight_;
    }
    const double&
    unwriteableMarginRight() const
    {
        return unwriteableMarginRight_;
    }

    double&
    scaling()
    {
        return scaling_;
    }
    const double&
    scaling() const
    {
        return scaling_;
    }

    bool&
    printBGColors()
    {
        return printBGColors_;
    }
    const bool&
    printBGColors() const
    {
        return printBGColors_;
    }

    bool&
    printBGImages()
    {
        return printBGImages_;
    }
    const bool&
    printBGImages() const
    {
        return printBGImages_;
    }

    short&
    printRange()
    {
        return printRange_;
    }
    const short&
    printRange() const
    {
        return printRange_;
    }

    nsString&
    title()
    {
        return title_;
    }
    const nsString&
    title() const
    {
        return title_;
    }

    nsString&
    docURL()
    {
        return docURL_;
    }
    const nsString&
    docURL() const
    {
        return docURL_;
    }

    nsString&
    headerStrLeft()
    {
        return headerStrLeft_;
    }
    const nsString&
    headerStrLeft() const
    {
        return headerStrLeft_;
    }

    nsString&
    headerStrCenter()
    {
        return headerStrCenter_;
    }
    const nsString&
    headerStrCenter() const
    {
        return headerStrCenter_;
    }

    nsString&
    headerStrRight()
    {
        return headerStrRight_;
    }
    const nsString&
    headerStrRight() const
    {
        return headerStrRight_;
    }

    nsString&
    footerStrLeft()
    {
        return footerStrLeft_;
    }
    const nsString&
    footerStrLeft() const
    {
        return footerStrLeft_;
    }

    nsString&
    footerStrCenter()
    {
        return footerStrCenter_;
    }
    const nsString&
    footerStrCenter() const
    {
        return footerStrCenter_;
    }

    nsString&
    footerStrRight()
    {
        return footerStrRight_;
    }
    const nsString&
    footerStrRight() const
    {
        return footerStrRight_;
    }

    short&
    howToEnableFrameUI()
    {
        return howToEnableFrameUI_;
    }
    const short&
    howToEnableFrameUI() const
    {
        return howToEnableFrameUI_;
    }

    bool&
    isCancelled()
    {
        return isCancelled_;
    }
    const bool&
    isCancelled() const
    {
        return isCancelled_;
    }

    short&
    printFrameTypeUsage()
    {
        return printFrameTypeUsage_;
    }
    const short&
    printFrameTypeUsage() const
    {
        return printFrameTypeUsage_;
    }

    short&
    printFrameType()
    {
        return printFrameType_;
    }
    const short&
    printFrameType() const
    {
        return printFrameType_;
    }

    bool&
    printSilent()
    {
        return printSilent_;
    }
    const bool&
    printSilent() const
    {
        return printSilent_;
    }

    bool&
    shrinkToFit()
    {
        return shrinkToFit_;
    }
    const bool&
    shrinkToFit() const
    {
        return shrinkToFit_;
    }

    bool&
    showPrintProgress()
    {
        return showPrintProgress_;
    }
    const bool&
    showPrintProgress() const
    {
        return showPrintProgress_;
    }

    nsString&
    paperName()
    {
        return paperName_;
    }
    const nsString&
    paperName() const
    {
        return paperName_;
    }

    short&
    paperData()
    {
        return paperData_;
    }
    const short&
    paperData() const
    {
        return paperData_;
    }

    double&
    paperWidth()
    {
        return paperWidth_;
    }
    const double&
    paperWidth() const
    {
        return paperWidth_;
    }

    double&
    paperHeight()
    {
        return paperHeight_;
    }
    const double&
    paperHeight() const
    {
        return paperHeight_;
    }

    short&
    paperSizeUnit()
    {
        return paperSizeUnit_;
    }
    const short&
    paperSizeUnit() const
    {
        return paperSizeUnit_;
    }

    bool&
    printReversed()
    {
        return printReversed_;
    }
    const bool&
    printReversed() const
    {
        return printReversed_;
    }

    bool&
    printInColor()
    {
        return printInColor_;
    }
    const bool&
    printInColor() const
    {
        return printInColor_;
    }

    int32_t&
    orientation()
    {
        return orientation_;
    }
    const int32_t&
    orientation() const
    {
        return orientation_;
    }

    int32_t&
    numCopies()
    {
        return numCopies_;
    }
    const int32_t&
    numCopies() const
    {
        return numCopies_;
    }

    nsString&
    printerName()
    {
        return printerName_;
    }
    const nsString&
    printerName() const
    {
        return printerName_;
    }

    bool&
    printToFile()
    {
        return printToFile_;
    }
    const bool&
    printToFile() const
    {
        return printToFile_;
    }

    nsString&
    toFileName()
    {
        return toFileName_;
    }
    const nsString&
    toFileName() const
    {
        return toFileName_;
    }

    short&
    outputFormat()
    {
        return outputFormat_;
    }
    const short&
    outputFormat() const
    {
        return outputFormat_;
    }

    int32_t&
    printPageDelay()
    {
        return printPageDelay_;
    }
    const int32_t&
    printPageDelay() const
    {
        return printPageDelay_;
    }

    int32_t&
    resolution()
    {
        return resolution_;
    }
    const int32_t&
    resolution() const
    {
        return resolution_;
    }

    int32_t&
    duplex()
    {
        return duplex_;
    }
    const int32_t&
    duplex() const
    {
        return duplex_;
    }

    bool&
    isInitializedFromPrinter()
    {
        return isInitializedFromPrinter_;
    }
    const bool&
    isInitializedFromPrinter() const
    {
        return isInitializedFromPrinter_;
    }

    bool&
    isInitializedFromPrefs()
    {
        return isInitializedFromPrefs_;
    }
    const bool&
    isInitializedFromPrefs() const
    {
        return isInitializedFromPrefs_;
    }

    int32_t&
    optionFlags()
    {
        return optionFlags_;
    }
    const int32_t&
    optionFlags() const
    {
        return optionFlags_;
    }

    nsString&
    driverName()
    {
        return driverName_;
    }
    const nsString&
    driverName() const
    {
        return driverName_;
    }

    nsString&
    deviceName()
    {
        return deviceName_;
    }
    const nsString&
    deviceName() const
    {
        return deviceName_;
    }

    double&
    printableWidthInInches()
    {
        return printableWidthInInches_;
    }
    const double&
    printableWidthInInches() const
    {
        return printableWidthInInches_;
    }

    double&
    printableHeightInInches()
    {
        return printableHeightInInches_;
    }
    const double&
    printableHeightInInches() const
    {
        return printableHeightInInches_;
    }

    bool&
    isFramesetDocument()
    {
        return isFramesetDocument_;
    }
    const bool&
    isFramesetDocument() const
    {
        return isFramesetDocument_;
    }

    bool&
    isFramesetFrameSelected()
    {
        return isFramesetFrameSelected_;
    }
    const bool&
    isFramesetFrameSelected() const
    {
        return isFramesetFrameSelected_;
    }

    bool&
    isIFrameSelected()
    {
        return isIFrameSelected_;
    }
    const bool&
    isIFrameSelected() const
    {
        return isIFrameSelected_;
    }

    bool&
    isRangeSelection()
    {
        return isRangeSelection_;
    }
    const bool&
    isRangeSelection() const
    {
        return isRangeSelection_;
    }

    nsTArray<uint8_t>&
    devModeData()
    {
        return devModeData_;
    }
    const nsTArray<uint8_t>&
    devModeData() const
    {
        return devModeData_;
    }

    nsTArray<CStringKeyValue>&
    GTKPrintSettings()
    {
        return GTKPrintSettings_;
    }
    const nsTArray<CStringKeyValue>&
    GTKPrintSettings() const
    {
        return GTKPrintSettings_;
    }

    nsString&
    printJobName()
    {
        return printJobName_;
    }
    const nsString&
    printJobName() const
    {
        return printJobName_;
    }

    bool&
    printAllPages()
    {
        return printAllPages_;
    }
    const bool&
    printAllPages() const
    {
        return printAllPages_;
    }

    bool&
    mustCollate()
    {
        return mustCollate_;
    }
    const bool&
    mustCollate() const
    {
        return mustCollate_;
    }

    nsString&
    disposition()
    {
        return disposition_;
    }
    const nsString&
    disposition() const
    {
        return disposition_;
    }

    short&
    pagesAcross()
    {
        return pagesAcross_;
    }
    const short&
    pagesAcross() const
    {
        return pagesAcross_;
    }

    short&
    pagesDown()
    {
        return pagesDown_;
    }
    const short&
    pagesDown() const
    {
        return pagesDown_;
    }

    double&
    printTime()
    {
        return printTime_;
    }
    const double&
    printTime() const
    {
        return printTime_;
    }

    bool&
    detailedErrorReporting()
    {
        return detailedErrorReporting_;
    }
    const bool&
    detailedErrorReporting() const
    {
        return detailedErrorReporting_;
    }

    nsString&
    faxNumber()
    {
        return faxNumber_;
    }
    const nsString&
    faxNumber() const
    {
        return faxNumber_;
    }

    bool&
    addHeaderAndFooter()
    {
        return addHeaderAndFooter_;
    }
    const bool&
    addHeaderAndFooter() const
    {
        return addHeaderAndFooter_;
    }

    bool&
    fileNameExtensionHidden()
    {
        return fileNameExtensionHidden_;
    }
    const bool&
    fileNameExtensionHidden() const
    {
        return fileNameExtensionHidden_;
    }

    float&
    scalingFactor()
    {
        return scalingFactor_;
    }
    const float&
    scalingFactor() const
    {
        return scalingFactor_;
    }

    float&
    widthScale()
    {
        return widthScale_;
    }
    const float&
    widthScale() const
    {
        return widthScale_;
    }

    float&
    heightScale()
    {
        return heightScale_;
    }
    const float&
    heightScale() const
    {
        return heightScale_;
    }

    double&
    adjustedPaperWidth()
    {
        return adjustedPaperWidth_;
    }
    const double&
    adjustedPaperWidth() const
    {
        return adjustedPaperWidth_;
    }

    double&
    adjustedPaperHeight()
    {
        return adjustedPaperHeight_;
    }
    const double&
    adjustedPaperHeight() const
    {
        return adjustedPaperHeight_;
    }

private:
    PRemotePrintJobParent* remotePrintJobParent_;
    PRemotePrintJobChild* remotePrintJobChild_;
    int32_t startPageRange_;
    int32_t endPageRange_;
    double edgeTop_;
    double edgeLeft_;
    double edgeBottom_;
    double edgeRight_;
    double marginTop_;
    double marginLeft_;
    double marginBottom_;
    double marginRight_;
    double unwriteableMarginTop_;
    double unwriteableMarginLeft_;
    double unwriteableMarginBottom_;
    double unwriteableMarginRight_;
    double scaling_;
    bool printBGColors_;
    bool printBGImages_;
    short printRange_;
    nsString title_;
    nsString docURL_;
    nsString headerStrLeft_;
    nsString headerStrCenter_;
    nsString headerStrRight_;
    nsString footerStrLeft_;
    nsString footerStrCenter_;
    nsString footerStrRight_;
    short howToEnableFrameUI_;
    bool isCancelled_;
    short printFrameTypeUsage_;
    short printFrameType_;
    bool printSilent_;
    bool shrinkToFit_;
    bool showPrintProgress_;
    nsString paperName_;
    short paperData_;
    double paperWidth_;
    double paperHeight_;
    short paperSizeUnit_;
    bool printReversed_;
    bool printInColor_;
    int32_t orientation_;
    int32_t numCopies_;
    nsString printerName_;
    bool printToFile_;
    nsString toFileName_;
    short outputFormat_;
    int32_t printPageDelay_;
    int32_t resolution_;
    int32_t duplex_;
    bool isInitializedFromPrinter_;
    bool isInitializedFromPrefs_;
    int32_t optionFlags_;
    nsString driverName_;
    nsString deviceName_;
    double printableWidthInInches_;
    double printableHeightInInches_;
    bool isFramesetDocument_;
    bool isFramesetFrameSelected_;
    bool isIFrameSelected_;
    bool isRangeSelection_;
    nsTArray<uint8_t> devModeData_;
    nsTArray<CStringKeyValue> GTKPrintSettings_;
    nsString printJobName_;
    bool printAllPages_;
    bool mustCollate_;
    nsString disposition_;
    short pagesAcross_;
    short pagesDown_;
    double printTime_;
    bool detailedErrorReporting_;
    nsString faxNumber_;
    bool addHeaderAndFooter_;
    bool fileNameExtensionHidden_;
    float scalingFactor_;
    float widthScale_;
    float heightScale_;
    double adjustedPaperWidth_;
    double adjustedPaperHeight_;
};
} // namespace embedding
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::embedding::PrintData>
{
    typedef mozilla::embedding::PrintData paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef PPrintingTypes_h
