//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPServiceParent_h
#define PGMPServiceParent_h

#include "mozilla/gmp/PGMPService.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

class nsIFile;

// Headers for things that cannot be forward declared
#include "base/process.h"

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPServiceParent :
    public mozilla::ipc::IToplevelProtocol
{
private:
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef mozilla::gmp::CDMInputBuffer CDMInputBuffer;
    typedef mozilla::gmp::CDMKeyInformation CDMKeyInformation;
    typedef mozilla::gmp::CDMVideoDecoderConfig CDMVideoDecoderConfig;
    typedef mozilla::gmp::CDMVideoFrame CDMVideoFrame;
    typedef mozilla::gmp::CDMVideoPlane CDMVideoPlane;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef mozilla::gmp::NodeIdData NodeIdData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPContentParent PGMPContentParent;
    typedef mozilla::gmp::PGMPContentChild PGMPContentChild;

    typedef PGMPService::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvLaunchGMP(
            const nsCString& nodeId,
            const nsCString& api,
            nsTArray<nsCString>&& tags,
            nsTArray<ProcessId>&& alreadyBridgedTo,
            uint32_t* pluginId,
            ProcessId* id,
            nsCString* displayName,
            Endpoint<mozilla::gmp::PGMPContentParent>* endpoint,
            nsresult* aResult,
            nsCString* aErrorDescription) = 0;
    virtual mozilla::ipc::IPCResult
    RecvLaunchGMPForNodeId(
            const NodeIdData& nodeId,
            const nsCString& api,
            nsTArray<nsCString>&& tags,
            nsTArray<ProcessId>&& alreadyBridgedTo,
            uint32_t* pluginId,
            ProcessId* id,
            nsCString* displayName,
            Endpoint<mozilla::gmp::PGMPContentParent>* endpoint,
            nsresult* aResult,
            nsCString* aErrorDescription) = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetGMPNodeId(
            const nsString& origin,
            const nsString& topLevelOrigin,
            const nsString& gmpName,
            nsCString* id) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

    void
    ProcessingError(
            Result aCode,
            const char* aReason) override;
    bool
    ShouldContinueFromReplyTimeout() override;
    void
    EnteredCxxStack() override;
    void
    ExitedCxxStack() override;
    void
    EnteredCall() override;
    void
    ExitedCall() override;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PGMPServiceParent();

    virtual ~PGMPServiceParent();

    MOZ_MUST_USE bool
    SendBeginShutdown();

    MessageChannel*
    GetIPCChannel() override;
    const MessageChannel*
    GetIPCChannel() const override;
    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

    void
    OnChannelClose() override;

    void
    OnChannelError() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    virtual void
    DeallocPGMPServiceParent();

    MessageChannel mChannel;
    State mState;
};


} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::gmp::PGMPServiceParent*>
{
    typedef mozilla::gmp::PGMPServiceParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPServiceParent :
    public PGMPServiceParent
{
    mozilla::ipc::IPCResult
    RecvLaunchGMP(
            const nsCString& nodeId,
            const nsCString& api,
            nsTArray<nsCString>&& tags,
            nsTArray<ProcessId>&& alreadyBridgedTo,
            uint32_t* pluginId,
            ProcessId* id,
            nsCString* displayName,
            Endpoint<mozilla::gmp::PGMPContentParent>* endpoint,
            nsresult* aResult,
            nsCString* aErrorDescription) override;

    mozilla::ipc::IPCResult
    RecvLaunchGMPForNodeId(
            const NodeIdData& nodeId,
            const nsCString& api,
            nsTArray<nsCString>&& tags,
            nsTArray<ProcessId>&& alreadyBridgedTo,
            uint32_t* pluginId,
            ProcessId* id,
            nsCString* displayName,
            Endpoint<mozilla::gmp::PGMPContentParent>* endpoint,
            nsresult* aResult,
            nsCString* aErrorDescription) override;

    mozilla::ipc::IPCResult
    RecvGetGMPNodeId(
            const nsString& origin,
            const nsString& topLevelOrigin,
            const nsString& gmpName,
            nsCString* id) override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT GMPServiceParent();
    virtual ~GMPServiceParent();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
mozilla::ipc::IPCResult
GMPServiceParent::RecvLaunchGMP(
        const nsCString& nodeId,
        const nsCString& api,
        nsTArray<nsCString>&& tags,
        nsTArray<ProcessId>&& alreadyBridgedTo,
        uint32_t* pluginId,
        ProcessId* id,
        nsCString* displayName,
        Endpoint<mozilla::gmp::PGMPContentParent>* endpoint,
        nsresult* aResult,
        nsCString* aErrorDescription)
{
}

mozilla::ipc::IPCResult
GMPServiceParent::RecvLaunchGMPForNodeId(
        const NodeIdData& nodeId,
        const nsCString& api,
        nsTArray<nsCString>&& tags,
        nsTArray<ProcessId>&& alreadyBridgedTo,
        uint32_t* pluginId,
        ProcessId* id,
        nsCString* displayName,
        Endpoint<mozilla::gmp::PGMPContentParent>* endpoint,
        nsresult* aResult,
        nsCString* aErrorDescription)
{
}

mozilla::ipc::IPCResult
GMPServiceParent::RecvGetGMPNodeId(
        const nsString& origin,
        const nsString& topLevelOrigin,
        const nsString& gmpName,
        nsCString* id)
{
}

void
GMPServiceParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT GMPServiceParent::GMPServiceParent()
{
    MOZ_COUNT_CTOR(GMPServiceParent);
}

MOZ_IMPLICIT GMPServiceParent::~GMPServiceParent()
{
    MOZ_COUNT_DTOR(GMPServiceParent);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPServiceParent_h
