//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPStorageChild_h
#define PGMPStorageChild_h

#include "mozilla/gmp/PGMPStorage.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "gmp-errors.h"

namespace mozilla {
namespace gmp {
class PGMPChild;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPStorageChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::gmp::PGMPChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef mozilla::gmp::CDMInputBuffer CDMInputBuffer;
    typedef mozilla::gmp::CDMKeyInformation CDMKeyInformation;
    typedef mozilla::gmp::CDMVideoDecoderConfig CDMVideoDecoderConfig;
    typedef mozilla::gmp::CDMVideoFrame CDMVideoFrame;
    typedef mozilla::gmp::CDMVideoPlane CDMVideoPlane;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef mozilla::gmp::NodeIdData NodeIdData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPChild PGMPChild;
    typedef mozilla::gmp::PGMPParent PGMPParent;

    typedef PGMPStorage::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvOpenComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReadComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus,
            nsTArray<uint8_t>&& aBytes) = 0;
    virtual mozilla::ipc::IPCResult
    RecvWriteComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus) = 0;
    virtual mozilla::ipc::IPCResult
    RecvShutdown() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PGMPStorageChild();

    virtual ~PGMPStorageChild();

    PGMPChild*
    Manager() const;

    bool
    SendOpen(const nsCString& aRecordName);

    bool
    SendRead(const nsCString& aRecordName);

    bool
    SendWrite(
            const nsCString& aRecordName,
            const nsTArray<uint8_t>& aBytes);

    bool
    SendClose(const nsCString& aRecordName);

    static bool
    Send__delete__(PGMPStorageChild* actor);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::gmp::PGMPStorageChild*>
{
    typedef mozilla::gmp::PGMPStorageChild* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPStorageChild :
    public PGMPStorageChild
{
    mozilla::ipc::IPCResult
    RecvOpenComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus) override;

    mozilla::ipc::IPCResult
    RecvReadComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus,
            nsTArray<uint8_t>&& aBytes) override;

    mozilla::ipc::IPCResult
    RecvWriteComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus) override;

    mozilla::ipc::IPCResult
    RecvShutdown() override;

    MOZ_IMPLICIT GMPStorageChild();
    virtual ~GMPStorageChild();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
mozilla::ipc::IPCResult
GMPStorageChild::RecvOpenComplete(
        const nsCString& aRecordName,
        const GMPErr& aStatus)
{
}

mozilla::ipc::IPCResult
GMPStorageChild::RecvReadComplete(
        const nsCString& aRecordName,
        const GMPErr& aStatus,
        nsTArray<uint8_t>&& aBytes)
{
}

mozilla::ipc::IPCResult
GMPStorageChild::RecvWriteComplete(
        const nsCString& aRecordName,
        const GMPErr& aStatus)
{
}

mozilla::ipc::IPCResult
GMPStorageChild::RecvShutdown()
{
}

MOZ_IMPLICIT GMPStorageChild::GMPStorageChild()
{
    MOZ_COUNT_CTOR(GMPStorageChild);
}

MOZ_IMPLICIT GMPStorageChild::~GMPStorageChild()
{
    MOZ_COUNT_DTOR(GMPStorageChild);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPStorageChild_h
