//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPStorageParent_h
#define PGMPStorageParent_h

#include "mozilla/gmp/PGMPStorage.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "gmp-errors.h"

namespace mozilla {
namespace gmp {
class PGMPParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPStorageParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::gmp::PGMPParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef mozilla::gmp::CDMInputBuffer CDMInputBuffer;
    typedef mozilla::gmp::CDMKeyInformation CDMKeyInformation;
    typedef mozilla::gmp::CDMVideoDecoderConfig CDMVideoDecoderConfig;
    typedef mozilla::gmp::CDMVideoFrame CDMVideoFrame;
    typedef mozilla::gmp::CDMVideoPlane CDMVideoPlane;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef mozilla::gmp::NodeIdData NodeIdData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPParent PGMPParent;
    typedef mozilla::gmp::PGMPChild PGMPChild;

    typedef PGMPStorage::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvOpen(const nsCString& aRecordName) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRead(const nsCString& aRecordName) = 0;
    virtual mozilla::ipc::IPCResult
    RecvWrite(
            const nsCString& aRecordName,
            nsTArray<uint8_t>&& aBytes) = 0;
    virtual mozilla::ipc::IPCResult
    RecvClose(const nsCString& aRecordName) = 0;
    virtual mozilla::ipc::IPCResult
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PGMPStorageParent();

    virtual ~PGMPStorageParent();

    PGMPParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendOpenComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus);

    MOZ_MUST_USE bool
    SendReadComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus,
            const nsTArray<uint8_t>& aBytes);

    MOZ_MUST_USE bool
    SendWriteComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus);

    MOZ_MUST_USE bool
    SendShutdown();

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::gmp::PGMPStorageParent*>
{
    typedef mozilla::gmp::PGMPStorageParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPStorageParent :
    public PGMPStorageParent
{
    mozilla::ipc::IPCResult
    RecvOpen(const nsCString& aRecordName) override;

    mozilla::ipc::IPCResult
    RecvRead(const nsCString& aRecordName) override;

    mozilla::ipc::IPCResult
    RecvWrite(
            const nsCString& aRecordName,
            nsTArray<uint8_t>&& aBytes) override;

    mozilla::ipc::IPCResult
    RecvClose(const nsCString& aRecordName) override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT GMPStorageParent();
    virtual ~GMPStorageParent();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
mozilla::ipc::IPCResult
GMPStorageParent::RecvOpen(const nsCString& aRecordName)
{
}

mozilla::ipc::IPCResult
GMPStorageParent::RecvRead(const nsCString& aRecordName)
{
}

mozilla::ipc::IPCResult
GMPStorageParent::RecvWrite(
        const nsCString& aRecordName,
        nsTArray<uint8_t>&& aBytes)
{
}

mozilla::ipc::IPCResult
GMPStorageParent::RecvClose(const nsCString& aRecordName)
{
}

void
GMPStorageParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT GMPStorageParent::GMPStorageParent()
{
    MOZ_COUNT_CTOR(GMPStorageParent);
}

MOZ_IMPLICIT GMPStorageParent::~GMPStorageParent()
{
    MOZ_COUNT_DTOR(GMPStorageParent);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPStorageParent_h
