//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPVideoDecoderChild_h
#define PGMPVideoDecoderChild_h

#include "mozilla/gmp/PGMPVideoDecoder.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "GMPMessageUtils.h"
#include "gmp-errors.h"
#include "gmp-video-codec.h"

namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPVideoDecoderChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::gmp::PGMPContentChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef mozilla::gmp::CDMInputBuffer CDMInputBuffer;
    typedef mozilla::gmp::CDMKeyInformation CDMKeyInformation;
    typedef mozilla::gmp::CDMVideoDecoderConfig CDMVideoDecoderConfig;
    typedef mozilla::gmp::CDMVideoFrame CDMVideoFrame;
    typedef mozilla::gmp::CDMVideoPlane CDMVideoPlane;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef mozilla::gmp::NodeIdData NodeIdData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPContentChild PGMPContentChild;
    typedef mozilla::gmp::PGMPContentParent PGMPContentParent;

    typedef PGMPVideoDecoder::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvInitDecode(
            const GMPVideoCodec& aCodecSettings,
            nsTArray<uint8_t>&& aCodecSpecific,
            const int32_t& aCoreCount) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDecode(
            const GMPVideoEncodedFrameData& aInputFrame,
            const bool& aMissingFrames,
            nsTArray<uint8_t>&& aCodecSpecificInfo,
            const int64_t& aRenderTimeMs) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReset() = 0;
    virtual mozilla::ipc::IPCResult
    RecvDrain() = 0;
    virtual mozilla::ipc::IPCResult
    RecvDecodingComplete() = 0;
    virtual mozilla::ipc::IPCResult
    RecvChildShmemForPool(Shmem&& aFrameBuffer) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PGMPVideoDecoderChild();

    virtual ~PGMPVideoDecoderChild();

    PGMPContentChild*
    Manager() const;

    static bool
    Send__delete__(PGMPVideoDecoderChild* actor);

    bool
    SendDecoded(const GMPVideoi420FrameData& aDecodedFrame);

    bool
    SendReceivedDecodedReferenceFrame(const uint64_t& aPictureId);

    bool
    SendReceivedDecodedFrame(const uint64_t& aPictureId);

    bool
    SendInputDataExhausted();

    bool
    SendDrainComplete();

    bool
    SendResetComplete();

    bool
    SendError(const GMPErr& aErr);

    bool
    SendShutdown();

    bool
    SendParentShmemForPool(Shmem& aEncodedBuffer);

    bool
    CallNeedShmem(
            const uint32_t& aFrameBufferSize,
            Shmem* aMem);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::gmp::PGMPVideoDecoderChild*>
{
    typedef mozilla::gmp::PGMPVideoDecoderChild* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPVideoDecoderChild :
    public PGMPVideoDecoderChild
{
    mozilla::ipc::IPCResult
    RecvInitDecode(
            const GMPVideoCodec& aCodecSettings,
            nsTArray<uint8_t>&& aCodecSpecific,
            const int32_t& aCoreCount) override;

    mozilla::ipc::IPCResult
    RecvDecode(
            const GMPVideoEncodedFrameData& aInputFrame,
            const bool& aMissingFrames,
            nsTArray<uint8_t>&& aCodecSpecificInfo,
            const int64_t& aRenderTimeMs) override;

    mozilla::ipc::IPCResult
    RecvReset() override;

    mozilla::ipc::IPCResult
    RecvDrain() override;

    mozilla::ipc::IPCResult
    RecvDecodingComplete() override;

    mozilla::ipc::IPCResult
    RecvChildShmemForPool(Shmem&& aFrameBuffer) override;

    MOZ_IMPLICIT GMPVideoDecoderChild();
    virtual ~GMPVideoDecoderChild();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
mozilla::ipc::IPCResult
GMPVideoDecoderChild::RecvInitDecode(
        const GMPVideoCodec& aCodecSettings,
        nsTArray<uint8_t>&& aCodecSpecific,
        const int32_t& aCoreCount)
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderChild::RecvDecode(
        const GMPVideoEncodedFrameData& aInputFrame,
        const bool& aMissingFrames,
        nsTArray<uint8_t>&& aCodecSpecificInfo,
        const int64_t& aRenderTimeMs)
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderChild::RecvReset()
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderChild::RecvDrain()
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderChild::RecvDecodingComplete()
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderChild::RecvChildShmemForPool(Shmem&& aFrameBuffer)
{
}

MOZ_IMPLICIT GMPVideoDecoderChild::GMPVideoDecoderChild()
{
    MOZ_COUNT_CTOR(GMPVideoDecoderChild);
}

MOZ_IMPLICIT GMPVideoDecoderChild::~GMPVideoDecoderChild()
{
    MOZ_COUNT_DTOR(GMPVideoDecoderChild);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPVideoDecoderChild_h
