//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPVideoDecoderParent_h
#define PGMPVideoDecoderParent_h

#include "mozilla/gmp/PGMPVideoDecoder.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "GMPMessageUtils.h"
#include "gmp-errors.h"
#include "gmp-video-codec.h"

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPVideoDecoderParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::gmp::PGMPContentParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef mozilla::gmp::CDMInputBuffer CDMInputBuffer;
    typedef mozilla::gmp::CDMKeyInformation CDMKeyInformation;
    typedef mozilla::gmp::CDMVideoDecoderConfig CDMVideoDecoderConfig;
    typedef mozilla::gmp::CDMVideoFrame CDMVideoFrame;
    typedef mozilla::gmp::CDMVideoPlane CDMVideoPlane;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef mozilla::gmp::NodeIdData NodeIdData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPContentParent PGMPContentParent;
    typedef mozilla::gmp::PGMPContentChild PGMPContentChild;

    typedef PGMPVideoDecoder::State State;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
    virtual mozilla::ipc::IPCResult
    RecvDecoded(const GMPVideoi420FrameData& aDecodedFrame) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReceivedDecodedReferenceFrame(const uint64_t& aPictureId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReceivedDecodedFrame(const uint64_t& aPictureId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvInputDataExhausted() = 0;
    virtual mozilla::ipc::IPCResult
    RecvDrainComplete() = 0;
    virtual mozilla::ipc::IPCResult
    RecvResetComplete() = 0;
    virtual mozilla::ipc::IPCResult
    RecvError(const GMPErr& aErr) = 0;
    virtual mozilla::ipc::IPCResult
    RecvShutdown() = 0;
    virtual mozilla::ipc::IPCResult
    RecvParentShmemForPool(Shmem&& aEncodedBuffer) = 0;
    virtual mozilla::ipc::IPCResult
    AnswerNeedShmem(
            const uint32_t& aFrameBufferSize,
            Shmem* aMem) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PGMPVideoDecoderParent();

    virtual ~PGMPVideoDecoderParent();

    PGMPContentParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendInitDecode(
            const GMPVideoCodec& aCodecSettings,
            const nsTArray<uint8_t>& aCodecSpecific,
            const int32_t& aCoreCount);

    MOZ_MUST_USE bool
    SendDecode(
            const GMPVideoEncodedFrameData& aInputFrame,
            const bool& aMissingFrames,
            const nsTArray<uint8_t>& aCodecSpecificInfo,
            const int64_t& aRenderTimeMs);

    MOZ_MUST_USE bool
    SendReset();

    MOZ_MUST_USE bool
    SendDrain();

    MOZ_MUST_USE bool
    SendDecodingComplete();

    MOZ_MUST_USE bool
    SendChildShmemForPool(Shmem& aFrameBuffer);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::gmp::PGMPVideoDecoderParent*>
{
    typedef mozilla::gmp::PGMPVideoDecoderParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPVideoDecoderParent :
    public PGMPVideoDecoderParent
{
    mozilla::ipc::IPCResult
    RecvDecoded(const GMPVideoi420FrameData& aDecodedFrame) override;

    mozilla::ipc::IPCResult
    RecvReceivedDecodedReferenceFrame(const uint64_t& aPictureId) override;

    mozilla::ipc::IPCResult
    RecvReceivedDecodedFrame(const uint64_t& aPictureId) override;

    mozilla::ipc::IPCResult
    RecvInputDataExhausted() override;

    mozilla::ipc::IPCResult
    RecvDrainComplete() override;

    mozilla::ipc::IPCResult
    RecvResetComplete() override;

    mozilla::ipc::IPCResult
    RecvError(const GMPErr& aErr) override;

    mozilla::ipc::IPCResult
    RecvShutdown() override;

    mozilla::ipc::IPCResult
    RecvParentShmemForPool(Shmem&& aEncodedBuffer) override;

    mozilla::ipc::IPCResult
    AnswerNeedShmem(
            const uint32_t& aFrameBufferSize,
            Shmem* aMem) override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT GMPVideoDecoderParent();
    virtual ~GMPVideoDecoderParent();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvDecoded(const GMPVideoi420FrameData& aDecodedFrame)
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvReceivedDecodedReferenceFrame(const uint64_t& aPictureId)
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvReceivedDecodedFrame(const uint64_t& aPictureId)
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvInputDataExhausted()
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvDrainComplete()
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvResetComplete()
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvError(const GMPErr& aErr)
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvShutdown()
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvParentShmemForPool(Shmem&& aEncodedBuffer)
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::AnswerNeedShmem(
        const uint32_t& aFrameBufferSize,
        Shmem* aMem)
{
}

void
GMPVideoDecoderParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT GMPVideoDecoderParent::GMPVideoDecoderParent()
{
    MOZ_COUNT_CTOR(GMPVideoDecoderParent);
}

MOZ_IMPLICIT GMPVideoDecoderParent::~GMPVideoDecoderParent()
{
    MOZ_COUNT_DTOR(GMPVideoDecoderParent);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPVideoDecoderParent_h
