//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPVideoEncoderChild_h
#define PGMPVideoEncoderChild_h

#include "mozilla/gmp/PGMPVideoEncoder.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "GMPMessageUtils.h"
#include "gmp-errors.h"
#include "gmp-video-codec.h"
#include "gmp-video-frame-encoded.h"

namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPVideoEncoderChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::gmp::PGMPContentChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef mozilla::gmp::CDMInputBuffer CDMInputBuffer;
    typedef mozilla::gmp::CDMKeyInformation CDMKeyInformation;
    typedef mozilla::gmp::CDMVideoDecoderConfig CDMVideoDecoderConfig;
    typedef mozilla::gmp::CDMVideoFrame CDMVideoFrame;
    typedef mozilla::gmp::CDMVideoPlane CDMVideoPlane;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef mozilla::gmp::NodeIdData NodeIdData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPContentChild PGMPContentChild;
    typedef mozilla::gmp::PGMPContentParent PGMPContentParent;

    typedef PGMPVideoEncoder::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvInitEncode(
            const GMPVideoCodec& aCodecSettings,
            nsTArray<uint8_t>&& aCodecSpecific,
            const int32_t& aNumberOfCores,
            const uint32_t& aMaxPayloadSize) = 0;
    virtual mozilla::ipc::IPCResult
    RecvEncode(
            const GMPVideoi420FrameData& aInputFrame,
            nsTArray<uint8_t>&& aCodecSpecificInfo,
            nsTArray<GMPVideoFrameType>&& aFrameTypes) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetChannelParameters(
            const uint32_t& aPacketLoss,
            const uint32_t& aRTT) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetRates(
            const uint32_t& aNewBitRate,
            const uint32_t& aFrameRate) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetPeriodicKeyFrames(const bool& aEnable) = 0;
    virtual mozilla::ipc::IPCResult
    RecvEncodingComplete() = 0;
    virtual mozilla::ipc::IPCResult
    RecvChildShmemForPool(Shmem&& aEncodedBuffer) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PGMPVideoEncoderChild();

    virtual ~PGMPVideoEncoderChild();

    PGMPContentChild*
    Manager() const;

    static bool
    Send__delete__(PGMPVideoEncoderChild* actor);

    bool
    SendEncoded(
            const GMPVideoEncodedFrameData& aEncodedFrame,
            const nsTArray<uint8_t>& aCodecSpecificInfo);

    bool
    SendError(const GMPErr& aErr);

    bool
    SendShutdown();

    bool
    SendParentShmemForPool(Shmem& aFrameBuffer);

    bool
    CallNeedShmem(
            const uint32_t& aEncodedBufferSize,
            Shmem* aMem);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::gmp::PGMPVideoEncoderChild*>
{
    typedef mozilla::gmp::PGMPVideoEncoderChild* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPVideoEncoderChild :
    public PGMPVideoEncoderChild
{
    mozilla::ipc::IPCResult
    RecvInitEncode(
            const GMPVideoCodec& aCodecSettings,
            nsTArray<uint8_t>&& aCodecSpecific,
            const int32_t& aNumberOfCores,
            const uint32_t& aMaxPayloadSize) override;

    mozilla::ipc::IPCResult
    RecvEncode(
            const GMPVideoi420FrameData& aInputFrame,
            nsTArray<uint8_t>&& aCodecSpecificInfo,
            nsTArray<GMPVideoFrameType>&& aFrameTypes) override;

    mozilla::ipc::IPCResult
    RecvSetChannelParameters(
            const uint32_t& aPacketLoss,
            const uint32_t& aRTT) override;

    mozilla::ipc::IPCResult
    RecvSetRates(
            const uint32_t& aNewBitRate,
            const uint32_t& aFrameRate) override;

    mozilla::ipc::IPCResult
    RecvSetPeriodicKeyFrames(const bool& aEnable) override;

    mozilla::ipc::IPCResult
    RecvEncodingComplete() override;

    mozilla::ipc::IPCResult
    RecvChildShmemForPool(Shmem&& aEncodedBuffer) override;

    MOZ_IMPLICIT GMPVideoEncoderChild();
    virtual ~GMPVideoEncoderChild();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
mozilla::ipc::IPCResult
GMPVideoEncoderChild::RecvInitEncode(
        const GMPVideoCodec& aCodecSettings,
        nsTArray<uint8_t>&& aCodecSpecific,
        const int32_t& aNumberOfCores,
        const uint32_t& aMaxPayloadSize)
{
}

mozilla::ipc::IPCResult
GMPVideoEncoderChild::RecvEncode(
        const GMPVideoi420FrameData& aInputFrame,
        nsTArray<uint8_t>&& aCodecSpecificInfo,
        nsTArray<GMPVideoFrameType>&& aFrameTypes)
{
}

mozilla::ipc::IPCResult
GMPVideoEncoderChild::RecvSetChannelParameters(
        const uint32_t& aPacketLoss,
        const uint32_t& aRTT)
{
}

mozilla::ipc::IPCResult
GMPVideoEncoderChild::RecvSetRates(
        const uint32_t& aNewBitRate,
        const uint32_t& aFrameRate)
{
}

mozilla::ipc::IPCResult
GMPVideoEncoderChild::RecvSetPeriodicKeyFrames(const bool& aEnable)
{
}

mozilla::ipc::IPCResult
GMPVideoEncoderChild::RecvEncodingComplete()
{
}

mozilla::ipc::IPCResult
GMPVideoEncoderChild::RecvChildShmemForPool(Shmem&& aEncodedBuffer)
{
}

MOZ_IMPLICIT GMPVideoEncoderChild::GMPVideoEncoderChild()
{
    MOZ_COUNT_CTOR(GMPVideoEncoderChild);
}

MOZ_IMPLICIT GMPVideoEncoderChild::~GMPVideoEncoderChild()
{
    MOZ_COUNT_DTOR(GMPVideoEncoderChild);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPVideoEncoderChild_h
