//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHalChild_h
#define PHalChild_h

#include "mozilla/hal_sandbox/PHal.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/HalSensor.h"
#include "mozilla/HalTypes.h"
#include "mozilla/dom/ScreenOrientation.h"
#include "nsRect.h"
#include "prtime.h"

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace hal_sandbox {


class PHalChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::dom::PContentChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef base::ProcessId ProcessId;
    typedef mozilla::hal::ProcessPriority ProcessPriority;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::hal::ScreenConfiguration ScreenConfiguration;
    typedef mozilla::dom::ScreenOrientationInternal ScreenOrientationInternal;
    typedef mozilla::hal::SensorAccuracyType SensorAccuracyType;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::hal::WakeLockControl WakeLockControl;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PBrowserChild PBrowserChild;
    typedef mozilla::dom::PBrowserParent PBrowserParent;

    typedef PHal::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvNotifyNetworkChange(const NetworkInformation& aNetworkInfo) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyWakeLockChange(const WakeLockInformation& aWakeLockInfo) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyScreenConfigurationChange(const ScreenConfiguration& aScreenOrientation) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifySensorChange(const SensorData& aSensorData) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PHalChild();

    virtual ~PHalChild();

    PContentChild*
    Manager() const;

    bool
    SendVibrate(
            const nsTArray<uint32_t>& pattern,
            const nsTArray<uint64_t>& id,
            PBrowserChild* browser);

    bool
    SendCancelVibrate(
            const nsTArray<uint64_t>& id,
            PBrowserChild* browser);

    bool
    SendEnableNetworkNotifications();

    bool
    SendDisableNetworkNotifications();

    bool
    SendGetCurrentNetworkInformation(NetworkInformation* aNetworkInfo);

    bool
    SendModifyWakeLock(
            const nsString& aTopic,
            const WakeLockControl& aLockAdjust,
            const WakeLockControl& aHiddenAdjust,
            const uint64_t& aProcessID);

    bool
    SendEnableWakeLockNotifications();

    bool
    SendDisableWakeLockNotifications();

    bool
    SendGetWakeLockInfo(
            const nsString& aTopic,
            WakeLockInformation* aWakeLockInfo);

    bool
    SendEnableScreenConfigurationNotifications();

    bool
    SendDisableScreenConfigurationNotifications();

    bool
    SendLockScreenOrientation(
            const ScreenOrientationInternal& aOrientation,
            bool* allowed);

    bool
    SendUnlockScreenOrientation();

    bool
    SendEnableSensorNotifications(const SensorType& aSensor);

    bool
    SendDisableSensorNotifications(const SensorType& aSensor);

    static bool
    Send__delete__(PHalChild* actor);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace hal_sandbox
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::hal_sandbox::PHalChild*>
{
    typedef mozilla::hal_sandbox::PHalChild* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace hal_sandbox {
class HalChild :
    public PHalChild
{
    mozilla::ipc::IPCResult
    RecvNotifyNetworkChange(const NetworkInformation& aNetworkInfo) override;

    mozilla::ipc::IPCResult
    RecvNotifyWakeLockChange(const WakeLockInformation& aWakeLockInfo) override;

    mozilla::ipc::IPCResult
    RecvNotifyScreenConfigurationChange(const ScreenConfiguration& aScreenOrientation) override;

    mozilla::ipc::IPCResult
    RecvNotifySensorChange(const SensorData& aSensorData) override;

    MOZ_IMPLICIT HalChild();
    virtual ~HalChild();
};
} // namespace hal_sandbox
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace hal_sandbox {
mozilla::ipc::IPCResult
HalChild::RecvNotifyNetworkChange(const NetworkInformation& aNetworkInfo)
{
}

mozilla::ipc::IPCResult
HalChild::RecvNotifyWakeLockChange(const WakeLockInformation& aWakeLockInfo)
{
}

mozilla::ipc::IPCResult
HalChild::RecvNotifyScreenConfigurationChange(const ScreenConfiguration& aScreenOrientation)
{
}

mozilla::ipc::IPCResult
HalChild::RecvNotifySensorChange(const SensorData& aSensorData)
{
}

MOZ_IMPLICIT HalChild::HalChild()
{
    MOZ_COUNT_CTOR(HalChild);
}

MOZ_IMPLICIT HalChild::~HalChild()
{
    MOZ_COUNT_DTOR(HalChild);
}

} // namespace hal_sandbox
} // namespace mozilla
#endif // if 0

#endif // ifndef PHalChild_h
