//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef InputStreamParams_h
#define InputStreamParams_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/ipc/ProtocolTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HeaderEntry|
//
namespace mozilla {
namespace ipc {
class HeaderEntry final
{
private:

public:
    MOZ_IMPLICIT HeaderEntry() :
        name_(),
        value_()
    {
    }

    MOZ_IMPLICIT HeaderEntry(
            const nsCString& _name,
            const nsCString& _value) :
        name_(_name),
        value_(_value)
    {
    }

    bool
    operator==(const HeaderEntry& _o) const;

    bool
    operator!=(const HeaderEntry& _o) const;

    nsCString&
    name()
    {
        return name_;
    }
    const nsCString&
    name() const
    {
        return name_;
    }

    nsCString&
    value()
    {
        return value_;
    }
    const nsCString&
    value() const
    {
        return value_;
    }

private:
    nsCString name_;
    nsCString value_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::ipc::HeaderEntry>
{
    typedef mozilla::ipc::HeaderEntry paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct StringInputStreamParams|
//
namespace mozilla {
namespace ipc {
class StringInputStreamParams final
{
private:

public:
    MOZ_IMPLICIT StringInputStreamParams() :
        data_()
    {
    }

    MOZ_IMPLICIT StringInputStreamParams(const nsCString& _data) :
        data_(_data)
    {
    }

    bool
    operator==(const StringInputStreamParams& _o) const;

    bool
    operator!=(const StringInputStreamParams& _o) const;

    nsCString&
    data()
    {
        return data_;
    }
    const nsCString&
    data() const
    {
        return data_;
    }

private:
    nsCString data_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::ipc::StringInputStreamParams>
{
    typedef mozilla::ipc::StringInputStreamParams paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileInputStreamParams|
//
namespace mozilla {
namespace ipc {
class FileInputStreamParams final
{
private:

public:
    MOZ_IMPLICIT FileInputStreamParams() :
        fileDescriptorIndex_(),
        behaviorFlags_(),
        ioFlags_()
    {
    }

    MOZ_IMPLICIT FileInputStreamParams(
            const uint32_t& _fileDescriptorIndex,
            const int32_t& _behaviorFlags,
            const int32_t& _ioFlags) :
        fileDescriptorIndex_(_fileDescriptorIndex),
        behaviorFlags_(_behaviorFlags),
        ioFlags_(_ioFlags)
    {
    }

    bool
    operator==(const FileInputStreamParams& _o) const;

    bool
    operator!=(const FileInputStreamParams& _o) const;

    uint32_t&
    fileDescriptorIndex()
    {
        return fileDescriptorIndex_;
    }
    const uint32_t&
    fileDescriptorIndex() const
    {
        return fileDescriptorIndex_;
    }

    int32_t&
    behaviorFlags()
    {
        return behaviorFlags_;
    }
    const int32_t&
    behaviorFlags() const
    {
        return behaviorFlags_;
    }

    int32_t&
    ioFlags()
    {
        return ioFlags_;
    }
    const int32_t&
    ioFlags() const
    {
        return ioFlags_;
    }

private:
    uint32_t fileDescriptorIndex_;
    int32_t behaviorFlags_;
    int32_t ioFlags_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::ipc::FileInputStreamParams>
{
    typedef mozilla::ipc::FileInputStreamParams paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCBlobInputStreamParams|
//
namespace mozilla {
namespace ipc {
class IPCBlobInputStreamParams final
{
private:

public:
    MOZ_IMPLICIT IPCBlobInputStreamParams() :
        id_(),
        start_(),
        length_()
    {
    }

    MOZ_IMPLICIT IPCBlobInputStreamParams(
            const nsID& _id,
            const uint64_t& _start,
            const uint64_t& _length) :
        id_(_id),
        start_(_start),
        length_(_length)
    {
    }

    bool
    operator==(const IPCBlobInputStreamParams& _o) const;

    bool
    operator!=(const IPCBlobInputStreamParams& _o) const;

    nsID&
    id()
    {
        return id_;
    }
    const nsID&
    id() const
    {
        return id_;
    }

    uint64_t&
    start()
    {
        return start_;
    }
    const uint64_t&
    start() const
    {
        return start_;
    }

    uint64_t&
    length()
    {
        return length_;
    }
    const uint64_t&
    length() const
    {
        return length_;
    }

private:
    nsID id_;
    uint64_t start_;
    uint64_t length_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::ipc::IPCBlobInputStreamParams>
{
    typedef mozilla::ipc::IPCBlobInputStreamParams paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class BufferedInputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class MIMEInputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class MultiplexInputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class SlicedInputStreamParams;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union InputStreamParams|
//
namespace mozilla {
namespace ipc {
class InputStreamParams final
{
public:
    enum Type {
        T__None,
        TStringInputStreamParams = 1,
        TFileInputStreamParams,
        TBufferedInputStreamParams,
        TMIMEInputStreamParams,
        TMultiplexInputStreamParams,
        TSlicedInputStreamParams,
        TIPCBlobInputStreamParams,
        T__Last = TIPCBlobInputStreamParams
    };

private:
    typedef mozilla::ipc::StringInputStreamParams StringInputStreamParams;
    typedef mozilla::ipc::FileInputStreamParams FileInputStreamParams;
    typedef mozilla::ipc::BufferedInputStreamParams BufferedInputStreamParams;
    typedef mozilla::ipc::MIMEInputStreamParams MIMEInputStreamParams;
    typedef mozilla::ipc::MultiplexInputStreamParams MultiplexInputStreamParams;
    typedef mozilla::ipc::SlicedInputStreamParams SlicedInputStreamParams;
    typedef mozilla::ipc::IPCBlobInputStreamParams IPCBlobInputStreamParams;
    typedef StringInputStreamParams StringInputStreamParams__tdef;
    typedef FileInputStreamParams FileInputStreamParams__tdef;
    typedef BufferedInputStreamParams* BufferedInputStreamParams__tdef;
    typedef MIMEInputStreamParams* MIMEInputStreamParams__tdef;
    typedef MultiplexInputStreamParams* MultiplexInputStreamParams__tdef;
    typedef SlicedInputStreamParams* SlicedInputStreamParams__tdef;
    typedef IPCBlobInputStreamParams IPCBlobInputStreamParams__tdef;

    union Value {
        mozilla::AlignedStorage2<StringInputStreamParams> VStringInputStreamParams;
        mozilla::AlignedStorage2<FileInputStreamParams> VFileInputStreamParams;
        BufferedInputStreamParams* VBufferedInputStreamParams;
        MIMEInputStreamParams* VMIMEInputStreamParams;
        MultiplexInputStreamParams* VMultiplexInputStreamParams;
        SlicedInputStreamParams* VSlicedInputStreamParams;
        mozilla::AlignedStorage2<IPCBlobInputStreamParams> VIPCBlobInputStreamParams;
    };

    StringInputStreamParams*
    ptr_StringInputStreamParams()
    {
        return ((mValue).VStringInputStreamParams).addr();
    }
    const StringInputStreamParams*
    constptr_StringInputStreamParams() const
    {
        return ((mValue).VStringInputStreamParams).addr();
    }
    FileInputStreamParams*
    ptr_FileInputStreamParams()
    {
        return ((mValue).VFileInputStreamParams).addr();
    }
    const FileInputStreamParams*
    constptr_FileInputStreamParams() const
    {
        return ((mValue).VFileInputStreamParams).addr();
    }
    BufferedInputStreamParams*&
    ptr_BufferedInputStreamParams()
    {
        return (mValue).VBufferedInputStreamParams;
    }
    const BufferedInputStreamParams*
    constptr_BufferedInputStreamParams() const
    {
        return (mValue).VBufferedInputStreamParams;
    }
    MIMEInputStreamParams*&
    ptr_MIMEInputStreamParams()
    {
        return (mValue).VMIMEInputStreamParams;
    }
    const MIMEInputStreamParams*
    constptr_MIMEInputStreamParams() const
    {
        return (mValue).VMIMEInputStreamParams;
    }
    MultiplexInputStreamParams*&
    ptr_MultiplexInputStreamParams()
    {
        return (mValue).VMultiplexInputStreamParams;
    }
    const MultiplexInputStreamParams*
    constptr_MultiplexInputStreamParams() const
    {
        return (mValue).VMultiplexInputStreamParams;
    }
    SlicedInputStreamParams*&
    ptr_SlicedInputStreamParams()
    {
        return (mValue).VSlicedInputStreamParams;
    }
    const SlicedInputStreamParams*
    constptr_SlicedInputStreamParams() const
    {
        return (mValue).VSlicedInputStreamParams;
    }
    IPCBlobInputStreamParams*
    ptr_IPCBlobInputStreamParams()
    {
        return ((mValue).VIPCBlobInputStreamParams).addr();
    }
    const IPCBlobInputStreamParams*
    constptr_IPCBlobInputStreamParams() const
    {
        return ((mValue).VIPCBlobInputStreamParams).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT InputStreamParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT InputStreamParams(const StringInputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(StringInputStreamParams&& aOther);

    MOZ_IMPLICIT InputStreamParams(const FileInputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(FileInputStreamParams&& aOther);

    MOZ_IMPLICIT InputStreamParams(const BufferedInputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(BufferedInputStreamParams&& aOther);

    MOZ_IMPLICIT InputStreamParams(const MIMEInputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(MIMEInputStreamParams&& aOther);

    MOZ_IMPLICIT InputStreamParams(const MultiplexInputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(MultiplexInputStreamParams&& aOther);

    MOZ_IMPLICIT InputStreamParams(const SlicedInputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(SlicedInputStreamParams&& aOther);

    MOZ_IMPLICIT InputStreamParams(const IPCBlobInputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(IPCBlobInputStreamParams&& aOther);

    MOZ_IMPLICIT InputStreamParams(const InputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(InputStreamParams&& aOther);

    ~InputStreamParams();

    Type
    type() const
    {
        return mType;
    }

    InputStreamParams&
    operator=(const StringInputStreamParams& aRhs);

    InputStreamParams&
    operator=(StringInputStreamParams&& aRhs);

    InputStreamParams&
    operator=(const FileInputStreamParams& aRhs);

    InputStreamParams&
    operator=(FileInputStreamParams&& aRhs);

    InputStreamParams&
    operator=(const BufferedInputStreamParams& aRhs);

    InputStreamParams&
    operator=(BufferedInputStreamParams&& aRhs);

    InputStreamParams&
    operator=(const MIMEInputStreamParams& aRhs);

    InputStreamParams&
    operator=(MIMEInputStreamParams&& aRhs);

    InputStreamParams&
    operator=(const MultiplexInputStreamParams& aRhs);

    InputStreamParams&
    operator=(MultiplexInputStreamParams&& aRhs);

    InputStreamParams&
    operator=(const SlicedInputStreamParams& aRhs);

    InputStreamParams&
    operator=(SlicedInputStreamParams&& aRhs);

    InputStreamParams&
    operator=(const IPCBlobInputStreamParams& aRhs);

    InputStreamParams&
    operator=(IPCBlobInputStreamParams&& aRhs);

    InputStreamParams&
    operator=(const InputStreamParams& aRhs);

    InputStreamParams&
    operator=(InputStreamParams&& aRhs);

    bool
    operator==(const StringInputStreamParams& aRhs) const;

    bool
    operator==(const FileInputStreamParams& aRhs) const;

    bool
    operator==(const BufferedInputStreamParams& aRhs) const;

    bool
    operator==(const MIMEInputStreamParams& aRhs) const;

    bool
    operator==(const MultiplexInputStreamParams& aRhs) const;

    bool
    operator==(const SlicedInputStreamParams& aRhs) const;

    bool
    operator==(const IPCBlobInputStreamParams& aRhs) const;

    bool
    operator==(const InputStreamParams& aRhs) const;

    StringInputStreamParams&
    get_StringInputStreamParams()
    {
        AssertSanity(TStringInputStreamParams);
        return (*(ptr_StringInputStreamParams()));
    }
    const StringInputStreamParams&
    get_StringInputStreamParams() const
    {
        AssertSanity(TStringInputStreamParams);
        return (*(constptr_StringInputStreamParams()));
    }
    void
    get(StringInputStreamParams* aOutValue) const;
    operator StringInputStreamParams&()
    {
        return get_StringInputStreamParams();
    }
    operator const StringInputStreamParams&() const
    {
        return get_StringInputStreamParams();
    }

    FileInputStreamParams&
    get_FileInputStreamParams()
    {
        AssertSanity(TFileInputStreamParams);
        return (*(ptr_FileInputStreamParams()));
    }
    const FileInputStreamParams&
    get_FileInputStreamParams() const
    {
        AssertSanity(TFileInputStreamParams);
        return (*(constptr_FileInputStreamParams()));
    }
    void
    get(FileInputStreamParams* aOutValue) const;
    operator FileInputStreamParams&()
    {
        return get_FileInputStreamParams();
    }
    operator const FileInputStreamParams&() const
    {
        return get_FileInputStreamParams();
    }

    BufferedInputStreamParams&
    get_BufferedInputStreamParams()
    {
        AssertSanity(TBufferedInputStreamParams);
        return (*(ptr_BufferedInputStreamParams()));
    }
    const BufferedInputStreamParams&
    get_BufferedInputStreamParams() const
    {
        AssertSanity(TBufferedInputStreamParams);
        return (*(constptr_BufferedInputStreamParams()));
    }
    void
    get(BufferedInputStreamParams* aOutValue) const;
    operator BufferedInputStreamParams&()
    {
        return get_BufferedInputStreamParams();
    }
    operator const BufferedInputStreamParams&() const
    {
        return get_BufferedInputStreamParams();
    }

    MIMEInputStreamParams&
    get_MIMEInputStreamParams()
    {
        AssertSanity(TMIMEInputStreamParams);
        return (*(ptr_MIMEInputStreamParams()));
    }
    const MIMEInputStreamParams&
    get_MIMEInputStreamParams() const
    {
        AssertSanity(TMIMEInputStreamParams);
        return (*(constptr_MIMEInputStreamParams()));
    }
    void
    get(MIMEInputStreamParams* aOutValue) const;
    operator MIMEInputStreamParams&()
    {
        return get_MIMEInputStreamParams();
    }
    operator const MIMEInputStreamParams&() const
    {
        return get_MIMEInputStreamParams();
    }

    MultiplexInputStreamParams&
    get_MultiplexInputStreamParams()
    {
        AssertSanity(TMultiplexInputStreamParams);
        return (*(ptr_MultiplexInputStreamParams()));
    }
    const MultiplexInputStreamParams&
    get_MultiplexInputStreamParams() const
    {
        AssertSanity(TMultiplexInputStreamParams);
        return (*(constptr_MultiplexInputStreamParams()));
    }
    void
    get(MultiplexInputStreamParams* aOutValue) const;
    operator MultiplexInputStreamParams&()
    {
        return get_MultiplexInputStreamParams();
    }
    operator const MultiplexInputStreamParams&() const
    {
        return get_MultiplexInputStreamParams();
    }

    SlicedInputStreamParams&
    get_SlicedInputStreamParams()
    {
        AssertSanity(TSlicedInputStreamParams);
        return (*(ptr_SlicedInputStreamParams()));
    }
    const SlicedInputStreamParams&
    get_SlicedInputStreamParams() const
    {
        AssertSanity(TSlicedInputStreamParams);
        return (*(constptr_SlicedInputStreamParams()));
    }
    void
    get(SlicedInputStreamParams* aOutValue) const;
    operator SlicedInputStreamParams&()
    {
        return get_SlicedInputStreamParams();
    }
    operator const SlicedInputStreamParams&() const
    {
        return get_SlicedInputStreamParams();
    }

    IPCBlobInputStreamParams&
    get_IPCBlobInputStreamParams()
    {
        AssertSanity(TIPCBlobInputStreamParams);
        return (*(ptr_IPCBlobInputStreamParams()));
    }
    const IPCBlobInputStreamParams&
    get_IPCBlobInputStreamParams() const
    {
        AssertSanity(TIPCBlobInputStreamParams);
        return (*(constptr_IPCBlobInputStreamParams()));
    }
    void
    get(IPCBlobInputStreamParams* aOutValue) const;
    operator IPCBlobInputStreamParams&()
    {
        return get_IPCBlobInputStreamParams();
    }
    operator const IPCBlobInputStreamParams&() const
    {
        return get_IPCBlobInputStreamParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::ipc::InputStreamParams>
{
    typedef mozilla::ipc::InputStreamParams paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MultiplexInputStreamParams|
//
namespace mozilla {
namespace ipc {
class MultiplexInputStreamParams final
{
private:
    typedef mozilla::ipc::InputStreamParams InputStreamParams;

public:
    MOZ_IMPLICIT MultiplexInputStreamParams() :
        streams_(),
        currentStream_(),
        status_(),
        startedReadingCurrent_()
    {
    }

    MOZ_IMPLICIT MultiplexInputStreamParams(
            const nsTArray<InputStreamParams>& _streams,
            const uint32_t& _currentStream,
            const nsresult& _status,
            const bool& _startedReadingCurrent) :
        streams_(_streams),
        currentStream_(_currentStream),
        status_(_status),
        startedReadingCurrent_(_startedReadingCurrent)
    {
    }

    bool
    operator==(const MultiplexInputStreamParams& _o) const;

    bool
    operator!=(const MultiplexInputStreamParams& _o) const;

    nsTArray<InputStreamParams>&
    streams()
    {
        return streams_;
    }
    const nsTArray<InputStreamParams>&
    streams() const
    {
        return streams_;
    }

    uint32_t&
    currentStream()
    {
        return currentStream_;
    }
    const uint32_t&
    currentStream() const
    {
        return currentStream_;
    }

    nsresult&
    status()
    {
        return status_;
    }
    const nsresult&
    status() const
    {
        return status_;
    }

    bool&
    startedReadingCurrent()
    {
        return startedReadingCurrent_;
    }
    const bool&
    startedReadingCurrent() const
    {
        return startedReadingCurrent_;
    }

private:
    nsTArray<InputStreamParams> streams_;
    uint32_t currentStream_;
    nsresult status_;
    bool startedReadingCurrent_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::ipc::MultiplexInputStreamParams>
{
    typedef mozilla::ipc::MultiplexInputStreamParams paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SlicedInputStreamParams|
//
namespace mozilla {
namespace ipc {
class SlicedInputStreamParams final
{
private:
    typedef mozilla::ipc::InputStreamParams InputStreamParams;

public:
    MOZ_IMPLICIT SlicedInputStreamParams() :
        stream_(),
        start_(),
        length_(),
        curPos_(),
        closed_()
    {
    }

    MOZ_IMPLICIT SlicedInputStreamParams(
            const InputStreamParams& _stream,
            const uint64_t& _start,
            const uint64_t& _length,
            const uint64_t& _curPos,
            const bool& _closed) :
        stream_(_stream),
        start_(_start),
        length_(_length),
        curPos_(_curPos),
        closed_(_closed)
    {
    }

    bool
    operator==(const SlicedInputStreamParams& _o) const;

    bool
    operator!=(const SlicedInputStreamParams& _o) const;

    InputStreamParams&
    stream()
    {
        return stream_;
    }
    const InputStreamParams&
    stream() const
    {
        return stream_;
    }

    uint64_t&
    start()
    {
        return start_;
    }
    const uint64_t&
    start() const
    {
        return start_;
    }

    uint64_t&
    length()
    {
        return length_;
    }
    const uint64_t&
    length() const
    {
        return length_;
    }

    uint64_t&
    curPos()
    {
        return curPos_;
    }
    const uint64_t&
    curPos() const
    {
        return curPos_;
    }

    bool&
    closed()
    {
        return closed_;
    }
    const bool&
    closed() const
    {
        return closed_;
    }

private:
    InputStreamParams stream_;
    uint64_t start_;
    uint64_t length_;
    uint64_t curPos_;
    bool closed_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::ipc::SlicedInputStreamParams>
{
    typedef mozilla::ipc::SlicedInputStreamParams paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class InputStreamParams;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalInputStreamParams|
//
namespace mozilla {
namespace ipc {
class OptionalInputStreamParams final
{
public:
    enum Type {
        T__None,
        Tvoid_t = 1,
        TInputStreamParams,
        T__Last = TInputStreamParams
    };

private:
    typedef mozilla::void_t void_t;
    typedef mozilla::ipc::InputStreamParams InputStreamParams;
    typedef void_t void_t__tdef;
    typedef InputStreamParams* InputStreamParams__tdef;

    union Value {
        mozilla::AlignedStorage2<void_t> Vvoid_t;
        InputStreamParams* VInputStreamParams;
    };

    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }
    InputStreamParams*&
    ptr_InputStreamParams()
    {
        return (mValue).VInputStreamParams;
    }
    const InputStreamParams*
    constptr_InputStreamParams() const
    {
        return (mValue).VInputStreamParams;
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalInputStreamParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalInputStreamParams(const void_t& aOther);

    MOZ_IMPLICIT OptionalInputStreamParams(void_t&& aOther);

    MOZ_IMPLICIT OptionalInputStreamParams(const InputStreamParams& aOther);

    MOZ_IMPLICIT OptionalInputStreamParams(InputStreamParams&& aOther);

    MOZ_IMPLICIT OptionalInputStreamParams(const OptionalInputStreamParams& aOther);

    MOZ_IMPLICIT OptionalInputStreamParams(OptionalInputStreamParams&& aOther);

    ~OptionalInputStreamParams();

    Type
    type() const
    {
        return mType;
    }

    OptionalInputStreamParams&
    operator=(const void_t& aRhs);

    OptionalInputStreamParams&
    operator=(void_t&& aRhs);

    OptionalInputStreamParams&
    operator=(const InputStreamParams& aRhs);

    OptionalInputStreamParams&
    operator=(InputStreamParams&& aRhs);

    OptionalInputStreamParams&
    operator=(const OptionalInputStreamParams& aRhs);

    OptionalInputStreamParams&
    operator=(OptionalInputStreamParams&& aRhs);

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const InputStreamParams& aRhs) const;

    bool
    operator==(const OptionalInputStreamParams& aRhs) const;

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

    InputStreamParams&
    get_InputStreamParams()
    {
        AssertSanity(TInputStreamParams);
        return (*(ptr_InputStreamParams()));
    }
    const InputStreamParams&
    get_InputStreamParams() const
    {
        AssertSanity(TInputStreamParams);
        return (*(constptr_InputStreamParams()));
    }
    void
    get(InputStreamParams* aOutValue) const;
    operator InputStreamParams&()
    {
        return get_InputStreamParams();
    }
    operator const InputStreamParams&() const
    {
        return get_InputStreamParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::ipc::OptionalInputStreamParams>
{
    typedef mozilla::ipc::OptionalInputStreamParams paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct BufferedInputStreamParams|
//
namespace mozilla {
namespace ipc {
class BufferedInputStreamParams final
{
private:
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;

public:
    MOZ_IMPLICIT BufferedInputStreamParams() :
        optionalStream_(),
        bufferSize_()
    {
    }

    MOZ_IMPLICIT BufferedInputStreamParams(
            const OptionalInputStreamParams& _optionalStream,
            const uint32_t& _bufferSize) :
        optionalStream_(_optionalStream),
        bufferSize_(_bufferSize)
    {
    }

    bool
    operator==(const BufferedInputStreamParams& _o) const;

    bool
    operator!=(const BufferedInputStreamParams& _o) const;

    OptionalInputStreamParams&
    optionalStream()
    {
        return optionalStream_;
    }
    const OptionalInputStreamParams&
    optionalStream() const
    {
        return optionalStream_;
    }

    uint32_t&
    bufferSize()
    {
        return bufferSize_;
    }
    const uint32_t&
    bufferSize() const
    {
        return bufferSize_;
    }

private:
    OptionalInputStreamParams optionalStream_;
    uint32_t bufferSize_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::ipc::BufferedInputStreamParams>
{
    typedef mozilla::ipc::BufferedInputStreamParams paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MIMEInputStreamParams|
//
namespace mozilla {
namespace ipc {
class MIMEInputStreamParams final
{
private:
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;
    typedef mozilla::ipc::HeaderEntry HeaderEntry;

public:
    MOZ_IMPLICIT MIMEInputStreamParams() :
        optionalStream_(),
        headers_(),
        startedReading_()
    {
    }

    MOZ_IMPLICIT MIMEInputStreamParams(
            const OptionalInputStreamParams& _optionalStream,
            const nsTArray<HeaderEntry>& _headers,
            const bool& _startedReading) :
        optionalStream_(_optionalStream),
        headers_(_headers),
        startedReading_(_startedReading)
    {
    }

    bool
    operator==(const MIMEInputStreamParams& _o) const;

    bool
    operator!=(const MIMEInputStreamParams& _o) const;

    OptionalInputStreamParams&
    optionalStream()
    {
        return optionalStream_;
    }
    const OptionalInputStreamParams&
    optionalStream() const
    {
        return optionalStream_;
    }

    nsTArray<HeaderEntry>&
    headers()
    {
        return headers_;
    }
    const nsTArray<HeaderEntry>&
    headers() const
    {
        return headers_;
    }

    bool&
    startedReading()
    {
        return startedReading_;
    }
    const bool&
    startedReading() const
    {
        return startedReading_;
    }

private:
    OptionalInputStreamParams optionalStream_;
    nsTArray<HeaderEntry> headers_;
    bool startedReading_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::ipc::MIMEInputStreamParams>
{
    typedef mozilla::ipc::MIMEInputStreamParams paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef InputStreamParams_h
