//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBackgroundSharedTypes_h
#define PBackgroundSharedTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/ipc/BackgroundUtils.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ContentPrincipalInfo|
//
namespace mozilla {
namespace ipc {
class ContentPrincipalInfo final
{
private:
    typedef mozilla::OriginAttributes OriginAttributes;

public:
    MOZ_IMPLICIT ContentPrincipalInfo() :
        attrs_(),
        originNoSuffix_(),
        spec_()
    {
    }

    MOZ_IMPLICIT ContentPrincipalInfo(
            const OriginAttributes& _attrs,
            const nsCString& _originNoSuffix,
            const nsCString& _spec) :
        attrs_(_attrs),
        originNoSuffix_(_originNoSuffix),
        spec_(_spec)
    {
    }

    bool
    operator==(const ContentPrincipalInfo& _o) const;

    bool
    operator!=(const ContentPrincipalInfo& _o) const;

    OriginAttributes&
    attrs()
    {
        return attrs_;
    }
    const OriginAttributes&
    attrs() const
    {
        return attrs_;
    }

    nsCString&
    originNoSuffix()
    {
        return originNoSuffix_;
    }
    const nsCString&
    originNoSuffix() const
    {
        return originNoSuffix_;
    }

    nsCString&
    spec()
    {
        return spec_;
    }
    const nsCString&
    spec() const
    {
        return spec_;
    }

private:
    OriginAttributes attrs_;
    nsCString originNoSuffix_;
    nsCString spec_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::ipc::ContentPrincipalInfo>
{
    typedef mozilla::ipc::ContentPrincipalInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SystemPrincipalInfo|
//
namespace mozilla {
namespace ipc {
class SystemPrincipalInfo final
{
private:

public:
    MOZ_IMPLICIT SystemPrincipalInfo()
    {
    }

    bool
    operator==(const SystemPrincipalInfo& _o) const;

    bool
    operator!=(const SystemPrincipalInfo& _o) const;

private:
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::ipc::SystemPrincipalInfo>
{
    typedef mozilla::ipc::SystemPrincipalInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct NullPrincipalInfo|
//
namespace mozilla {
namespace ipc {
class NullPrincipalInfo final
{
private:
    typedef mozilla::OriginAttributes OriginAttributes;

public:
    MOZ_IMPLICIT NullPrincipalInfo() :
        attrs_(),
        spec_()
    {
    }

    MOZ_IMPLICIT NullPrincipalInfo(
            const OriginAttributes& _attrs,
            const nsCString& _spec) :
        attrs_(_attrs),
        spec_(_spec)
    {
    }

    bool
    operator==(const NullPrincipalInfo& _o) const;

    bool
    operator!=(const NullPrincipalInfo& _o) const;

    OriginAttributes&
    attrs()
    {
        return attrs_;
    }
    const OriginAttributes&
    attrs() const
    {
        return attrs_;
    }

    nsCString&
    spec()
    {
        return spec_;
    }
    const nsCString&
    spec() const
    {
        return spec_;
    }

private:
    OriginAttributes attrs_;
    nsCString spec_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::ipc::NullPrincipalInfo>
{
    typedef mozilla::ipc::NullPrincipalInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class ExpandedPrincipalInfo;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union PrincipalInfo|
//
namespace mozilla {
namespace ipc {
class PrincipalInfo final
{
public:
    enum Type {
        T__None,
        TContentPrincipalInfo = 1,
        TSystemPrincipalInfo,
        TNullPrincipalInfo,
        TExpandedPrincipalInfo,
        T__Last = TExpandedPrincipalInfo
    };

private:
    typedef mozilla::ipc::ContentPrincipalInfo ContentPrincipalInfo;
    typedef mozilla::ipc::SystemPrincipalInfo SystemPrincipalInfo;
    typedef mozilla::ipc::NullPrincipalInfo NullPrincipalInfo;
    typedef mozilla::ipc::ExpandedPrincipalInfo ExpandedPrincipalInfo;
    typedef ContentPrincipalInfo ContentPrincipalInfo__tdef;
    typedef SystemPrincipalInfo SystemPrincipalInfo__tdef;
    typedef NullPrincipalInfo NullPrincipalInfo__tdef;
    typedef ExpandedPrincipalInfo* ExpandedPrincipalInfo__tdef;

    union Value {
        mozilla::AlignedStorage2<ContentPrincipalInfo> VContentPrincipalInfo;
        mozilla::AlignedStorage2<SystemPrincipalInfo> VSystemPrincipalInfo;
        mozilla::AlignedStorage2<NullPrincipalInfo> VNullPrincipalInfo;
        ExpandedPrincipalInfo* VExpandedPrincipalInfo;
    };

    ContentPrincipalInfo*
    ptr_ContentPrincipalInfo()
    {
        return ((mValue).VContentPrincipalInfo).addr();
    }
    const ContentPrincipalInfo*
    constptr_ContentPrincipalInfo() const
    {
        return ((mValue).VContentPrincipalInfo).addr();
    }
    SystemPrincipalInfo*
    ptr_SystemPrincipalInfo()
    {
        return ((mValue).VSystemPrincipalInfo).addr();
    }
    const SystemPrincipalInfo*
    constptr_SystemPrincipalInfo() const
    {
        return ((mValue).VSystemPrincipalInfo).addr();
    }
    NullPrincipalInfo*
    ptr_NullPrincipalInfo()
    {
        return ((mValue).VNullPrincipalInfo).addr();
    }
    const NullPrincipalInfo*
    constptr_NullPrincipalInfo() const
    {
        return ((mValue).VNullPrincipalInfo).addr();
    }
    ExpandedPrincipalInfo*&
    ptr_ExpandedPrincipalInfo()
    {
        return (mValue).VExpandedPrincipalInfo;
    }
    const ExpandedPrincipalInfo*
    constptr_ExpandedPrincipalInfo() const
    {
        return (mValue).VExpandedPrincipalInfo;
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT PrincipalInfo() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT PrincipalInfo(const ContentPrincipalInfo& aOther);

    MOZ_IMPLICIT PrincipalInfo(ContentPrincipalInfo&& aOther);

    MOZ_IMPLICIT PrincipalInfo(const SystemPrincipalInfo& aOther);

    MOZ_IMPLICIT PrincipalInfo(SystemPrincipalInfo&& aOther);

    MOZ_IMPLICIT PrincipalInfo(const NullPrincipalInfo& aOther);

    MOZ_IMPLICIT PrincipalInfo(NullPrincipalInfo&& aOther);

    MOZ_IMPLICIT PrincipalInfo(const ExpandedPrincipalInfo& aOther);

    MOZ_IMPLICIT PrincipalInfo(ExpandedPrincipalInfo&& aOther);

    MOZ_IMPLICIT PrincipalInfo(const PrincipalInfo& aOther);

    MOZ_IMPLICIT PrincipalInfo(PrincipalInfo&& aOther);

    ~PrincipalInfo();

    Type
    type() const
    {
        return mType;
    }

    PrincipalInfo&
    operator=(const ContentPrincipalInfo& aRhs);

    PrincipalInfo&
    operator=(ContentPrincipalInfo&& aRhs);

    PrincipalInfo&
    operator=(const SystemPrincipalInfo& aRhs);

    PrincipalInfo&
    operator=(SystemPrincipalInfo&& aRhs);

    PrincipalInfo&
    operator=(const NullPrincipalInfo& aRhs);

    PrincipalInfo&
    operator=(NullPrincipalInfo&& aRhs);

    PrincipalInfo&
    operator=(const ExpandedPrincipalInfo& aRhs);

    PrincipalInfo&
    operator=(ExpandedPrincipalInfo&& aRhs);

    PrincipalInfo&
    operator=(const PrincipalInfo& aRhs);

    PrincipalInfo&
    operator=(PrincipalInfo&& aRhs);

    bool
    operator==(const ContentPrincipalInfo& aRhs) const;

    bool
    operator==(const SystemPrincipalInfo& aRhs) const;

    bool
    operator==(const NullPrincipalInfo& aRhs) const;

    bool
    operator==(const ExpandedPrincipalInfo& aRhs) const;

    bool
    operator==(const PrincipalInfo& aRhs) const;

    ContentPrincipalInfo&
    get_ContentPrincipalInfo()
    {
        AssertSanity(TContentPrincipalInfo);
        return (*(ptr_ContentPrincipalInfo()));
    }
    const ContentPrincipalInfo&
    get_ContentPrincipalInfo() const
    {
        AssertSanity(TContentPrincipalInfo);
        return (*(constptr_ContentPrincipalInfo()));
    }
    void
    get(ContentPrincipalInfo* aOutValue) const;
    operator ContentPrincipalInfo&()
    {
        return get_ContentPrincipalInfo();
    }
    operator const ContentPrincipalInfo&() const
    {
        return get_ContentPrincipalInfo();
    }

    SystemPrincipalInfo&
    get_SystemPrincipalInfo()
    {
        AssertSanity(TSystemPrincipalInfo);
        return (*(ptr_SystemPrincipalInfo()));
    }
    const SystemPrincipalInfo&
    get_SystemPrincipalInfo() const
    {
        AssertSanity(TSystemPrincipalInfo);
        return (*(constptr_SystemPrincipalInfo()));
    }
    void
    get(SystemPrincipalInfo* aOutValue) const;
    operator SystemPrincipalInfo&()
    {
        return get_SystemPrincipalInfo();
    }
    operator const SystemPrincipalInfo&() const
    {
        return get_SystemPrincipalInfo();
    }

    NullPrincipalInfo&
    get_NullPrincipalInfo()
    {
        AssertSanity(TNullPrincipalInfo);
        return (*(ptr_NullPrincipalInfo()));
    }
    const NullPrincipalInfo&
    get_NullPrincipalInfo() const
    {
        AssertSanity(TNullPrincipalInfo);
        return (*(constptr_NullPrincipalInfo()));
    }
    void
    get(NullPrincipalInfo* aOutValue) const;
    operator NullPrincipalInfo&()
    {
        return get_NullPrincipalInfo();
    }
    operator const NullPrincipalInfo&() const
    {
        return get_NullPrincipalInfo();
    }

    ExpandedPrincipalInfo&
    get_ExpandedPrincipalInfo()
    {
        AssertSanity(TExpandedPrincipalInfo);
        return (*(ptr_ExpandedPrincipalInfo()));
    }
    const ExpandedPrincipalInfo&
    get_ExpandedPrincipalInfo() const
    {
        AssertSanity(TExpandedPrincipalInfo);
        return (*(constptr_ExpandedPrincipalInfo()));
    }
    void
    get(ExpandedPrincipalInfo* aOutValue) const;
    operator ExpandedPrincipalInfo&()
    {
        return get_ExpandedPrincipalInfo();
    }
    operator const ExpandedPrincipalInfo&() const
    {
        return get_ExpandedPrincipalInfo();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::ipc::PrincipalInfo>
{
    typedef mozilla::ipc::PrincipalInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ExpandedPrincipalInfo|
//
namespace mozilla {
namespace ipc {
class ExpandedPrincipalInfo final
{
private:
    typedef mozilla::OriginAttributes OriginAttributes;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;

public:
    MOZ_IMPLICIT ExpandedPrincipalInfo() :
        attrs_(),
        whitelist_()
    {
    }

    MOZ_IMPLICIT ExpandedPrincipalInfo(
            const OriginAttributes& _attrs,
            const nsTArray<PrincipalInfo>& _whitelist) :
        attrs_(_attrs),
        whitelist_(_whitelist)
    {
    }

    bool
    operator==(const ExpandedPrincipalInfo& _o) const;

    bool
    operator!=(const ExpandedPrincipalInfo& _o) const;

    OriginAttributes&
    attrs()
    {
        return attrs_;
    }
    const OriginAttributes&
    attrs() const
    {
        return attrs_;
    }

    nsTArray<PrincipalInfo>&
    whitelist()
    {
        return whitelist_;
    }
    const nsTArray<PrincipalInfo>&
    whitelist() const
    {
        return whitelist_;
    }

private:
    OriginAttributes attrs_;
    nsTArray<PrincipalInfo> whitelist_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::ipc::ExpandedPrincipalInfo>
{
    typedef mozilla::ipc::ExpandedPrincipalInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalPrincipalInfo|
//
namespace mozilla {
namespace ipc {
class OptionalPrincipalInfo final
{
public:
    enum Type {
        T__None,
        Tvoid_t = 1,
        TPrincipalInfo,
        T__Last = TPrincipalInfo
    };

private:
    typedef mozilla::void_t void_t;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef void_t void_t__tdef;
    typedef PrincipalInfo PrincipalInfo__tdef;

    union Value {
        mozilla::AlignedStorage2<void_t> Vvoid_t;
        mozilla::AlignedStorage2<PrincipalInfo> VPrincipalInfo;
    };

    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }
    PrincipalInfo*
    ptr_PrincipalInfo()
    {
        return ((mValue).VPrincipalInfo).addr();
    }
    const PrincipalInfo*
    constptr_PrincipalInfo() const
    {
        return ((mValue).VPrincipalInfo).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalPrincipalInfo() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalPrincipalInfo(const void_t& aOther);

    MOZ_IMPLICIT OptionalPrincipalInfo(void_t&& aOther);

    MOZ_IMPLICIT OptionalPrincipalInfo(const PrincipalInfo& aOther);

    MOZ_IMPLICIT OptionalPrincipalInfo(PrincipalInfo&& aOther);

    MOZ_IMPLICIT OptionalPrincipalInfo(const OptionalPrincipalInfo& aOther);

    MOZ_IMPLICIT OptionalPrincipalInfo(OptionalPrincipalInfo&& aOther);

    ~OptionalPrincipalInfo();

    Type
    type() const
    {
        return mType;
    }

    OptionalPrincipalInfo&
    operator=(const void_t& aRhs);

    OptionalPrincipalInfo&
    operator=(void_t&& aRhs);

    OptionalPrincipalInfo&
    operator=(const PrincipalInfo& aRhs);

    OptionalPrincipalInfo&
    operator=(PrincipalInfo&& aRhs);

    OptionalPrincipalInfo&
    operator=(const OptionalPrincipalInfo& aRhs);

    OptionalPrincipalInfo&
    operator=(OptionalPrincipalInfo&& aRhs);

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const PrincipalInfo& aRhs) const;

    bool
    operator==(const OptionalPrincipalInfo& aRhs) const;

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

    PrincipalInfo&
    get_PrincipalInfo()
    {
        AssertSanity(TPrincipalInfo);
        return (*(ptr_PrincipalInfo()));
    }
    const PrincipalInfo&
    get_PrincipalInfo() const
    {
        AssertSanity(TPrincipalInfo);
        return (*(constptr_PrincipalInfo()));
    }
    void
    get(PrincipalInfo* aOutValue) const;
    operator PrincipalInfo&()
    {
        return get_PrincipalInfo();
    }
    operator const PrincipalInfo&() const
    {
        return get_PrincipalInfo();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::ipc::OptionalPrincipalInfo>
{
    typedef mozilla::ipc::OptionalPrincipalInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef PBackgroundSharedTypes_h
