//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PAPZCTreeManagerChild_h
#define PAPZCTreeManagerChild_h

#include "mozilla/layers/PAPZCTreeManager.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "FrameMetrics.h"
#include "InputData.h"
#include "Units.h"
#include "ipc/nsGUIEventIPC.h"
#include "mozilla/EventForwards.h"
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/layers/AsyncDragMetrics.h"
#include "mozilla/layers/GeckoContentController.h"
#include "mozilla/layers/LayersMessageUtils.h"
#include "mozilla/layers/LayersTypes.h"

namespace mozilla {
namespace layers {
class PCompositorBridgeChild;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PCompositorBridgeParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositorBridgeChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
struct ScrollableLayerGuid;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class KeyboardMap;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {


class PAPZCTreeManagerChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::layers::PCompositorBridgeChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::layers::AsyncDragMetrics AsyncDragMetrics;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::layers::KeyboardMap KeyboardMap;
    typedef mozilla::LayoutDevicePoint LayoutDevicePoint;
    typedef mozilla::layers::MaybeZoomConstraints MaybeZoomConstraints;
    typedef mozilla::Modifiers Modifiers;
    typedef mozilla::PinchGestureInput::PinchGestureType PinchGestureType;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::layers::ScrollableLayerGuid ScrollableLayerGuid;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::layers::GeckoContentController::TapType TapType;
    typedef mozilla::layers::TouchBehaviorFlags TouchBehaviorFlags;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::layers::FrameMetrics::ViewID ViewID;
    typedef mozilla::layers::PCompositorBridgeChild PCompositorBridgeChild;
    typedef mozilla::layers::PCompositorBridgeParent PCompositorBridgeParent;

    typedef PAPZCTreeManager::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvHandleTap(
            const TapType& aType,
            const LayoutDevicePoint& point,
            const Modifiers& aModifiers,
            const ScrollableLayerGuid& aGuid,
            const uint64_t& aInputBlockId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyPinchGesture(
            const PinchGestureType& aType,
            const ScrollableLayerGuid& aGuid,
            const LayoutDeviceCoord& aSpanChange,
            const Modifiers& aModifiers) = 0;
    virtual mozilla::ipc::IPCResult
    RecvCancelAutoscroll(const ViewID& aScrollId) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PAPZCTreeManagerChild();

    virtual ~PAPZCTreeManagerChild();

    PCompositorBridgeChild*
    Manager() const;

    bool
    SendZoomToRect(
            const ScrollableLayerGuid& aGuid,
            const CSSRect& aRect,
            const uint32_t& Flags);

    bool
    SendContentReceivedInputBlock(
            const uint64_t& aInputBlockId,
            const bool& PreventDefault);

    bool
    SendSetTargetAPZC(
            const uint64_t& aInputBlockId,
            const nsTArray<ScrollableLayerGuid>& Targets);

    bool
    SendUpdateZoomConstraints(
            const ScrollableLayerGuid& aGuid,
            const MaybeZoomConstraints& aConstraints);

    bool
    SendSetKeyboardMap(const KeyboardMap& aKeyboardMap);

    bool
    SendSetDPI(const float& aDpiValue);

    bool
    SendSetAllowedTouchBehavior(
            const uint64_t& aInputBlockId,
            const nsTArray<TouchBehaviorFlags>& aValues);

    bool
    SendStartScrollbarDrag(
            const ScrollableLayerGuid& aGuid,
            const AsyncDragMetrics& aDragMetrics);

    bool
    SendStartAutoscroll(
            const ScrollableLayerGuid& aGuid,
            const ScreenPoint& aAnchorLocation);

    bool
    SendStopAutoscroll(const ScrollableLayerGuid& aGuid);

    bool
    SendSetLongTapEnabled(const bool& aTapGestureEnabled);

    static bool
    Send__delete__(PAPZCTreeManagerChild* actor);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::layers::PAPZCTreeManagerChild*>
{
    typedef mozilla::layers::PAPZCTreeManagerChild* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace layers {
class APZCTreeManagerChild :
    public PAPZCTreeManagerChild
{
    mozilla::ipc::IPCResult
    RecvHandleTap(
            const TapType& aType,
            const LayoutDevicePoint& point,
            const Modifiers& aModifiers,
            const ScrollableLayerGuid& aGuid,
            const uint64_t& aInputBlockId) override;

    mozilla::ipc::IPCResult
    RecvNotifyPinchGesture(
            const PinchGestureType& aType,
            const ScrollableLayerGuid& aGuid,
            const LayoutDeviceCoord& aSpanChange,
            const Modifiers& aModifiers) override;

    mozilla::ipc::IPCResult
    RecvCancelAutoscroll(const ViewID& aScrollId) override;

    MOZ_IMPLICIT APZCTreeManagerChild();
    virtual ~APZCTreeManagerChild();
};
} // namespace layers
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace layers {
mozilla::ipc::IPCResult
APZCTreeManagerChild::RecvHandleTap(
        const TapType& aType,
        const LayoutDevicePoint& point,
        const Modifiers& aModifiers,
        const ScrollableLayerGuid& aGuid,
        const uint64_t& aInputBlockId)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerChild::RecvNotifyPinchGesture(
        const PinchGestureType& aType,
        const ScrollableLayerGuid& aGuid,
        const LayoutDeviceCoord& aSpanChange,
        const Modifiers& aModifiers)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerChild::RecvCancelAutoscroll(const ViewID& aScrollId)
{
}

MOZ_IMPLICIT APZCTreeManagerChild::APZCTreeManagerChild()
{
    MOZ_COUNT_CTOR(APZCTreeManagerChild);
}

MOZ_IMPLICIT APZCTreeManagerChild::~APZCTreeManagerChild()
{
    MOZ_COUNT_DTOR(APZCTreeManagerChild);
}

} // namespace layers
} // namespace mozilla
#endif // if 0

#endif // ifndef PAPZCTreeManagerChild_h
