//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PAPZChild_h
#define PAPZChild_h

#include "mozilla/layers/PAPZ.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "FrameMetrics.h"
#include "Units.h"
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/dom/ipc/IdType.h"
#include "mozilla/layers/AsyncDragMetrics.h"
#include "mozilla/layers/GeckoContentController.h"
#include "mozilla/layers/LayersMessageUtils.h"

namespace mozilla {
namespace layers {
class PCompositorBridgeChild;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PCompositorBridgeParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositorBridgeChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
struct FrameMetrics;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
struct ScrollableLayerGuid;
} // namespace layers
} // namespace mozilla

class nsRegion;

namespace mozilla {
namespace layers {


class PAPZChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::layers::PCompositorBridgeChild;
protected:
    typedef mozilla::layers::GeckoContentController::APZStateChange APZStateChange;
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::layers::AsyncDragMetrics AsyncDragMetrics;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef mozilla::dom::ContentParentId ContentParentId;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::layers::FrameMetrics FrameMetrics;
    typedef mozilla::layers::MaybeZoomConstraints MaybeZoomConstraints;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::layers::ScrollableLayerGuid ScrollableLayerGuid;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::dom::TabId TabId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::layers::FrameMetrics::ViewID ViewID;
    typedef mozilla::layers::PCompositorBridgeChild PCompositorBridgeChild;
    typedef mozilla::layers::PCompositorBridgeParent PCompositorBridgeParent;

    typedef PAPZ::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvRequestContentRepaint(const FrameMetrics& frame) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUpdateOverscrollVelocity(
            const float& aX,
            const float& aY,
            const bool& aIsRootContent) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUpdateOverscrollOffset(
            const float& aX,
            const float& aY,
            const bool& aIsRootContent) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyMozMouseScrollEvent(
            const ViewID& aScrollId,
            const nsString& aEvent) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyAPZStateChange(
            const ScrollableLayerGuid& aGuid,
            const APZStateChange& aChange,
            const int& aArg) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyFlushComplete() = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyAsyncScrollbarDragRejected(const ViewID& aScrollId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyAsyncAutoscrollRejected(const ViewID& aScrollId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDestroy() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PAPZChild();

    virtual ~PAPZChild();

    PCompositorBridgeChild*
    Manager() const;

    static bool
    Send__delete__(PAPZChild* actor);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::layers::PAPZChild*>
{
    typedef mozilla::layers::PAPZChild* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace layers {
class APZChild :
    public PAPZChild
{
    mozilla::ipc::IPCResult
    RecvRequestContentRepaint(const FrameMetrics& frame) override;

    mozilla::ipc::IPCResult
    RecvUpdateOverscrollVelocity(
            const float& aX,
            const float& aY,
            const bool& aIsRootContent) override;

    mozilla::ipc::IPCResult
    RecvUpdateOverscrollOffset(
            const float& aX,
            const float& aY,
            const bool& aIsRootContent) override;

    mozilla::ipc::IPCResult
    RecvNotifyMozMouseScrollEvent(
            const ViewID& aScrollId,
            const nsString& aEvent) override;

    mozilla::ipc::IPCResult
    RecvNotifyAPZStateChange(
            const ScrollableLayerGuid& aGuid,
            const APZStateChange& aChange,
            const int& aArg) override;

    mozilla::ipc::IPCResult
    RecvNotifyFlushComplete() override;

    mozilla::ipc::IPCResult
    RecvNotifyAsyncScrollbarDragRejected(const ViewID& aScrollId) override;

    mozilla::ipc::IPCResult
    RecvNotifyAsyncAutoscrollRejected(const ViewID& aScrollId) override;

    mozilla::ipc::IPCResult
    RecvDestroy() override;

    MOZ_IMPLICIT APZChild();
    virtual ~APZChild();
};
} // namespace layers
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace layers {
mozilla::ipc::IPCResult
APZChild::RecvRequestContentRepaint(const FrameMetrics& frame)
{
}

mozilla::ipc::IPCResult
APZChild::RecvUpdateOverscrollVelocity(
        const float& aX,
        const float& aY,
        const bool& aIsRootContent)
{
}

mozilla::ipc::IPCResult
APZChild::RecvUpdateOverscrollOffset(
        const float& aX,
        const float& aY,
        const bool& aIsRootContent)
{
}

mozilla::ipc::IPCResult
APZChild::RecvNotifyMozMouseScrollEvent(
        const ViewID& aScrollId,
        const nsString& aEvent)
{
}

mozilla::ipc::IPCResult
APZChild::RecvNotifyAPZStateChange(
        const ScrollableLayerGuid& aGuid,
        const APZStateChange& aChange,
        const int& aArg)
{
}

mozilla::ipc::IPCResult
APZChild::RecvNotifyFlushComplete()
{
}

mozilla::ipc::IPCResult
APZChild::RecvNotifyAsyncScrollbarDragRejected(const ViewID& aScrollId)
{
}

mozilla::ipc::IPCResult
APZChild::RecvNotifyAsyncAutoscrollRejected(const ViewID& aScrollId)
{
}

mozilla::ipc::IPCResult
APZChild::RecvDestroy()
{
}

MOZ_IMPLICIT APZChild::APZChild()
{
    MOZ_COUNT_CTOR(APZChild);
}

MOZ_IMPLICIT APZChild::~APZChild()
{
    MOZ_COUNT_DTOR(APZChild);
}

} // namespace layers
} // namespace mozilla
#endif // if 0

#endif // ifndef PAPZChild_h
