//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PAPZParent_h
#define PAPZParent_h

#include "mozilla/layers/PAPZ.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "FrameMetrics.h"
#include "Units.h"
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/dom/ipc/IdType.h"
#include "mozilla/layers/AsyncDragMetrics.h"
#include "mozilla/layers/GeckoContentController.h"
#include "mozilla/layers/LayersMessageUtils.h"

namespace mozilla {
namespace layers {
class PCompositorBridgeParent;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PCompositorBridgeChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositorBridgeParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
struct FrameMetrics;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
struct ScrollableLayerGuid;
} // namespace layers
} // namespace mozilla

class nsRegion;

namespace mozilla {
namespace layers {


class PAPZParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::layers::PCompositorBridgeParent;
protected:
    typedef mozilla::layers::GeckoContentController::APZStateChange APZStateChange;
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::layers::AsyncDragMetrics AsyncDragMetrics;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef mozilla::dom::ContentParentId ContentParentId;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::layers::FrameMetrics FrameMetrics;
    typedef mozilla::layers::MaybeZoomConstraints MaybeZoomConstraints;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::layers::ScrollableLayerGuid ScrollableLayerGuid;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::dom::TabId TabId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::layers::FrameMetrics::ViewID ViewID;
    typedef mozilla::layers::PCompositorBridgeParent PCompositorBridgeParent;
    typedef mozilla::layers::PCompositorBridgeChild PCompositorBridgeChild;

    typedef PAPZ::State State;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PAPZParent();

    virtual ~PAPZParent();

    PCompositorBridgeParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendRequestContentRepaint(const FrameMetrics& frame);

    MOZ_MUST_USE bool
    SendUpdateOverscrollVelocity(
            const float& aX,
            const float& aY,
            const bool& aIsRootContent);

    MOZ_MUST_USE bool
    SendUpdateOverscrollOffset(
            const float& aX,
            const float& aY,
            const bool& aIsRootContent);

    MOZ_MUST_USE bool
    SendNotifyMozMouseScrollEvent(
            const ViewID& aScrollId,
            const nsString& aEvent);

    MOZ_MUST_USE bool
    SendNotifyAPZStateChange(
            const ScrollableLayerGuid& aGuid,
            const APZStateChange& aChange,
            const int& aArg);

    MOZ_MUST_USE bool
    SendNotifyFlushComplete();

    MOZ_MUST_USE bool
    SendNotifyAsyncScrollbarDragRejected(const ViewID& aScrollId);

    MOZ_MUST_USE bool
    SendNotifyAsyncAutoscrollRejected(const ViewID& aScrollId);

    MOZ_MUST_USE bool
    SendDestroy();

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::layers::PAPZParent*>
{
    typedef mozilla::layers::PAPZParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace layers {
class APZParent :
    public PAPZParent
{
    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT APZParent();
    virtual ~APZParent();
};
} // namespace layers
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace layers {
void
APZParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT APZParent::APZParent()
{
    MOZ_COUNT_CTOR(APZParent);
}

MOZ_IMPLICIT APZParent::~APZParent()
{
    MOZ_COUNT_DTOR(APZParent);
}

} // namespace layers
} // namespace mozilla
#endif // if 0

#endif // ifndef PAPZParent_h
