//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PMediaParent_h
#define PMediaParent_h

#include "mozilla/media/PMedia.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace media {


class PMediaParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::dom::PContentParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef mozilla::ipc::ContentPrincipalInfo ContentPrincipalInfo;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::ExpandedPrincipalInfo ExpandedPrincipalInfo;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::NullPrincipalInfo NullPrincipalInfo;
    typedef mozilla::ipc::OptionalPrincipalInfo OptionalPrincipalInfo;
    typedef mozilla::OriginAttributes OriginAttributes;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::SystemPrincipalInfo SystemPrincipalInfo;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::void_t void_t;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;

    typedef PMedia::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvGetPrincipalKey(
            const uint32_t& aRequestId,
            const PrincipalInfo& aPrincipal,
            const bool& aPersist) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSanitizeOriginKeys(
            const uint64_t& aSinceWhen,
            const bool& aOnlyPrivateBrowsing) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PMediaParent();

    virtual ~PMediaParent();

    PContentParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendGetPrincipalKeyResponse(
            const uint32_t& aRequestId,
            const nsCString& key);

    MOZ_MUST_USE static bool
    Send__delete__(PMediaParent* actor);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace media
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::media::PMediaParent*>
{
    typedef mozilla::media::PMediaParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace media {
class MediaParent :
    public PMediaParent
{
    mozilla::ipc::IPCResult
    RecvGetPrincipalKey(
            const uint32_t& aRequestId,
            const PrincipalInfo& aPrincipal,
            const bool& aPersist) override;

    mozilla::ipc::IPCResult
    RecvSanitizeOriginKeys(
            const uint64_t& aSinceWhen,
            const bool& aOnlyPrivateBrowsing) override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT MediaParent();
    virtual ~MediaParent();
};
} // namespace media
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace media {
mozilla::ipc::IPCResult
MediaParent::RecvGetPrincipalKey(
        const uint32_t& aRequestId,
        const PrincipalInfo& aPrincipal,
        const bool& aPersist)
{
}

mozilla::ipc::IPCResult
MediaParent::RecvSanitizeOriginKeys(
        const uint64_t& aSinceWhen,
        const bool& aOnlyPrivateBrowsing)
{
}

void
MediaParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT MediaParent::MediaParent()
{
    MOZ_COUNT_CTOR(MediaParent);
}

MOZ_IMPLICIT MediaParent::~MediaParent()
{
    MOZ_COUNT_DTOR(MediaParent);
}

} // namespace media
} // namespace mozilla
#endif // if 0

#endif // ifndef PMediaParent_h
