//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PMediaSystemResourceManagerParent_h
#define PMediaSystemResourceManagerParent_h

#include "mozilla/media/PMediaSystemResourceManager.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/media/MediaSystemResourceMessageUtils.h"
#include "mozilla/media/MediaSystemResourceTypes.h"

namespace mozilla {
namespace layers {
class PImageBridgeParent;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PImageBridgeChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PImageBridgeParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace media {


class PMediaSystemResourceManagerParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::layers::PImageBridgeParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::MediaSystemResourceType MediaSystemResourceType;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::layers::PImageBridgeParent PImageBridgeParent;
    typedef mozilla::layers::PImageBridgeChild PImageBridgeChild;

    typedef PMediaSystemResourceManager::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvAcquire(
            const uint32_t& aId,
            const MediaSystemResourceType& aResourceType,
            const bool& aWillWait) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRelease(const uint32_t& aId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRemoveResourceManager() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PMediaSystemResourceManagerParent();

    virtual ~PMediaSystemResourceManagerParent();

    PImageBridgeParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendResponse(
            const uint32_t& aId,
            const bool& aSuccess);

    MOZ_MUST_USE static bool
    Send__delete__(PMediaSystemResourceManagerParent* actor);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace media
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::media::PMediaSystemResourceManagerParent*>
{
    typedef mozilla::media::PMediaSystemResourceManagerParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace media {
class MediaSystemResourceManagerParent :
    public PMediaSystemResourceManagerParent
{
    mozilla::ipc::IPCResult
    RecvAcquire(
            const uint32_t& aId,
            const MediaSystemResourceType& aResourceType,
            const bool& aWillWait) override;

    mozilla::ipc::IPCResult
    RecvRelease(const uint32_t& aId) override;

    mozilla::ipc::IPCResult
    RecvRemoveResourceManager() override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT MediaSystemResourceManagerParent();
    virtual ~MediaSystemResourceManagerParent();
};
} // namespace media
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace media {
mozilla::ipc::IPCResult
MediaSystemResourceManagerParent::RecvAcquire(
        const uint32_t& aId,
        const MediaSystemResourceType& aResourceType,
        const bool& aWillWait)
{
}

mozilla::ipc::IPCResult
MediaSystemResourceManagerParent::RecvRelease(const uint32_t& aId)
{
}

mozilla::ipc::IPCResult
MediaSystemResourceManagerParent::RecvRemoveResourceManager()
{
}

void
MediaSystemResourceManagerParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT MediaSystemResourceManagerParent::MediaSystemResourceManagerParent()
{
    MOZ_COUNT_CTOR(MediaSystemResourceManagerParent);
}

MOZ_IMPLICIT MediaSystemResourceManagerParent::~MediaSystemResourceManagerParent()
{
    MOZ_COUNT_DTOR(MediaSystemResourceManagerParent);
}

} // namespace media
} // namespace mozilla
#endif // if 0

#endif // ifndef PMediaSystemResourceManagerParent_h
