//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef NeckoChannelParams_h
#define NeckoChannelParams_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/TimeStamp.h"
#include "mozilla/ipc/BackgroundUtils.h"
#include "mozilla/net/PHttpChannelParams.h"
#include "nsHttpResponseHead.h"
#include "mozilla/dom/BlobTypes.h"
#include "mozilla/dom/ClientIPCTypes.h"
#include "mozilla/ipc/URIParams.h"
#include "mozilla/dom/IPCServiceWorkerDescriptor.h"
#include "mozilla/ipc/IPCStream.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RedirectHistoryEntryInfo|
//
namespace mozilla {
namespace net {
class RedirectHistoryEntryInfo final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;

public:
    MOZ_IMPLICIT RedirectHistoryEntryInfo() :
        principalInfo_(),
        referrerUri_(),
        remoteAddress_()
    {
    }

    MOZ_IMPLICIT RedirectHistoryEntryInfo(
            const PrincipalInfo& _principalInfo,
            const OptionalURIParams& _referrerUri,
            const nsCString& _remoteAddress) :
        principalInfo_(_principalInfo),
        referrerUri_(_referrerUri),
        remoteAddress_(_remoteAddress)
    {
    }

    bool
    operator==(const RedirectHistoryEntryInfo& _o) const;

    bool
    operator!=(const RedirectHistoryEntryInfo& _o) const;

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    OptionalURIParams&
    referrerUri()
    {
        return referrerUri_;
    }
    const OptionalURIParams&
    referrerUri() const
    {
        return referrerUri_;
    }

    nsCString&
    remoteAddress()
    {
        return remoteAddress_;
    }
    const nsCString&
    remoteAddress() const
    {
        return remoteAddress_;
    }

private:
    PrincipalInfo principalInfo_;
    OptionalURIParams referrerUri_;
    nsCString remoteAddress_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::RedirectHistoryEntryInfo>
{
    typedef mozilla::net::RedirectHistoryEntryInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LoadInfoArgs|
//
namespace mozilla {
namespace net {
class LoadInfoArgs final
{
private:
    typedef mozilla::ipc::OptionalPrincipalInfo OptionalPrincipalInfo;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;
    typedef mozilla::OriginAttributes OriginAttributes;
    typedef mozilla::net::RedirectHistoryEntryInfo RedirectHistoryEntryInfo;
    typedef mozilla::dom::OptionalIPCClientInfo OptionalIPCClientInfo;
    typedef mozilla::dom::OptionalIPCServiceWorkerDescriptor OptionalIPCServiceWorkerDescriptor;

public:
    MOZ_IMPLICIT LoadInfoArgs() :
        requestingPrincipalInfo_(),
        triggeringPrincipalInfo_(),
        principalToInheritInfo_(),
        sandboxedLoadingPrincipalInfo_(),
        resultPrincipalURI_(),
        securityFlags_(),
        contentPolicyType_(),
        tainting_(),
        upgradeInsecureRequests_(),
        verifySignedContent_(),
        enforceSRI_(),
        forceAllowDataURI_(),
        forceInheritPrincipalDropped_(),
        innerWindowID_(),
        outerWindowID_(),
        parentOuterWindowID_(),
        topOuterWindowID_(),
        frameOuterWindowID_(),
        enforceSecurity_(),
        initialSecurityCheckDone_(),
        isInThirdPartyContext_(),
        isDocshellReload_(),
        originAttributes_(),
        redirectChainIncludingInternalRedirects_(),
        redirectChain_(),
        ancestorPrincipals_(),
        ancestorOuterWindowIDs_(),
        clientInfo_(),
        reservedClientInfo_(),
        initialClientInfo_(),
        controller_(),
        corsUnsafeHeaders_(),
        forcePreflight_(),
        isPreflight_(),
        loadTriggeredFromExternal_(),
        serviceWorkerTaintingSynthesized_()
    {
    }

    MOZ_IMPLICIT LoadInfoArgs(
            const OptionalPrincipalInfo& _requestingPrincipalInfo,
            const PrincipalInfo& _triggeringPrincipalInfo,
            const OptionalPrincipalInfo& _principalToInheritInfo,
            const OptionalPrincipalInfo& _sandboxedLoadingPrincipalInfo,
            const OptionalURIParams& _resultPrincipalURI,
            const uint32_t& _securityFlags,
            const uint32_t& _contentPolicyType,
            const uint32_t& _tainting,
            const bool& _upgradeInsecureRequests,
            const bool& _verifySignedContent,
            const bool& _enforceSRI,
            const bool& _forceAllowDataURI,
            const bool& _forceInheritPrincipalDropped,
            const uint64_t& _innerWindowID,
            const uint64_t& _outerWindowID,
            const uint64_t& _parentOuterWindowID,
            const uint64_t& _topOuterWindowID,
            const uint64_t& _frameOuterWindowID,
            const bool& _enforceSecurity,
            const bool& _initialSecurityCheckDone,
            const bool& _isInThirdPartyContext,
            const bool& _isDocshellReload,
            const OriginAttributes& _originAttributes,
            const nsTArray<RedirectHistoryEntryInfo>& _redirectChainIncludingInternalRedirects,
            const nsTArray<RedirectHistoryEntryInfo>& _redirectChain,
            const nsTArray<PrincipalInfo>& _ancestorPrincipals,
            const nsTArray<uint64_t>& _ancestorOuterWindowIDs,
            const OptionalIPCClientInfo& _clientInfo,
            const OptionalIPCClientInfo& _reservedClientInfo,
            const OptionalIPCClientInfo& _initialClientInfo,
            const OptionalIPCServiceWorkerDescriptor& _controller,
            const nsTArray<nsCString>& _corsUnsafeHeaders,
            const bool& _forcePreflight,
            const bool& _isPreflight,
            const bool& _loadTriggeredFromExternal,
            const bool& _serviceWorkerTaintingSynthesized) :
        requestingPrincipalInfo_(_requestingPrincipalInfo),
        triggeringPrincipalInfo_(_triggeringPrincipalInfo),
        principalToInheritInfo_(_principalToInheritInfo),
        sandboxedLoadingPrincipalInfo_(_sandboxedLoadingPrincipalInfo),
        resultPrincipalURI_(_resultPrincipalURI),
        securityFlags_(_securityFlags),
        contentPolicyType_(_contentPolicyType),
        tainting_(_tainting),
        upgradeInsecureRequests_(_upgradeInsecureRequests),
        verifySignedContent_(_verifySignedContent),
        enforceSRI_(_enforceSRI),
        forceAllowDataURI_(_forceAllowDataURI),
        forceInheritPrincipalDropped_(_forceInheritPrincipalDropped),
        innerWindowID_(_innerWindowID),
        outerWindowID_(_outerWindowID),
        parentOuterWindowID_(_parentOuterWindowID),
        topOuterWindowID_(_topOuterWindowID),
        frameOuterWindowID_(_frameOuterWindowID),
        enforceSecurity_(_enforceSecurity),
        initialSecurityCheckDone_(_initialSecurityCheckDone),
        isInThirdPartyContext_(_isInThirdPartyContext),
        isDocshellReload_(_isDocshellReload),
        originAttributes_(_originAttributes),
        redirectChainIncludingInternalRedirects_(_redirectChainIncludingInternalRedirects),
        redirectChain_(_redirectChain),
        ancestorPrincipals_(_ancestorPrincipals),
        ancestorOuterWindowIDs_(_ancestorOuterWindowIDs),
        clientInfo_(_clientInfo),
        reservedClientInfo_(_reservedClientInfo),
        initialClientInfo_(_initialClientInfo),
        controller_(_controller),
        corsUnsafeHeaders_(_corsUnsafeHeaders),
        forcePreflight_(_forcePreflight),
        isPreflight_(_isPreflight),
        loadTriggeredFromExternal_(_loadTriggeredFromExternal),
        serviceWorkerTaintingSynthesized_(_serviceWorkerTaintingSynthesized)
    {
    }

    bool
    operator==(const LoadInfoArgs& _o) const;

    bool
    operator!=(const LoadInfoArgs& _o) const;

    OptionalPrincipalInfo&
    requestingPrincipalInfo()
    {
        return requestingPrincipalInfo_;
    }
    const OptionalPrincipalInfo&
    requestingPrincipalInfo() const
    {
        return requestingPrincipalInfo_;
    }

    PrincipalInfo&
    triggeringPrincipalInfo()
    {
        return triggeringPrincipalInfo_;
    }
    const PrincipalInfo&
    triggeringPrincipalInfo() const
    {
        return triggeringPrincipalInfo_;
    }

    OptionalPrincipalInfo&
    principalToInheritInfo()
    {
        return principalToInheritInfo_;
    }
    const OptionalPrincipalInfo&
    principalToInheritInfo() const
    {
        return principalToInheritInfo_;
    }

    OptionalPrincipalInfo&
    sandboxedLoadingPrincipalInfo()
    {
        return sandboxedLoadingPrincipalInfo_;
    }
    const OptionalPrincipalInfo&
    sandboxedLoadingPrincipalInfo() const
    {
        return sandboxedLoadingPrincipalInfo_;
    }

    OptionalURIParams&
    resultPrincipalURI()
    {
        return resultPrincipalURI_;
    }
    const OptionalURIParams&
    resultPrincipalURI() const
    {
        return resultPrincipalURI_;
    }

    uint32_t&
    securityFlags()
    {
        return securityFlags_;
    }
    const uint32_t&
    securityFlags() const
    {
        return securityFlags_;
    }

    uint32_t&
    contentPolicyType()
    {
        return contentPolicyType_;
    }
    const uint32_t&
    contentPolicyType() const
    {
        return contentPolicyType_;
    }

    uint32_t&
    tainting()
    {
        return tainting_;
    }
    const uint32_t&
    tainting() const
    {
        return tainting_;
    }

    bool&
    upgradeInsecureRequests()
    {
        return upgradeInsecureRequests_;
    }
    const bool&
    upgradeInsecureRequests() const
    {
        return upgradeInsecureRequests_;
    }

    bool&
    verifySignedContent()
    {
        return verifySignedContent_;
    }
    const bool&
    verifySignedContent() const
    {
        return verifySignedContent_;
    }

    bool&
    enforceSRI()
    {
        return enforceSRI_;
    }
    const bool&
    enforceSRI() const
    {
        return enforceSRI_;
    }

    bool&
    forceAllowDataURI()
    {
        return forceAllowDataURI_;
    }
    const bool&
    forceAllowDataURI() const
    {
        return forceAllowDataURI_;
    }

    bool&
    forceInheritPrincipalDropped()
    {
        return forceInheritPrincipalDropped_;
    }
    const bool&
    forceInheritPrincipalDropped() const
    {
        return forceInheritPrincipalDropped_;
    }

    uint64_t&
    innerWindowID()
    {
        return innerWindowID_;
    }
    const uint64_t&
    innerWindowID() const
    {
        return innerWindowID_;
    }

    uint64_t&
    outerWindowID()
    {
        return outerWindowID_;
    }
    const uint64_t&
    outerWindowID() const
    {
        return outerWindowID_;
    }

    uint64_t&
    parentOuterWindowID()
    {
        return parentOuterWindowID_;
    }
    const uint64_t&
    parentOuterWindowID() const
    {
        return parentOuterWindowID_;
    }

    uint64_t&
    topOuterWindowID()
    {
        return topOuterWindowID_;
    }
    const uint64_t&
    topOuterWindowID() const
    {
        return topOuterWindowID_;
    }

    uint64_t&
    frameOuterWindowID()
    {
        return frameOuterWindowID_;
    }
    const uint64_t&
    frameOuterWindowID() const
    {
        return frameOuterWindowID_;
    }

    bool&
    enforceSecurity()
    {
        return enforceSecurity_;
    }
    const bool&
    enforceSecurity() const
    {
        return enforceSecurity_;
    }

    bool&
    initialSecurityCheckDone()
    {
        return initialSecurityCheckDone_;
    }
    const bool&
    initialSecurityCheckDone() const
    {
        return initialSecurityCheckDone_;
    }

    bool&
    isInThirdPartyContext()
    {
        return isInThirdPartyContext_;
    }
    const bool&
    isInThirdPartyContext() const
    {
        return isInThirdPartyContext_;
    }

    bool&
    isDocshellReload()
    {
        return isDocshellReload_;
    }
    const bool&
    isDocshellReload() const
    {
        return isDocshellReload_;
    }

    OriginAttributes&
    originAttributes()
    {
        return originAttributes_;
    }
    const OriginAttributes&
    originAttributes() const
    {
        return originAttributes_;
    }

    nsTArray<RedirectHistoryEntryInfo>&
    redirectChainIncludingInternalRedirects()
    {
        return redirectChainIncludingInternalRedirects_;
    }
    const nsTArray<RedirectHistoryEntryInfo>&
    redirectChainIncludingInternalRedirects() const
    {
        return redirectChainIncludingInternalRedirects_;
    }

    nsTArray<RedirectHistoryEntryInfo>&
    redirectChain()
    {
        return redirectChain_;
    }
    const nsTArray<RedirectHistoryEntryInfo>&
    redirectChain() const
    {
        return redirectChain_;
    }

    nsTArray<PrincipalInfo>&
    ancestorPrincipals()
    {
        return ancestorPrincipals_;
    }
    const nsTArray<PrincipalInfo>&
    ancestorPrincipals() const
    {
        return ancestorPrincipals_;
    }

    nsTArray<uint64_t>&
    ancestorOuterWindowIDs()
    {
        return ancestorOuterWindowIDs_;
    }
    const nsTArray<uint64_t>&
    ancestorOuterWindowIDs() const
    {
        return ancestorOuterWindowIDs_;
    }

    OptionalIPCClientInfo&
    clientInfo()
    {
        return clientInfo_;
    }
    const OptionalIPCClientInfo&
    clientInfo() const
    {
        return clientInfo_;
    }

    OptionalIPCClientInfo&
    reservedClientInfo()
    {
        return reservedClientInfo_;
    }
    const OptionalIPCClientInfo&
    reservedClientInfo() const
    {
        return reservedClientInfo_;
    }

    OptionalIPCClientInfo&
    initialClientInfo()
    {
        return initialClientInfo_;
    }
    const OptionalIPCClientInfo&
    initialClientInfo() const
    {
        return initialClientInfo_;
    }

    OptionalIPCServiceWorkerDescriptor&
    controller()
    {
        return controller_;
    }
    const OptionalIPCServiceWorkerDescriptor&
    controller() const
    {
        return controller_;
    }

    nsTArray<nsCString>&
    corsUnsafeHeaders()
    {
        return corsUnsafeHeaders_;
    }
    const nsTArray<nsCString>&
    corsUnsafeHeaders() const
    {
        return corsUnsafeHeaders_;
    }

    bool&
    forcePreflight()
    {
        return forcePreflight_;
    }
    const bool&
    forcePreflight() const
    {
        return forcePreflight_;
    }

    bool&
    isPreflight()
    {
        return isPreflight_;
    }
    const bool&
    isPreflight() const
    {
        return isPreflight_;
    }

    bool&
    loadTriggeredFromExternal()
    {
        return loadTriggeredFromExternal_;
    }
    const bool&
    loadTriggeredFromExternal() const
    {
        return loadTriggeredFromExternal_;
    }

    bool&
    serviceWorkerTaintingSynthesized()
    {
        return serviceWorkerTaintingSynthesized_;
    }
    const bool&
    serviceWorkerTaintingSynthesized() const
    {
        return serviceWorkerTaintingSynthesized_;
    }

private:
    OptionalPrincipalInfo requestingPrincipalInfo_;
    PrincipalInfo triggeringPrincipalInfo_;
    OptionalPrincipalInfo principalToInheritInfo_;
    OptionalPrincipalInfo sandboxedLoadingPrincipalInfo_;
    OptionalURIParams resultPrincipalURI_;
    uint32_t securityFlags_;
    uint32_t contentPolicyType_;
    uint32_t tainting_;
    bool upgradeInsecureRequests_;
    bool verifySignedContent_;
    bool enforceSRI_;
    bool forceAllowDataURI_;
    bool forceInheritPrincipalDropped_;
    uint64_t innerWindowID_;
    uint64_t outerWindowID_;
    uint64_t parentOuterWindowID_;
    uint64_t topOuterWindowID_;
    uint64_t frameOuterWindowID_;
    bool enforceSecurity_;
    bool initialSecurityCheckDone_;
    bool isInThirdPartyContext_;
    bool isDocshellReload_;
    OriginAttributes originAttributes_;
    nsTArray<RedirectHistoryEntryInfo> redirectChainIncludingInternalRedirects_;
    nsTArray<RedirectHistoryEntryInfo> redirectChain_;
    nsTArray<PrincipalInfo> ancestorPrincipals_;
    nsTArray<uint64_t> ancestorOuterWindowIDs_;
    OptionalIPCClientInfo clientInfo_;
    OptionalIPCClientInfo reservedClientInfo_;
    OptionalIPCClientInfo initialClientInfo_;
    OptionalIPCServiceWorkerDescriptor controller_;
    nsTArray<nsCString> corsUnsafeHeaders_;
    bool forcePreflight_;
    bool isPreflight_;
    bool loadTriggeredFromExternal_;
    bool serviceWorkerTaintingSynthesized_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::LoadInfoArgs>
{
    typedef mozilla::net::LoadInfoArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalLoadInfoArgs|
//
namespace mozilla {
namespace net {
class OptionalLoadInfoArgs final
{
public:
    enum Type {
        T__None,
        Tvoid_t = 1,
        TLoadInfoArgs,
        T__Last = TLoadInfoArgs
    };

private:
    typedef mozilla::void_t void_t;
    typedef mozilla::net::LoadInfoArgs LoadInfoArgs;
    typedef void_t void_t__tdef;
    typedef LoadInfoArgs LoadInfoArgs__tdef;

    union Value {
        mozilla::AlignedStorage2<void_t> Vvoid_t;
        mozilla::AlignedStorage2<LoadInfoArgs> VLoadInfoArgs;
    };

    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }
    LoadInfoArgs*
    ptr_LoadInfoArgs()
    {
        return ((mValue).VLoadInfoArgs).addr();
    }
    const LoadInfoArgs*
    constptr_LoadInfoArgs() const
    {
        return ((mValue).VLoadInfoArgs).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalLoadInfoArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalLoadInfoArgs(const void_t& aOther);

    MOZ_IMPLICIT OptionalLoadInfoArgs(void_t&& aOther);

    MOZ_IMPLICIT OptionalLoadInfoArgs(const LoadInfoArgs& aOther);

    MOZ_IMPLICIT OptionalLoadInfoArgs(LoadInfoArgs&& aOther);

    MOZ_IMPLICIT OptionalLoadInfoArgs(const OptionalLoadInfoArgs& aOther);

    MOZ_IMPLICIT OptionalLoadInfoArgs(OptionalLoadInfoArgs&& aOther);

    ~OptionalLoadInfoArgs();

    Type
    type() const
    {
        return mType;
    }

    OptionalLoadInfoArgs&
    operator=(const void_t& aRhs);

    OptionalLoadInfoArgs&
    operator=(void_t&& aRhs);

    OptionalLoadInfoArgs&
    operator=(const LoadInfoArgs& aRhs);

    OptionalLoadInfoArgs&
    operator=(LoadInfoArgs&& aRhs);

    OptionalLoadInfoArgs&
    operator=(const OptionalLoadInfoArgs& aRhs);

    OptionalLoadInfoArgs&
    operator=(OptionalLoadInfoArgs&& aRhs);

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const LoadInfoArgs& aRhs) const;

    bool
    operator==(const OptionalLoadInfoArgs& aRhs) const;

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

    LoadInfoArgs&
    get_LoadInfoArgs()
    {
        AssertSanity(TLoadInfoArgs);
        return (*(ptr_LoadInfoArgs()));
    }
    const LoadInfoArgs&
    get_LoadInfoArgs() const
    {
        AssertSanity(TLoadInfoArgs);
        return (*(constptr_LoadInfoArgs()));
    }
    void
    get(LoadInfoArgs* aOutValue) const;
    operator LoadInfoArgs&()
    {
        return get_LoadInfoArgs();
    }
    operator const LoadInfoArgs&() const
    {
        return get_LoadInfoArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::OptionalLoadInfoArgs>
{
    typedef mozilla::net::OptionalLoadInfoArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalHttpResponseHead|
//
namespace mozilla {
namespace net {
class OptionalHttpResponseHead final
{
public:
    enum Type {
        T__None,
        Tvoid_t = 1,
        TnsHttpResponseHead,
        T__Last = TnsHttpResponseHead
    };

private:
    typedef mozilla::void_t void_t;
    typedef mozilla::net::nsHttpResponseHead nsHttpResponseHead;
    typedef void_t void_t__tdef;
    typedef nsHttpResponseHead nsHttpResponseHead__tdef;

    union Value {
        mozilla::AlignedStorage2<void_t> Vvoid_t;
        mozilla::AlignedStorage2<nsHttpResponseHead> VnsHttpResponseHead;
    };

    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }
    nsHttpResponseHead*
    ptr_nsHttpResponseHead()
    {
        return ((mValue).VnsHttpResponseHead).addr();
    }
    const nsHttpResponseHead*
    constptr_nsHttpResponseHead() const
    {
        return ((mValue).VnsHttpResponseHead).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalHttpResponseHead() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalHttpResponseHead(const void_t& aOther);

    MOZ_IMPLICIT OptionalHttpResponseHead(void_t&& aOther);

    MOZ_IMPLICIT OptionalHttpResponseHead(const nsHttpResponseHead& aOther);

    MOZ_IMPLICIT OptionalHttpResponseHead(nsHttpResponseHead&& aOther);

    MOZ_IMPLICIT OptionalHttpResponseHead(const OptionalHttpResponseHead& aOther);

    MOZ_IMPLICIT OptionalHttpResponseHead(OptionalHttpResponseHead&& aOther);

    ~OptionalHttpResponseHead();

    Type
    type() const
    {
        return mType;
    }

    OptionalHttpResponseHead&
    operator=(const void_t& aRhs);

    OptionalHttpResponseHead&
    operator=(void_t&& aRhs);

    OptionalHttpResponseHead&
    operator=(const nsHttpResponseHead& aRhs);

    OptionalHttpResponseHead&
    operator=(nsHttpResponseHead&& aRhs);

    OptionalHttpResponseHead&
    operator=(const OptionalHttpResponseHead& aRhs);

    OptionalHttpResponseHead&
    operator=(OptionalHttpResponseHead&& aRhs);

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const nsHttpResponseHead& aRhs) const;

    bool
    operator==(const OptionalHttpResponseHead& aRhs) const;

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

    nsHttpResponseHead&
    get_nsHttpResponseHead()
    {
        AssertSanity(TnsHttpResponseHead);
        return (*(ptr_nsHttpResponseHead()));
    }
    const nsHttpResponseHead&
    get_nsHttpResponseHead() const
    {
        AssertSanity(TnsHttpResponseHead);
        return (*(constptr_nsHttpResponseHead()));
    }
    void
    get(nsHttpResponseHead* aOutValue) const;
    operator nsHttpResponseHead&()
    {
        return get_nsHttpResponseHead();
    }
    operator const nsHttpResponseHead&() const
    {
        return get_nsHttpResponseHead();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::OptionalHttpResponseHead>
{
    typedef mozilla::net::OptionalHttpResponseHead paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CorsPreflightArgs|
//
namespace mozilla {
namespace net {
class CorsPreflightArgs final
{
private:

public:
    MOZ_IMPLICIT CorsPreflightArgs() :
        unsafeHeaders_()
    {
    }

    MOZ_IMPLICIT CorsPreflightArgs(const nsTArray<nsCString>& _unsafeHeaders) :
        unsafeHeaders_(_unsafeHeaders)
    {
    }

    bool
    operator==(const CorsPreflightArgs& _o) const;

    bool
    operator!=(const CorsPreflightArgs& _o) const;

    nsTArray<nsCString>&
    unsafeHeaders()
    {
        return unsafeHeaders_;
    }
    const nsTArray<nsCString>&
    unsafeHeaders() const
    {
        return unsafeHeaders_;
    }

private:
    nsTArray<nsCString> unsafeHeaders_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::CorsPreflightArgs>
{
    typedef mozilla::net::CorsPreflightArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalCorsPreflightArgs|
//
namespace mozilla {
namespace net {
class OptionalCorsPreflightArgs final
{
public:
    enum Type {
        T__None,
        Tvoid_t = 1,
        TCorsPreflightArgs,
        T__Last = TCorsPreflightArgs
    };

private:
    typedef mozilla::void_t void_t;
    typedef mozilla::net::CorsPreflightArgs CorsPreflightArgs;
    typedef void_t void_t__tdef;
    typedef CorsPreflightArgs CorsPreflightArgs__tdef;

    union Value {
        mozilla::AlignedStorage2<void_t> Vvoid_t;
        mozilla::AlignedStorage2<CorsPreflightArgs> VCorsPreflightArgs;
    };

    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }
    CorsPreflightArgs*
    ptr_CorsPreflightArgs()
    {
        return ((mValue).VCorsPreflightArgs).addr();
    }
    const CorsPreflightArgs*
    constptr_CorsPreflightArgs() const
    {
        return ((mValue).VCorsPreflightArgs).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalCorsPreflightArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalCorsPreflightArgs(const void_t& aOther);

    MOZ_IMPLICIT OptionalCorsPreflightArgs(void_t&& aOther);

    MOZ_IMPLICIT OptionalCorsPreflightArgs(const CorsPreflightArgs& aOther);

    MOZ_IMPLICIT OptionalCorsPreflightArgs(CorsPreflightArgs&& aOther);

    MOZ_IMPLICIT OptionalCorsPreflightArgs(const OptionalCorsPreflightArgs& aOther);

    MOZ_IMPLICIT OptionalCorsPreflightArgs(OptionalCorsPreflightArgs&& aOther);

    ~OptionalCorsPreflightArgs();

    Type
    type() const
    {
        return mType;
    }

    OptionalCorsPreflightArgs&
    operator=(const void_t& aRhs);

    OptionalCorsPreflightArgs&
    operator=(void_t&& aRhs);

    OptionalCorsPreflightArgs&
    operator=(const CorsPreflightArgs& aRhs);

    OptionalCorsPreflightArgs&
    operator=(CorsPreflightArgs&& aRhs);

    OptionalCorsPreflightArgs&
    operator=(const OptionalCorsPreflightArgs& aRhs);

    OptionalCorsPreflightArgs&
    operator=(OptionalCorsPreflightArgs&& aRhs);

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const CorsPreflightArgs& aRhs) const;

    bool
    operator==(const OptionalCorsPreflightArgs& aRhs) const;

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

    CorsPreflightArgs&
    get_CorsPreflightArgs()
    {
        AssertSanity(TCorsPreflightArgs);
        return (*(ptr_CorsPreflightArgs()));
    }
    const CorsPreflightArgs&
    get_CorsPreflightArgs() const
    {
        AssertSanity(TCorsPreflightArgs);
        return (*(constptr_CorsPreflightArgs()));
    }
    void
    get(CorsPreflightArgs* aOutValue) const;
    operator CorsPreflightArgs&()
    {
        return get_CorsPreflightArgs();
    }
    operator const CorsPreflightArgs&() const
    {
        return get_CorsPreflightArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::OptionalCorsPreflightArgs>
{
    typedef mozilla::net::OptionalCorsPreflightArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelOpenArgs|
//
namespace mozilla {
namespace net {
class HttpChannelOpenArgs final
{
private:
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;
    typedef mozilla::ipc::OptionalIPCStream OptionalIPCStream;
    typedef mozilla::net::OptionalLoadInfoArgs OptionalLoadInfoArgs;
    typedef mozilla::net::OptionalHttpResponseHead OptionalHttpResponseHead;
    typedef mozilla::net::OptionalCorsPreflightArgs OptionalCorsPreflightArgs;
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT HttpChannelOpenArgs() :
        uri_(),
        original_(),
        doc_(),
        referrer_(),
        referrerPolicy_(),
        apiRedirectTo_(),
        topWindowURI_(),
        loadFlags_(),
        requestHeaders_(),
        requestMethod_(),
        uploadStream_(),
        uploadStreamHasHeaders_(),
        priority_(),
        classOfService_(),
        redirectionLimit_(),
        allowSTS_(),
        thirdPartyFlags_(),
        resumeAt_(),
        startPos_(),
        entityID_(),
        chooseApplicationCache_(),
        appCacheClientID_(),
        allowSpdy_(),
        allowAltSvc_(),
        beConservative_(),
        tlsFlags_(),
        loadInfo_(),
        synthesizedResponseHead_(),
        synthesizedSecurityInfoSerialization_(),
        cacheKey_(),
        requestContextID_(),
        preflightArgs_(),
        initialRwin_(),
        blockAuthPrompt_(),
        suspendAfterSynthesizeResponse_(),
        allowStaleCacheContent_(),
        contentTypeHint_(),
        corsMode_(),
        redirectMode_(),
        channelId_(),
        contentWindowId_(),
        preferredAlternativeType_(),
        topLevelOuterContentWindowId_(),
        launchServiceWorkerStart_(),
        launchServiceWorkerEnd_(),
        dispatchFetchEventStart_(),
        dispatchFetchEventEnd_(),
        handleFetchEventStart_(),
        handleFetchEventEnd_(),
        forceMainDocumentChannel_()
    {
    }

    MOZ_IMPLICIT HttpChannelOpenArgs(
            const URIParams& _uri,
            const OptionalURIParams& _original,
            const OptionalURIParams& _doc,
            const OptionalURIParams& _referrer,
            const uint32_t& _referrerPolicy,
            const OptionalURIParams& _apiRedirectTo,
            const OptionalURIParams& _topWindowURI,
            const uint32_t& _loadFlags,
            const RequestHeaderTuples& _requestHeaders,
            const nsCString& _requestMethod,
            const OptionalIPCStream& _uploadStream,
            const bool& _uploadStreamHasHeaders,
            const int16_t& _priority,
            const uint32_t& _classOfService,
            const uint8_t& _redirectionLimit,
            const bool& _allowSTS,
            const uint32_t& _thirdPartyFlags,
            const bool& _resumeAt,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const bool& _chooseApplicationCache,
            const nsCString& _appCacheClientID,
            const bool& _allowSpdy,
            const bool& _allowAltSvc,
            const bool& _beConservative,
            const uint32_t& _tlsFlags,
            const OptionalLoadInfoArgs& _loadInfo,
            const OptionalHttpResponseHead& _synthesizedResponseHead,
            const nsCString& _synthesizedSecurityInfoSerialization,
            const uint32_t& _cacheKey,
            const uint64_t& _requestContextID,
            const OptionalCorsPreflightArgs& _preflightArgs,
            const uint32_t& _initialRwin,
            const bool& _blockAuthPrompt,
            const bool& _suspendAfterSynthesizeResponse,
            const bool& _allowStaleCacheContent,
            const nsCString& _contentTypeHint,
            const uint32_t& _corsMode,
            const uint32_t& _redirectMode,
            const uint64_t& _channelId,
            const uint64_t& _contentWindowId,
            const nsCString& _preferredAlternativeType,
            const uint64_t& _topLevelOuterContentWindowId,
            const TimeStamp& _launchServiceWorkerStart,
            const TimeStamp& _launchServiceWorkerEnd,
            const TimeStamp& _dispatchFetchEventStart,
            const TimeStamp& _dispatchFetchEventEnd,
            const TimeStamp& _handleFetchEventStart,
            const TimeStamp& _handleFetchEventEnd,
            const bool& _forceMainDocumentChannel) :
        uri_(_uri),
        original_(_original),
        doc_(_doc),
        referrer_(_referrer),
        referrerPolicy_(_referrerPolicy),
        apiRedirectTo_(_apiRedirectTo),
        topWindowURI_(_topWindowURI),
        loadFlags_(_loadFlags),
        requestHeaders_(_requestHeaders),
        requestMethod_(_requestMethod),
        uploadStream_(_uploadStream),
        uploadStreamHasHeaders_(_uploadStreamHasHeaders),
        priority_(_priority),
        classOfService_(_classOfService),
        redirectionLimit_(_redirectionLimit),
        allowSTS_(_allowSTS),
        thirdPartyFlags_(_thirdPartyFlags),
        resumeAt_(_resumeAt),
        startPos_(_startPos),
        entityID_(_entityID),
        chooseApplicationCache_(_chooseApplicationCache),
        appCacheClientID_(_appCacheClientID),
        allowSpdy_(_allowSpdy),
        allowAltSvc_(_allowAltSvc),
        beConservative_(_beConservative),
        tlsFlags_(_tlsFlags),
        loadInfo_(_loadInfo),
        synthesizedResponseHead_(_synthesizedResponseHead),
        synthesizedSecurityInfoSerialization_(_synthesizedSecurityInfoSerialization),
        cacheKey_(_cacheKey),
        requestContextID_(_requestContextID),
        preflightArgs_(_preflightArgs),
        initialRwin_(_initialRwin),
        blockAuthPrompt_(_blockAuthPrompt),
        suspendAfterSynthesizeResponse_(_suspendAfterSynthesizeResponse),
        allowStaleCacheContent_(_allowStaleCacheContent),
        contentTypeHint_(_contentTypeHint),
        corsMode_(_corsMode),
        redirectMode_(_redirectMode),
        channelId_(_channelId),
        contentWindowId_(_contentWindowId),
        preferredAlternativeType_(_preferredAlternativeType),
        topLevelOuterContentWindowId_(_topLevelOuterContentWindowId),
        launchServiceWorkerStart_(_launchServiceWorkerStart),
        launchServiceWorkerEnd_(_launchServiceWorkerEnd),
        dispatchFetchEventStart_(_dispatchFetchEventStart),
        dispatchFetchEventEnd_(_dispatchFetchEventEnd),
        handleFetchEventStart_(_handleFetchEventStart),
        handleFetchEventEnd_(_handleFetchEventEnd),
        forceMainDocumentChannel_(_forceMainDocumentChannel)
    {
    }

    bool
    operator==(const HttpChannelOpenArgs& _o) const;

    bool
    operator!=(const HttpChannelOpenArgs& _o) const;

    URIParams&
    uri()
    {
        return uri_;
    }
    const URIParams&
    uri() const
    {
        return uri_;
    }

    OptionalURIParams&
    original()
    {
        return original_;
    }
    const OptionalURIParams&
    original() const
    {
        return original_;
    }

    OptionalURIParams&
    doc()
    {
        return doc_;
    }
    const OptionalURIParams&
    doc() const
    {
        return doc_;
    }

    OptionalURIParams&
    referrer()
    {
        return referrer_;
    }
    const OptionalURIParams&
    referrer() const
    {
        return referrer_;
    }

    uint32_t&
    referrerPolicy()
    {
        return referrerPolicy_;
    }
    const uint32_t&
    referrerPolicy() const
    {
        return referrerPolicy_;
    }

    OptionalURIParams&
    apiRedirectTo()
    {
        return apiRedirectTo_;
    }
    const OptionalURIParams&
    apiRedirectTo() const
    {
        return apiRedirectTo_;
    }

    OptionalURIParams&
    topWindowURI()
    {
        return topWindowURI_;
    }
    const OptionalURIParams&
    topWindowURI() const
    {
        return topWindowURI_;
    }

    uint32_t&
    loadFlags()
    {
        return loadFlags_;
    }
    const uint32_t&
    loadFlags() const
    {
        return loadFlags_;
    }

    RequestHeaderTuples&
    requestHeaders()
    {
        return requestHeaders_;
    }
    const RequestHeaderTuples&
    requestHeaders() const
    {
        return requestHeaders_;
    }

    nsCString&
    requestMethod()
    {
        return requestMethod_;
    }
    const nsCString&
    requestMethod() const
    {
        return requestMethod_;
    }

    OptionalIPCStream&
    uploadStream()
    {
        return uploadStream_;
    }
    const OptionalIPCStream&
    uploadStream() const
    {
        return uploadStream_;
    }

    bool&
    uploadStreamHasHeaders()
    {
        return uploadStreamHasHeaders_;
    }
    const bool&
    uploadStreamHasHeaders() const
    {
        return uploadStreamHasHeaders_;
    }

    int16_t&
    priority()
    {
        return priority_;
    }
    const int16_t&
    priority() const
    {
        return priority_;
    }

    uint32_t&
    classOfService()
    {
        return classOfService_;
    }
    const uint32_t&
    classOfService() const
    {
        return classOfService_;
    }

    uint8_t&
    redirectionLimit()
    {
        return redirectionLimit_;
    }
    const uint8_t&
    redirectionLimit() const
    {
        return redirectionLimit_;
    }

    bool&
    allowSTS()
    {
        return allowSTS_;
    }
    const bool&
    allowSTS() const
    {
        return allowSTS_;
    }

    uint32_t&
    thirdPartyFlags()
    {
        return thirdPartyFlags_;
    }
    const uint32_t&
    thirdPartyFlags() const
    {
        return thirdPartyFlags_;
    }

    bool&
    resumeAt()
    {
        return resumeAt_;
    }
    const bool&
    resumeAt() const
    {
        return resumeAt_;
    }

    uint64_t&
    startPos()
    {
        return startPos_;
    }
    const uint64_t&
    startPos() const
    {
        return startPos_;
    }

    nsCString&
    entityID()
    {
        return entityID_;
    }
    const nsCString&
    entityID() const
    {
        return entityID_;
    }

    bool&
    chooseApplicationCache()
    {
        return chooseApplicationCache_;
    }
    const bool&
    chooseApplicationCache() const
    {
        return chooseApplicationCache_;
    }

    nsCString&
    appCacheClientID()
    {
        return appCacheClientID_;
    }
    const nsCString&
    appCacheClientID() const
    {
        return appCacheClientID_;
    }

    bool&
    allowSpdy()
    {
        return allowSpdy_;
    }
    const bool&
    allowSpdy() const
    {
        return allowSpdy_;
    }

    bool&
    allowAltSvc()
    {
        return allowAltSvc_;
    }
    const bool&
    allowAltSvc() const
    {
        return allowAltSvc_;
    }

    bool&
    beConservative()
    {
        return beConservative_;
    }
    const bool&
    beConservative() const
    {
        return beConservative_;
    }

    uint32_t&
    tlsFlags()
    {
        return tlsFlags_;
    }
    const uint32_t&
    tlsFlags() const
    {
        return tlsFlags_;
    }

    OptionalLoadInfoArgs&
    loadInfo()
    {
        return loadInfo_;
    }
    const OptionalLoadInfoArgs&
    loadInfo() const
    {
        return loadInfo_;
    }

    OptionalHttpResponseHead&
    synthesizedResponseHead()
    {
        return synthesizedResponseHead_;
    }
    const OptionalHttpResponseHead&
    synthesizedResponseHead() const
    {
        return synthesizedResponseHead_;
    }

    nsCString&
    synthesizedSecurityInfoSerialization()
    {
        return synthesizedSecurityInfoSerialization_;
    }
    const nsCString&
    synthesizedSecurityInfoSerialization() const
    {
        return synthesizedSecurityInfoSerialization_;
    }

    uint32_t&
    cacheKey()
    {
        return cacheKey_;
    }
    const uint32_t&
    cacheKey() const
    {
        return cacheKey_;
    }

    uint64_t&
    requestContextID()
    {
        return requestContextID_;
    }
    const uint64_t&
    requestContextID() const
    {
        return requestContextID_;
    }

    OptionalCorsPreflightArgs&
    preflightArgs()
    {
        return preflightArgs_;
    }
    const OptionalCorsPreflightArgs&
    preflightArgs() const
    {
        return preflightArgs_;
    }

    uint32_t&
    initialRwin()
    {
        return initialRwin_;
    }
    const uint32_t&
    initialRwin() const
    {
        return initialRwin_;
    }

    bool&
    blockAuthPrompt()
    {
        return blockAuthPrompt_;
    }
    const bool&
    blockAuthPrompt() const
    {
        return blockAuthPrompt_;
    }

    bool&
    suspendAfterSynthesizeResponse()
    {
        return suspendAfterSynthesizeResponse_;
    }
    const bool&
    suspendAfterSynthesizeResponse() const
    {
        return suspendAfterSynthesizeResponse_;
    }

    bool&
    allowStaleCacheContent()
    {
        return allowStaleCacheContent_;
    }
    const bool&
    allowStaleCacheContent() const
    {
        return allowStaleCacheContent_;
    }

    nsCString&
    contentTypeHint()
    {
        return contentTypeHint_;
    }
    const nsCString&
    contentTypeHint() const
    {
        return contentTypeHint_;
    }

    uint32_t&
    corsMode()
    {
        return corsMode_;
    }
    const uint32_t&
    corsMode() const
    {
        return corsMode_;
    }

    uint32_t&
    redirectMode()
    {
        return redirectMode_;
    }
    const uint32_t&
    redirectMode() const
    {
        return redirectMode_;
    }

    uint64_t&
    channelId()
    {
        return channelId_;
    }
    const uint64_t&
    channelId() const
    {
        return channelId_;
    }

    uint64_t&
    contentWindowId()
    {
        return contentWindowId_;
    }
    const uint64_t&
    contentWindowId() const
    {
        return contentWindowId_;
    }

    nsCString&
    preferredAlternativeType()
    {
        return preferredAlternativeType_;
    }
    const nsCString&
    preferredAlternativeType() const
    {
        return preferredAlternativeType_;
    }

    uint64_t&
    topLevelOuterContentWindowId()
    {
        return topLevelOuterContentWindowId_;
    }
    const uint64_t&
    topLevelOuterContentWindowId() const
    {
        return topLevelOuterContentWindowId_;
    }

    TimeStamp&
    launchServiceWorkerStart()
    {
        return launchServiceWorkerStart_;
    }
    const TimeStamp&
    launchServiceWorkerStart() const
    {
        return launchServiceWorkerStart_;
    }

    TimeStamp&
    launchServiceWorkerEnd()
    {
        return launchServiceWorkerEnd_;
    }
    const TimeStamp&
    launchServiceWorkerEnd() const
    {
        return launchServiceWorkerEnd_;
    }

    TimeStamp&
    dispatchFetchEventStart()
    {
        return dispatchFetchEventStart_;
    }
    const TimeStamp&
    dispatchFetchEventStart() const
    {
        return dispatchFetchEventStart_;
    }

    TimeStamp&
    dispatchFetchEventEnd()
    {
        return dispatchFetchEventEnd_;
    }
    const TimeStamp&
    dispatchFetchEventEnd() const
    {
        return dispatchFetchEventEnd_;
    }

    TimeStamp&
    handleFetchEventStart()
    {
        return handleFetchEventStart_;
    }
    const TimeStamp&
    handleFetchEventStart() const
    {
        return handleFetchEventStart_;
    }

    TimeStamp&
    handleFetchEventEnd()
    {
        return handleFetchEventEnd_;
    }
    const TimeStamp&
    handleFetchEventEnd() const
    {
        return handleFetchEventEnd_;
    }

    bool&
    forceMainDocumentChannel()
    {
        return forceMainDocumentChannel_;
    }
    const bool&
    forceMainDocumentChannel() const
    {
        return forceMainDocumentChannel_;
    }

private:
    URIParams uri_;
    OptionalURIParams original_;
    OptionalURIParams doc_;
    OptionalURIParams referrer_;
    uint32_t referrerPolicy_;
    OptionalURIParams apiRedirectTo_;
    OptionalURIParams topWindowURI_;
    uint32_t loadFlags_;
    RequestHeaderTuples requestHeaders_;
    nsCString requestMethod_;
    OptionalIPCStream uploadStream_;
    bool uploadStreamHasHeaders_;
    int16_t priority_;
    uint32_t classOfService_;
    uint8_t redirectionLimit_;
    bool allowSTS_;
    uint32_t thirdPartyFlags_;
    bool resumeAt_;
    uint64_t startPos_;
    nsCString entityID_;
    bool chooseApplicationCache_;
    nsCString appCacheClientID_;
    bool allowSpdy_;
    bool allowAltSvc_;
    bool beConservative_;
    uint32_t tlsFlags_;
    OptionalLoadInfoArgs loadInfo_;
    OptionalHttpResponseHead synthesizedResponseHead_;
    nsCString synthesizedSecurityInfoSerialization_;
    uint32_t cacheKey_;
    uint64_t requestContextID_;
    OptionalCorsPreflightArgs preflightArgs_;
    uint32_t initialRwin_;
    bool blockAuthPrompt_;
    bool suspendAfterSynthesizeResponse_;
    bool allowStaleCacheContent_;
    nsCString contentTypeHint_;
    uint32_t corsMode_;
    uint32_t redirectMode_;
    uint64_t channelId_;
    uint64_t contentWindowId_;
    nsCString preferredAlternativeType_;
    uint64_t topLevelOuterContentWindowId_;
    TimeStamp launchServiceWorkerStart_;
    TimeStamp launchServiceWorkerEnd_;
    TimeStamp dispatchFetchEventStart_;
    TimeStamp dispatchFetchEventEnd_;
    TimeStamp handleFetchEventStart_;
    TimeStamp handleFetchEventEnd_;
    bool forceMainDocumentChannel_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::HttpChannelOpenArgs>
{
    typedef mozilla::net::HttpChannelOpenArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelConnectArgs|
//
namespace mozilla {
namespace net {
class HttpChannelConnectArgs final
{
private:

public:
    MOZ_IMPLICIT HttpChannelConnectArgs() :
        registrarId_(),
        shouldIntercept_()
    {
    }

    MOZ_IMPLICIT HttpChannelConnectArgs(
            const uint32_t& _registrarId,
            const bool& _shouldIntercept) :
        registrarId_(_registrarId),
        shouldIntercept_(_shouldIntercept)
    {
    }

    bool
    operator==(const HttpChannelConnectArgs& _o) const;

    bool
    operator!=(const HttpChannelConnectArgs& _o) const;

    uint32_t&
    registrarId()
    {
        return registrarId_;
    }
    const uint32_t&
    registrarId() const
    {
        return registrarId_;
    }

    bool&
    shouldIntercept()
    {
        return shouldIntercept_;
    }
    const bool&
    shouldIntercept() const
    {
        return shouldIntercept_;
    }

private:
    uint32_t registrarId_;
    bool shouldIntercept_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::HttpChannelConnectArgs>
{
    typedef mozilla::net::HttpChannelConnectArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union HttpChannelCreationArgs|
//
namespace mozilla {
namespace net {
class HttpChannelCreationArgs final
{
public:
    enum Type {
        T__None,
        THttpChannelOpenArgs = 1,
        THttpChannelConnectArgs,
        T__Last = THttpChannelConnectArgs
    };

private:
    typedef mozilla::net::HttpChannelOpenArgs HttpChannelOpenArgs;
    typedef mozilla::net::HttpChannelConnectArgs HttpChannelConnectArgs;
    typedef HttpChannelOpenArgs HttpChannelOpenArgs__tdef;
    typedef HttpChannelConnectArgs HttpChannelConnectArgs__tdef;

    union Value {
        mozilla::AlignedStorage2<HttpChannelOpenArgs> VHttpChannelOpenArgs;
        mozilla::AlignedStorage2<HttpChannelConnectArgs> VHttpChannelConnectArgs;
    };

    HttpChannelOpenArgs*
    ptr_HttpChannelOpenArgs()
    {
        return ((mValue).VHttpChannelOpenArgs).addr();
    }
    const HttpChannelOpenArgs*
    constptr_HttpChannelOpenArgs() const
    {
        return ((mValue).VHttpChannelOpenArgs).addr();
    }
    HttpChannelConnectArgs*
    ptr_HttpChannelConnectArgs()
    {
        return ((mValue).VHttpChannelConnectArgs).addr();
    }
    const HttpChannelConnectArgs*
    constptr_HttpChannelConnectArgs() const
    {
        return ((mValue).VHttpChannelConnectArgs).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT HttpChannelCreationArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelOpenArgs& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(HttpChannelOpenArgs&& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelConnectArgs& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(HttpChannelConnectArgs&& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelCreationArgs& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(HttpChannelCreationArgs&& aOther);

    ~HttpChannelCreationArgs();

    Type
    type() const
    {
        return mType;
    }

    HttpChannelCreationArgs&
    operator=(const HttpChannelOpenArgs& aRhs);

    HttpChannelCreationArgs&
    operator=(HttpChannelOpenArgs&& aRhs);

    HttpChannelCreationArgs&
    operator=(const HttpChannelConnectArgs& aRhs);

    HttpChannelCreationArgs&
    operator=(HttpChannelConnectArgs&& aRhs);

    HttpChannelCreationArgs&
    operator=(const HttpChannelCreationArgs& aRhs);

    HttpChannelCreationArgs&
    operator=(HttpChannelCreationArgs&& aRhs);

    bool
    operator==(const HttpChannelOpenArgs& aRhs) const;

    bool
    operator==(const HttpChannelConnectArgs& aRhs) const;

    bool
    operator==(const HttpChannelCreationArgs& aRhs) const;

    HttpChannelOpenArgs&
    get_HttpChannelOpenArgs()
    {
        AssertSanity(THttpChannelOpenArgs);
        return (*(ptr_HttpChannelOpenArgs()));
    }
    const HttpChannelOpenArgs&
    get_HttpChannelOpenArgs() const
    {
        AssertSanity(THttpChannelOpenArgs);
        return (*(constptr_HttpChannelOpenArgs()));
    }
    void
    get(HttpChannelOpenArgs* aOutValue) const;
    operator HttpChannelOpenArgs&()
    {
        return get_HttpChannelOpenArgs();
    }
    operator const HttpChannelOpenArgs&() const
    {
        return get_HttpChannelOpenArgs();
    }

    HttpChannelConnectArgs&
    get_HttpChannelConnectArgs()
    {
        AssertSanity(THttpChannelConnectArgs);
        return (*(ptr_HttpChannelConnectArgs()));
    }
    const HttpChannelConnectArgs&
    get_HttpChannelConnectArgs() const
    {
        AssertSanity(THttpChannelConnectArgs);
        return (*(constptr_HttpChannelConnectArgs()));
    }
    void
    get(HttpChannelConnectArgs* aOutValue) const;
    operator HttpChannelConnectArgs&()
    {
        return get_HttpChannelConnectArgs();
    }
    operator const HttpChannelConnectArgs&() const
    {
        return get_HttpChannelConnectArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::HttpChannelCreationArgs>
{
    typedef mozilla::net::HttpChannelCreationArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FTPChannelOpenArgs|
//
namespace mozilla {
namespace net {
class FTPChannelOpenArgs final
{
private:
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::ipc::OptionalIPCStream OptionalIPCStream;
    typedef mozilla::net::OptionalLoadInfoArgs OptionalLoadInfoArgs;

public:
    MOZ_IMPLICIT FTPChannelOpenArgs() :
        uri_(),
        startPos_(),
        entityID_(),
        uploadStream_(),
        loadInfo_()
    {
    }

    MOZ_IMPLICIT FTPChannelOpenArgs(
            const URIParams& _uri,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const OptionalIPCStream& _uploadStream,
            const OptionalLoadInfoArgs& _loadInfo) :
        uri_(_uri),
        startPos_(_startPos),
        entityID_(_entityID),
        uploadStream_(_uploadStream),
        loadInfo_(_loadInfo)
    {
    }

    bool
    operator==(const FTPChannelOpenArgs& _o) const;

    bool
    operator!=(const FTPChannelOpenArgs& _o) const;

    URIParams&
    uri()
    {
        return uri_;
    }
    const URIParams&
    uri() const
    {
        return uri_;
    }

    uint64_t&
    startPos()
    {
        return startPos_;
    }
    const uint64_t&
    startPos() const
    {
        return startPos_;
    }

    nsCString&
    entityID()
    {
        return entityID_;
    }
    const nsCString&
    entityID() const
    {
        return entityID_;
    }

    OptionalIPCStream&
    uploadStream()
    {
        return uploadStream_;
    }
    const OptionalIPCStream&
    uploadStream() const
    {
        return uploadStream_;
    }

    OptionalLoadInfoArgs&
    loadInfo()
    {
        return loadInfo_;
    }
    const OptionalLoadInfoArgs&
    loadInfo() const
    {
        return loadInfo_;
    }

private:
    URIParams uri_;
    uint64_t startPos_;
    nsCString entityID_;
    OptionalIPCStream uploadStream_;
    OptionalLoadInfoArgs loadInfo_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::FTPChannelOpenArgs>
{
    typedef mozilla::net::FTPChannelOpenArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FTPChannelConnectArgs|
//
namespace mozilla {
namespace net {
class FTPChannelConnectArgs final
{
private:

public:
    MOZ_IMPLICIT FTPChannelConnectArgs() :
        channelId_()
    {
    }

    MOZ_IMPLICIT FTPChannelConnectArgs(const uint32_t& _channelId) :
        channelId_(_channelId)
    {
    }

    bool
    operator==(const FTPChannelConnectArgs& _o) const;

    bool
    operator!=(const FTPChannelConnectArgs& _o) const;

    uint32_t&
    channelId()
    {
        return channelId_;
    }
    const uint32_t&
    channelId() const
    {
        return channelId_;
    }

private:
    uint32_t channelId_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::FTPChannelConnectArgs>
{
    typedef mozilla::net::FTPChannelConnectArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FTPChannelCreationArgs|
//
namespace mozilla {
namespace net {
class FTPChannelCreationArgs final
{
public:
    enum Type {
        T__None,
        TFTPChannelOpenArgs = 1,
        TFTPChannelConnectArgs,
        T__Last = TFTPChannelConnectArgs
    };

private:
    typedef mozilla::net::FTPChannelOpenArgs FTPChannelOpenArgs;
    typedef mozilla::net::FTPChannelConnectArgs FTPChannelConnectArgs;
    typedef FTPChannelOpenArgs FTPChannelOpenArgs__tdef;
    typedef FTPChannelConnectArgs FTPChannelConnectArgs__tdef;

    union Value {
        mozilla::AlignedStorage2<FTPChannelOpenArgs> VFTPChannelOpenArgs;
        mozilla::AlignedStorage2<FTPChannelConnectArgs> VFTPChannelConnectArgs;
    };

    FTPChannelOpenArgs*
    ptr_FTPChannelOpenArgs()
    {
        return ((mValue).VFTPChannelOpenArgs).addr();
    }
    const FTPChannelOpenArgs*
    constptr_FTPChannelOpenArgs() const
    {
        return ((mValue).VFTPChannelOpenArgs).addr();
    }
    FTPChannelConnectArgs*
    ptr_FTPChannelConnectArgs()
    {
        return ((mValue).VFTPChannelConnectArgs).addr();
    }
    const FTPChannelConnectArgs*
    constptr_FTPChannelConnectArgs() const
    {
        return ((mValue).VFTPChannelConnectArgs).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FTPChannelCreationArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelOpenArgs& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(FTPChannelOpenArgs&& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelConnectArgs& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(FTPChannelConnectArgs&& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelCreationArgs& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(FTPChannelCreationArgs&& aOther);

    ~FTPChannelCreationArgs();

    Type
    type() const
    {
        return mType;
    }

    FTPChannelCreationArgs&
    operator=(const FTPChannelOpenArgs& aRhs);

    FTPChannelCreationArgs&
    operator=(FTPChannelOpenArgs&& aRhs);

    FTPChannelCreationArgs&
    operator=(const FTPChannelConnectArgs& aRhs);

    FTPChannelCreationArgs&
    operator=(FTPChannelConnectArgs&& aRhs);

    FTPChannelCreationArgs&
    operator=(const FTPChannelCreationArgs& aRhs);

    FTPChannelCreationArgs&
    operator=(FTPChannelCreationArgs&& aRhs);

    bool
    operator==(const FTPChannelOpenArgs& aRhs) const;

    bool
    operator==(const FTPChannelConnectArgs& aRhs) const;

    bool
    operator==(const FTPChannelCreationArgs& aRhs) const;

    FTPChannelOpenArgs&
    get_FTPChannelOpenArgs()
    {
        AssertSanity(TFTPChannelOpenArgs);
        return (*(ptr_FTPChannelOpenArgs()));
    }
    const FTPChannelOpenArgs&
    get_FTPChannelOpenArgs() const
    {
        AssertSanity(TFTPChannelOpenArgs);
        return (*(constptr_FTPChannelOpenArgs()));
    }
    void
    get(FTPChannelOpenArgs* aOutValue) const;
    operator FTPChannelOpenArgs&()
    {
        return get_FTPChannelOpenArgs();
    }
    operator const FTPChannelOpenArgs&() const
    {
        return get_FTPChannelOpenArgs();
    }

    FTPChannelConnectArgs&
    get_FTPChannelConnectArgs()
    {
        AssertSanity(TFTPChannelConnectArgs);
        return (*(ptr_FTPChannelConnectArgs()));
    }
    const FTPChannelConnectArgs&
    get_FTPChannelConnectArgs() const
    {
        AssertSanity(TFTPChannelConnectArgs);
        return (*(constptr_FTPChannelConnectArgs()));
    }
    void
    get(FTPChannelConnectArgs* aOutValue) const;
    operator FTPChannelConnectArgs&()
    {
        return get_FTPChannelConnectArgs();
    }
    operator const FTPChannelConnectArgs&() const
    {
        return get_FTPChannelConnectArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::FTPChannelCreationArgs>
{
    typedef mozilla::net::FTPChannelCreationArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace net {
class PHttpChannelParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PHttpChannelChild;
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelDiverterArgs|
//
namespace mozilla {
namespace net {
class HttpChannelDiverterArgs final
{
private:
    typedef mozilla::net::PHttpChannelParent PHttpChannelParent;
    typedef mozilla::net::PHttpChannelChild PHttpChannelChild;

public:
    MOZ_IMPLICIT HttpChannelDiverterArgs() :
        mChannelParent_(),
        mChannelChild_(),
        mApplyConversion_()
    {
    }

    MOZ_IMPLICIT HttpChannelDiverterArgs(
            PHttpChannelParent* _mChannelParent,
            PHttpChannelChild* _mChannelChild,
            const bool& _mApplyConversion) :
        mChannelParent_(_mChannelParent),
        mChannelChild_(_mChannelChild),
        mApplyConversion_(_mApplyConversion)
    {
    }

    bool
    operator==(const HttpChannelDiverterArgs& _o) const;

    bool
    operator!=(const HttpChannelDiverterArgs& _o) const;

    PHttpChannelParent*&
    mChannelParent()
    {
        return mChannelParent_;
    }
    PHttpChannelParent*
    mChannelParent() const
    {
        return mChannelParent_;
    }

    PHttpChannelChild*&
    mChannelChild()
    {
        return mChannelChild_;
    }
    PHttpChannelChild*
    mChannelChild() const
    {
        return mChannelChild_;
    }

    bool&
    mApplyConversion()
    {
        return mApplyConversion_;
    }
    const bool&
    mApplyConversion() const
    {
        return mApplyConversion_;
    }

private:
    PHttpChannelParent* mChannelParent_;
    PHttpChannelChild* mChannelChild_;
    bool mApplyConversion_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::HttpChannelDiverterArgs>
{
    typedef mozilla::net::HttpChannelDiverterArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace net {
class PFTPChannelParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PFTPChannelChild;
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union ChannelDiverterArgs|
//
namespace mozilla {
namespace net {
class ChannelDiverterArgs final
{
public:
    enum Type {
        T__None,
        THttpChannelDiverterArgs = 1,
        TPFTPChannelParent,
        TPFTPChannelChild,
        T__Last = TPFTPChannelChild
    };

private:
    typedef mozilla::net::HttpChannelDiverterArgs HttpChannelDiverterArgs;
    typedef mozilla::net::PFTPChannelParent PFTPChannelParent;
    typedef mozilla::net::PFTPChannelChild PFTPChannelChild;
    typedef HttpChannelDiverterArgs HttpChannelDiverterArgs__tdef;
    typedef PFTPChannelParent* PFTPChannelParent__tdef;
    typedef PFTPChannelChild* PFTPChannelChild__tdef;

    union Value {
        mozilla::AlignedStorage2<HttpChannelDiverterArgs> VHttpChannelDiverterArgs;
        mozilla::AlignedStorage2<PFTPChannelParent*> VPFTPChannelParent;
        mozilla::AlignedStorage2<PFTPChannelChild*> VPFTPChannelChild;
    };

    HttpChannelDiverterArgs*
    ptr_HttpChannelDiverterArgs()
    {
        return ((mValue).VHttpChannelDiverterArgs).addr();
    }
    const HttpChannelDiverterArgs*
    constptr_HttpChannelDiverterArgs() const
    {
        return ((mValue).VHttpChannelDiverterArgs).addr();
    }
    PFTPChannelParent**
    ptr_PFTPChannelParent()
    {
        return ((mValue).VPFTPChannelParent).addr();
    }
    PFTPChannelParent* const*
    constptr_PFTPChannelParent() const
    {
        return ((mValue).VPFTPChannelParent).addr();
    }
    PFTPChannelChild**
    ptr_PFTPChannelChild()
    {
        return ((mValue).VPFTPChannelChild).addr();
    }
    PFTPChannelChild* const*
    constptr_PFTPChannelChild() const
    {
        return ((mValue).VPFTPChannelChild).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT ChannelDiverterArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT ChannelDiverterArgs(const HttpChannelDiverterArgs& aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(HttpChannelDiverterArgs&& aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(PFTPChannelParent* aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(PFTPChannelChild* aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(const ChannelDiverterArgs& aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(ChannelDiverterArgs&& aOther);

    ~ChannelDiverterArgs();

    Type
    type() const
    {
        return mType;
    }

    ChannelDiverterArgs&
    operator=(const HttpChannelDiverterArgs& aRhs);

    ChannelDiverterArgs&
    operator=(HttpChannelDiverterArgs&& aRhs);

    ChannelDiverterArgs&
    operator=(PFTPChannelParent* aRhs);

    ChannelDiverterArgs&
    operator=(PFTPChannelChild* aRhs);

    ChannelDiverterArgs&
    operator=(const ChannelDiverterArgs& aRhs);

    ChannelDiverterArgs&
    operator=(ChannelDiverterArgs&& aRhs);

    bool
    operator==(const HttpChannelDiverterArgs& aRhs) const;

    bool
    operator==(PFTPChannelParent* aRhs) const;

    bool
    operator==(PFTPChannelChild* aRhs) const;

    bool
    operator==(const ChannelDiverterArgs& aRhs) const;

    HttpChannelDiverterArgs&
    get_HttpChannelDiverterArgs()
    {
        AssertSanity(THttpChannelDiverterArgs);
        return (*(ptr_HttpChannelDiverterArgs()));
    }
    const HttpChannelDiverterArgs&
    get_HttpChannelDiverterArgs() const
    {
        AssertSanity(THttpChannelDiverterArgs);
        return (*(constptr_HttpChannelDiverterArgs()));
    }
    void
    get(HttpChannelDiverterArgs* aOutValue) const;
    operator HttpChannelDiverterArgs&()
    {
        return get_HttpChannelDiverterArgs();
    }
    operator const HttpChannelDiverterArgs&() const
    {
        return get_HttpChannelDiverterArgs();
    }

    PFTPChannelParent*&
    get_PFTPChannelParent()
    {
        AssertSanity(TPFTPChannelParent);
        return (*(ptr_PFTPChannelParent()));
    }
    PFTPChannelParent*
    get_PFTPChannelParent() const
    {
        AssertSanity(TPFTPChannelParent);
        return (*(constptr_PFTPChannelParent()));
    }
    void
    get(PFTPChannelParent** aOutValue) const;
    operator PFTPChannelParent*&()
    {
        return get_PFTPChannelParent();
    }
    operator PFTPChannelParent*() const
    {
        return get_PFTPChannelParent();
    }

    PFTPChannelChild*&
    get_PFTPChannelChild()
    {
        AssertSanity(TPFTPChannelChild);
        return (*(ptr_PFTPChannelChild()));
    }
    PFTPChannelChild*
    get_PFTPChannelChild() const
    {
        AssertSanity(TPFTPChannelChild);
        return (*(constptr_PFTPChannelChild()));
    }
    void
    get(PFTPChannelChild** aOutValue) const;
    operator PFTPChannelChild*&()
    {
        return get_PFTPChannelChild();
    }
    operator PFTPChannelChild*() const
    {
        return get_PFTPChannelChild();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::ChannelDiverterArgs>
{
    typedef mozilla::net::ChannelDiverterArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CookieStruct|
//
namespace mozilla {
namespace net {
class CookieStruct final
{
private:

public:
    MOZ_IMPLICIT CookieStruct() :
        name_(),
        value_(),
        host_(),
        path_(),
        expiry_(),
        lastAccessed_(),
        creationTime_(),
        isHttpOnly_(),
        isSession_(),
        isSecure_(),
        sameSite_()
    {
    }

    MOZ_IMPLICIT CookieStruct(
            const nsCString& _name,
            const nsCString& _value,
            const nsCString& _host,
            const nsCString& _path,
            const int64_t& _expiry,
            const int64_t& _lastAccessed,
            const int64_t& _creationTime,
            const bool& _isHttpOnly,
            const bool& _isSession,
            const bool& _isSecure,
            const int8_t& _sameSite) :
        name_(_name),
        value_(_value),
        host_(_host),
        path_(_path),
        expiry_(_expiry),
        lastAccessed_(_lastAccessed),
        creationTime_(_creationTime),
        isHttpOnly_(_isHttpOnly),
        isSession_(_isSession),
        isSecure_(_isSecure),
        sameSite_(_sameSite)
    {
    }

    bool
    operator==(const CookieStruct& _o) const;

    bool
    operator!=(const CookieStruct& _o) const;

    nsCString&
    name()
    {
        return name_;
    }
    const nsCString&
    name() const
    {
        return name_;
    }

    nsCString&
    value()
    {
        return value_;
    }
    const nsCString&
    value() const
    {
        return value_;
    }

    nsCString&
    host()
    {
        return host_;
    }
    const nsCString&
    host() const
    {
        return host_;
    }

    nsCString&
    path()
    {
        return path_;
    }
    const nsCString&
    path() const
    {
        return path_;
    }

    int64_t&
    expiry()
    {
        return expiry_;
    }
    const int64_t&
    expiry() const
    {
        return expiry_;
    }

    int64_t&
    lastAccessed()
    {
        return lastAccessed_;
    }
    const int64_t&
    lastAccessed() const
    {
        return lastAccessed_;
    }

    int64_t&
    creationTime()
    {
        return creationTime_;
    }
    const int64_t&
    creationTime() const
    {
        return creationTime_;
    }

    bool&
    isHttpOnly()
    {
        return isHttpOnly_;
    }
    const bool&
    isHttpOnly() const
    {
        return isHttpOnly_;
    }

    bool&
    isSession()
    {
        return isSession_;
    }
    const bool&
    isSession() const
    {
        return isSession_;
    }

    bool&
    isSecure()
    {
        return isSecure_;
    }
    const bool&
    isSecure() const
    {
        return isSecure_;
    }

    int8_t&
    sameSite()
    {
        return sameSite_;
    }
    const int8_t&
    sameSite() const
    {
        return sameSite_;
    }

private:
    nsCString name_;
    nsCString value_;
    nsCString host_;
    nsCString path_;
    int64_t expiry_;
    int64_t lastAccessed_;
    int64_t creationTime_;
    bool isHttpOnly_;
    bool isSession_;
    bool isSecure_;
    int8_t sameSite_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::CookieStruct>
{
    typedef mozilla::net::CookieStruct paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef NeckoChannelParams_h
