//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PTCPSocketChild_h
#define PTCPSocketChild_h

#include "mozilla/net/PTCPSocket.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/net/NeckoMessageUtils.h"

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PTCPServerSocketChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
struct void_t;
} // namespace mozilla

namespace mozilla {
namespace net {


class PTCPSocketChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::net::PTCPServerSocketChild;
    friend class mozilla::net::PNeckoChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoChild PNeckoChild;
    typedef mozilla::net::PNeckoParent PNeckoParent;

    typedef PTCPSocket::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvCallback(
            const nsString& type,
            const CallbackData& data,
            const uint32_t& readyState) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUpdateBufferedAmount(
            const uint32_t& bufferedAmount,
            const uint32_t& trackingNumber) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRequestDelete() = 0;
    virtual mozilla::ipc::IPCResult
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PTCPSocketChild();

    virtual ~PTCPSocketChild();

    PNeckoChild*
    Manager() const;

    bool
    SendOpen(
            const nsString& host,
            const uint16_t& port,
            const bool& useSSL,
            const bool& useArrayBuffers);

    bool
    SendOpenBind(
            const nsCString& host,
            const uint16_t& port,
            const nsCString& localAddr,
            const uint16_t& localPort,
            const bool& useSSL,
            const bool& reuseAddrPort,
            const bool& aUseArrayBuffers,
            const nsCString& aFilter);

    bool
    SendData(
            const SendableData& data,
            const uint32_t& trackingNumber);

    bool
    SendStartTLS();

    bool
    SendSuspend();

    bool
    SendResume();

    bool
    SendClose();

    bool
    SendRequestDelete();

    static bool
    Send__delete__(PTCPSocketChild* actor);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace net
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::PTCPSocketChild*>
{
    typedef mozilla::net::PTCPSocketChild* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class TCPSocketChild :
    public PTCPSocketChild
{
    mozilla::ipc::IPCResult
    RecvCallback(
            const nsString& type,
            const CallbackData& data,
            const uint32_t& readyState) override;

    mozilla::ipc::IPCResult
    RecvUpdateBufferedAmount(
            const uint32_t& bufferedAmount,
            const uint32_t& trackingNumber) override;

    mozilla::ipc::IPCResult
    RecvRequestDelete() override;

    MOZ_IMPLICIT TCPSocketChild();
    virtual ~TCPSocketChild();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
mozilla::ipc::IPCResult
TCPSocketChild::RecvCallback(
        const nsString& type,
        const CallbackData& data,
        const uint32_t& readyState)
{
}

mozilla::ipc::IPCResult
TCPSocketChild::RecvUpdateBufferedAmount(
        const uint32_t& bufferedAmount,
        const uint32_t& trackingNumber)
{
}

mozilla::ipc::IPCResult
TCPSocketChild::RecvRequestDelete()
{
}

MOZ_IMPLICIT TCPSocketChild::TCPSocketChild()
{
    MOZ_COUNT_CTOR(TCPSocketChild);
}

MOZ_IMPLICIT TCPSocketChild::~TCPSocketChild()
{
    MOZ_COUNT_DTOR(TCPSocketChild);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PTCPSocketChild_h
