//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PTCPSocketParent_h
#define PTCPSocketParent_h

#include "mozilla/net/PTCPSocket.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/net/NeckoMessageUtils.h"

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PTCPServerSocketParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
struct void_t;
} // namespace mozilla

namespace mozilla {
namespace net {


class PTCPSocketParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::net::PTCPServerSocketParent;
    friend class mozilla::net::PNeckoParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoParent PNeckoParent;
    typedef mozilla::net::PNeckoChild PNeckoChild;

    typedef PTCPSocket::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvOpen(
            const nsString& host,
            const uint16_t& port,
            const bool& useSSL,
            const bool& useArrayBuffers) = 0;
    virtual mozilla::ipc::IPCResult
    RecvOpenBind(
            const nsCString& host,
            const uint16_t& port,
            const nsCString& localAddr,
            const uint16_t& localPort,
            const bool& useSSL,
            const bool& reuseAddrPort,
            const bool& aUseArrayBuffers,
            const nsCString& aFilter) = 0;
    virtual mozilla::ipc::IPCResult
    RecvData(
            const SendableData& data,
            const uint32_t& trackingNumber) = 0;
    virtual mozilla::ipc::IPCResult
    RecvStartTLS() = 0;
    virtual mozilla::ipc::IPCResult
    RecvSuspend() = 0;
    virtual mozilla::ipc::IPCResult
    RecvResume() = 0;
    virtual mozilla::ipc::IPCResult
    RecvClose() = 0;
    virtual mozilla::ipc::IPCResult
    RecvRequestDelete() = 0;
    virtual mozilla::ipc::IPCResult
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PTCPSocketParent();

    virtual ~PTCPSocketParent();

    PNeckoParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendCallback(
            const nsString& type,
            const CallbackData& data,
            const uint32_t& readyState);

    MOZ_MUST_USE bool
    SendUpdateBufferedAmount(
            const uint32_t& bufferedAmount,
            const uint32_t& trackingNumber);

    MOZ_MUST_USE bool
    SendRequestDelete();

    MOZ_MUST_USE static bool
    Send__delete__(PTCPSocketParent* actor);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace net
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::PTCPSocketParent*>
{
    typedef mozilla::net::PTCPSocketParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class TCPSocketParent :
    public PTCPSocketParent
{
    mozilla::ipc::IPCResult
    RecvOpen(
            const nsString& host,
            const uint16_t& port,
            const bool& useSSL,
            const bool& useArrayBuffers) override;

    mozilla::ipc::IPCResult
    RecvOpenBind(
            const nsCString& host,
            const uint16_t& port,
            const nsCString& localAddr,
            const uint16_t& localPort,
            const bool& useSSL,
            const bool& reuseAddrPort,
            const bool& aUseArrayBuffers,
            const nsCString& aFilter) override;

    mozilla::ipc::IPCResult
    RecvData(
            const SendableData& data,
            const uint32_t& trackingNumber) override;

    mozilla::ipc::IPCResult
    RecvStartTLS() override;

    mozilla::ipc::IPCResult
    RecvSuspend() override;

    mozilla::ipc::IPCResult
    RecvResume() override;

    mozilla::ipc::IPCResult
    RecvClose() override;

    mozilla::ipc::IPCResult
    RecvRequestDelete() override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT TCPSocketParent();
    virtual ~TCPSocketParent();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
mozilla::ipc::IPCResult
TCPSocketParent::RecvOpen(
        const nsString& host,
        const uint16_t& port,
        const bool& useSSL,
        const bool& useArrayBuffers)
{
}

mozilla::ipc::IPCResult
TCPSocketParent::RecvOpenBind(
        const nsCString& host,
        const uint16_t& port,
        const nsCString& localAddr,
        const uint16_t& localPort,
        const bool& useSSL,
        const bool& reuseAddrPort,
        const bool& aUseArrayBuffers,
        const nsCString& aFilter)
{
}

mozilla::ipc::IPCResult
TCPSocketParent::RecvData(
        const SendableData& data,
        const uint32_t& trackingNumber)
{
}

mozilla::ipc::IPCResult
TCPSocketParent::RecvStartTLS()
{
}

mozilla::ipc::IPCResult
TCPSocketParent::RecvSuspend()
{
}

mozilla::ipc::IPCResult
TCPSocketParent::RecvResume()
{
}

mozilla::ipc::IPCResult
TCPSocketParent::RecvClose()
{
}

mozilla::ipc::IPCResult
TCPSocketParent::RecvRequestDelete()
{
}

void
TCPSocketParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT TCPSocketParent::TCPSocketParent()
{
    MOZ_COUNT_CTOR(TCPSocketParent);
}

MOZ_IMPLICIT TCPSocketParent::~TCPSocketParent()
{
    MOZ_COUNT_DTOR(TCPSocketParent);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PTCPSocketParent_h
