//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PUDPSocketParent_h
#define PUDPSocketParent_h

#include "mozilla/net/PUDPSocket.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/net/DNS.h"
#include "mozilla/net/NeckoMessageUtils.h"
#include "prio.h"

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PFileDescriptorSetParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PFileDescriptorSetChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PChildToParentStreamParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PChildToParentStreamChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PParentToChildStreamParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PParentToChildStreamChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
struct void_t;
} // namespace mozilla

namespace mozilla {
namespace net {


class PUDPSocketParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::net::PNeckoParent;
    friend class mozilla::ipc::PBackgroundParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::BufferedInputStreamParams BufferedInputStreamParams;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::FileInputStreamParams FileInputStreamParams;
    typedef mozilla::ipc::HeaderEntry HeaderEntry;
    typedef mozilla::ipc::IPCBlobInputStreamParams IPCBlobInputStreamParams;
    typedef mozilla::ipc::IPCRemoteStream IPCRemoteStream;
    typedef mozilla::ipc::IPCRemoteStreamType IPCRemoteStreamType;
    typedef mozilla::ipc::IPCStream IPCStream;
    typedef mozilla::ipc::InputStreamParams InputStreamParams;
    typedef mozilla::ipc::InputStreamParamsWithFds InputStreamParamsWithFds;
    typedef mozilla::ipc::MIMEInputStreamParams MIMEInputStreamParams;
    typedef mozilla::ipc::MultiplexInputStreamParams MultiplexInputStreamParams;
    typedef mozilla::net::NetAddr NetAddr;
    typedef mozilla::dom::OptionalFileDescriptorSet OptionalFileDescriptorSet;
    typedef mozilla::ipc::OptionalIPCStream OptionalIPCStream;
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolFdMapping ProtocolFdMapping;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::SlicedInputStreamParams SlicedInputStreamParams;
    typedef mozilla::ipc::StringInputStreamParams StringInputStreamParams;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoParent PNeckoParent;
    typedef mozilla::net::PNeckoChild PNeckoChild;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;
    typedef mozilla::ipc::PFileDescriptorSetParent PFileDescriptorSetParent;
    typedef mozilla::ipc::PFileDescriptorSetChild PFileDescriptorSetChild;
    typedef mozilla::ipc::PChildToParentStreamParent PChildToParentStreamParent;
    typedef mozilla::ipc::PChildToParentStreamChild PChildToParentStreamChild;
    typedef mozilla::ipc::PParentToChildStreamParent PParentToChildStreamParent;
    typedef mozilla::ipc::PParentToChildStreamChild PParentToChildStreamChild;

    typedef PUDPSocket::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvBind(
            const UDPAddressInfo& addressInfo,
            const bool& addressReuse,
            const bool& loopback,
            const uint32_t& recvBufferSize,
            const uint32_t& sendBufferSize) = 0;
    virtual mozilla::ipc::IPCResult
    RecvConnect(const UDPAddressInfo& addressInfo) = 0;
    virtual mozilla::ipc::IPCResult
    RecvOutgoingData(
            const UDPData& data,
            const UDPSocketAddr& addr) = 0;
    virtual mozilla::ipc::IPCResult
    RecvJoinMulticast(
            const nsCString& multicastAddress,
            const nsCString& iface) = 0;
    virtual mozilla::ipc::IPCResult
    RecvLeaveMulticast(
            const nsCString& multicastAddress,
            const nsCString& iface) = 0;
    virtual mozilla::ipc::IPCResult
    RecvClose() = 0;
    virtual mozilla::ipc::IPCResult
    RecvRequestDelete() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PUDPSocketParent();

    virtual ~PUDPSocketParent();

    MOZ_MUST_USE bool
    SendCallbackOpened(const UDPAddressInfo& addressInfo);

    MOZ_MUST_USE bool
    SendCallbackConnected(const UDPAddressInfo& addressInfo);

    MOZ_MUST_USE bool
    SendCallbackClosed();

    MOZ_MUST_USE bool
    SendCallbackReceivedData(
            const UDPAddressInfo& addressInfo,
            const nsTArray<uint8_t>& data);

    MOZ_MUST_USE bool
    SendCallbackError(
            const nsCString& message,
            const nsCString& filename,
            const uint32_t& lineNumber);

    MOZ_MUST_USE static bool
    Send__delete__(PUDPSocketParent* actor);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace net
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::PUDPSocketParent*>
{
    typedef mozilla::net::PUDPSocketParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class UDPSocketParent :
    public PUDPSocketParent
{
    mozilla::ipc::IPCResult
    RecvBind(
            const UDPAddressInfo& addressInfo,
            const bool& addressReuse,
            const bool& loopback,
            const uint32_t& recvBufferSize,
            const uint32_t& sendBufferSize) override;

    mozilla::ipc::IPCResult
    RecvConnect(const UDPAddressInfo& addressInfo) override;

    mozilla::ipc::IPCResult
    RecvOutgoingData(
            const UDPData& data,
            const UDPSocketAddr& addr) override;

    mozilla::ipc::IPCResult
    RecvJoinMulticast(
            const nsCString& multicastAddress,
            const nsCString& iface) override;

    mozilla::ipc::IPCResult
    RecvLeaveMulticast(
            const nsCString& multicastAddress,
            const nsCString& iface) override;

    mozilla::ipc::IPCResult
    RecvClose() override;

    mozilla::ipc::IPCResult
    RecvRequestDelete() override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT UDPSocketParent();
    virtual ~UDPSocketParent();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
mozilla::ipc::IPCResult
UDPSocketParent::RecvBind(
        const UDPAddressInfo& addressInfo,
        const bool& addressReuse,
        const bool& loopback,
        const uint32_t& recvBufferSize,
        const uint32_t& sendBufferSize)
{
}

mozilla::ipc::IPCResult
UDPSocketParent::RecvConnect(const UDPAddressInfo& addressInfo)
{
}

mozilla::ipc::IPCResult
UDPSocketParent::RecvOutgoingData(
        const UDPData& data,
        const UDPSocketAddr& addr)
{
}

mozilla::ipc::IPCResult
UDPSocketParent::RecvJoinMulticast(
        const nsCString& multicastAddress,
        const nsCString& iface)
{
}

mozilla::ipc::IPCResult
UDPSocketParent::RecvLeaveMulticast(
        const nsCString& multicastAddress,
        const nsCString& iface)
{
}

mozilla::ipc::IPCResult
UDPSocketParent::RecvClose()
{
}

mozilla::ipc::IPCResult
UDPSocketParent::RecvRequestDelete()
{
}

void
UDPSocketParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT UDPSocketParent::UDPSocketParent()
{
    MOZ_COUNT_CTOR(UDPSocketParent);
}

MOZ_IMPLICIT UDPSocketParent::~UDPSocketParent()
{
    MOZ_COUNT_DTOR(UDPSocketParent);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PUDPSocketParent_h
