//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PPSMContentDownloaderParent_h
#define PPSMContentDownloaderParent_h

#include "mozilla/psm/PPSMContentDownloader.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace net {
class PChannelDiverterParent;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PChannelDiverterChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace psm {


class PPSMContentDownloaderParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::dom::PContentParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::net::PChannelDiverterParent PChannelDiverterParent;
    typedef mozilla::net::PChannelDiverterChild PChannelDiverterChild;

    typedef PPSMContentDownloader::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvOnStartRequest(const uint32_t& contentLength) = 0;
    virtual mozilla::ipc::IPCResult
    RecvOnDataAvailable(
            const nsCString& data,
            const uint64_t& offset,
            const uint32_t& count) = 0;
    virtual mozilla::ipc::IPCResult
    RecvOnStopRequest(const nsresult& code) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDivertToParentUsing(PChannelDiverterParent* diverter) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PPSMContentDownloaderParent();

    virtual ~PPSMContentDownloaderParent();

    PContentParent*
    Manager() const;

    MOZ_MUST_USE static bool
    Send__delete__(PPSMContentDownloaderParent* actor);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace psm
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::psm::PPSMContentDownloaderParent*>
{
    typedef mozilla::psm::PPSMContentDownloaderParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace psm {
class PSMContentDownloaderParent :
    public PPSMContentDownloaderParent
{
    mozilla::ipc::IPCResult
    RecvOnStartRequest(const uint32_t& contentLength) override;

    mozilla::ipc::IPCResult
    RecvOnDataAvailable(
            const nsCString& data,
            const uint64_t& offset,
            const uint32_t& count) override;

    mozilla::ipc::IPCResult
    RecvOnStopRequest(const nsresult& code) override;

    mozilla::ipc::IPCResult
    RecvDivertToParentUsing(PChannelDiverterParent* diverter) override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT PSMContentDownloaderParent();
    virtual ~PSMContentDownloaderParent();
};
} // namespace psm
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace psm {
mozilla::ipc::IPCResult
PSMContentDownloaderParent::RecvOnStartRequest(const uint32_t& contentLength)
{
}

mozilla::ipc::IPCResult
PSMContentDownloaderParent::RecvOnDataAvailable(
        const nsCString& data,
        const uint64_t& offset,
        const uint32_t& count)
{
}

mozilla::ipc::IPCResult
PSMContentDownloaderParent::RecvOnStopRequest(const nsresult& code)
{
}

mozilla::ipc::IPCResult
PSMContentDownloaderParent::RecvDivertToParentUsing(PChannelDiverterParent* diverter)
{
}

void
PSMContentDownloaderParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT PSMContentDownloaderParent::PSMContentDownloaderParent()
{
    MOZ_COUNT_CTOR(PSMContentDownloaderParent);
}

MOZ_IMPLICIT PSMContentDownloaderParent::~PSMContentDownloaderParent()
{
    MOZ_COUNT_DTOR(PSMContentDownloaderParent);
}

} // namespace psm
} // namespace mozilla
#endif // if 0

#endif // ifndef PPSMContentDownloaderParent_h
